----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:12:36 04/14/2010 
-- Design Name: 
-- Module Name:    ClockShift - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ClockShift is
    Port ( 
			  phi : in  STD_LOGIC;
           fastclkby2 : in  STD_LOGIC;
           phidelayed : out  STD_LOGIC;
           pulser : out  STD_LOGIC;
           pulsew : out  STD_LOGIC;
			  pulsec : out  STD_LOGIC
			);
end ClockShift;

architecture Behavioral of ClockShift is

		-- clock shift register
		signal phi0D1: std_logic := '0';
		signal phi0D2: std_logic := '0';
		signal phi0D3: std_logic := '0';
		signal phi0D4: std_logic := '0';
		signal phi0D5: std_logic := '0';
		signal phi0D6: std_logic := '0';
		signal phi0D7: std_logic := '0';

begin

                Delay1: process(fastclkby2)
                begin
                        if (falling_edge(fastclkby2)) then
                                phi0D1 <= phi;
                                phi0D2 <= phi0D1;
                                phi0D3 <= phi0D2;
                                phi0D4 <= phi0D3;
                                phi0D5 <= phi0D4;
                                phi0D6 <= phi0D5;
                                phi0D7 <= phi0D6;
                        end if;
                end process Delay1;

                phidelayed <= phi0D6;

		pulser <= phi0D3 and not(phi0D2);
		pulsew <= phi0D4 and not(phi0D3);
		pulsec <= phi0D5 and not(phi0D4);

end Behavioral;

