----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:10:29 04/15/2010 
-- Design Name: 
-- Module Name:    ControlRegister - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ControlRegister is
    Port ( data : inout  STD_LOGIC_VECTOR (7 downto 0);
           clk : in  STD_LOGIC;
			  sel : in STD_LOGIC;
			  rnw : in STD_LOGIC;
           reset : in  STD_LOGIC;
           bootromin : in  STD_LOGIC;
           wprotect : out  STD_LOGIC_VECTOR (1 downto 0);
           bogusok : out  STD_LOGIC;
           bootrom : out  STD_LOGIC;
           prgrom : out  STD_LOGIC;
			  slow64k : out STD_LOGIC;
			  slowonly : out STD_LOGIC;
           clklatch : out  STD_LOGIC_VECTOR (3 downto 0);

    	init_slowonly : in std_logic;
    	init_bogusok : in std_logic;
    	init_clklatch : in std_logic_vector(3 downto 0)
	);

end ControlRegister;

architecture Behavioral of ControlRegister is

begin


		DoWriteAccess: process(clk, reset, bootromin, init_slowonly, init_bogusok, init_clklatch)
		begin
			if (reset = '0') then
				slowonly <= init_slowonly;
				slow64k <= '1';
				bootrom <= bootromin;
				prgrom <= '0';
				wprotect <= "00";
				bogusok <= init_bogusok;
				clklatch <= init_clklatch;
			elsif (falling_edge(clk) and rnw = '0') then
				if (sel = '1') then
					
							-- write $00efff
							--clkdiv <= data(1 downto 0);
							wprotect <= data(3 downto 2);
							--slowonly <= data(4);
							bogusok <= data(4);
							slowonly <= data(4);
							slow64k <= data(5);
							bootrom <= data(6);
							prgrom <= data(7);
                     case data(1 downto 0) is
                          when "00" =>
                                clklatch <= "0001";     -- 1 = 12,5 MHz
                          when "01" =>
                                clklatch <= "0010";     -- 2 = 8,3 MHz
                          when "10" =>
                                clklatch <= "0101";     -- 5 = 4,2 MHz
                          when "11" =>
                                clklatch <= "1001";     -- 9 = 2,5 MHz
                          when others =>
                                clklatch <= "1111";
                     end case;
				end if;
			end if;
		end process DoWriteAccess;

--		DoReadAccess: process(cpuclkint, phi0D2, reset)
--		begin
--			if (cpuclkint = '0') then 
--				cpudata <= "ZZZZZZZZ";
--				myregister <= '0';
--			elsif (rising_edge(phi0D2) and cpurnw = '1') then
--				if (islow64k = '1'
--						and isio = '1'
--						and cpuaddr_ismyio = '0') then
--					 case cpuaddrin_16 is
--						when "1111" =>
--							-- read $00efff
--							myregister <= '1';
--							cpudata <= (prgrom, bootrom, slow64k, slowonly, wprotect(1), wprotect(0), clkdiv(1), clkdiv(0));
--						when others =>
--							cpudata <= "ZZZZZZZZ";
--							myregister <= '0';
--					end case;
--				end if;
--			end if;
--		end process DoReadAccess;


end Behavioral;

