----------------------------------------------------------------------------
----------------------------------------------------------------------------
--  The Free IP Project
--  VHDL DES Core
--  (c) 1999, The Free IP Project and David Kessner
--
--
--  FREE IP GENERAL PUBLIC LICENSE
--  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION
--
--  1.  You may copy and distribute verbatim copies of this core, as long
--      as this file, and the other associated files, remain intact and
--      unmodified.  Modifications are outlined below.  Also, see the
--      import/export warning above for further restrictions on
--      distribution.
--  2.  You may use this core in any way, be it academic, commercial, or
--      military.  Modified or not.
--  3.  Distribution of this core must be free of charge.  Charging is
--      allowed only for value added services.  Value added services
--      would include copying fees, modifications, customizations, and
--      inclusion in other products.
--  4.  If a modified source code is distributed, the original unmodified
--      source code must also be included (or a link to the Free IP web
--      site).  In the modified source code there must be clear
--      identification of the modified version.
--  5.  Visit the Free IP web site for additional information.
--      http://www.free-ip.com
--
----------------------------------------------------------------------------
----------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;

package rom_suite is
  component pet_rom_short
    port (addr	:in std_logic_vector (14 downto 0);
          data  :out std_logic_vector (7 downto 0)
         );
  end component;
end rom_suite;


------------------------------------------------------------------------------
------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;
--use work.test_suite.all;

entity pet_rom_short is
    port (addr	:in std_logic_vector (14 downto 0);
          data  :out std_logic_vector (7 downto 0)
         );
end pet_rom_short;

architecture arch_test_rom of pet_rom_short is
begin
  process (addr)
  begin
    case addr(12 downto 0) is
      --addrbits 13
      --databits 8
      --varname data
      --little-endian
      --start_of_rom      -- rom2vhdl output.  Fri Apr 16 23:04:55 2010      -- rom2vhdl output.  Sat Apr 17 00:32:44 2010      -- rom2vhdl output.  Sat Apr 17 00:33:19 2010

      when "0000000000000" =>  data <= "01001100";  -- 6000 = 4C
      when "0000000000001" =>  data <= "00110110";  -- 6001 = 36
      when "0000000000010" =>  data <= "11100000";  -- 6002 = E0
      when "0000000000011" =>  data <= "01001100";  -- 6003 = 4C
      when "0000000000100" =>  data <= "10100111";  -- 6004 = A7
      when "0000000000101" =>  data <= "11100000";  -- 6005 = E0
      when "0000000000110" =>  data <= "01001100";  -- 6006 = 4C
      when "0000000000111" =>  data <= "00010110";  -- 6007 = 16
      when "0000000001000" =>  data <= "11100001";  -- 6008 = E1
      when "0000000001001" =>  data <= "01001100";  -- 6009 = 4C
      when "0000000001010" =>  data <= "00000010";  -- 600A = 2
      when "0000000001011" =>  data <= "11100010";  -- 600B = E2
      when "0000000001100" =>  data <= "01001100";  -- 600C = 4C
      when "0000000001101" =>  data <= "01000010";  -- 600D = 42
      when "0000000001110" =>  data <= "11100100";  -- 600E = E4
      when "0000000001111" =>  data <= "01001100";  -- 600F = 4C
      when "0000000010000" =>  data <= "01010101";  -- 6010 = 55
      when "0000000010001" =>  data <= "11100100";  -- 6011 = E4
      when "0000000010010" =>  data <= "01001100";  -- 6012 = 4C
      when "0000000010011" =>  data <= "00000000";  -- 6013 = 0
      when "0000000010100" =>  data <= "11100110";  -- 6014 = E6
      when "0000000010101" =>  data <= "01001100";  -- 6015 = 4C
      when "0000000010110" =>  data <= "01000010";  -- 6016 = 42
      when "0000000010111" =>  data <= "11100000";  -- 6017 = E0
      when "0000000011000" =>  data <= "01001100";  -- 6018 = 4C
      when "0000000011001" =>  data <= "00001111";  -- 6019 = F
      when "0000000011010" =>  data <= "11100110";  -- 601A = E6
      when "0000000011011" =>  data <= "01001100";  -- 601B = 4C
      when "0000000011100" =>  data <= "00010111";  -- 601C = 17
      when "0000000011101" =>  data <= "11100110";  -- 601D = E6
      when "0000000011110" =>  data <= "01001100";  -- 601E = 4C
      when "0000000011111" =>  data <= "00011101";  -- 601F = 1D
      when "0000000100000" =>  data <= "11100110";  -- 6020 = E6
      when "0000000100001" =>  data <= "01001100";  -- 6021 = 4C
      when "0000000100010" =>  data <= "11101010";  -- 6022 = EA
      when "0000000100011" =>  data <= "11100110";  -- 6023 = E6
      when "0000000100100" =>  data <= "01001100";  -- 6024 = 4C
      when "0000000100101" =>  data <= "11010001";  -- 6025 = D1
      when "0000000100110" =>  data <= "11100011";  -- 6026 = E3
      when "0000000100111" =>  data <= "01001100";  -- 6027 = 4C
      when "0000000101000" =>  data <= "10111111";  -- 6028 = BF
      when "0000000101001" =>  data <= "11100100";  -- 6029 = E4
      when "0000000101010" =>  data <= "01001100";  -- 602A = 4C
      when "0000000101011" =>  data <= "01010111";  -- 602B = 57
      when "0000000101100" =>  data <= "11100110";  -- 602C = E6
      when "0000000101101" =>  data <= "01001100";  -- 602D = 4C
      when "0000000101110" =>  data <= "10011000";  -- 602E = 98
      when "0000000101111" =>  data <= "11100000";  -- 602F = E0
      when "0000000110000" =>  data <= "01001100";  -- 6030 = 4C
      when "0000000110001" =>  data <= "10011000";  -- 6031 = 98
      when "0000000110010" =>  data <= "11100000";  -- 6032 = E0
      when "0000000110011" =>  data <= "01001100";  -- 6033 = 4C
      when "0000000110100" =>  data <= "10011000";  -- 6034 = 98
      when "0000000110101" =>  data <= "11100000";  -- 6035 = E0
      when "0000000110110" =>  data <= "00100000";  -- 6036 = 20
      when "0000000110111" =>  data <= "10000011";  -- 6037 = 83
      when "0000000111000" =>  data <= "11100110";  -- 6038 = E6
      when "0000000111001" =>  data <= "00100000";  -- 6039 = 20
      when "0000000111010" =>  data <= "00010111";  -- 603A = 17
      when "0000000111011" =>  data <= "11100110";  -- 603B = E6
      when "0000000111100" =>  data <= "00100000";  -- 603C = 20
      when "0000000111101" =>  data <= "01010100";  -- 603D = 54
      when "0000000111110" =>  data <= "11100110";  -- 603E = E6
      when "0000000111111" =>  data <= "00100000";  -- 603F = 20
      when "0000001000000" =>  data <= "01010100";  -- 6040 = 54
      when "0000001000001" =>  data <= "11100110";  -- 6041 = E6
      when "0000001000010" =>  data <= "10100010";  -- 6042 = A2
      when "0000001000011" =>  data <= "00011000";  -- 6043 = 18
      when "0000001000100" =>  data <= "10101001";  -- 6044 = A9
      when "0000001000101" =>  data <= "11000000";  -- 6045 = C0
      when "0000001000110" =>  data <= "10100000";  -- 6046 = A0
      when "0000001000111" =>  data <= "10000011";  -- 6047 = 83
      when "0000001001000" =>  data <= "10010100";  -- 6048 = 94
      when "0000001001001" =>  data <= "11100000";  -- 6049 = E0
      when "0000001001010" =>  data <= "00111000";  -- 604A = 38
      when "0000001001011" =>  data <= "11101001";  -- 604B = E9
      when "0000001001100" =>  data <= "00101000";  -- 604C = 28
      when "0000001001101" =>  data <= "10110000";  -- 604D = B0
      when "0000001001110" =>  data <= "00000001";  -- 604E = 1
      when "0000001001111" =>  data <= "10001000";  -- 604F = 88
      when "0000001010000" =>  data <= "11001010";  -- 6050 = CA
      when "0000001010001" =>  data <= "00010000";  -- 6051 = 10
      when "0000001010010" =>  data <= "11110101";  -- 6052 = F5
      when "0000001010011" =>  data <= "10000100";  -- 6053 = 84
      when "0000001010100" =>  data <= "11000101";  -- 6054 = C5
      when "0000001010101" =>  data <= "11101000";  -- 6055 = E8
      when "0000001010110" =>  data <= "10000110";  -- 6056 = 86
      when "0000001010111" =>  data <= "10011111";  -- 6057 = 9F
      when "0000001011000" =>  data <= "10000110";  -- 6058 = 86
      when "0000001011001" =>  data <= "11000100";  -- 6059 = C4
      when "0000001011010" =>  data <= "10101001";  -- 605A = A9
      when "0000001011011" =>  data <= "00100000";  -- 605B = 20
      when "0000001011100" =>  data <= "10011101";  -- 605C = 9D
      when "0000001011101" =>  data <= "00000000";  -- 605D = 0
      when "0000001011110" =>  data <= "10000000";  -- 605E = 80
      when "0000001011111" =>  data <= "10011101";  -- 605F = 9D
      when "0000001100000" =>  data <= "00000000";  -- 6060 = 0
      when "0000001100001" =>  data <= "10000001";  -- 6061 = 81
      when "0000001100010" =>  data <= "10011101";  -- 6062 = 9D
      when "0000001100011" =>  data <= "00000000";  -- 6063 = 0
      when "0000001100100" =>  data <= "10000010";  -- 6064 = 82
      when "0000001100101" =>  data <= "10011101";  -- 6065 = 9D
      when "0000001100110" =>  data <= "00000000";  -- 6066 = 0
      when "0000001100111" =>  data <= "10000011";  -- 6067 = 83
      when "0000001101000" =>  data <= "11101000";  -- 6068 = E8
      when "0000001101001" =>  data <= "11010000";  -- 6069 = D0
      when "0000001101010" =>  data <= "11110001";  -- 606A = F1
      when "0000001101011" =>  data <= "10100000";  -- 606B = A0
      when "0000001101100" =>  data <= "00000000";  -- 606C = 0
      when "0000001101101" =>  data <= "10000100";  -- 606D = 84
      when "0000001101110" =>  data <= "11000110";  -- 606E = C6
      when "0000001101111" =>  data <= "10000100";  -- 606F = 84
      when "0000001110000" =>  data <= "11011000";  -- 6070 = D8
      when "0000001110001" =>  data <= "10100110";  -- 6071 = A6
      when "0000001110010" =>  data <= "11011000";  -- 6072 = D8
      when "0000001110011" =>  data <= "10110101";  -- 6073 = B5
      when "0000001110100" =>  data <= "11100000";  -- 6074 = E0
      when "0000001110101" =>  data <= "00001001";  -- 6075 = 9
      when "0000001110110" =>  data <= "10000000";  -- 6076 = 80
      when "0000001110111" =>  data <= "10000101";  -- 6077 = 85
      when "0000001111000" =>  data <= "11000101";  -- 6078 = C5
      when "0000001111001" =>  data <= "10111101";  -- 6079 = BD
      when "0000001111010" =>  data <= "10011000";  -- 607A = 98
      when "0000001111011" =>  data <= "11100111";  -- 607B = E7
      when "0000001111100" =>  data <= "10000101";  -- 607C = 85
      when "0000001111101" =>  data <= "11000100";  -- 607D = C4
      when "0000001111110" =>  data <= "10101001";  -- 607E = A9
      when "0000001111111" =>  data <= "00100111";  -- 607F = 27
      when "0000010000000" =>  data <= "10000101";  -- 6080 = 85
      when "0000010000001" =>  data <= "11010101";  -- 6081 = D5
      when "0000010000010" =>  data <= "11100000";  -- 6082 = E0
      when "0000010000011" =>  data <= "00011000";  -- 6083 = 18
      when "0000010000100" =>  data <= "11110000";  -- 6084 = F0
      when "0000010000101" =>  data <= "00001000";  -- 6085 = 8
      when "0000010000110" =>  data <= "10110101";  -- 6086 = B5
      when "0000010000111" =>  data <= "11100001";  -- 6087 = E1
      when "0000010001000" =>  data <= "00110000";  -- 6088 = 30
      when "0000010001001" =>  data <= "00000100";  -- 6089 = 4
      when "0000010001010" =>  data <= "10101001";  -- 608A = A9
      when "0000010001011" =>  data <= "01001111";  -- 608B = 4F
      when "0000010001100" =>  data <= "10000101";  -- 608C = 85
      when "0000010001101" =>  data <= "11010101";  -- 608D = D5
      when "0000010001110" =>  data <= "10100101";  -- 608E = A5
      when "0000010001111" =>  data <= "11000110";  -- 608F = C6
      when "0000010010000" =>  data <= "11001001";  -- 6090 = C9
      when "0000010010001" =>  data <= "00101000";  -- 6091 = 28
      when "0000010010010" =>  data <= "10010000";  -- 6092 = 90
      when "0000010010011" =>  data <= "00000100";  -- 6093 = 4
      when "0000010010100" =>  data <= "11101001";  -- 6094 = E9
      when "0000010010101" =>  data <= "00101000";  -- 6095 = 28
      when "0000010010110" =>  data <= "10000101";  -- 6096 = 85
      when "0000010010111" =>  data <= "11000110";  -- 6097 = C6
      when "0000010011000" =>  data <= "01100000";  -- 6098 = 60
      when "0000010011001" =>  data <= "10101010";  -- 6099 = AA
      when "0000010011010" =>  data <= "10101010";  -- 609A = AA
      when "0000010011011" =>  data <= "10101010";  -- 609B = AA
      when "0000010011100" =>  data <= "10101010";  -- 609C = AA
      when "0000010011101" =>  data <= "10101010";  -- 609D = AA
      when "0000010011110" =>  data <= "10101010";  -- 609E = AA
      when "0000010011111" =>  data <= "10101010";  -- 609F = AA
      when "0000010100000" =>  data <= "10101010";  -- 60A0 = AA
      when "0000010100001" =>  data <= "10101010";  -- 60A1 = AA
      when "0000010100010" =>  data <= "10101010";  -- 60A2 = AA
      when "0000010100011" =>  data <= "10101010";  -- 60A3 = AA
      when "0000010100100" =>  data <= "10101010";  -- 60A4 = AA
      when "0000010100101" =>  data <= "10101010";  -- 60A5 = AA
      when "0000010100110" =>  data <= "10101010";  -- 60A6 = AA
      when "0000010100111" =>  data <= "10101100";  -- 60A7 = AC
      when "0000010101000" =>  data <= "01101111";  -- 60A8 = 6F
      when "0000010101001" =>  data <= "00000010";  -- 60A9 = 2
      when "0000010101010" =>  data <= "10100010";  -- 60AA = A2
      when "0000010101011" =>  data <= "00000000";  -- 60AB = 0
      when "0000010101100" =>  data <= "10111101";  -- 60AC = BD
      when "0000010101101" =>  data <= "01110000";  -- 60AD = 70
      when "0000010101110" =>  data <= "00000010";  -- 60AE = 2
      when "0000010101111" =>  data <= "10011101";  -- 60AF = 9D
      when "0000010110000" =>  data <= "01101111";  -- 60B0 = 6F
      when "0000010110001" =>  data <= "00000010";  -- 60B1 = 2
      when "0000010110010" =>  data <= "11101000";  -- 60B2 = E8
      when "0000010110011" =>  data <= "11100100";  -- 60B3 = E4
      when "0000010110100" =>  data <= "10011110";  -- 60B4 = 9E
      when "0000010110101" =>  data <= "11010000";  -- 60B5 = D0
      when "0000010110110" =>  data <= "11110101";  -- 60B6 = F5
      when "0000010110111" =>  data <= "11000110";  -- 60B7 = C6
      when "0000010111000" =>  data <= "10011110";  -- 60B8 = 9E
      when "0000010111001" =>  data <= "10011000";  -- 60B9 = 98
      when "0000010111010" =>  data <= "01011000";  -- 60BA = 58
      when "0000010111011" =>  data <= "01100000";  -- 60BB = 60
      when "0000010111100" =>  data <= "00100000";  -- 60BC = 20
      when "0000010111101" =>  data <= "00111100";  -- 60BD = 3C
      when "0000010111110" =>  data <= "11100110";  -- 60BE = E6
      when "0000010111111" =>  data <= "10100101";  -- 60BF = A5
      when "0000011000000" =>  data <= "10011110";  -- 60C0 = 9E
      when "0000011000001" =>  data <= "10000101";  -- 60C1 = 85
      when "0000011000010" =>  data <= "10100111";  -- 60C2 = A7
      when "0000011000011" =>  data <= "11110000";  -- 60C3 = F0
      when "0000011000100" =>  data <= "11111010";  -- 60C4 = FA
      when "0000011000101" =>  data <= "01111000";  -- 60C5 = 78
      when "0000011000110" =>  data <= "10100101";  -- 60C6 = A5
      when "0000011000111" =>  data <= "10101010";  -- 60C7 = AA
      when "0000011001000" =>  data <= "11110000";  -- 60C8 = F0
      when "0000011001001" =>  data <= "00001001";  -- 60C9 = 9
      when "0000011001010" =>  data <= "10100101";  -- 60CA = A5
      when "0000011001011" =>  data <= "10101001";  -- 60CB = A9
      when "0000011001100" =>  data <= "10100000";  -- 60CC = A0
      when "0000011001101" =>  data <= "00000000";  -- 60CD = 0
      when "0000011001110" =>  data <= "10000100";  -- 60CE = 84
      when "0000011001111" =>  data <= "10101010";  -- 60CF = AA
      when "0000011010000" =>  data <= "00100000";  -- 60D0 = 20
      when "0000011010001" =>  data <= "00000110";  -- 60D1 = 6
      when "0000011010010" =>  data <= "11100110";  -- 60D2 = E6
      when "0000011010011" =>  data <= "00100000";  -- 60D3 = 20
      when "0000011010100" =>  data <= "10100111";  -- 60D4 = A7
      when "0000011010101" =>  data <= "11100000";  -- 60D5 = E0
      when "0000011010110" =>  data <= "11001001";  -- 60D6 = C9
      when "0000011010111" =>  data <= "10000011";  -- 60D7 = 83
      when "0000011011000" =>  data <= "11010000";  -- 60D8 = D0
      when "0000011011001" =>  data <= "00010000";  -- 60D9 = 10
      when "0000011011010" =>  data <= "01111000";  -- 60DA = 78
      when "0000011011011" =>  data <= "10100010";  -- 60DB = A2
      when "0000011011100" =>  data <= "00001001";  -- 60DC = 9
      when "0000011011101" =>  data <= "10000110";  -- 60DD = 86
      when "0000011011110" =>  data <= "10011110";  -- 60DE = 9E
      when "0000011011111" =>  data <= "10111101";  -- 60DF = BD
      when "0000011100000" =>  data <= "10001110";  -- 60E0 = 8E
      when "0000011100001" =>  data <= "11100111";  -- 60E1 = E7
      when "0000011100010" =>  data <= "10011101";  -- 60E2 = 9D
      when "0000011100011" =>  data <= "01101110";  -- 60E3 = 6E
      when "0000011100100" =>  data <= "00000010";  -- 60E4 = 2
      when "0000011100101" =>  data <= "11001010";  -- 60E5 = CA
      when "0000011100110" =>  data <= "11010000";  -- 60E6 = D0
      when "0000011100111" =>  data <= "11110111";  -- 60E7 = F7
      when "0000011101000" =>  data <= "11110000";  -- 60E8 = F0
      when "0000011101001" =>  data <= "11010101";  -- 60E9 = D5
      when "0000011101010" =>  data <= "11001001";  -- 60EA = C9
      when "0000011101011" =>  data <= "00001101";  -- 60EB = D
      when "0000011101100" =>  data <= "11010000";  -- 60EC = D0
      when "0000011101101" =>  data <= "11001110";  -- 60ED = CE
      when "0000011101110" =>  data <= "10100100";  -- 60EE = A4
      when "0000011101111" =>  data <= "11010101";  -- 60EF = D5
      when "0000011110000" =>  data <= "10000100";  -- 60F0 = 84
      when "0000011110001" =>  data <= "10101100";  -- 60F1 = AC
      when "0000011110010" =>  data <= "10110001";  -- 60F2 = B1
      when "0000011110011" =>  data <= "11000100";  -- 60F3 = C4
      when "0000011110100" =>  data <= "11001001";  -- 60F4 = C9
      when "0000011110101" =>  data <= "00100000";  -- 60F5 = 20
      when "0000011110110" =>  data <= "11010000";  -- 60F6 = D0
      when "0000011110111" =>  data <= "00000011";  -- 60F7 = 3
      when "0000011111000" =>  data <= "10001000";  -- 60F8 = 88
      when "0000011111001" =>  data <= "11010000";  -- 60F9 = D0
      when "0000011111010" =>  data <= "11110111";  -- 60FA = F7
      when "0000011111011" =>  data <= "11001000";  -- 60FB = C8
      when "0000011111100" =>  data <= "10000100";  -- 60FC = 84
      when "0000011111101" =>  data <= "10100001";  -- 60FD = A1
      when "0000011111110" =>  data <= "10100000";  -- 60FE = A0
      when "0000011111111" =>  data <= "00000000";  -- 60FF = 0
      when "0000100000000" =>  data <= "10000100";  -- 6100 = 84
      when "0000100000001" =>  data <= "11000110";  -- 6101 = C6
      when "0000100000010" =>  data <= "10000100";  -- 6102 = 84
      when "0000100000011" =>  data <= "11001101";  -- 6103 = CD
      when "0000100000100" =>  data <= "10100101";  -- 6104 = A5
      when "0000100000101" =>  data <= "10100011";  -- 6105 = A3
      when "0000100000110" =>  data <= "00110000";  -- 6106 = 30
      when "0000100000111" =>  data <= "00010110";  -- 6107 = 16
      when "0000100001000" =>  data <= "11000101";  -- 6108 = C5
      when "0000100001001" =>  data <= "11011000";  -- 6109 = D8
      when "0000100001010" =>  data <= "11010000";  -- 610A = D0
      when "0000100001011" =>  data <= "00010010";  -- 610B = 12
      when "0000100001100" =>  data <= "10100101";  -- 610C = A5
      when "0000100001101" =>  data <= "10100100";  -- 610D = A4
      when "0000100001110" =>  data <= "10000101";  -- 610E = 85
      when "0000100001111" =>  data <= "11000110";  -- 610F = C6
      when "0000100010000" =>  data <= "11000101";  -- 6110 = C5
      when "0000100010001" =>  data <= "10100001";  -- 6111 = A1
      when "0000100010010" =>  data <= "10010000";  -- 6112 = 90
      when "0000100010011" =>  data <= "00001010";  -- 6113 = A
      when "0000100010100" =>  data <= "10110000";  -- 6114 = B0
      when "0000100010101" =>  data <= "00101011";  -- 6115 = 2B
      when "0000100010110" =>  data <= "10011000";  -- 6116 = 98
      when "0000100010111" =>  data <= "01001000";  -- 6117 = 48
      when "0000100011000" =>  data <= "10001010";  -- 6118 = 8A
      when "0000100011001" =>  data <= "01001000";  -- 6119 = 48
      when "0000100011010" =>  data <= "10100101";  -- 611A = A5
      when "0000100011011" =>  data <= "10101100";  -- 611B = AC
      when "0000100011100" =>  data <= "11110000";  -- 611C = F0
      when "0000100011101" =>  data <= "10100001";  -- 611D = A1
      when "0000100011110" =>  data <= "10100100";  -- 611E = A4
      when "0000100011111" =>  data <= "11000110";  -- 611F = C6
      when "0000100100000" =>  data <= "10110001";  -- 6120 = B1
      when "0000100100001" =>  data <= "11000100";  -- 6121 = C4
      when "0000100100010" =>  data <= "10000101";  -- 6122 = 85
      when "0000100100011" =>  data <= "11011001";  -- 6123 = D9
      when "0000100100100" =>  data <= "00101001";  -- 6124 = 29
      when "0000100100101" =>  data <= "00111111";  -- 6125 = 3F
      when "0000100100110" =>  data <= "00000110";  -- 6126 = 6
      when "0000100100111" =>  data <= "11011001";  -- 6127 = D9
      when "0000100101000" =>  data <= "00100100";  -- 6128 = 24
      when "0000100101001" =>  data <= "11011001";  -- 6129 = D9
      when "0000100101010" =>  data <= "00010000";  -- 612A = 10
      when "0000100101011" =>  data <= "00000010";  -- 612B = 2
      when "0000100101100" =>  data <= "00001001";  -- 612C = 9
      when "0000100101101" =>  data <= "10000000";  -- 612D = 80
      when "0000100101110" =>  data <= "10010000";  -- 612E = 90
      when "0000100101111" =>  data <= "00000100";  -- 612F = 4
      when "0000100110000" =>  data <= "10100110";  -- 6130 = A6
      when "0000100110001" =>  data <= "11001101";  -- 6131 = CD
      when "0000100110010" =>  data <= "11010000";  -- 6132 = D0
      when "0000100110011" =>  data <= "00000100";  -- 6133 = 4
      when "0000100110100" =>  data <= "01110000";  -- 6134 = 70
      when "0000100110101" =>  data <= "00000010";  -- 6135 = 2
      when "0000100110110" =>  data <= "00001001";  -- 6136 = 9
      when "0000100110111" =>  data <= "01000000";  -- 6137 = 40
      when "0000100111000" =>  data <= "11100110";  -- 6138 = E6
      when "0000100111001" =>  data <= "11000110";  -- 6139 = C6
      when "0000100111010" =>  data <= "00100000";  -- 613A = 20
      when "0000100111011" =>  data <= "01100111";  -- 613B = 67
      when "0000100111100" =>  data <= "11100001";  -- 613C = E1
      when "0000100111101" =>  data <= "11000100";  -- 613D = C4
      when "0000100111110" =>  data <= "10100001";  -- 613E = A1
      when "0000100111111" =>  data <= "11010000";  -- 613F = D0
      when "0000101000000" =>  data <= "00010111";  -- 6140 = 17
      when "0000101000001" =>  data <= "10101001";  -- 6141 = A9
      when "0000101000010" =>  data <= "00000000";  -- 6142 = 0
      when "0000101000011" =>  data <= "10000101";  -- 6143 = 85
      when "0000101000100" =>  data <= "10101100";  -- 6144 = AC
      when "0000101000101" =>  data <= "10101001";  -- 6145 = A9
      when "0000101000110" =>  data <= "00001101";  -- 6146 = D
      when "0000101000111" =>  data <= "10100110";  -- 6147 = A6
      when "0000101001000" =>  data <= "10101111";  -- 6148 = AF
      when "0000101001001" =>  data <= "11100000";  -- 6149 = E0
      when "0000101001010" =>  data <= "00000011";  -- 614A = 3
      when "0000101001011" =>  data <= "11110000";  -- 614B = F0
      when "0000101001100" =>  data <= "00000110";  -- 614C = 6
      when "0000101001101" =>  data <= "10100110";  -- 614D = A6
      when "0000101001110" =>  data <= "10110000";  -- 614E = B0
      when "0000101001111" =>  data <= "11100000";  -- 614F = E0
      when "0000101010000" =>  data <= "00000011";  -- 6150 = 3
      when "0000101010001" =>  data <= "11110000";  -- 6151 = F0
      when "0000101010010" =>  data <= "00000011";  -- 6152 = 3
      when "0000101010011" =>  data <= "00100000";  -- 6153 = 20
      when "0000101010100" =>  data <= "00000010";  -- 6154 = 2
      when "0000101010101" =>  data <= "11100010";  -- 6155 = E2
      when "0000101010110" =>  data <= "10101001";  -- 6156 = A9
      when "0000101010111" =>  data <= "00001101";  -- 6157 = D
      when "0000101011000" =>  data <= "10000101";  -- 6158 = 85
      when "0000101011001" =>  data <= "11011001";  -- 6159 = D9
      when "0000101011010" =>  data <= "01101000";  -- 615A = 68
      when "0000101011011" =>  data <= "10101010";  -- 615B = AA
      when "0000101011100" =>  data <= "01101000";  -- 615C = 68
      when "0000101011101" =>  data <= "10101000";  -- 615D = A8
      when "0000101011110" =>  data <= "10100101";  -- 615E = A5
      when "0000101011111" =>  data <= "11011001";  -- 615F = D9
      when "0000101100000" =>  data <= "11001001";  -- 6160 = C9
      when "0000101100001" =>  data <= "11011110";  -- 6161 = DE
      when "0000101100010" =>  data <= "11010000";  -- 6162 = D0
      when "0000101100011" =>  data <= "00000010";  -- 6163 = 2
      when "0000101100100" =>  data <= "10101001";  -- 6164 = A9
      when "0000101100101" =>  data <= "11111111";  -- 6165 = FF
      when "0000101100110" =>  data <= "01100000";  -- 6166 = 60
      when "0000101100111" =>  data <= "11001001";  -- 6167 = C9
      when "0000101101000" =>  data <= "00100010";  -- 6168 = 22
      when "0000101101001" =>  data <= "11010000";  -- 6169 = D0
      when "0000101101010" =>  data <= "00001000";  -- 616A = 8
      when "0000101101011" =>  data <= "10100101";  -- 616B = A5
      when "0000101101100" =>  data <= "11001101";  -- 616C = CD
      when "0000101101101" =>  data <= "01001001";  -- 616D = 49
      when "0000101101110" =>  data <= "00000001";  -- 616E = 1
      when "0000101101111" =>  data <= "10000101";  -- 616F = 85
      when "0000101110000" =>  data <= "11001101";  -- 6170 = CD
      when "0000101110001" =>  data <= "10101001";  -- 6171 = A9
      when "0000101110010" =>  data <= "00100010";  -- 6172 = 22
      when "0000101110011" =>  data <= "01100000";  -- 6173 = 60
      when "0000101110100" =>  data <= "00001001";  -- 6174 = 9
      when "0000101110101" =>  data <= "01000000";  -- 6175 = 40
      when "0000101110110" =>  data <= "10100110";  -- 6176 = A6
      when "0000101110111" =>  data <= "10011111";  -- 6177 = 9F
      when "0000101111000" =>  data <= "11110000";  -- 6178 = F0
      when "0000101111001" =>  data <= "00000010";  -- 6179 = 2
      when "0000101111010" =>  data <= "00001001";  -- 617A = 9
      when "0000101111011" =>  data <= "10000000";  -- 617B = 80
      when "0000101111100" =>  data <= "10100110";  -- 617C = A6
      when "0000101111101" =>  data <= "11011100";  -- 617D = DC
      when "0000101111110" =>  data <= "11110000";  -- 617E = F0
      when "0000101111111" =>  data <= "00000010";  -- 617F = 2
      when "0000110000000" =>  data <= "11000110";  -- 6180 = C6
      when "0000110000001" =>  data <= "11011100";  -- 6181 = DC
      when "0000110000010" =>  data <= "00100000";  -- 6182 = 20
      when "0000110000011" =>  data <= "00000110";  -- 6183 = 6
      when "0000110000100" =>  data <= "11100110";  -- 6184 = E6
      when "0000110000101" =>  data <= "11100110";  -- 6185 = E6
      when "0000110000110" =>  data <= "11000110";  -- 6186 = C6
      when "0000110000111" =>  data <= "10100100";  -- 6187 = A4
      when "0000110001000" =>  data <= "11010101";  -- 6188 = D5
      when "0000110001001" =>  data <= "11000100";  -- 6189 = C4
      when "0000110001010" =>  data <= "11000110";  -- 618A = C6
      when "0000110001011" =>  data <= "10110000";  -- 618B = B0
      when "0000110001100" =>  data <= "00011001";  -- 618C = 19
      when "0000110001101" =>  data <= "10100110";  -- 618D = A6
      when "0000110001110" =>  data <= "11011000";  -- 618E = D8
      when "0000110001111" =>  data <= "11000000";  -- 618F = C0
      when "0000110010000" =>  data <= "01001111";  -- 6190 = 4F
      when "0000110010001" =>  data <= "11010000";  -- 6191 = D0
      when "0000110010010" =>  data <= "00001100";  -- 6192 = C
      when "0000110010011" =>  data <= "00100000";  -- 6193 = 20
      when "0000110010100" =>  data <= "10110011";  -- 6194 = B3
      when "0000110010101" =>  data <= "11100001";  -- 6195 = E1
      when "0000110010110" =>  data <= "00100000";  -- 6196 = 20
      when "0000110010111" =>  data <= "10101001";  -- 6197 = A9
      when "0000110011000" =>  data <= "11100011";  -- 6198 = E3
      when "0000110011001" =>  data <= "10101001";  -- 6199 = A9
      when "0000110011010" =>  data <= "00000000";  -- 619A = 0
      when "0000110011011" =>  data <= "10000101";  -- 619B = 85
      when "0000110011100" =>  data <= "11000110";  -- 619C = C6
      when "0000110011101" =>  data <= "11110000";  -- 619D = F0
      when "0000110011110" =>  data <= "00000111";  -- 619E = 7
      when "0000110011111" =>  data <= "11100000";  -- 619F = E0
      when "0000110100000" =>  data <= "00011000";  -- 61A0 = 18
      when "0000110100001" =>  data <= "11010000";  -- 61A1 = D0
      when "0000110100010" =>  data <= "00011011";  -- 61A2 = 1B
      when "0000110100011" =>  data <= "00100000";  -- 61A3 = 20
      when "0000110100100" =>  data <= "11000100";  -- 61A4 = C4
      when "0000110100101" =>  data <= "11100001";  -- 61A5 = E1
      when "0000110100110" =>  data <= "01101000";  -- 61A6 = 68
      when "0000110100111" =>  data <= "10101000";  -- 61A7 = A8
      when "0000110101000" =>  data <= "10100101";  -- 61A8 = A5
      when "0000110101001" =>  data <= "11011100";  -- 61A9 = DC
      when "0000110101010" =>  data <= "11110000";  -- 61AA = F0
      when "0000110101011" =>  data <= "00000010";  -- 61AB = 2
      when "0000110101100" =>  data <= "01000110";  -- 61AC = 46
      when "0000110101101" =>  data <= "11001101";  -- 61AD = CD
      when "0000110101110" =>  data <= "01101000";  -- 61AE = 68
      when "0000110101111" =>  data <= "10101010";  -- 61AF = AA
      when "0000110110000" =>  data <= "01101000";  -- 61B0 = 68
      when "0000110110001" =>  data <= "01011000";  -- 61B1 = 58
      when "0000110110010" =>  data <= "01100000";  -- 61B2 = 60
      when "0000110110011" =>  data <= "11100000";  -- 61B3 = E0
      when "0000110110100" =>  data <= "00010111";  -- 61B4 = 17
      when "0000110110101" =>  data <= "10110000";  -- 61B5 = B0
      when "0000110110110" =>  data <= "00000110";  -- 61B6 = 6
      when "0000110110111" =>  data <= "10110101";  -- 61B7 = B5
      when "0000110111000" =>  data <= "11100010";  -- 61B8 = E2
      when "0000110111001" =>  data <= "00001001";  -- 61B9 = 9
      when "0000110111010" =>  data <= "10000000";  -- 61BA = 80
      when "0000110111011" =>  data <= "10010101";  -- 61BB = 95
      when "0000110111100" =>  data <= "11100010";  -- 61BC = E2
      when "0000110111101" =>  data <= "01100000";  -- 61BD = 60
      when "0000110111110" =>  data <= "00100000";  -- 61BE = 20
      when "0000110111111" =>  data <= "11001101";  -- 61BF = CD
      when "0000111000000" =>  data <= "11100001";  -- 61C0 = E1
      when "0000111000001" =>  data <= "01001100";  -- 61C1 = 4C
      when "0000111000010" =>  data <= "10100110";  -- 61C2 = A6
      when "0000111000011" =>  data <= "11100001";  -- 61C3 = E1
      when "0000111000100" =>  data <= "00100000";  -- 61C4 = 20
      when "0000111000101" =>  data <= "11010001";  -- 61C5 = D1
      when "0000111000110" =>  data <= "11100011";  -- 61C6 = E3
      when "0000111000111" =>  data <= "11000110";  -- 61C7 = C6
      when "0000111001000" =>  data <= "10100011";  -- 61C8 = A3
      when "0000111001001" =>  data <= "11000110";  -- 61C9 = C6
      when "0000111001010" =>  data <= "11011000";  -- 61CA = D8
      when "0000111001011" =>  data <= "10100110";  -- 61CB = A6
      when "0000111001100" =>  data <= "11011000";  -- 61CC = D8
      when "0000111001101" =>  data <= "00010110";  -- 61CD = 16
      when "0000111001110" =>  data <= "11100001";  -- 61CE = E1
      when "0000111001111" =>  data <= "01010110";  -- 61CF = 56
      when "0000111010000" =>  data <= "11100001";  -- 61D0 = E1
      when "0000111010001" =>  data <= "00100000";  -- 61D1 = 20
      when "0000111010010" =>  data <= "10110011";  -- 61D2 = B3
      when "0000111010011" =>  data <= "11100001";  -- 61D3 = E1
      when "0000111010100" =>  data <= "10100101";  -- 61D4 = A5
      when "0000111010101" =>  data <= "11000110";  -- 61D5 = C6
      when "0000111010110" =>  data <= "01001000";  -- 61D6 = 48
      when "0000111010111" =>  data <= "00100000";  -- 61D7 = 20
      when "0000111011000" =>  data <= "01110001";  -- 61D8 = 71
      when "0000111011001" =>  data <= "11100000";  -- 61D9 = E0
      when "0000111011010" =>  data <= "01101000";  -- 61DA = 68
      when "0000111011011" =>  data <= "10000101";  -- 61DB = 85
      when "0000111011100" =>  data <= "11000110";  -- 61DC = C6
      when "0000111011101" =>  data <= "01100000";  -- 61DD = 60
      when "0000111011110" =>  data <= "10100000";  -- 61DE = A0
      when "0000111011111" =>  data <= "00100111";  -- 61DF = 27
      when "0000111100000" =>  data <= "10100110";  -- 61E0 = A6
      when "0000111100001" =>  data <= "11011000";  -- 61E1 = D8
      when "0000111100010" =>  data <= "11010000";  -- 61E2 = D0
      when "0000111100011" =>  data <= "00000110";  -- 61E3 = 6
      when "0000111100100" =>  data <= "10000110";  -- 61E4 = 86
      when "0000111100101" =>  data <= "11000110";  -- 61E5 = C6
      when "0000111100110" =>  data <= "01101000";  -- 61E6 = 68
      when "0000111100111" =>  data <= "01101000";  -- 61E7 = 68
      when "0000111101000" =>  data <= "11010000";  -- 61E8 = D0
      when "0000111101001" =>  data <= "10111100";  -- 61E9 = BC
      when "0000111101010" =>  data <= "10110101";  -- 61EA = B5
      when "0000111101011" =>  data <= "11011111";  -- 61EB = DF
      when "0000111101100" =>  data <= "00110000";  -- 61EC = 30
      when "0000111101101" =>  data <= "00000101";  -- 61ED = 5
      when "0000111101110" =>  data <= "11001010";  -- 61EE = CA
      when "0000111101111" =>  data <= "10110101";  -- 61EF = B5
      when "0000111110000" =>  data <= "11011111";  -- 61F0 = DF
      when "0000111110001" =>  data <= "10100000";  -- 61F1 = A0
      when "0000111110010" =>  data <= "01001111";  -- 61F2 = 4F
      when "0000111110011" =>  data <= "11001010";  -- 61F3 = CA
      when "0000111110100" =>  data <= "10000110";  -- 61F4 = 86
      when "0000111110101" =>  data <= "11011000";  -- 61F5 = D8
      when "0000111110110" =>  data <= "10000101";  -- 61F6 = 85
      when "0000111110111" =>  data <= "11000101";  -- 61F7 = C5
      when "0000111111000" =>  data <= "10111101";  -- 61F8 = BD
      when "0000111111001" =>  data <= "10011000";  -- 61F9 = 98
      when "0000111111010" =>  data <= "11100111";  -- 61FA = E7
      when "0000111111011" =>  data <= "10000101";  -- 61FB = 85
      when "0000111111100" =>  data <= "11000100";  -- 61FC = C4
      when "0000111111101" =>  data <= "10000100";  -- 61FD = 84
      when "0000111111110" =>  data <= "11000110";  -- 61FE = C6
      when "0000111111111" =>  data <= "10000100";  -- 61FF = 84
      when "0001000000000" =>  data <= "11010101";  -- 6200 = D5
      when "0001000000001" =>  data <= "01100000";  -- 6201 = 60
      when "0001000000010" =>  data <= "01001000";  -- 6202 = 48
      when "0001000000011" =>  data <= "10000101";  -- 6203 = 85
      when "0001000000100" =>  data <= "11011001";  -- 6204 = D9
      when "0001000000101" =>  data <= "10001010";  -- 6205 = 8A
      when "0001000000110" =>  data <= "01001000";  -- 6206 = 48
      when "0001000000111" =>  data <= "10011000";  -- 6207 = 98
      when "0001000001000" =>  data <= "01001000";  -- 6208 = 48
      when "0001000001001" =>  data <= "10101001";  -- 6209 = A9
      when "0001000001010" =>  data <= "00000000";  -- 620A = 0
      when "0001000001011" =>  data <= "10000101";  -- 620B = 85
      when "0001000001100" =>  data <= "10101100";  -- 620C = AC
      when "0001000001101" =>  data <= "10100100";  -- 620D = A4
      when "0001000001110" =>  data <= "11000110";  -- 620E = C6
      when "0001000001111" =>  data <= "10100101";  -- 620F = A5
      when "0001000010000" =>  data <= "11011001";  -- 6210 = D9
      when "0001000010001" =>  data <= "00101001";  -- 6211 = 29
      when "0001000010010" =>  data <= "01111111";  -- 6212 = 7F
      when "0001000010011" =>  data <= "11001001";  -- 6213 = C9
      when "0001000010100" =>  data <= "00011011";  -- 6214 = 1B
      when "0001000010101" =>  data <= "11010000";  -- 6215 = D0
      when "0001000010110" =>  data <= "00000011";  -- 6216 = 3
      when "0001000010111" =>  data <= "01001100";  -- 6217 = 4C
      when "0001000011000" =>  data <= "11000110";  -- 6218 = C6
      when "0001000011001" =>  data <= "11100011";  -- 6219 = E3
      when "0001000011010" =>  data <= "10100101";  -- 621A = A5
      when "0001000011011" =>  data <= "11011001";  -- 621B = D9
      when "0001000011100" =>  data <= "00010000";  -- 621C = 10
      when "0001000011101" =>  data <= "00000011";  -- 621D = 3
      when "0001000011110" =>  data <= "01001100";  -- 621E = 4C
      when "0001000011111" =>  data <= "11010101";  -- 621F = D5
      when "0001000100000" =>  data <= "11100010";  -- 6220 = E2
      when "0001000100001" =>  data <= "11001001";  -- 6221 = C9
      when "0001000100010" =>  data <= "00001101";  -- 6222 = D
      when "0001000100011" =>  data <= "11010000";  -- 6223 = D0
      when "0001000100100" =>  data <= "00000011";  -- 6224 = 3
      when "0001000100101" =>  data <= "01001100";  -- 6225 = 4C
      when "0001000100110" =>  data <= "10111111";  -- 6226 = BF
      when "0001000100111" =>  data <= "11100011";  -- 6227 = E3
      when "0001000101000" =>  data <= "11001001";  -- 6228 = C9
      when "0001000101001" =>  data <= "00100000";  -- 6229 = 20
      when "0001000101010" =>  data <= "10010000";  -- 622A = 90
      when "0001000101011" =>  data <= "00001000";  -- 622B = 8
      when "0001000101100" =>  data <= "00101001";  -- 622C = 29
      when "0001000101101" =>  data <= "00111111";  -- 622D = 3F
      when "0001000101110" =>  data <= "00100000";  -- 622E = 20
      when "0001000101111" =>  data <= "01100111";  -- 622F = 67
      when "0001000110000" =>  data <= "11100001";  -- 6230 = E1
      when "0001000110001" =>  data <= "01001100";  -- 6231 = 4C
      when "0001000110010" =>  data <= "01110110";  -- 6232 = 76
      when "0001000110011" =>  data <= "11100001";  -- 6233 = E1
      when "0001000110100" =>  data <= "10100110";  -- 6234 = A6
      when "0001000110101" =>  data <= "11011100";  -- 6235 = DC
      when "0001000110110" =>  data <= "11110000";  -- 6236 = F0
      when "0001000110111" =>  data <= "00000011";  -- 6237 = 3
      when "0001000111000" =>  data <= "01001100";  -- 6238 = 4C
      when "0001000111001" =>  data <= "01111010";  -- 6239 = 7A
      when "0001000111010" =>  data <= "11100001";  -- 623A = E1
      when "0001000111011" =>  data <= "11001001";  -- 623B = C9
      when "0001000111100" =>  data <= "00010100";  -- 623C = 14
      when "0001000111101" =>  data <= "11010000";  -- 623D = D0
      when "0001000111110" =>  data <= "00011100";  -- 623E = 1C
      when "0001000111111" =>  data <= "10001000";  -- 623F = 88
      when "0001001000000" =>  data <= "10000100";  -- 6240 = 84
      when "0001001000001" =>  data <= "11000110";  -- 6241 = C6
      when "0001001000010" =>  data <= "00010000";  -- 6242 = 10
      when "0001001000011" =>  data <= "00000110";  -- 6243 = 6
      when "0001001000100" =>  data <= "00100000";  -- 6244 = 20
      when "0001001000101" =>  data <= "11011110";  -- 6245 = DE
      when "0001001000110" =>  data <= "11100001";  -- 6246 = E1
      when "0001001000111" =>  data <= "01001100";  -- 6247 = 4C
      when "0001001001000" =>  data <= "01010101";  -- 6248 = 55
      when "0001001001001" =>  data <= "11100010";  -- 6249 = E2
      when "0001001001010" =>  data <= "11001000";  -- 624A = C8
      when "0001001001011" =>  data <= "10110001";  -- 624B = B1
      when "0001001001100" =>  data <= "11000100";  -- 624C = C4
      when "0001001001101" =>  data <= "10001000";  -- 624D = 88
      when "0001001001110" =>  data <= "10010001";  -- 624E = 91
      when "0001001001111" =>  data <= "11000100";  -- 624F = C4
      when "0001001010000" =>  data <= "11001000";  -- 6250 = C8
      when "0001001010001" =>  data <= "11000100";  -- 6251 = C4
      when "0001001010010" =>  data <= "11010101";  -- 6252 = D5
      when "0001001010011" =>  data <= "11010000";  -- 6253 = D0
      when "0001001010100" =>  data <= "11110101";  -- 6254 = F5
      when "0001001010101" =>  data <= "10101001";  -- 6255 = A9
      when "0001001010110" =>  data <= "00100000";  -- 6256 = 20
      when "0001001010111" =>  data <= "10010001";  -- 6257 = 91
      when "0001001011000" =>  data <= "11000100";  -- 6258 = C4
      when "0001001011001" =>  data <= "11010000";  -- 6259 = D0
      when "0001001011010" =>  data <= "00101001";  -- 625A = 29
      when "0001001011011" =>  data <= "10100110";  -- 625B = A6
      when "0001001011100" =>  data <= "11001101";  -- 625C = CD
      when "0001001011101" =>  data <= "11110000";  -- 625D = F0
      when "0001001011110" =>  data <= "00000011";  -- 625E = 3
      when "0001001011111" =>  data <= "01001100";  -- 625F = 4C
      when "0001001100000" =>  data <= "01111010";  -- 6260 = 7A
      when "0001001100001" =>  data <= "11100001";  -- 6261 = E1
      when "0001001100010" =>  data <= "11001001";  -- 6262 = C9
      when "0001001100011" =>  data <= "00010010";  -- 6263 = 12
      when "0001001100100" =>  data <= "11010000";  -- 6264 = D0
      when "0001001100101" =>  data <= "00000100";  -- 6265 = 4
      when "0001001100110" =>  data <= "10000101";  -- 6266 = 85
      when "0001001100111" =>  data <= "10011111";  -- 6267 = 9F
      when "0001001101000" =>  data <= "11110000";  -- 6268 = F0
      when "0001001101001" =>  data <= "00011010";  -- 6269 = 1A
      when "0001001101010" =>  data <= "11001001";  -- 626A = C9
      when "0001001101011" =>  data <= "00010011";  -- 626B = 13
      when "0001001101100" =>  data <= "11010000";  -- 626C = D0
      when "0001001101101" =>  data <= "00000011";  -- 626D = 3
      when "0001001101110" =>  data <= "00100000";  -- 626E = 20
      when "0001001101111" =>  data <= "01101011";  -- 626F = 6B
      when "0001001110000" =>  data <= "11100000";  -- 6270 = E0
      when "0001001110001" =>  data <= "11001001";  -- 6271 = C9
      when "0001001110010" =>  data <= "00011101";  -- 6272 = 1D
      when "0001001110011" =>  data <= "11010000";  -- 6273 = D0
      when "0001001110100" =>  data <= "00010010";  -- 6274 = 12
      when "0001001110101" =>  data <= "11001000";  -- 6275 = C8
      when "0001001110110" =>  data <= "10000100";  -- 6276 = 84
      when "0001001110111" =>  data <= "11000110";  -- 6277 = C6
      when "0001001111000" =>  data <= "10001000";  -- 6278 = 88
      when "0001001111001" =>  data <= "11000100";  -- 6279 = C4
      when "0001001111010" =>  data <= "11010101";  -- 627A = D5
      when "0001001111011" =>  data <= "10010000";  -- 627B = 90
      when "0001001111100" =>  data <= "00000111";  -- 627C = 7
      when "0001001111101" =>  data <= "00100000";  -- 627D = 20
      when "0001001111110" =>  data <= "10101001";  -- 627E = A9
      when "0001001111111" =>  data <= "11100011";  -- 627F = E3
      when "0001010000000" =>  data <= "10100000";  -- 6280 = A0
      when "0001010000001" =>  data <= "00000000";  -- 6281 = 0
      when "0001010000010" =>  data <= "10000100";  -- 6282 = 84
      when "0001010000011" =>  data <= "11000110";  -- 6283 = C6
      when "0001010000100" =>  data <= "01001100";  -- 6284 = 4C
      when "0001010000101" =>  data <= "10100110";  -- 6285 = A6
      when "0001010000110" =>  data <= "11100001";  -- 6286 = E1
      when "0001010000111" =>  data <= "11001001";  -- 6287 = C9
      when "0001010001000" =>  data <= "00010001";  -- 6288 = 11
      when "0001010001001" =>  data <= "11010000";  -- 6289 = D0
      when "0001010001010" =>  data <= "00010001";  -- 628A = 11
      when "0001010001011" =>  data <= "00011000";  -- 628B = 18
      when "0001010001100" =>  data <= "10011000";  -- 628C = 98
      when "0001010001101" =>  data <= "01101001";  -- 628D = 69
      when "0001010001110" =>  data <= "00101000";  -- 628E = 28
      when "0001010001111" =>  data <= "10101000";  -- 628F = A8
      when "0001010010000" =>  data <= "11000101";  -- 6290 = C5
      when "0001010010001" =>  data <= "11010101";  -- 6291 = D5
      when "0001010010010" =>  data <= "10010000";  -- 6292 = 90
      when "0001010010011" =>  data <= "11101110";  -- 6293 = EE
      when "0001010010100" =>  data <= "11110000";  -- 6294 = F0
      when "0001010010101" =>  data <= "11101100";  -- 6295 = EC
      when "0001010010110" =>  data <= "00100000";  -- 6296 = 20
      when "0001010010111" =>  data <= "10101001";  -- 6297 = A9
      when "0001010011000" =>  data <= "11100011";  -- 6298 = E3
      when "0001010011001" =>  data <= "01001100";  -- 6299 = 4C
      when "0001010011010" =>  data <= "10100110";  -- 629A = A6
      when "0001010011011" =>  data <= "11100001";  -- 629B = E1
      when "0001010011100" =>  data <= "11001001";  -- 629C = C9
      when "0001010011101" =>  data <= "00010000";  -- 629D = 10
      when "0001010011110" =>  data <= "11010000";  -- 629E = D0
      when "0001010011111" =>  data <= "00001100";  -- 629F = C
      when "0001010100000" =>  data <= "10101001";  -- 62A0 = A9
      when "0001010100001" =>  data <= "00100000";  -- 62A1 = 20
      when "0001010100010" =>  data <= "10001000";  -- 62A2 = 88
      when "0001010100011" =>  data <= "11001000";  -- 62A3 = C8
      when "0001010100100" =>  data <= "10010001";  -- 62A4 = 91
      when "0001010100101" =>  data <= "11000100";  -- 62A5 = C4
      when "0001010100110" =>  data <= "11000100";  -- 62A6 = C4
      when "0001010100111" =>  data <= "11010101";  -- 62A7 = D5
      when "0001010101000" =>  data <= "10010000";  -- 62A8 = 90
      when "0001010101001" =>  data <= "11111001";  -- 62A9 = F9
      when "0001010101010" =>  data <= "10110000";  -- 62AA = B0
      when "0001010101011" =>  data <= "11101101";  -- 62AB = ED
      when "0001010101100" =>  data <= "11001001";  -- 62AC = C9
      when "0001010101101" =>  data <= "00001110";  -- 62AD = E
      when "0001010101110" =>  data <= "11010000";  -- 62AE = D0
      when "0001010101111" =>  data <= "00000101";  -- 62AF = 5
      when "0001010110000" =>  data <= "00100000";  -- 62B0 = 20
      when "0001010110001" =>  data <= "00001111";  -- 62B1 = F
      when "0001010110010" =>  data <= "11100110";  -- 62B2 = E6
      when "0001010110011" =>  data <= "00110000";  -- 62B3 = 30
      when "0001010110100" =>  data <= "11100100";  -- 62B4 = E4
      when "0001010110101" =>  data <= "11001001";  -- 62B5 = C9
      when "0001010110110" =>  data <= "00000111";  -- 62B6 = 7
      when "0001010110111" =>  data <= "11010000";  -- 62B7 = D0
      when "0001010111000" =>  data <= "00000101";  -- 62B8 = 5
      when "0001010111001" =>  data <= "00100000";  -- 62B9 = 20
      when "0001010111010" =>  data <= "01010111";  -- 62BA = 57
      when "0001010111011" =>  data <= "11100110";  -- 62BB = E6
      when "0001010111100" =>  data <= "11110000";  -- 62BC = F0
      when "0001010111101" =>  data <= "11011011";  -- 62BD = DB
      when "0001010111110" =>  data <= "11001001";  -- 62BE = C9
      when "0001010111111" =>  data <= "00001001";  -- 62BF = 9
      when "0001011000000" =>  data <= "11010000";  -- 62C0 = D0
      when "0001011000001" =>  data <= "11010111";  -- 62C1 = D7
      when "0001011000010" =>  data <= "11000100";  -- 62C2 = C4
      when "0001011000011" =>  data <= "11010101";  -- 62C3 = D5
      when "0001011000100" =>  data <= "10010000";  -- 62C4 = 90
      when "0001011000101" =>  data <= "00000111";  -- 62C5 = 7
      when "0001011000110" =>  data <= "10100100";  -- 62C6 = A4
      when "0001011000111" =>  data <= "11010101";  -- 62C7 = D5
      when "0001011001000" =>  data <= "10000100";  -- 62C8 = 84
      when "0001011001001" =>  data <= "11000110";  -- 62C9 = C6
      when "0001011001010" =>  data <= "01001100";  -- 62CA = 4C
      when "0001011001011" =>  data <= "10100110";  -- 62CB = A6
      when "0001011001100" =>  data <= "11100001";  -- 62CC = E1
      when "0001011001101" =>  data <= "11001000";  -- 62CD = C8
      when "0001011001110" =>  data <= "00100000";  -- 62CE = 20
      when "0001011001111" =>  data <= "10001000";  -- 62CF = 88
      when "0001011010000" =>  data <= "11100101";  -- 62D0 = E5
      when "0001011010001" =>  data <= "11110000";  -- 62D1 = F0
      when "0001011010010" =>  data <= "11101111";  -- 62D2 = EF
      when "0001011010011" =>  data <= "11010000";  -- 62D3 = D0
      when "0001011010100" =>  data <= "11110011";  -- 62D4 = F3
      when "0001011010101" =>  data <= "00101001";  -- 62D5 = 29
      when "0001011010110" =>  data <= "01111111";  -- 62D6 = 7F
      when "0001011010111" =>  data <= "11001001";  -- 62D7 = C9
      when "0001011011000" =>  data <= "01111111";  -- 62D8 = 7F
      when "0001011011001" =>  data <= "11010000";  -- 62D9 = D0
      when "0001011011010" =>  data <= "00000010";  -- 62DA = 2
      when "0001011011011" =>  data <= "10101001";  -- 62DB = A9
      when "0001011011100" =>  data <= "01011110";  -- 62DC = 5E
      when "0001011011101" =>  data <= "11001001";  -- 62DD = C9
      when "0001011011110" =>  data <= "00100000";  -- 62DE = 20
      when "0001011011111" =>  data <= "10010000";  -- 62DF = 90
      when "0001011100000" =>  data <= "00000011";  -- 62E0 = 3
      when "0001011100001" =>  data <= "01001100";  -- 62E1 = 4C
      when "0001011100010" =>  data <= "01110100";  -- 62E2 = 74
      when "0001011100011" =>  data <= "11100001";  -- 62E3 = E1
      when "0001011100100" =>  data <= "11001001";  -- 62E4 = C9
      when "0001011100101" =>  data <= "00001101";  -- 62E5 = D
      when "0001011100110" =>  data <= "11010000";  -- 62E6 = D0
      when "0001011100111" =>  data <= "00000011";  -- 62E7 = 3
      when "0001011101000" =>  data <= "01001100";  -- 62E8 = 4C
      when "0001011101001" =>  data <= "10111111";  -- 62E9 = BF
      when "0001011101010" =>  data <= "11100011";  -- 62EA = E3
      when "0001011101011" =>  data <= "10100110";  -- 62EB = A6
      when "0001011101100" =>  data <= "11001101";  -- 62EC = CD
      when "0001011101101" =>  data <= "11010000";  -- 62ED = D0
      when "0001011101110" =>  data <= "00110000";  -- 62EE = 30
      when "0001011101111" =>  data <= "11001001";  -- 62EF = C9
      when "0001011110000" =>  data <= "00010100";  -- 62F0 = 14
      when "0001011110001" =>  data <= "11010000";  -- 62F1 = D0
      when "0001011110010" =>  data <= "00101000";  -- 62F2 = 28
      when "0001011110011" =>  data <= "10100100";  -- 62F3 = A4
      when "0001011110100" =>  data <= "11010101";  -- 62F4 = D5
      when "0001011110101" =>  data <= "10110001";  -- 62F5 = B1
      when "0001011110110" =>  data <= "11000100";  -- 62F6 = C4
      when "0001011110111" =>  data <= "11001001";  -- 62F7 = C9
      when "0001011111000" =>  data <= "00100000";  -- 62F8 = 20
      when "0001011111001" =>  data <= "11010000";  -- 62F9 = D0
      when "0001011111010" =>  data <= "00000100";  -- 62FA = 4
      when "0001011111011" =>  data <= "11000100";  -- 62FB = C4
      when "0001011111100" =>  data <= "11000110";  -- 62FC = C6
      when "0001011111101" =>  data <= "11010000";  -- 62FD = D0
      when "0001011111110" =>  data <= "00000111";  -- 62FE = 7
      when "0001011111111" =>  data <= "11000000";  -- 62FF = C0
      when "0001100000000" =>  data <= "01001111";  -- 6300 = 4F
      when "0001100000001" =>  data <= "11110000";  -- 6301 = F0
      when "0001100000010" =>  data <= "10000001";  -- 6302 = 81
      when "0001100000011" =>  data <= "00100000";  -- 6303 = 20
      when "0001100000100" =>  data <= "11101010";  -- 6304 = EA
      when "0001100000101" =>  data <= "11100110";  -- 6305 = E6
      when "0001100000110" =>  data <= "10100100";  -- 6306 = A4
      when "0001100000111" =>  data <= "11010101";  -- 6307 = D5
      when "0001100001000" =>  data <= "10001000";  -- 6308 = 88
      when "0001100001001" =>  data <= "10110001";  -- 6309 = B1
      when "0001100001010" =>  data <= "11000100";  -- 630A = C4
      when "0001100001011" =>  data <= "11001000";  -- 630B = C8
      when "0001100001100" =>  data <= "10010001";  -- 630C = 91
      when "0001100001101" =>  data <= "11000100";  -- 630D = C4
      when "0001100001110" =>  data <= "10001000";  -- 630E = 88
      when "0001100001111" =>  data <= "11000100";  -- 630F = C4
      when "0001100010000" =>  data <= "11000110";  -- 6310 = C6
      when "0001100010001" =>  data <= "11010000";  -- 6311 = D0
      when "0001100010010" =>  data <= "11110101";  -- 6312 = F5
      when "0001100010011" =>  data <= "10101001";  -- 6313 = A9
      when "0001100010100" =>  data <= "00100000";  -- 6314 = 20
      when "0001100010101" =>  data <= "10010001";  -- 6315 = 91
      when "0001100010110" =>  data <= "11000100";  -- 6316 = C4
      when "0001100010111" =>  data <= "11100110";  -- 6317 = E6
      when "0001100011000" =>  data <= "11011100";  -- 6318 = DC
      when "0001100011001" =>  data <= "11010000";  -- 6319 = D0
      when "0001100011010" =>  data <= "01011000";  -- 631A = 58
      when "0001100011011" =>  data <= "10100110";  -- 631B = A6
      when "0001100011100" =>  data <= "11011100";  -- 631C = DC
      when "0001100011101" =>  data <= "11110000";  -- 631D = F0
      when "0001100011110" =>  data <= "00000101";  -- 631E = 5
      when "0001100011111" =>  data <= "00001001";  -- 631F = 9
      when "0001100100000" =>  data <= "01000000";  -- 6320 = 40
      when "0001100100001" =>  data <= "01001100";  -- 6321 = 4C
      when "0001100100010" =>  data <= "01111010";  -- 6322 = 7A
      when "0001100100011" =>  data <= "11100001";  -- 6323 = E1
      when "0001100100100" =>  data <= "11001001";  -- 6324 = C9
      when "0001100100101" =>  data <= "00010001";  -- 6325 = 11
      when "0001100100110" =>  data <= "11010000";  -- 6326 = D0
      when "0001100100111" =>  data <= "00101011";  -- 6327 = 2B
      when "0001100101000" =>  data <= "10100101";  -- 6328 = A5
      when "0001100101001" =>  data <= "11000110";  -- 6329 = C6
      when "0001100101010" =>  data <= "11001001";  -- 632A = C9
      when "0001100101011" =>  data <= "00101000";  -- 632B = 28
      when "0001100101100" =>  data <= "10010000";  -- 632C = 90
      when "0001100101101" =>  data <= "00000110";  -- 632D = 6
      when "0001100101110" =>  data <= "11101001";  -- 632E = E9
      when "0001100101111" =>  data <= "00101000";  -- 632F = 28
      when "0001100110000" =>  data <= "10000101";  -- 6330 = 85
      when "0001100110001" =>  data <= "11000110";  -- 6331 = C6
      when "0001100110010" =>  data <= "10110000";  -- 6332 = B0
      when "0001100110011" =>  data <= "00111111";  -- 6333 = 3F
      when "0001100110100" =>  data <= "10100110";  -- 6334 = A6
      when "0001100110101" =>  data <= "11011000";  -- 6335 = D8
      when "0001100110110" =>  data <= "11110000";  -- 6336 = F0
      when "0001100110111" =>  data <= "00111011";  -- 6337 = 3B
      when "0001100111000" =>  data <= "10110101";  -- 6338 = B5
      when "0001100111001" =>  data <= "11011111";  -- 6339 = DF
      when "0001100111010" =>  data <= "00010000";  -- 633A = 10
      when "0001100111011" =>  data <= "00000111";  -- 633B = 7
      when "0001100111100" =>  data <= "11000110";  -- 633C = C6
      when "0001100111101" =>  data <= "11011000";  -- 633D = D8
      when "0001100111110" =>  data <= "00100000";  -- 633E = 20
      when "0001100111111" =>  data <= "01110001";  -- 633F = 71
      when "0001101000000" =>  data <= "11100000";  -- 6340 = E0
      when "0001101000001" =>  data <= "10010000";  -- 6341 = 90
      when "0001101000010" =>  data <= "00110000";  -- 6342 = 30
      when "0001101000011" =>  data <= "11001010";  -- 6343 = CA
      when "0001101000100" =>  data <= "11001010";  -- 6344 = CA
      when "0001101000101" =>  data <= "10000110";  -- 6345 = 86
      when "0001101000110" =>  data <= "11011000";  -- 6346 = D8
      when "0001101000111" =>  data <= "00100000";  -- 6347 = 20
      when "0001101001000" =>  data <= "01110001";  -- 6348 = 71
      when "0001101001001" =>  data <= "11100000";  -- 6349 = E0
      when "0001101001010" =>  data <= "10100101";  -- 634A = A5
      when "0001101001011" =>  data <= "11000110";  -- 634B = C6
      when "0001101001100" =>  data <= "00011000";  -- 634C = 18
      when "0001101001101" =>  data <= "01101001";  -- 634D = 69
      when "0001101001110" =>  data <= "00101000";  -- 634E = 28
      when "0001101001111" =>  data <= "10000101";  -- 634F = 85
      when "0001101010000" =>  data <= "11000110";  -- 6350 = C6
      when "0001101010001" =>  data <= "11010000";  -- 6351 = D0
      when "0001101010010" =>  data <= "00100000";  -- 6352 = 20
      when "0001101010011" =>  data <= "11001001";  -- 6353 = C9
      when "0001101010100" =>  data <= "00010010";  -- 6354 = 12
      when "0001101010101" =>  data <= "11010000";  -- 6355 = D0
      when "0001101010110" =>  data <= "00000110";  -- 6356 = 6
      when "0001101010111" =>  data <= "10101001";  -- 6357 = A9
      when "0001101011000" =>  data <= "00000000";  -- 6358 = 0
      when "0001101011001" =>  data <= "10000101";  -- 6359 = 85
      when "0001101011010" =>  data <= "10011111";  -- 635A = 9F
      when "0001101011011" =>  data <= "11110000";  -- 635B = F0
      when "0001101011100" =>  data <= "00010110";  -- 635C = 16
      when "0001101011101" =>  data <= "11001001";  -- 635D = C9
      when "0001101011110" =>  data <= "00011101";  -- 635E = 1D
      when "0001101011111" =>  data <= "11010000";  -- 635F = D0
      when "0001101100000" =>  data <= "00001011";  -- 6360 = B
      when "0001101100001" =>  data <= "10001000";  -- 6361 = 88
      when "0001101100010" =>  data <= "10000100";  -- 6362 = 84
      when "0001101100011" =>  data <= "11000110";  -- 6363 = C6
      when "0001101100100" =>  data <= "00010000";  -- 6364 = 10
      when "0001101100101" =>  data <= "00001101";  -- 6365 = D
      when "0001101100110" =>  data <= "00100000";  -- 6366 = 20
      when "0001101100111" =>  data <= "11011110";  -- 6367 = DE
      when "0001101101000" =>  data <= "11100001";  -- 6368 = E1
      when "0001101101001" =>  data <= "01001100";  -- 6369 = 4C
      when "0001101101010" =>  data <= "10100110";  -- 636A = A6
      when "0001101101011" =>  data <= "11100001";  -- 636B = E1
      when "0001101101100" =>  data <= "11001001";  -- 636C = C9
      when "0001101101101" =>  data <= "00010011";  -- 636D = 13
      when "0001101101110" =>  data <= "11010000";  -- 636E = D0
      when "0001101101111" =>  data <= "00000110";  -- 636F = 6
      when "0001101110000" =>  data <= "00100000";  -- 6370 = 20
      when "0001101110001" =>  data <= "01000010";  -- 6371 = 42
      when "0001101110010" =>  data <= "11100000";  -- 6372 = E0
      when "0001101110011" =>  data <= "01001100";  -- 6373 = 4C
      when "0001101110100" =>  data <= "10100110";  -- 6374 = A6
      when "0001101110101" =>  data <= "11100001";  -- 6375 = E1
      when "0001101110110" =>  data <= "11001001";  -- 6376 = C9
      when "0001101110111" =>  data <= "00010110";  -- 6377 = 16
      when "0001101111000" =>  data <= "11010000";  -- 6378 = D0
      when "0001101111001" =>  data <= "00001101";  -- 6379 = D
      when "0001101111010" =>  data <= "10101001";  -- 637A = A9
      when "0001101111011" =>  data <= "00100000";  -- 637B = 20
      when "0001101111100" =>  data <= "10100000";  -- 637C = A0
      when "0001101111101" =>  data <= "00000000";  -- 637D = 0
      when "0001101111110" =>  data <= "11000100";  -- 637E = C4
      when "0001101111111" =>  data <= "11000110";  -- 637F = C6
      when "0001110000000" =>  data <= "10110000";  -- 6380 = B0
      when "0001110000001" =>  data <= "11110001";  -- 6381 = F1
      when "0001110000010" =>  data <= "10010001";  -- 6382 = 91
      when "0001110000011" =>  data <= "11000100";  -- 6383 = C4
      when "0001110000100" =>  data <= "11001000";  -- 6384 = C8
      when "0001110000101" =>  data <= "11010000";  -- 6385 = D0
      when "0001110000110" =>  data <= "11110111";  -- 6386 = F7
      when "0001110000111" =>  data <= "11001001";  -- 6387 = C9
      when "0001110001000" =>  data <= "00001110";  -- 6388 = E
      when "0001110001001" =>  data <= "11010000";  -- 6389 = D0
      when "0001110001010" =>  data <= "00000101";  -- 638A = 5
      when "0001110001011" =>  data <= "00100000";  -- 638B = 20
      when "0001110001100" =>  data <= "00010111";  -- 638C = 17
      when "0001110001101" =>  data <= "11100110";  -- 638D = E6
      when "0001110001110" =>  data <= "00110000";  -- 638E = 30
      when "0001110001111" =>  data <= "11100011";  -- 638F = E3
      when "0001110010000" =>  data <= "11001001";  -- 6390 = C9
      when "0001110010001" =>  data <= "00000111";  -- 6391 = 7
      when "0001110010010" =>  data <= "11010000";  -- 6392 = D0
      when "0001110010011" =>  data <= "00000101";  -- 6393 = 5
      when "0001110010100" =>  data <= "00100000";  -- 6394 = 20
      when "0001110010101" =>  data <= "01010100";  -- 6395 = 54
      when "0001110010110" =>  data <= "11100110";  -- 6396 = E6
      when "0001110010111" =>  data <= "11110000";  -- 6397 = F0
      when "0001110011000" =>  data <= "11011010";  -- 6398 = DA
      when "0001110011001" =>  data <= "11001001";  -- 6399 = C9
      when "0001110011010" =>  data <= "00001001";  -- 639A = 9
      when "0001110011011" =>  data <= "11010000";  -- 639B = D0
      when "0001110011100" =>  data <= "11010110";  -- 639C = D6
      when "0001110011101" =>  data <= "00100000";  -- 639D = 20
      when "0001110011110" =>  data <= "10001000";  -- 639E = 88
      when "0001110011111" =>  data <= "11100101";  -- 639F = E5
      when "0001110100000" =>  data <= "01001101";  -- 63A0 = 4D
      when "0001110100001" =>  data <= "11101111";  -- 63A1 = EF
      when "0001110100010" =>  data <= "00000011";  -- 63A2 = 3
      when "0001110100011" =>  data <= "10011101";  -- 63A3 = 9D
      when "0001110100100" =>  data <= "11110000";  -- 63A4 = F0
      when "0001110100101" =>  data <= "00000011";  -- 63A5 = 3
      when "0001110100110" =>  data <= "01001100";  -- 63A6 = 4C
      when "0001110100111" =>  data <= "10100110";  -- 63A7 = A6
      when "0001110101000" =>  data <= "11100001";  -- 63A8 = E1
      when "0001110101001" =>  data <= "00111000";  -- 63A9 = 38
      when "0001110101010" =>  data <= "01000110";  -- 63AA = 46
      when "0001110101011" =>  data <= "10100011";  -- 63AB = A3
      when "0001110101100" =>  data <= "10100110";  -- 63AC = A6
      when "0001110101101" =>  data <= "11011000";  -- 63AD = D8
      when "0001110101110" =>  data <= "11101000";  -- 63AE = E8
      when "0001110101111" =>  data <= "11100000";  -- 63AF = E0
      when "0001110110000" =>  data <= "00011001";  -- 63B0 = 19
      when "0001110110001" =>  data <= "11010000";  -- 63B1 = D0
      when "0001110110010" =>  data <= "00000011";  -- 63B2 = 3
      when "0001110110011" =>  data <= "00100000";  -- 63B3 = 20
      when "0001110110100" =>  data <= "11010001";  -- 63B4 = D1
      when "0001110110101" =>  data <= "11100011";  -- 63B5 = E3
      when "0001110110110" =>  data <= "10110101";  -- 63B6 = B5
      when "0001110110111" =>  data <= "11100000";  -- 63B7 = E0
      when "0001110111000" =>  data <= "00010000";  -- 63B8 = 10
      when "0001110111001" =>  data <= "11110100";  -- 63B9 = F4
      when "0001110111010" =>  data <= "10000110";  -- 63BA = 86
      when "0001110111011" =>  data <= "11011000";  -- 63BB = D8
      when "0001110111100" =>  data <= "01001100";  -- 63BC = 4C
      when "0001110111101" =>  data <= "01110001";  -- 63BD = 71
      when "0001110111110" =>  data <= "11100000";  -- 63BE = E0
      when "0001110111111" =>  data <= "00100000";  -- 63BF = 20
      when "0001111000000" =>  data <= "10101001";  -- 63C0 = A9
      when "0001111000001" =>  data <= "11100011";  -- 63C1 = E3
      when "0001111000010" =>  data <= "10101001";  -- 63C2 = A9
      when "0001111000011" =>  data <= "00000000";  -- 63C3 = 0
      when "0001111000100" =>  data <= "10000101";  -- 63C4 = 85
      when "0001111000101" =>  data <= "11000110";  -- 63C5 = C6
      when "0001111000110" =>  data <= "10101001";  -- 63C6 = A9
      when "0001111000111" =>  data <= "00000000";  -- 63C7 = 0
      when "0001111001000" =>  data <= "10000101";  -- 63C8 = 85
      when "0001111001001" =>  data <= "11011100";  -- 63C9 = DC
      when "0001111001010" =>  data <= "10000101";  -- 63CA = 85
      when "0001111001011" =>  data <= "10011111";  -- 63CB = 9F
      when "0001111001100" =>  data <= "10000101";  -- 63CC = 85
      when "0001111001101" =>  data <= "11001101";  -- 63CD = CD
      when "0001111001110" =>  data <= "01001100";  -- 63CE = 4C
      when "0001111001111" =>  data <= "10100110";  -- 63CF = A6
      when "0001111010000" =>  data <= "11100001";  -- 63D0 = E1
      when "0001111010001" =>  data <= "10100010";  -- 63D1 = A2
      when "0001111010010" =>  data <= "00011001";  -- 63D2 = 19
      when "0001111010011" =>  data <= "10000110";  -- 63D3 = 86
      when "0001111010100" =>  data <= "11011000";  -- 63D4 = D8
      when "0001111010101" =>  data <= "10100010";  -- 63D5 = A2
      when "0001111010110" =>  data <= "11111111";  -- 63D6 = FF
      when "0001111010111" =>  data <= "11101000";  -- 63D7 = E8
      when "0001111011000" =>  data <= "10111101";  -- 63D8 = BD
      when "0001111011001" =>  data <= "10011000";  -- 63D9 = 98
      when "0001111011010" =>  data <= "11100111";  -- 63DA = E7
      when "0001111011011" =>  data <= "10000101";  -- 63DB = 85
      when "0001111011100" =>  data <= "11000100";  -- 63DC = C4
      when "0001111011101" =>  data <= "10110101";  -- 63DD = B5
      when "0001111011110" =>  data <= "11100000";  -- 63DE = E0
      when "0001111011111" =>  data <= "00001001";  -- 63DF = 9
      when "0001111100000" =>  data <= "10000000";  -- 63E0 = 80
      when "0001111100001" =>  data <= "10000101";  -- 63E1 = 85
      when "0001111100010" =>  data <= "11000101";  -- 63E2 = C5
      when "0001111100011" =>  data <= "11100000";  -- 63E3 = E0
      when "0001111100100" =>  data <= "00011000";  -- 63E4 = 18
      when "0001111100101" =>  data <= "10110000";  -- 63E5 = B0
      when "0001111100110" =>  data <= "00011101";  -- 63E6 = 1D
      when "0001111100111" =>  data <= "10110100";  -- 63E7 = B4
      when "0001111101000" =>  data <= "11100001";  -- 63E8 = E1
      when "0001111101001" =>  data <= "00110000";  -- 63E9 = 30
      when "0001111101010" =>  data <= "00000010";  -- 63EA = 2
      when "0001111101011" =>  data <= "00101001";  -- 63EB = 29
      when "0001111101100" =>  data <= "01111111";  -- 63EC = 7F
      when "0001111101101" =>  data <= "10010101";  -- 63ED = 95
      when "0001111101110" =>  data <= "11100000";  -- 63EE = E0
      when "0001111101111" =>  data <= "10011000";  -- 63EF = 98
      when "0001111110000" =>  data <= "00001001";  -- 63F0 = 9
      when "0001111110001" =>  data <= "10000000";  -- 63F1 = 80
      when "0001111110010" =>  data <= "10000101";  -- 63F2 = 85
      when "0001111110011" =>  data <= "11001000";  -- 63F3 = C8
      when "0001111110100" =>  data <= "10111101";  -- 63F4 = BD
      when "0001111110101" =>  data <= "10011001";  -- 63F5 = 99
      when "0001111110110" =>  data <= "11100111";  -- 63F6 = E7
      when "0001111110111" =>  data <= "10000101";  -- 63F7 = 85
      when "0001111111000" =>  data <= "11000111";  -- 63F8 = C7
      when "0001111111001" =>  data <= "10100000";  -- 63F9 = A0
      when "0001111111010" =>  data <= "00100111";  -- 63FA = 27
      when "0001111111011" =>  data <= "10110001";  -- 63FB = B1
      when "0001111111100" =>  data <= "11000111";  -- 63FC = C7
      when "0001111111101" =>  data <= "10010001";  -- 63FD = 91
      when "0001111111110" =>  data <= "11000100";  -- 63FE = C4
      when "0001111111111" =>  data <= "10001000";  -- 63FF = 88
      when "0010000000000" =>  data <= "00010000";  -- 6400 = 10
      when "0010000000001" =>  data <= "11111001";  -- 6401 = F9
      when "0010000000010" =>  data <= "00110000";  -- 6402 = 30
      when "0010000000011" =>  data <= "11010011";  -- 6403 = D3
      when "0010000000100" =>  data <= "10010101";  -- 6404 = 95
      when "0010000000101" =>  data <= "11100000";  -- 6405 = E0
      when "0010000000110" =>  data <= "10100000";  -- 6406 = A0
      when "0010000000111" =>  data <= "00100111";  -- 6407 = 27
      when "0010000001000" =>  data <= "10101001";  -- 6408 = A9
      when "0010000001001" =>  data <= "00100000";  -- 6409 = 20
      when "0010000001010" =>  data <= "10010001";  -- 640A = 91
      when "0010000001011" =>  data <= "11000100";  -- 640B = C4
      when "0010000001100" =>  data <= "10001000";  -- 640C = 88
      when "0010000001101" =>  data <= "00010000";  -- 640D = 10
      when "0010000001110" =>  data <= "11111011";  -- 640E = FB
      when "0010000001111" =>  data <= "11000110";  -- 640F = C6
      when "0010000010000" =>  data <= "11011000";  -- 6410 = D8
      when "0010000010001" =>  data <= "10100101";  -- 6411 = A5
      when "0010000010010" =>  data <= "11100000";  -- 6412 = E0
      when "0010000010011" =>  data <= "00010000";  -- 6413 = 10
      when "0010000010100" =>  data <= "11000000";  -- 6414 = C0
      when "0010000010101" =>  data <= "10101101";  -- 6415 = AD
      when "0010000010110" =>  data <= "00010010";  -- 6416 = 12
      when "0010000010111" =>  data <= "11101000";  -- 6417 = E8
      when "0010000011000" =>  data <= "11001001";  -- 6418 = C9
      when "0010000011001" =>  data <= "11111110";  -- 6419 = FE
      when "0010000011010" =>  data <= "11010000";  -- 641A = D0
      when "0010000011011" =>  data <= "00001011";  -- 641B = B
      when "0010000011100" =>  data <= "10100000";  -- 641C = A0
      when "0010000011101" =>  data <= "00000000";  -- 641D = 0
      when "0010000011110" =>  data <= "11101010";  -- 641E = EA
      when "0010000011111" =>  data <= "11001010";  -- 641F = CA
      when "0010000100000" =>  data <= "11010000";  -- 6420 = D0
      when "0010000100001" =>  data <= "11111100";  -- 6421 = FC
      when "0010000100010" =>  data <= "10001000";  -- 6422 = 88
      when "0010000100011" =>  data <= "11010000";  -- 6423 = D0
      when "0010000100100" =>  data <= "11111001";  -- 6424 = F9
      when "0010000100101" =>  data <= "10000100";  -- 6425 = 84
      when "0010000100110" =>  data <= "10011110";  -- 6426 = 9E
      when "0010000100111" =>  data <= "10100110";  -- 6427 = A6
      when "0010000101000" =>  data <= "11011000";  -- 6428 = D8
      when "0010000101001" =>  data <= "01100000";  -- 6429 = 60
      when "0010000101010" =>  data <= "10101010";  -- 642A = AA
      when "0010000101011" =>  data <= "10101010";  -- 642B = AA
      when "0010000101100" =>  data <= "10101010";  -- 642C = AA
      when "0010000101101" =>  data <= "10101010";  -- 642D = AA
      when "0010000101110" =>  data <= "00100000";  -- 642E = 20
      when "0010000101111" =>  data <= "11101010";  -- 642F = EA
      when "0010000110000" =>  data <= "11111111";  -- 6430 = FF
      when "0010000110001" =>  data <= "11101110";  -- 6431 = EE
      when "0010000110010" =>  data <= "11101101";  -- 6432 = ED
      when "0010000110011" =>  data <= "00000011";  -- 6433 = 3
      when "0010000110100" =>  data <= "10101101";  -- 6434 = AD
      when "0010000110101" =>  data <= "11101101";  -- 6435 = ED
      when "0010000110110" =>  data <= "00000011";  -- 6436 = 3
      when "0010000110111" =>  data <= "11001001";  -- 6437 = C9
      when "0010000111000" =>  data <= "00000110";  -- 6438 = 6
      when "0010000111001" =>  data <= "11010000";  -- 6439 = D0
      when "0010000111010" =>  data <= "00011101";  -- 643A = 1D
      when "0010000111011" =>  data <= "10101001";  -- 643B = A9
      when "0010000111100" =>  data <= "00000000";  -- 643C = 0
      when "0010000111101" =>  data <= "10001101";  -- 643D = 8D
      when "0010000111110" =>  data <= "11101101";  -- 643E = ED
      when "0010000111111" =>  data <= "00000011";  -- 643F = 3
      when "0010001000000" =>  data <= "11110000";  -- 6440 = F0
      when "0010001000001" =>  data <= "11101100";  -- 6441 = EC
      when "0010001000010" =>  data <= "01001000";  -- 6442 = 48
      when "0010001000011" =>  data <= "10001010";  -- 6443 = 8A
      when "0010001000100" =>  data <= "01001000";  -- 6444 = 48
      when "0010001000101" =>  data <= "10011000";  -- 6445 = 98
      when "0010001000110" =>  data <= "01001000";  -- 6446 = 48
      when "0010001000111" =>  data <= "10111010";  -- 6447 = BA
      when "0010001001000" =>  data <= "10111101";  -- 6448 = BD
      when "0010001001001" =>  data <= "00000100";  -- 6449 = 4
      when "0010001001010" =>  data <= "00000001";  -- 644A = 1
      when "0010001001011" =>  data <= "00101001";  -- 644B = 29
      when "0010001001100" =>  data <= "00010000";  -- 644C = 10
      when "0010001001101" =>  data <= "11110000";  -- 644D = F0
      when "0010001001110" =>  data <= "00000011";  -- 644E = 3
      when "0010001001111" =>  data <= "01101100";  -- 644F = 6C
      when "0010001010000" =>  data <= "10010010";  -- 6450 = 92
      when "0010001010001" =>  data <= "00000000";  -- 6451 = 0
      when "0010001010010" =>  data <= "01101100";  -- 6452 = 6C
      when "0010001010011" =>  data <= "10010000";  -- 6453 = 90
      when "0010001010100" =>  data <= "00000000";  -- 6454 = 0
      when "0010001010101" =>  data <= "01001100";  -- 6455 = 4C
      when "0010001010110" =>  data <= "00101110";  -- 6456 = 2E
      when "0010001010111" =>  data <= "11100100";  -- 6457 = E4
      when "0010001011000" =>  data <= "10100101";  -- 6458 = A5
      when "0010001011001" =>  data <= "10100111";  -- 6459 = A7
      when "0010001011010" =>  data <= "11010000";  -- 645A = D0
      when "0010001011011" =>  data <= "00011111";  -- 645B = 1F
      when "0010001011100" =>  data <= "11000110";  -- 645C = C6
      when "0010001011101" =>  data <= "10101000";  -- 645D = A8
      when "0010001011110" =>  data <= "11010000";  -- 645E = D0
      when "0010001011111" =>  data <= "00011011";  -- 645F = 1B
      when "0010001100000" =>  data <= "10101001";  -- 6460 = A9
      when "0010001100001" =>  data <= "00010100";  -- 6461 = 14
      when "0010001100010" =>  data <= "00101100";  -- 6462 = 2C
      when "0010001100011" =>  data <= "11101110";  -- 6463 = EE
      when "0010001100100" =>  data <= "00000011";  -- 6464 = 3
      when "0010001100101" =>  data <= "00010000";  -- 6465 = 10
      when "0010001100110" =>  data <= "00000010";  -- 6466 = 2
      when "0010001100111" =>  data <= "10101001";  -- 6467 = A9
      when "0010001101000" =>  data <= "00000010";  -- 6468 = 2
      when "0010001101001" =>  data <= "10000101";  -- 6469 = 85
      when "0010001101010" =>  data <= "10101000";  -- 646A = A8
      when "0010001101011" =>  data <= "10100100";  -- 646B = A4
      when "0010001101100" =>  data <= "11000110";  -- 646C = C6
      when "0010001101101" =>  data <= "01000110";  -- 646D = 46
      when "0010001101110" =>  data <= "10101010";  -- 646E = AA
      when "0010001101111" =>  data <= "10110001";  -- 646F = B1
      when "0010001110000" =>  data <= "11000100";  -- 6470 = C4
      when "0010001110001" =>  data <= "10110000";  -- 6471 = B0
      when "0010001110010" =>  data <= "00000100";  -- 6472 = 4
      when "0010001110011" =>  data <= "11100110";  -- 6473 = E6
      when "0010001110100" =>  data <= "10101010";  -- 6474 = AA
      when "0010001110101" =>  data <= "10000101";  -- 6475 = 85
      when "0010001110110" =>  data <= "10101001";  -- 6476 = A9
      when "0010001110111" =>  data <= "01001001";  -- 6477 = 49
      when "0010001111000" =>  data <= "10000000";  -- 6478 = 80
      when "0010001111001" =>  data <= "10010001";  -- 6479 = 91
      when "0010001111010" =>  data <= "11000100";  -- 647A = C4
      when "0010001111011" =>  data <= "10100000";  -- 647B = A0
      when "0010001111100" =>  data <= "00000000";  -- 647C = 0
      when "0010001111101" =>  data <= "10101101";  -- 647D = AD
      when "0010001111110" =>  data <= "00010000";  -- 647E = 10
      when "0010001111111" =>  data <= "11101000";  -- 647F = E8
      when "0010010000000" =>  data <= "00101001";  -- 6480 = 29
      when "0010010000001" =>  data <= "11110000";  -- 6481 = F0
      when "0010010000010" =>  data <= "10001101";  -- 6482 = 8D
      when "0010010000011" =>  data <= "00010000";  -- 6483 = 10
      when "0010010000100" =>  data <= "11101000";  -- 6484 = E8
      when "0010010000101" =>  data <= "10101101";  -- 6485 = AD
      when "0010010000110" =>  data <= "00010000";  -- 6486 = 10
      when "0010010000111" =>  data <= "11101000";  -- 6487 = E8
      when "0010010001000" =>  data <= "00001010";  -- 6488 = A
      when "0010010001001" =>  data <= "00001010";  -- 6489 = A
      when "0010010001010" =>  data <= "00001010";  -- 648A = A
      when "0010010001011" =>  data <= "00010000";  -- 648B = 10
      when "0010010001100" =>  data <= "00001001";  -- 648C = 9
      when "0010010001101" =>  data <= "10000100";  -- 648D = 84
      when "0010010001110" =>  data <= "11111001";  -- 648E = F9
      when "0010010001111" =>  data <= "10101101";  -- 648F = AD
      when "0010010010000" =>  data <= "00010011";  -- 6490 = 13
      when "0010010010001" =>  data <= "11101000";  -- 6491 = E8
      when "0010010010010" =>  data <= "00001001";  -- 6492 = 9
      when "0010010010011" =>  data <= "00001000";  -- 6493 = 8
      when "0010010010100" =>  data <= "11010000";  -- 6494 = D0
      when "0010010010101" =>  data <= "00001001";  -- 6495 = 9
      when "0010010010110" =>  data <= "10100101";  -- 6496 = A5
      when "0010010010111" =>  data <= "11111001";  -- 6497 = F9
      when "0010010011000" =>  data <= "11010000";  -- 6498 = D0
      when "0010010011001" =>  data <= "00001000";  -- 6499 = 8
      when "0010010011010" =>  data <= "10101101";  -- 649A = AD
      when "0010010011011" =>  data <= "00010011";  -- 649B = 13
      when "0010010011100" =>  data <= "11101000";  -- 649C = E8
      when "0010010011101" =>  data <= "00101001";  -- 649D = 29
      when "0010010011110" =>  data <= "11110111";  -- 649E = F7
      when "0010010011111" =>  data <= "10001101";  -- 649F = 8D
      when "0010010100000" =>  data <= "00010011";  -- 64A0 = 13
      when "0010010100001" =>  data <= "11101000";  -- 64A1 = E8
      when "0010010100010" =>  data <= "10010000";  -- 64A2 = 90
      when "0010010100011" =>  data <= "00001001";  -- 64A3 = 9
      when "0010010100100" =>  data <= "10000100";  -- 64A4 = 84
      when "0010010100101" =>  data <= "11111010";  -- 64A5 = FA
      when "0010010100110" =>  data <= "10101101";  -- 64A6 = AD
      when "0010010100111" =>  data <= "01000000";  -- 64A7 = 40
      when "0010010101000" =>  data <= "11101000";  -- 64A8 = E8
      when "0010010101001" =>  data <= "00001001";  -- 64A9 = 9
      when "0010010101010" =>  data <= "00010000";  -- 64AA = 10
      when "0010010101011" =>  data <= "11010000";  -- 64AB = D0
      when "0010010101100" =>  data <= "00001001";  -- 64AC = 9
      when "0010010101101" =>  data <= "10100101";  -- 64AD = A5
      when "0010010101110" =>  data <= "11111010";  -- 64AE = FA
      when "0010010101111" =>  data <= "11010000";  -- 64AF = D0
      when "0010010110000" =>  data <= "00001000";  -- 64B0 = 8
      when "0010010110001" =>  data <= "10101101";  -- 64B1 = AD
      when "0010010110010" =>  data <= "01000000";  -- 64B2 = 40
      when "0010010110011" =>  data <= "11101000";  -- 64B3 = E8
      when "0010010110100" =>  data <= "00101001";  -- 64B4 = 29
      when "0010010110101" =>  data <= "11101111";  -- 64B5 = EF
      when "0010010110110" =>  data <= "10001101";  -- 64B6 = 8D
      when "0010010110111" =>  data <= "01000000";  -- 64B7 = 40
      when "0010010111000" =>  data <= "11101000";  -- 64B8 = E8
      when "0010010111001" =>  data <= "00100000";  -- 64B9 = 20
      when "0010010111010" =>  data <= "10111111";  -- 64BA = BF
      when "0010010111011" =>  data <= "11100100";  -- 64BB = E4
      when "0010010111100" =>  data <= "01001100";  -- 64BC = 4C
      when "0010010111101" =>  data <= "00000000";  -- 64BD = 0
      when "0010010111110" =>  data <= "11100110";  -- 64BE = E6
      when "0010010111111" =>  data <= "10100000";  -- 64BF = A0
      when "0010011000000" =>  data <= "11111111";  -- 64C0 = FF
      when "0010011000001" =>  data <= "10000100";  -- 64C1 = 84
      when "0010011000010" =>  data <= "10100110";  -- 64C2 = A6
      when "0010011000011" =>  data <= "11001000";  -- 64C3 = C8
      when "0010011000100" =>  data <= "10000100";  -- 64C4 = 84
      when "0010011000101" =>  data <= "10011000";  -- 64C5 = 98
      when "0010011000110" =>  data <= "10101101";  -- 64C6 = AD
      when "0010011000111" =>  data <= "11101110";  -- 64C7 = EE
      when "0010011001000" =>  data <= "00000011";  -- 64C8 = 3
      when "0010011001001" =>  data <= "00101001";  -- 64C9 = 29
      when "0010011001010" =>  data <= "01111111";  -- 64CA = 7F
      when "0010011001011" =>  data <= "10001101";  -- 64CB = 8D
      when "0010011001100" =>  data <= "11101110";  -- 64CC = EE
      when "0010011001101" =>  data <= "00000011";  -- 64CD = 3
      when "0010011001110" =>  data <= "10100010";  -- 64CE = A2
      when "0010011001111" =>  data <= "01010000";  -- 64CF = 50
      when "0010011010000" =>  data <= "10100000";  -- 64D0 = A0
      when "0010011010001" =>  data <= "00001000";  -- 64D1 = 8
      when "0010011010010" =>  data <= "10101101";  -- 64D2 = AD
      when "0010011010011" =>  data <= "00010010";  -- 64D3 = 12
      when "0010011010100" =>  data <= "11101000";  -- 64D4 = E8
      when "0010011010101" =>  data <= "11001101";  -- 64D5 = CD
      when "0010011010110" =>  data <= "00010010";  -- 64D6 = 12
      when "0010011010111" =>  data <= "11101000";  -- 64D7 = E8
      when "0010011011000" =>  data <= "11010000";  -- 64D8 = D0
      when "0010011011001" =>  data <= "11110110";  -- 64D9 = F6
      when "0010011011010" =>  data <= "11001001";  -- 64DA = C9
      when "0010011011011" =>  data <= "11111111";  -- 64DB = FF
      when "0010011011100" =>  data <= "11010000";  -- 64DC = D0
      when "0010011011101" =>  data <= "00001001";  -- 64DD = 9
      when "0010011011110" =>  data <= "10001010";  -- 64DE = 8A
      when "0010011011111" =>  data <= "00111000";  -- 64DF = 38
      when "0010011100000" =>  data <= "11101001";  -- 64E0 = E9
      when "0010011100001" =>  data <= "00001000";  -- 64E1 = 8
      when "0010011100010" =>  data <= "10101010";  -- 64E2 = AA
      when "0010011100011" =>  data <= "11010000";  -- 64E3 = D0
      when "0010011100100" =>  data <= "00101100";  -- 64E4 = 2C
      when "0010011100101" =>  data <= "11110000";  -- 64E5 = F0
      when "0010011100110" =>  data <= "00101111";  -- 64E6 = 2F
      when "0010011100111" =>  data <= "01001010";  -- 64E7 = 4A
      when "0010011101000" =>  data <= "10110000";  -- 64E8 = B0
      when "0010011101001" =>  data <= "00100001";  -- 64E9 = 21
      when "0010011101010" =>  data <= "01001000";  -- 64EA = 48
      when "0010011101011" =>  data <= "10111101";  -- 64EB = BD
      when "0010011101100" =>  data <= "00111110";  -- 64EC = 3E
      when "0010011101101" =>  data <= "11100111";  -- 64ED = E7
      when "0010011101110" =>  data <= "11010000";  -- 64EE = D0
      when "0010011101111" =>  data <= "00000110";  -- 64EF = 6
      when "0010011110000" =>  data <= "10101001";  -- 64F0 = A9
      when "0010011110001" =>  data <= "00000001";  -- 64F1 = 1
      when "0010011110010" =>  data <= "10000101";  -- 64F2 = 85
      when "0010011110011" =>  data <= "10011000";  -- 64F3 = 98
      when "0010011110100" =>  data <= "11010000";  -- 64F4 = D0
      when "0010011110101" =>  data <= "00010100";  -- 64F5 = 14
      when "0010011110110" =>  data <= "11001001";  -- 64F6 = C9
      when "0010011110111" =>  data <= "00010000";  -- 64F7 = 10
      when "0010011111000" =>  data <= "11010000";  -- 64F8 = D0
      when "0010011111001" =>  data <= "00001010";  -- 64F9 = A
      when "0010011111010" =>  data <= "10101101";  -- 64FA = AD
      when "0010011111011" =>  data <= "11101110";  -- 64FB = EE
      when "0010011111100" =>  data <= "00000011";  -- 64FC = 3
      when "0010011111101" =>  data <= "00001001";  -- 64FD = 9
      when "0010011111110" =>  data <= "10000000";  -- 64FE = 80
      when "0010011111111" =>  data <= "10001101";  -- 64FF = 8D
      when "0010100000000" =>  data <= "11101110";  -- 6500 = EE
      when "0010100000001" =>  data <= "00000011";  -- 6501 = 3
      when "0010100000010" =>  data <= "00110000";  -- 6502 = 30
      when "0010100000011" =>  data <= "00000110";  -- 6503 = 6
      when "0010100000100" =>  data <= "11001001";  -- 6504 = C9
      when "0010100000101" =>  data <= "11111111";  -- 6505 = FF
      when "0010100000110" =>  data <= "11110000";  -- 6506 = F0
      when "0010100000111" =>  data <= "00000010";  -- 6507 = 2
      when "0010100001000" =>  data <= "10000101";  -- 6508 = 85
      when "0010100001001" =>  data <= "10100110";  -- 6509 = A6
      when "0010100001010" =>  data <= "01101000";  -- 650A = 68
      when "0010100001011" =>  data <= "11001010";  -- 650B = CA
      when "0010100001100" =>  data <= "11110000";  -- 650C = F0
      when "0010100001101" =>  data <= "00001000";  -- 650D = 8
      when "0010100001110" =>  data <= "10001000";  -- 650E = 88
      when "0010100001111" =>  data <= "11010000";  -- 650F = D0
      when "0010100010000" =>  data <= "11010110";  -- 6510 = D6
      when "0010100010001" =>  data <= "11101110";  -- 6511 = EE
      when "0010100010010" =>  data <= "00010000";  -- 6512 = 10
      when "0010100010011" =>  data <= "11101000";  -- 6513 = E8
      when "0010100010100" =>  data <= "11010000";  -- 6514 = D0
      when "0010100010101" =>  data <= "10111010";  -- 6515 = BA
      when "0010100010110" =>  data <= "10100101";  -- 6516 = A5
      when "0010100010111" =>  data <= "10100110";  -- 6517 = A6
      when "0010100011000" =>  data <= "11000101";  -- 6518 = C5
      when "0010100011001" =>  data <= "10010111";  -- 6519 = 97
      when "0010100011010" =>  data <= "11110000";  -- 651A = F0
      when "0010100011011" =>  data <= "00000111";  -- 651B = 7
      when "0010100011100" =>  data <= "10100010";  -- 651C = A2
      when "0010100011101" =>  data <= "00010000";  -- 651D = 10
      when "0010100011110" =>  data <= "10001110";  -- 651E = 8E
      when "0010100011111" =>  data <= "11101001";  -- 651F = E9
      when "0010100100000" =>  data <= "00000011";  -- 6520 = 3
      when "0010100100001" =>  data <= "11010000";  -- 6521 = D0
      when "0010100100010" =>  data <= "00110011";  -- 6522 = 33
      when "0010100100011" =>  data <= "00101100";  -- 6523 = 2C
      when "0010100100100" =>  data <= "11101110";  -- 6524 = EE
      when "0010100100101" =>  data <= "00000011";  -- 6525 = 3
      when "0010100100110" =>  data <= "00110000";  -- 6526 = 30
      when "0010100100111" =>  data <= "00100000";  -- 6527 = 20
      when "0010100101000" =>  data <= "01110000";  -- 6528 = 70
      when "0010100101001" =>  data <= "01011101";  -- 6529 = 5D
      when "0010100101010" =>  data <= "11001001";  -- 652A = C9
      when "0010100101011" =>  data <= "11111111";  -- 652B = FF
      when "0010100101100" =>  data <= "11110000";  -- 652C = F0
      when "0010100101101" =>  data <= "01011001";  -- 652D = 59
      when "0010100101110" =>  data <= "11001001";  -- 652E = C9
      when "0010100101111" =>  data <= "00010100";  -- 652F = 14
      when "0010100110000" =>  data <= "11110000";  -- 6530 = F0
      when "0010100110001" =>  data <= "00001100";  -- 6531 = C
      when "0010100110010" =>  data <= "11001001";  -- 6532 = C9
      when "0010100110011" =>  data <= "00100000";  -- 6533 = 20
      when "0010100110100" =>  data <= "11110000";  -- 6534 = F0
      when "0010100110101" =>  data <= "00001000";  -- 6535 = 8
      when "0010100110110" =>  data <= "11001001";  -- 6536 = C9
      when "0010100110111" =>  data <= "00011101";  -- 6537 = 1D
      when "0010100111000" =>  data <= "11110000";  -- 6538 = F0
      when "0010100111001" =>  data <= "00000100";  -- 6539 = 4
      when "0010100111010" =>  data <= "11001001";  -- 653A = C9
      when "0010100111011" =>  data <= "00010001";  -- 653B = 11
      when "0010100111100" =>  data <= "11010000";  -- 653C = D0
      when "0010100111101" =>  data <= "01001001";  -- 653D = 49
      when "0010100111110" =>  data <= "10101110";  -- 653E = AE
      when "0010100111111" =>  data <= "11101001";  -- 653F = E9
      when "0010101000000" =>  data <= "00000011";  -- 6540 = 3
      when "0010101000001" =>  data <= "11110000";  -- 6541 = F0
      when "0010101000010" =>  data <= "00000101";  -- 6542 = 5
      when "0010101000011" =>  data <= "11001110";  -- 6543 = CE
      when "0010101000100" =>  data <= "11101001";  -- 6544 = E9
      when "0010101000101" =>  data <= "00000011";  -- 6545 = 3
      when "0010101000110" =>  data <= "11010000";  -- 6546 = D0
      when "0010101000111" =>  data <= "00111111";  -- 6547 = 3F
      when "0010101001000" =>  data <= "11001110";  -- 6548 = CE
      when "0010101001001" =>  data <= "11101010";  -- 6549 = EA
      when "0010101001010" =>  data <= "00000011";  -- 654A = 3
      when "0010101001011" =>  data <= "11010000";  -- 654B = D0
      when "0010101001100" =>  data <= "00111010";  -- 654C = 3A
      when "0010101001101" =>  data <= "10100010";  -- 654D = A2
      when "0010101001110" =>  data <= "00000100";  -- 654E = 4
      when "0010101001111" =>  data <= "10001110";  -- 654F = 8E
      when "0010101010000" =>  data <= "11101010";  -- 6550 = EA
      when "0010101010001" =>  data <= "00000011";  -- 6551 = 3
      when "0010101010010" =>  data <= "10100110";  -- 6552 = A6
      when "0010101010011" =>  data <= "10011110";  -- 6553 = 9E
      when "0010101010100" =>  data <= "11010000";  -- 6554 = D0
      when "0010101010101" =>  data <= "00110001";  -- 6555 = 31
      when "0010101010110" =>  data <= "10000101";  -- 6556 = 85
      when "0010101010111" =>  data <= "10010111";  -- 6557 = 97
      when "0010101011000" =>  data <= "11001001";  -- 6558 = C9
      when "0010101011001" =>  data <= "11111111";  -- 6559 = FF
      when "0010101011010" =>  data <= "11110000";  -- 655A = F0
      when "0010101011011" =>  data <= "00101011";  -- 655B = 2B
      when "0010101011100" =>  data <= "11101010";  -- 655C = EA
      when "0010101011101" =>  data <= "11101010";  -- 655D = EA
      when "0010101011110" =>  data <= "11101010";  -- 655E = EA
      when "0010101011111" =>  data <= "11101010";  -- 655F = EA
      when "0010101100000" =>  data <= "11101010";  -- 6560 = EA
      when "0010101100001" =>  data <= "11101010";  -- 6561 = EA
      when "0010101100010" =>  data <= "11101010";  -- 6562 = EA
      when "0010101100011" =>  data <= "01000110";  -- 6563 = 46
      when "0010101100100" =>  data <= "10011000";  -- 6564 = 98
      when "0010101100101" =>  data <= "10010000";  -- 6565 = 90
      when "0010101100110" =>  data <= "00010011";  -- 6566 = 13
      when "0010101100111" =>  data <= "11101010";  -- 6567 = EA
      when "0010101101000" =>  data <= "11101010";  -- 6568 = EA
      when "0010101101001" =>  data <= "11101010";  -- 6569 = EA
      when "0010101101010" =>  data <= "11101010";  -- 656A = EA
      when "0010101101011" =>  data <= "11101010";  -- 656B = EA
      when "0010101101100" =>  data <= "11101010";  -- 656C = EA
      when "0010101101101" =>  data <= "11101010";  -- 656D = EA
      when "0010101101110" =>  data <= "11101010";  -- 656E = EA
      when "0010101101111" =>  data <= "11101010";  -- 656F = EA
      when "0010101110000" =>  data <= "11101010";  -- 6570 = EA
      when "0010101110001" =>  data <= "11101010";  -- 6571 = EA
      when "0010101110010" =>  data <= "11101010";  -- 6572 = EA
      when "0010101110011" =>  data <= "11101010";  -- 6573 = EA
      when "0010101110100" =>  data <= "11101010";  -- 6574 = EA
      when "0010101110101" =>  data <= "11101010";  -- 6575 = EA
      when "0010101110110" =>  data <= "11101010";  -- 6576 = EA
      when "0010101110111" =>  data <= "11101010";  -- 6577 = EA
      when "0010101111000" =>  data <= "00001001";  -- 6578 = 9
      when "0010101111001" =>  data <= "10000000";  -- 6579 = 80
      when "0010101111010" =>  data <= "10100110";  -- 657A = A6
      when "0010101111011" =>  data <= "10011110";  -- 657B = 9E
      when "0010101111100" =>  data <= "11101100";  -- 657C = EC
      when "0010101111101" =>  data <= "11101011";  -- 657D = EB
      when "0010101111110" =>  data <= "00000011";  -- 657E = 3
      when "0010101111111" =>  data <= "10110000";  -- 657F = B0
      when "0010110000000" =>  data <= "00000110";  -- 6580 = 6
      when "0010110000001" =>  data <= "10011101";  -- 6581 = 9D
      when "0010110000010" =>  data <= "01101111";  -- 6582 = 6F
      when "0010110000011" =>  data <= "00000010";  -- 6583 = 2
      when "0010110000100" =>  data <= "11101000";  -- 6584 = E8
      when "0010110000101" =>  data <= "10000110";  -- 6585 = 86
      when "0010110000110" =>  data <= "10011110";  -- 6586 = 9E
      when "0010110000111" =>  data <= "01100000";  -- 6587 = 60
      when "0010110001000" =>  data <= "10011000";  -- 6588 = 98
      when "0010110001001" =>  data <= "00101001";  -- 6589 = 29
      when "0010110001010" =>  data <= "00000111";  -- 658A = 7
      when "0010110001011" =>  data <= "10101010";  -- 658B = AA
      when "0010110001100" =>  data <= "10111101";  -- 658C = BD
      when "0010110001101" =>  data <= "11011100";  -- 658D = DC
      when "0010110001110" =>  data <= "11100111";  -- 658E = E7
      when "0010110001111" =>  data <= "10001101";  -- 658F = 8D
      when "0010110010000" =>  data <= "11101111";  -- 6590 = EF
      when "0010110010001" =>  data <= "00000011";  -- 6591 = 3
      when "0010110010010" =>  data <= "10011000";  -- 6592 = 98
      when "0010110010011" =>  data <= "01001010";  -- 6593 = 4A
      when "0010110010100" =>  data <= "01001010";  -- 6594 = 4A
      when "0010110010101" =>  data <= "01001010";  -- 6595 = 4A
      when "0010110010110" =>  data <= "10101010";  -- 6596 = AA
      when "0010110010111" =>  data <= "10111101";  -- 6597 = BD
      when "0010110011000" =>  data <= "11110000";  -- 6598 = F0
      when "0010110011001" =>  data <= "00000011";  -- 6599 = 3
      when "0010110011010" =>  data <= "00101100";  -- 659A = 2C
      when "0010110011011" =>  data <= "11101111";  -- 659B = EF
      when "0010110011100" =>  data <= "00000011";  -- 659C = 3
      when "0010110011101" =>  data <= "01100000";  -- 659D = 60
      when "0010110011110" =>  data <= "10101010";  -- 659E = AA
      when "0010110011111" =>  data <= "10101010";  -- 659F = AA
      when "0010110100000" =>  data <= "10101010";  -- 65A0 = AA
      when "0010110100001" =>  data <= "10101010";  -- 65A1 = AA
      when "0010110100010" =>  data <= "10101010";  -- 65A2 = AA
      when "0010110100011" =>  data <= "10101010";  -- 65A3 = AA
      when "0010110100100" =>  data <= "10101010";  -- 65A4 = AA
      when "0010110100101" =>  data <= "10101010";  -- 65A5 = AA
      when "0010110100110" =>  data <= "10101010";  -- 65A6 = AA
      when "0010110100111" =>  data <= "10101010";  -- 65A7 = AA
      when "0010110101000" =>  data <= "10101010";  -- 65A8 = AA
      when "0010110101001" =>  data <= "10101010";  -- 65A9 = AA
      when "0010110101010" =>  data <= "10101010";  -- 65AA = AA
      when "0010110101011" =>  data <= "10101010";  -- 65AB = AA
      when "0010110101100" =>  data <= "10101010";  -- 65AC = AA
      when "0010110101101" =>  data <= "10101010";  -- 65AD = AA
      when "0010110101110" =>  data <= "10101010";  -- 65AE = AA
      when "0010110101111" =>  data <= "10101010";  -- 65AF = AA
      when "0010110110000" =>  data <= "10101010";  -- 65B0 = AA
      when "0010110110001" =>  data <= "10101010";  -- 65B1 = AA
      when "0010110110010" =>  data <= "10101010";  -- 65B2 = AA
      when "0010110110011" =>  data <= "10101010";  -- 65B3 = AA
      when "0010110110100" =>  data <= "10101010";  -- 65B4 = AA
      when "0010110110101" =>  data <= "10101010";  -- 65B5 = AA
      when "0010110110110" =>  data <= "10101010";  -- 65B6 = AA
      when "0010110110111" =>  data <= "10101010";  -- 65B7 = AA
      when "0010110111000" =>  data <= "10101010";  -- 65B8 = AA
      when "0010110111001" =>  data <= "10101010";  -- 65B9 = AA
      when "0010110111010" =>  data <= "10101010";  -- 65BA = AA
      when "0010110111011" =>  data <= "10101010";  -- 65BB = AA
      when "0010110111100" =>  data <= "10101010";  -- 65BC = AA
      when "0010110111101" =>  data <= "10101010";  -- 65BD = AA
      when "0010110111110" =>  data <= "10101010";  -- 65BE = AA
      when "0010110111111" =>  data <= "10101010";  -- 65BF = AA
      when "0010111000000" =>  data <= "10101010";  -- 65C0 = AA
      when "0010111000001" =>  data <= "10101010";  -- 65C1 = AA
      when "0010111000010" =>  data <= "10101010";  -- 65C2 = AA
      when "0010111000011" =>  data <= "10101010";  -- 65C3 = AA
      when "0010111000100" =>  data <= "10101010";  -- 65C4 = AA
      when "0010111000101" =>  data <= "10101010";  -- 65C5 = AA
      when "0010111000110" =>  data <= "10101010";  -- 65C6 = AA
      when "0010111000111" =>  data <= "10101010";  -- 65C7 = AA
      when "0010111001000" =>  data <= "10101010";  -- 65C8 = AA
      when "0010111001001" =>  data <= "10101010";  -- 65C9 = AA
      when "0010111001010" =>  data <= "10101010";  -- 65CA = AA
      when "0010111001011" =>  data <= "10101010";  -- 65CB = AA
      when "0010111001100" =>  data <= "10101010";  -- 65CC = AA
      when "0010111001101" =>  data <= "10101010";  -- 65CD = AA
      when "0010111001110" =>  data <= "10101010";  -- 65CE = AA
      when "0010111001111" =>  data <= "10101010";  -- 65CF = AA
      when "0010111010000" =>  data <= "10101010";  -- 65D0 = AA
      when "0010111010001" =>  data <= "10101010";  -- 65D1 = AA
      when "0010111010010" =>  data <= "10101010";  -- 65D2 = AA
      when "0010111010011" =>  data <= "10101010";  -- 65D3 = AA
      when "0010111010100" =>  data <= "10101010";  -- 65D4 = AA
      when "0010111010101" =>  data <= "10101010";  -- 65D5 = AA
      when "0010111010110" =>  data <= "10101010";  -- 65D6 = AA
      when "0010111010111" =>  data <= "10101010";  -- 65D7 = AA
      when "0010111011000" =>  data <= "10101010";  -- 65D8 = AA
      when "0010111011001" =>  data <= "10101010";  -- 65D9 = AA
      when "0010111011010" =>  data <= "10101010";  -- 65DA = AA
      when "0010111011011" =>  data <= "10101010";  -- 65DB = AA
      when "0010111011100" =>  data <= "10101010";  -- 65DC = AA
      when "0010111011101" =>  data <= "10101010";  -- 65DD = AA
      when "0010111011110" =>  data <= "10101010";  -- 65DE = AA
      when "0010111011111" =>  data <= "10101010";  -- 65DF = AA
      when "0010111100000" =>  data <= "10101010";  -- 65E0 = AA
      when "0010111100001" =>  data <= "10101010";  -- 65E1 = AA
      when "0010111100010" =>  data <= "10101010";  -- 65E2 = AA
      when "0010111100011" =>  data <= "10101010";  -- 65E3 = AA
      when "0010111100100" =>  data <= "10101010";  -- 65E4 = AA
      when "0010111100101" =>  data <= "10101010";  -- 65E5 = AA
      when "0010111100110" =>  data <= "10101010";  -- 65E6 = AA
      when "0010111100111" =>  data <= "10101010";  -- 65E7 = AA
      when "0010111101000" =>  data <= "10101010";  -- 65E8 = AA
      when "0010111101001" =>  data <= "10101010";  -- 65E9 = AA
      when "0010111101010" =>  data <= "10101010";  -- 65EA = AA
      when "0010111101011" =>  data <= "10101010";  -- 65EB = AA
      when "0010111101100" =>  data <= "10101010";  -- 65EC = AA
      when "0010111101101" =>  data <= "10101010";  -- 65ED = AA
      when "0010111101110" =>  data <= "10101010";  -- 65EE = AA
      when "0010111101111" =>  data <= "10101010";  -- 65EF = AA
      when "0010111110000" =>  data <= "10101010";  -- 65F0 = AA
      when "0010111110001" =>  data <= "10101010";  -- 65F1 = AA
      when "0010111110010" =>  data <= "10101010";  -- 65F2 = AA
      when "0010111110011" =>  data <= "10101010";  -- 65F3 = AA
      when "0010111110100" =>  data <= "10101010";  -- 65F4 = AA
      when "0010111110101" =>  data <= "10101010";  -- 65F5 = AA
      when "0010111110110" =>  data <= "10101010";  -- 65F6 = AA
      when "0010111110111" =>  data <= "10101010";  -- 65F7 = AA
      when "0010111111000" =>  data <= "10101010";  -- 65F8 = AA
      when "0010111111001" =>  data <= "10101010";  -- 65F9 = AA
      when "0010111111010" =>  data <= "10101010";  -- 65FA = AA
      when "0010111111011" =>  data <= "10101010";  -- 65FB = AA
      when "0010111111100" =>  data <= "10101010";  -- 65FC = AA
      when "0010111111101" =>  data <= "10101010";  -- 65FD = AA
      when "0010111111110" =>  data <= "10101010";  -- 65FE = AA
      when "0010111111111" =>  data <= "10101010";  -- 65FF = AA
      when "0011000000000" =>  data <= "01101000";  -- 6600 = 68
      when "0011000000001" =>  data <= "10101000";  -- 6601 = A8
      when "0011000000010" =>  data <= "01101000";  -- 6602 = 68
      when "0011000000011" =>  data <= "10101010";  -- 6603 = AA
      when "0011000000100" =>  data <= "01101000";  -- 6604 = 68
      when "0011000000101" =>  data <= "01000000";  -- 6605 = 40
      when "0011000000110" =>  data <= "10100100";  -- 6606 = A4
      when "0011000000111" =>  data <= "11000110";  -- 6607 = C6
      when "0011000001000" =>  data <= "10010001";  -- 6608 = 91
      when "0011000001001" =>  data <= "11000100";  -- 6609 = C4
      when "0011000001010" =>  data <= "10101001";  -- 660A = A9
      when "0011000001011" =>  data <= "00000010";  -- 660B = 2
      when "0011000001100" =>  data <= "10000101";  -- 660C = 85
      when "0011000001101" =>  data <= "10101000";  -- 660D = A8
      when "0011000001110" =>  data <= "01100000";  -- 660E = 60
      when "0011000001111" =>  data <= "10101001";  -- 660F = A9
      when "0011000010000" =>  data <= "10110001";  -- 6610 = B1
      when "0011000010001" =>  data <= "10100010";  -- 6611 = A2
      when "0011000010010" =>  data <= "11100111";  -- 6612 = E7
      when "0011000010011" =>  data <= "10100000";  -- 6613 = A0
      when "0011000010100" =>  data <= "00001110";  -- 6614 = E
      when "0011000010101" =>  data <= "11010000";  -- 6615 = D0
      when "0011000010110" =>  data <= "00000110";  -- 6616 = 6
      when "0011000010111" =>  data <= "10101001";  -- 6617 = A9
      when "0011000011000" =>  data <= "11000011";  -- 6618 = C3
      when "0011000011001" =>  data <= "10100010";  -- 6619 = A2
      when "0011000011010" =>  data <= "11100111";  -- 661A = E7
      when "0011000011011" =>  data <= "10100000";  -- 661B = A0
      when "0011000011100" =>  data <= "00001100";  -- 661C = C
      when "0011000011101" =>  data <= "10000101";  -- 661D = 85
      when "0011000011110" =>  data <= "11000111";  -- 661E = C7
      when "0011000011111" =>  data <= "10000110";  -- 661F = 86
      when "0011000100000" =>  data <= "11001000";  -- 6620 = C8
      when "0011000100001" =>  data <= "10101101";  -- 6621 = AD
      when "0011000100010" =>  data <= "01001100";  -- 6622 = 4C
      when "0011000100011" =>  data <= "11101000";  -- 6623 = E8
      when "0011000100100" =>  data <= "00101001";  -- 6624 = 29
      when "0011000100101" =>  data <= "11110000";  -- 6625 = F0
      when "0011000100110" =>  data <= "10000101";  -- 6626 = 85
      when "0011000100111" =>  data <= "11010001";  -- 6627 = D1
      when "0011000101000" =>  data <= "10011000";  -- 6628 = 98
      when "0011000101001" =>  data <= "00000101";  -- 6629 = 5
      when "0011000101010" =>  data <= "11010001";  -- 662A = D1
      when "0011000101011" =>  data <= "10001101";  -- 662B = 8D
      when "0011000101100" =>  data <= "01001100";  -- 662C = 4C
      when "0011000101101" =>  data <= "11101000";  -- 662D = E8
      when "0011000101110" =>  data <= "10100000";  -- 662E = A0
      when "0011000101111" =>  data <= "00010001";  -- 662F = 11
      when "0011000110000" =>  data <= "10110001";  -- 6630 = B1
      when "0011000110001" =>  data <= "11000111";  -- 6631 = C7
      when "0011000110010" =>  data <= "10001100";  -- 6632 = 8C
      when "0011000110011" =>  data <= "10000000";  -- 6633 = 80
      when "0011000110100" =>  data <= "11101000";  -- 6634 = E8
      when "0011000110101" =>  data <= "10001101";  -- 6635 = 8D
      when "0011000110110" =>  data <= "10000001";  -- 6636 = 81
      when "0011000110111" =>  data <= "11101000";  -- 6637 = E8
      when "0011000111000" =>  data <= "10001000";  -- 6638 = 88
      when "0011000111001" =>  data <= "00010000";  -- 6639 = 10
      when "0011000111010" =>  data <= "11110101";  -- 663A = F5
      when "0011000111011" =>  data <= "01100000";  -- 663B = 60
      when "0011000111100" =>  data <= "00100000";  -- 663C = 20
      when "0011000111101" =>  data <= "00000010";  -- 663D = 2
      when "0011000111110" =>  data <= "11100010";  -- 663E = E2
      when "0011000111111" =>  data <= "10101010";  -- 663F = AA
      when "0011001000000" =>  data <= "10100101";  -- 6640 = A5
      when "0011001000001" =>  data <= "11010101";  -- 6641 = D5
      when "0011001000010" =>  data <= "00111000";  -- 6642 = 38
      when "0011001000011" =>  data <= "11100101";  -- 6643 = E5
      when "0011001000100" =>  data <= "11000110";  -- 6644 = C6
      when "0011001000101" =>  data <= "11001001";  -- 6645 = C9
      when "0011001000110" =>  data <= "00000101";  -- 6646 = 5
      when "0011001000111" =>  data <= "11010000";  -- 6647 = D0
      when "0011001001000" =>  data <= "00111001";  -- 6648 = 39
      when "0011001001001" =>  data <= "10001010";  -- 6649 = 8A
      when "0011001001010" =>  data <= "11001001";  -- 664A = C9
      when "0011001001011" =>  data <= "00011101";  -- 664B = 1D
      when "0011001001100" =>  data <= "11110000";  -- 664C = F0
      when "0011001001101" =>  data <= "00000110";  -- 664D = 6
      when "0011001001110" =>  data <= "00101001";  -- 664E = 29
      when "0011001001111" =>  data <= "01111111";  -- 664F = 7F
      when "0011001010000" =>  data <= "11001001";  -- 6650 = C9
      when "0011001010001" =>  data <= "00100000";  -- 6651 = 20
      when "0011001010010" =>  data <= "10010000";  -- 6652 = 90
      when "0011001010011" =>  data <= "00101110";  -- 6653 = 2E
      when "0011001010100" =>  data <= "00100000";  -- 6654 = 20
      when "0011001010101" =>  data <= "01010111";  -- 6655 = 57
      when "0011001010110" =>  data <= "11100110";  -- 6656 = E6
      when "0011001010111" =>  data <= "10101100";  -- 6657 = AC
      when "0011001011000" =>  data <= "11101100";  -- 6658 = EC
      when "0011001011001" =>  data <= "00000011";  -- 6659 = 3
      when "0011001011010" =>  data <= "11110000";  -- 665A = F0
      when "0011001011011" =>  data <= "00100110";  -- 665B = 26
      when "0011001011100" =>  data <= "10101001";  -- 665C = A9
      when "0011001011101" =>  data <= "00010000";  -- 665D = 10
      when "0011001011110" =>  data <= "10001101";  -- 665E = 8D
      when "0011001011111" =>  data <= "01001011";  -- 665F = 4B
      when "0011001100000" =>  data <= "11101000";  -- 6660 = E8
      when "0011001100001" =>  data <= "10101001";  -- 6661 = A9
      when "0011001100010" =>  data <= "00001111";  -- 6662 = F
      when "0011001100011" =>  data <= "10001101";  -- 6663 = 8D
      when "0011001100100" =>  data <= "01001010";  -- 6664 = 4A
      when "0011001100101" =>  data <= "11101000";  -- 6665 = E8
      when "0011001100110" =>  data <= "10100010";  -- 6666 = A2
      when "0011001100111" =>  data <= "00000111";  -- 6667 = 7
      when "0011001101000" =>  data <= "10111101";  -- 6668 = BD
      when "0011001101001" =>  data <= "11010100";  -- 6669 = D4
      when "0011001101010" =>  data <= "11100111";  -- 666A = E7
      when "0011001101011" =>  data <= "10001101";  -- 666B = 8D
      when "0011001101100" =>  data <= "01001000";  -- 666C = 48
      when "0011001101101" =>  data <= "11101000";  -- 666D = E8
      when "0011001101110" =>  data <= "10101101";  -- 666E = AD
      when "0011001101111" =>  data <= "11101100";  -- 666F = EC
      when "0011001110000" =>  data <= "00000011";  -- 6670 = 3
      when "0011001110001" =>  data <= "10001000";  -- 6671 = 88
      when "0011001110010" =>  data <= "11010000";  -- 6672 = D0
      when "0011001110011" =>  data <= "11111101";  -- 6673 = FD
      when "0011001110100" =>  data <= "00111000";  -- 6674 = 38
      when "0011001110101" =>  data <= "11101001";  -- 6675 = E9
      when "0011001110110" =>  data <= "00000001";  -- 6676 = 1
      when "0011001110111" =>  data <= "11010000";  -- 6677 = D0
      when "0011001111000" =>  data <= "11111000";  -- 6678 = F8
      when "0011001111001" =>  data <= "11001010";  -- 6679 = CA
      when "0011001111010" =>  data <= "11010000";  -- 667A = D0
      when "0011001111011" =>  data <= "11101100";  -- 667B = EC
      when "0011001111100" =>  data <= "10001110";  -- 667C = 8E
      when "0011001111101" =>  data <= "01001010";  -- 667D = 4A
      when "0011001111110" =>  data <= "11101000";  -- 667E = E8
      when "0011001111111" =>  data <= "10001110";  -- 667F = 8E
      when "0011010000000" =>  data <= "01001011";  -- 6680 = 4B
      when "0011010000001" =>  data <= "11101000";  -- 6681 = E8
      when "0011010000010" =>  data <= "01100000";  -- 6682 = 60
      when "0011010000011" =>  data <= "10101001";  -- 6683 = A9
      when "0011010000100" =>  data <= "01111111";  -- 6684 = 7F
      when "0011010000101" =>  data <= "10001101";  -- 6685 = 8D
      when "0011010000110" =>  data <= "01001110";  -- 6686 = 4E
      when "0011010000111" =>  data <= "11101000";  -- 6687 = E8
      when "0011010001000" =>  data <= "10100010";  -- 6688 = A2
      when "0011010001001" =>  data <= "01101101";  -- 6689 = 6D
      when "0011010001010" =>  data <= "10101001";  -- 668A = A9
      when "0011010001011" =>  data <= "00000000";  -- 668B = 0
      when "0011010001100" =>  data <= "10010101";  -- 668C = 95
      when "0011010001101" =>  data <= "10001101";  -- 668D = 8D
      when "0011010001110" =>  data <= "11001010";  -- 668E = CA
      when "0011010001111" =>  data <= "00010000";  -- 668F = 10
      when "0011010010000" =>  data <= "11111011";  -- 6690 = FB
      when "0011010010001" =>  data <= "10100010";  -- 6691 = A2
      when "0011010010010" =>  data <= "00001010";  -- 6692 = A
      when "0011010010011" =>  data <= "10011101";  -- 6693 = 9D
      when "0011010010100" =>  data <= "11110000";  -- 6694 = F0
      when "0011010010101" =>  data <= "00000011";  -- 6695 = 3
      when "0011010010110" =>  data <= "11001010";  -- 6696 = CA
      when "0011010010111" =>  data <= "00010000";  -- 6697 = 10
      when "0011010011000" =>  data <= "11111010";  -- 6698 = FA
      when "0011010011001" =>  data <= "10001101";  -- 6699 = 8D
      when "0011010011010" =>  data <= "11101110";  -- 669A = EE
      when "0011010011011" =>  data <= "00000011";  -- 669B = 3
      when "0011010011100" =>  data <= "10101001";  -- 669C = A9
      when "0011010011101" =>  data <= "01010101";  -- 669D = 55
      when "0011010011110" =>  data <= "10000101";  -- 669E = 85
      when "0011010011111" =>  data <= "10010000";  -- 669F = 90
      when "0011010100000" =>  data <= "10101001";  -- 66A0 = A9
      when "0011010100001" =>  data <= "11100100";  -- 66A1 = E4
      when "0011010100010" =>  data <= "10000101";  -- 66A2 = 85
      when "0011010100011" =>  data <= "10010001";  -- 66A3 = 91
      when "0011010100100" =>  data <= "10101001";  -- 66A4 = A9
      when "0011010100101" =>  data <= "00000011";  -- 66A5 = 3
      when "0011010100110" =>  data <= "10000101";  -- 66A6 = 85
      when "0011010100111" =>  data <= "10110000";  -- 66A7 = B0
      when "0011010101000" =>  data <= "10101001";  -- 66A8 = A9
      when "0011010101001" =>  data <= "00001111";  -- 66A9 = F
      when "0011010101010" =>  data <= "10001101";  -- 66AA = 8D
      when "0011010101011" =>  data <= "00010000";  -- 66AB = 10
      when "0011010101100" =>  data <= "11101000";  -- 66AC = E8
      when "0011010101101" =>  data <= "00001010";  -- 66AD = A
      when "0011010101110" =>  data <= "10001101";  -- 66AE = 8D
      when "0011010101111" =>  data <= "01000000";  -- 66AF = 40
      when "0011010110000" =>  data <= "11101000";  -- 66B0 = E8
      when "0011010110001" =>  data <= "10001101";  -- 66B1 = 8D
      when "0011010110010" =>  data <= "01000010";  -- 66B2 = 42
      when "0011010110011" =>  data <= "11101000";  -- 66B3 = E8
      when "0011010110100" =>  data <= "10001110";  -- 66B4 = 8E
      when "0011010110101" =>  data <= "00100010";  -- 66B5 = 22
      when "0011010110110" =>  data <= "11101000";  -- 66B6 = E8
      when "0011010110111" =>  data <= "10001110";  -- 66B7 = 8E
      when "0011010111000" =>  data <= "01000101";  -- 66B8 = 45
      when "0011010111001" =>  data <= "11101000";  -- 66B9 = E8
      when "0011010111010" =>  data <= "10101001";  -- 66BA = A9
      when "0011010111011" =>  data <= "00111101";  -- 66BB = 3D
      when "0011010111100" =>  data <= "10001101";  -- 66BC = 8D
      when "0011010111101" =>  data <= "00010011";  -- 66BD = 13
      when "0011010111110" =>  data <= "11101000";  -- 66BE = E8
      when "0011010111111" =>  data <= "00101100";  -- 66BF = 2C
      when "0011011000000" =>  data <= "00010010";  -- 66C0 = 12
      when "0011011000001" =>  data <= "11101000";  -- 66C1 = E8
      when "0011011000010" =>  data <= "10101001";  -- 66C2 = A9
      when "0011011000011" =>  data <= "00111100";  -- 66C3 = 3C
      when "0011011000100" =>  data <= "10001101";  -- 66C4 = 8D
      when "0011011000101" =>  data <= "00100001";  -- 66C5 = 21
      when "0011011000110" =>  data <= "11101000";  -- 66C6 = E8
      when "0011011000111" =>  data <= "10001101";  -- 66C7 = 8D
      when "0011011001000" =>  data <= "00100011";  -- 66C8 = 23
      when "0011011001001" =>  data <= "11101000";  -- 66C9 = E8
      when "0011011001010" =>  data <= "10001101";  -- 66CA = 8D
      when "0011011001011" =>  data <= "00010001";  -- 66CB = 11
      when "0011011001100" =>  data <= "11101000";  -- 66CC = E8
      when "0011011001101" =>  data <= "10001110";  -- 66CD = 8E
      when "0011011001110" =>  data <= "00100010";  -- 66CE = 22
      when "0011011001111" =>  data <= "11101000";  -- 66CF = E8
      when "0011011010000" =>  data <= "10101001";  -- 66D0 = A9
      when "0011011010001" =>  data <= "00001100";  -- 66D1 = C
      when "0011011010010" =>  data <= "10001101";  -- 66D2 = 8D
      when "0011011010011" =>  data <= "01001100";  -- 66D3 = 4C
      when "0011011010100" =>  data <= "11101000";  -- 66D4 = E8
      when "0011011010101" =>  data <= "10000101";  -- 66D5 = 85
      when "0011011010110" =>  data <= "10101000";  -- 66D6 = A8
      when "0011011010111" =>  data <= "10000101";  -- 66D7 = 85
      when "0011011011000" =>  data <= "10100111";  -- 66D8 = A7
      when "0011011011001" =>  data <= "10101001";  -- 66D9 = A9
      when "0011011011010" =>  data <= "00001001";  -- 66DA = 9
      when "0011011011011" =>  data <= "10001101";  -- 66DB = 8D
      when "0011011011100" =>  data <= "11101011";  -- 66DC = EB
      when "0011011011101" =>  data <= "00000011";  -- 66DD = 3
      when "0011011011110" =>  data <= "10101001";  -- 66DE = A9
      when "0011011011111" =>  data <= "00010000";  -- 66DF = 10
      when "0011011100000" =>  data <= "10001101";  -- 66E0 = 8D
      when "0011011100001" =>  data <= "11101100";  -- 66E1 = EC
      when "0011011100010" =>  data <= "00000011";  -- 66E2 = 3
      when "0011011100011" =>  data <= "10001101";  -- 66E3 = 8D
      when "0011011100100" =>  data <= "11101001";  -- 66E4 = E9
      when "0011011100101" =>  data <= "00000011";  -- 66E5 = 3
      when "0011011100110" =>  data <= "10001101";  -- 66E6 = 8D
      when "0011011100111" =>  data <= "11101010";  -- 66E7 = EA
      when "0011011101000" =>  data <= "00000011";  -- 66E8 = 3
      when "0011011101001" =>  data <= "01100000";  -- 66E9 = 60
      when "0011011101010" =>  data <= "10100110";  -- 66EA = A6
      when "0011011101011" =>  data <= "11011000";  -- 66EB = D8
      when "0011011101100" =>  data <= "11101000";  -- 66EC = E8
      when "0011011101101" =>  data <= "11100000";  -- 66ED = E0
      when "0011011101110" =>  data <= "00011000";  -- 66EE = 18
      when "0011011101111" =>  data <= "11110000";  -- 66EF = F0
      when "0011011110000" =>  data <= "00110011";  -- 66F0 = 33
      when "0011011110001" =>  data <= "10010000";  -- 66F1 = 90
      when "0011011110010" =>  data <= "00000011";  -- 66F2 = 3
      when "0011011110011" =>  data <= "01001100";  -- 66F3 = 4C
      when "0011011110100" =>  data <= "11000100";  -- 66F4 = C4
      when "0011011110101" =>  data <= "11100001";  -- 66F5 = E1
      when "0011011110110" =>  data <= "10100010";  -- 66F6 = A2
      when "0011011110111" =>  data <= "00010111";  -- 66F7 = 17
      when "0011011111000" =>  data <= "10110101";  -- 66F8 = B5
      when "0011011111001" =>  data <= "11100001";  -- 66F9 = E1
      when "0011011111010" =>  data <= "00001001";  -- 66FA = 9
      when "0011011111011" =>  data <= "10000000";  -- 66FB = 80
      when "0011011111100" =>  data <= "10000101";  -- 66FC = 85
      when "0011011111101" =>  data <= "11001000";  -- 66FD = C8
      when "0011011111110" =>  data <= "10110100";  -- 66FE = B4
      when "0011011111111" =>  data <= "11100000";  -- 66FF = E0
      when "0011100000000" =>  data <= "00110000";  -- 6700 = 30
      when "0011100000001" =>  data <= "00000010";  -- 6701 = 2
      when "0011100000010" =>  data <= "00101001";  -- 6702 = 29
      when "0011100000011" =>  data <= "01111111";  -- 6703 = 7F
      when "0011100000100" =>  data <= "10010101";  -- 6704 = 95
      when "0011100000101" =>  data <= "11100001";  -- 6705 = E1
      when "0011100000110" =>  data <= "10011000";  -- 6706 = 98
      when "0011100000111" =>  data <= "00001001";  -- 6707 = 9
      when "0011100001000" =>  data <= "10000000";  -- 6708 = 80
      when "0011100001001" =>  data <= "10000101";  -- 6709 = 85
      when "0011100001010" =>  data <= "11000101";  -- 670A = C5
      when "0011100001011" =>  data <= "10100000";  -- 670B = A0
      when "0011100001100" =>  data <= "00100111";  -- 670C = 27
      when "0011100001101" =>  data <= "10111101";  -- 670D = BD
      when "0011100001110" =>  data <= "10011001";  -- 670E = 99
      when "0011100001111" =>  data <= "11100111";  -- 670F = E7
      when "0011100010000" =>  data <= "10000101";  -- 6710 = 85
      when "0011100010001" =>  data <= "11000111";  -- 6711 = C7
      when "0011100010010" =>  data <= "10111101";  -- 6712 = BD
      when "0011100010011" =>  data <= "10011000";  -- 6713 = 98
      when "0011100010100" =>  data <= "11100111";  -- 6714 = E7
      when "0011100010101" =>  data <= "10000101";  -- 6715 = 85
      when "0011100010110" =>  data <= "11000100";  -- 6716 = C4
      when "0011100010111" =>  data <= "10110001";  -- 6717 = B1
      when "0011100011000" =>  data <= "11000100";  -- 6718 = C4
      when "0011100011001" =>  data <= "10010001";  -- 6719 = 91
      when "0011100011010" =>  data <= "11000111";  -- 671A = C7
      when "0011100011011" =>  data <= "10001000";  -- 671B = 88
      when "0011100011100" =>  data <= "00010000";  -- 671C = 10
      when "0011100011101" =>  data <= "11111001";  -- 671D = F9
      when "0011100011110" =>  data <= "11001010";  -- 671E = CA
      when "0011100011111" =>  data <= "11100100";  -- 671F = E4
      when "0011100100000" =>  data <= "11011000";  -- 6720 = D8
      when "0011100100001" =>  data <= "11010000";  -- 6721 = D0
      when "0011100100010" =>  data <= "11010101";  -- 6722 = D5
      when "0011100100011" =>  data <= "11101000";  -- 6723 = E8
      when "0011100100100" =>  data <= "10110101";  -- 6724 = B5
      when "0011100100101" =>  data <= "11100000";  -- 6725 = E0
      when "0011100100110" =>  data <= "00001001";  -- 6726 = 9
      when "0011100100111" =>  data <= "10000000";  -- 6727 = 80
      when "0011100101000" =>  data <= "10000101";  -- 6728 = 85
      when "0011100101001" =>  data <= "11000101";  -- 6729 = C5
      when "0011100101010" =>  data <= "00101001";  -- 672A = 29
      when "0011100101011" =>  data <= "01111111";  -- 672B = 7F
      when "0011100101100" =>  data <= "10010101";  -- 672C = 95
      when "0011100101101" =>  data <= "11100000";  -- 672D = E0
      when "0011100101110" =>  data <= "10111101";  -- 672E = BD
      when "0011100101111" =>  data <= "10011000";  -- 672F = 98
      when "0011100110000" =>  data <= "11100111";  -- 6730 = E7
      when "0011100110001" =>  data <= "10000101";  -- 6731 = 85
      when "0011100110010" =>  data <= "11000100";  -- 6732 = C4
      when "0011100110011" =>  data <= "10100000";  -- 6733 = A0
      when "0011100110100" =>  data <= "00100111";  -- 6734 = 27
      when "0011100110101" =>  data <= "10101001";  -- 6735 = A9
      when "0011100110110" =>  data <= "00100000";  -- 6736 = 20
      when "0011100110111" =>  data <= "10010001";  -- 6737 = 91
      when "0011100111000" =>  data <= "11000100";  -- 6738 = C4
      when "0011100111001" =>  data <= "10001000";  -- 6739 = 88
      when "0011100111010" =>  data <= "00010000";  -- 673A = 10
      when "0011100111011" =>  data <= "11111011";  -- 673B = FB
      when "0011100111100" =>  data <= "01001100";  -- 673C = 4C
      when "0011100111101" =>  data <= "01110001";  -- 673D = 71
      when "0011100111110" =>  data <= "11100000";  -- 673E = E0
      when "0011100111111" =>  data <= "00111101";  -- 673F = 3D
      when "0011101000000" =>  data <= "00101110";  -- 6740 = 2E
      when "0011101000001" =>  data <= "00010000";  -- 6741 = 10
      when "0011101000010" =>  data <= "00000011";  -- 6742 = 3
      when "0011101000011" =>  data <= "00111100";  -- 6743 = 3C
      when "0011101000100" =>  data <= "00100000";  -- 6744 = 20
      when "0011101000101" =>  data <= "01011011";  -- 6745 = 5B
      when "0011101000110" =>  data <= "00010010";  -- 6746 = 12
      when "0011101000111" =>  data <= "00101101";  -- 6747 = 2D
      when "0011101001000" =>  data <= "00110000";  -- 6748 = 30
      when "0011101001001" =>  data <= "00000000";  -- 6749 = 0
      when "0011101001010" =>  data <= "00111110";  -- 674A = 3E
      when "0011101001011" =>  data <= "11111111";  -- 674B = FF
      when "0011101001100" =>  data <= "01011101";  -- 674C = 5D
      when "0011101001101" =>  data <= "01000000";  -- 674D = 40
      when "0011101001110" =>  data <= "00000000";  -- 674E = 0
      when "0011101001111" =>  data <= "00101011";  -- 674F = 2B
      when "0011101010000" =>  data <= "00110010";  -- 6750 = 32
      when "0011101010001" =>  data <= "11111111";  -- 6751 = FF
      when "0011101010010" =>  data <= "00111111";  -- 6752 = 3F
      when "0011101010011" =>  data <= "00101100";  -- 6753 = 2C
      when "0011101010100" =>  data <= "01001110";  -- 6754 = 4E
      when "0011101010101" =>  data <= "01010110";  -- 6755 = 56
      when "0011101010110" =>  data <= "01011000";  -- 6756 = 58
      when "0011101010111" =>  data <= "00110011";  -- 6757 = 33
      when "0011101011000" =>  data <= "00110001";  -- 6758 = 31
      when "0011101011001" =>  data <= "00001101";  -- 6759 = D
      when "0011101011010" =>  data <= "00111011";  -- 675A = 3B
      when "0011101011011" =>  data <= "01001101";  -- 675B = 4D
      when "0011101011100" =>  data <= "01000010";  -- 675C = 42
      when "0011101011101" =>  data <= "01000011";  -- 675D = 43
      when "0011101011110" =>  data <= "01011010";  -- 675E = 5A
      when "0011101011111" =>  data <= "00101010";  -- 675F = 2A
      when "0011101100000" =>  data <= "00110101";  -- 6760 = 35
      when "0011101100001" =>  data <= "11111111";  -- 6761 = FF
      when "0011101100010" =>  data <= "00111010";  -- 6762 = 3A
      when "0011101100011" =>  data <= "01001011";  -- 6763 = 4B
      when "0011101100100" =>  data <= "01001000";  -- 6764 = 48
      when "0011101100101" =>  data <= "01000110";  -- 6765 = 46
      when "0011101100110" =>  data <= "01010011";  -- 6766 = 53
      when "0011101100111" =>  data <= "00110110";  -- 6767 = 36
      when "0011101101000" =>  data <= "00110100";  -- 6768 = 34
      when "0011101101001" =>  data <= "11111111";  -- 6769 = FF
      when "0011101101010" =>  data <= "01001100";  -- 676A = 4C
      when "0011101101011" =>  data <= "01001010";  -- 676B = 4A
      when "0011101101100" =>  data <= "01000111";  -- 676C = 47
      when "0011101101101" =>  data <= "01000100";  -- 676D = 44
      when "0011101101110" =>  data <= "01000001";  -- 676E = 41
      when "0011101101111" =>  data <= "00101111";  -- 676F = 2F
      when "0011101110000" =>  data <= "00111000";  -- 6770 = 38
      when "0011101110001" =>  data <= "11111111";  -- 6771 = FF
      when "0011101110010" =>  data <= "01010000";  -- 6772 = 50
      when "0011101110011" =>  data <= "01001001";  -- 6773 = 49
      when "0011101110100" =>  data <= "01011001";  -- 6774 = 59
      when "0011101110101" =>  data <= "01010010";  -- 6775 = 52
      when "0011101110110" =>  data <= "01010111";  -- 6776 = 57
      when "0011101110111" =>  data <= "00111001";  -- 6777 = 39
      when "0011101111000" =>  data <= "00110111";  -- 6778 = 37
      when "0011101111001" =>  data <= "01011110";  -- 6779 = 5E
      when "0011101111010" =>  data <= "01001111";  -- 677A = 4F
      when "0011101111011" =>  data <= "01010101";  -- 677B = 55
      when "0011101111100" =>  data <= "01010100";  -- 677C = 54
      when "0011101111101" =>  data <= "01000101";  -- 677D = 45
      when "0011101111110" =>  data <= "01010001";  -- 677E = 51
      when "0011101111111" =>  data <= "00010100";  -- 677F = 14
      when "0011110000000" =>  data <= "00010001";  -- 6780 = 11
      when "0011110000001" =>  data <= "00001001";  -- 6781 = 9
      when "0011110000010" =>  data <= "00101001";  -- 6782 = 29
      when "0011110000011" =>  data <= "01011100";  -- 6783 = 5C
      when "0011110000100" =>  data <= "00100111";  -- 6784 = 27
      when "0011110000101" =>  data <= "00100100";  -- 6785 = 24
      when "0011110000110" =>  data <= "00100010";  -- 6786 = 22
      when "0011110000111" =>  data <= "00011101";  -- 6787 = 1D
      when "0011110001000" =>  data <= "00010011";  -- 6788 = 13
      when "0011110001001" =>  data <= "01011111";  -- 6789 = 5F
      when "0011110001010" =>  data <= "00101000";  -- 678A = 28
      when "0011110001011" =>  data <= "00100110";  -- 678B = 26
      when "0011110001100" =>  data <= "00100101";  -- 678C = 25
      when "0011110001101" =>  data <= "00100011";  -- 678D = 23
      when "0011110001110" =>  data <= "00100001";  -- 678E = 21
      when "0011110001111" =>  data <= "01000100";  -- 678F = 44
      when "0011110010000" =>  data <= "11001100";  -- 6790 = CC
      when "0011110010001" =>  data <= "00100010";  -- 6791 = 22
      when "0011110010010" =>  data <= "00101010";  -- 6792 = 2A
      when "0011110010011" =>  data <= "00001101";  -- 6793 = D
      when "0011110010100" =>  data <= "01010010";  -- 6794 = 52
      when "0011110010101" =>  data <= "01010101";  -- 6795 = 55
      when "0011110010110" =>  data <= "01001110";  -- 6796 = 4E
      when "0011110010111" =>  data <= "00001101";  -- 6797 = D
      when "0011110011000" =>  data <= "00000000";  -- 6798 = 0
      when "0011110011001" =>  data <= "00101000";  -- 6799 = 28
      when "0011110011010" =>  data <= "01010000";  -- 679A = 50
      when "0011110011011" =>  data <= "01111000";  -- 679B = 78
      when "0011110011100" =>  data <= "10100000";  -- 679C = A0
      when "0011110011101" =>  data <= "11001000";  -- 679D = C8
      when "0011110011110" =>  data <= "11110000";  -- 679E = F0
      when "0011110011111" =>  data <= "00011000";  -- 679F = 18
      when "0011110100000" =>  data <= "01000000";  -- 67A0 = 40
      when "0011110100001" =>  data <= "01101000";  -- 67A1 = 68
      when "0011110100010" =>  data <= "10010000";  -- 67A2 = 90
      when "0011110100011" =>  data <= "10111000";  -- 67A3 = B8
      when "0011110100100" =>  data <= "11100000";  -- 67A4 = E0
      when "0011110100101" =>  data <= "00001000";  -- 67A5 = 8
      when "0011110100110" =>  data <= "00110000";  -- 67A6 = 30
      when "0011110100111" =>  data <= "01011000";  -- 67A7 = 58
      when "0011110101000" =>  data <= "10000000";  -- 67A8 = 80
      when "0011110101001" =>  data <= "10101000";  -- 67A9 = A8
      when "0011110101010" =>  data <= "11010000";  -- 67AA = D0
      when "0011110101011" =>  data <= "11111000";  -- 67AB = F8
      when "0011110101100" =>  data <= "00100000";  -- 67AC = 20
      when "0011110101101" =>  data <= "01001000";  -- 67AD = 48
      when "0011110101110" =>  data <= "01110000";  -- 67AE = 70
      when "0011110101111" =>  data <= "10011000";  -- 67AF = 98
      when "0011110110000" =>  data <= "11000000";  -- 67B0 = C0
      when "0011110110001" =>  data <= "00111101";  -- 67B1 = 3D
      when "0011110110010" =>  data <= "00101000";  -- 67B2 = 28
      when "0011110110011" =>  data <= "00110001";  -- 67B3 = 31
      when "0011110110100" =>  data <= "00000011";  -- 67B4 = 3
      when "0011110110101" =>  data <= "00100010";  -- 67B5 = 22
      when "0011110110110" =>  data <= "00000000";  -- 67B6 = 0
      when "0011110110111" =>  data <= "00011001";  -- 67B7 = 19
      when "0011110111000" =>  data <= "00011101";  -- 67B8 = 1D
      when "0011110111001" =>  data <= "00000000";  -- 67B9 = 0
      when "0011110111010" =>  data <= "00001001";  -- 67BA = 9
      when "0011110111011" =>  data <= "00000000";  -- 67BB = 0
      when "0011110111100" =>  data <= "00000000";  -- 67BC = 0
      when "0011110111101" =>  data <= "00010000";  -- 67BD = 10
      when "0011110111110" =>  data <= "00000000";  -- 67BE = 0
      when "0011110111111" =>  data <= "00000000";  -- 67BF = 0
      when "0011111000000" =>  data <= "00000000";  -- 67C0 = 0
      when "0011111000001" =>  data <= "00000000";  -- 67C1 = 0
      when "0011111000010" =>  data <= "00000000";  -- 67C2 = 0
      when "0011111000011" =>  data <= "00111101";  -- 67C3 = 3D
      when "0011111000100" =>  data <= "00101000";  -- 67C4 = 28
      when "0011111000101" =>  data <= "00110001";  -- 67C5 = 31
      when "0011111000110" =>  data <= "00000011";  -- 67C6 = 3
      when "0011111000111" =>  data <= "00101010";  -- 67C7 = 2A
      when "0011111001000" =>  data <= "00000000";  -- 67C8 = 0
      when "0011111001001" =>  data <= "00011001";  -- 67C9 = 19
      when "0011111001010" =>  data <= "00100010";  -- 67CA = 22
      when "0011111001011" =>  data <= "00000000";  -- 67CB = 0
      when "0011111001100" =>  data <= "00000111";  -- 67CC = 7
      when "0011111001101" =>  data <= "00000000";  -- 67CD = 0
      when "0011111001110" =>  data <= "00000000";  -- 67CE = 0
      when "0011111001111" =>  data <= "00010000";  -- 67CF = 10
      when "0011111010000" =>  data <= "00000000";  -- 67D0 = 0
      when "0011111010001" =>  data <= "00000000";  -- 67D1 = 0
      when "0011111010010" =>  data <= "00000000";  -- 67D2 = 0
      when "0011111010011" =>  data <= "00000000";  -- 67D3 = 0
      when "0011111010100" =>  data <= "00000000";  -- 67D4 = 0
      when "0011111010101" =>  data <= "00001110";  -- 67D5 = E
      when "0011111010110" =>  data <= "00011110";  -- 67D6 = 1E
      when "0011111010111" =>  data <= "00111110";  -- 67D7 = 3E
      when "0011111011000" =>  data <= "01111110";  -- 67D8 = 7E
      when "0011111011001" =>  data <= "00111110";  -- 67D9 = 3E
      when "0011111011010" =>  data <= "00011110";  -- 67DA = 1E
      when "0011111011011" =>  data <= "00001110";  -- 67DB = E
      when "0011111011100" =>  data <= "10000000";  -- 67DC = 80
      when "0011111011101" =>  data <= "01000000";  -- 67DD = 40
      when "0011111011110" =>  data <= "00100000";  -- 67DE = 20
      when "0011111011111" =>  data <= "00010000";  -- 67DF = 10
      when "0011111100000" =>  data <= "00001000";  -- 67E0 = 8
      when "0011111100001" =>  data <= "00000100";  -- 67E1 = 4
      when "0011111100010" =>  data <= "00000010";  -- 67E2 = 2
      when "0011111100011" =>  data <= "00000001";  -- 67E3 = 1
      when "0011111100100" =>  data <= "00101001";  -- 67E4 = 29
      when "0011111100101" =>  data <= "10101010";  -- 67E5 = AA
      when "0011111100110" =>  data <= "10101010";  -- 67E6 = AA
      when "0011111100111" =>  data <= "10101010";  -- 67E7 = AA
      when "0011111101000" =>  data <= "10101010";  -- 67E8 = AA
      when "0011111101001" =>  data <= "10101010";  -- 67E9 = AA
      when "0011111101010" =>  data <= "10101010";  -- 67EA = AA
      when "0011111101011" =>  data <= "10101010";  -- 67EB = AA
      when "0011111101100" =>  data <= "10101010";  -- 67EC = AA
      when "0011111101101" =>  data <= "10101010";  -- 67ED = AA
      when "0011111101110" =>  data <= "10101010";  -- 67EE = AA
      when "0011111101111" =>  data <= "10101010";  -- 67EF = AA
      when "0011111110000" =>  data <= "10101010";  -- 67F0 = AA
      when "0011111110001" =>  data <= "10101010";  -- 67F1 = AA
      when "0011111110010" =>  data <= "10101010";  -- 67F2 = AA
      when "0011111110011" =>  data <= "10101010";  -- 67F3 = AA
      when "0011111110100" =>  data <= "10101010";  -- 67F4 = AA
      when "0011111110101" =>  data <= "10101010";  -- 67F5 = AA
      when "0011111110110" =>  data <= "10101010";  -- 67F6 = AA
      when "0011111110111" =>  data <= "10101010";  -- 67F7 = AA
      when "0011111111000" =>  data <= "10101010";  -- 67F8 = AA
      when "0011111111001" =>  data <= "10101010";  -- 67F9 = AA
      when "0011111111010" =>  data <= "10101010";  -- 67FA = AA
      when "0011111111011" =>  data <= "10101010";  -- 67FB = AA
      when "0011111111100" =>  data <= "10101010";  -- 67FC = AA
      when "0011111111101" =>  data <= "10101010";  -- 67FD = AA
      when "0011111111110" =>  data <= "10101010";  -- 67FE = AA
      when "0011111111111" =>  data <= "10101010";  -- 67FF = AA
      when "0100000000000" =>  data <= "11111111";  -- 6800 = FF
      when "0100000000001" =>  data <= "11111111";  -- 6801 = FF
      when "0100000000010" =>  data <= "11111111";  -- 6802 = FF
      when "0100000000011" =>  data <= "11111111";  -- 6803 = FF
      when "0100000000100" =>  data <= "11111111";  -- 6804 = FF
      when "0100000000101" =>  data <= "11111111";  -- 6805 = FF
      when "0100000000110" =>  data <= "11111111";  -- 6806 = FF
      when "0100000000111" =>  data <= "11111111";  -- 6807 = FF
      when "0100000001000" =>  data <= "11111111";  -- 6808 = FF
      when "0100000001001" =>  data <= "11111111";  -- 6809 = FF
      when "0100000001010" =>  data <= "11111111";  -- 680A = FF
      when "0100000001011" =>  data <= "11111111";  -- 680B = FF
      when "0100000001100" =>  data <= "11111111";  -- 680C = FF
      when "0100000001101" =>  data <= "11111111";  -- 680D = FF
      when "0100000001110" =>  data <= "11111111";  -- 680E = FF
      when "0100000001111" =>  data <= "11111111";  -- 680F = FF
      when "0100000010000" =>  data <= "11111111";  -- 6810 = FF
      when "0100000010001" =>  data <= "11111111";  -- 6811 = FF
      when "0100000010010" =>  data <= "11111111";  -- 6812 = FF
      when "0100000010011" =>  data <= "11111111";  -- 6813 = FF
      when "0100000010100" =>  data <= "11111111";  -- 6814 = FF
      when "0100000010101" =>  data <= "11111111";  -- 6815 = FF
      when "0100000010110" =>  data <= "11111111";  -- 6816 = FF
      when "0100000010111" =>  data <= "11111111";  -- 6817 = FF
      when "0100000011000" =>  data <= "11111111";  -- 6818 = FF
      when "0100000011001" =>  data <= "11111111";  -- 6819 = FF
      when "0100000011010" =>  data <= "11111111";  -- 681A = FF
      when "0100000011011" =>  data <= "11111111";  -- 681B = FF
      when "0100000011100" =>  data <= "11111111";  -- 681C = FF
      when "0100000011101" =>  data <= "11111111";  -- 681D = FF
      when "0100000011110" =>  data <= "11111111";  -- 681E = FF
      when "0100000011111" =>  data <= "11111111";  -- 681F = FF
      when "0100000100000" =>  data <= "11111111";  -- 6820 = FF
      when "0100000100001" =>  data <= "11111111";  -- 6821 = FF
      when "0100000100010" =>  data <= "11111111";  -- 6822 = FF
      when "0100000100011" =>  data <= "11111111";  -- 6823 = FF
      when "0100000100100" =>  data <= "11111111";  -- 6824 = FF
      when "0100000100101" =>  data <= "11111111";  -- 6825 = FF
      when "0100000100110" =>  data <= "11111111";  -- 6826 = FF
      when "0100000100111" =>  data <= "11111111";  -- 6827 = FF
      when "0100000101000" =>  data <= "11111111";  -- 6828 = FF
      when "0100000101001" =>  data <= "11111111";  -- 6829 = FF
      when "0100000101010" =>  data <= "11111111";  -- 682A = FF
      when "0100000101011" =>  data <= "11111111";  -- 682B = FF
      when "0100000101100" =>  data <= "11111111";  -- 682C = FF
      when "0100000101101" =>  data <= "11111111";  -- 682D = FF
      when "0100000101110" =>  data <= "11111111";  -- 682E = FF
      when "0100000101111" =>  data <= "11111111";  -- 682F = FF
      when "0100000110000" =>  data <= "11111111";  -- 6830 = FF
      when "0100000110001" =>  data <= "11111111";  -- 6831 = FF
      when "0100000110010" =>  data <= "11111111";  -- 6832 = FF
      when "0100000110011" =>  data <= "11111111";  -- 6833 = FF
      when "0100000110100" =>  data <= "11111111";  -- 6834 = FF
      when "0100000110101" =>  data <= "11111111";  -- 6835 = FF
      when "0100000110110" =>  data <= "11111111";  -- 6836 = FF
      when "0100000110111" =>  data <= "11111111";  -- 6837 = FF
      when "0100000111000" =>  data <= "11111111";  -- 6838 = FF
      when "0100000111001" =>  data <= "11111111";  -- 6839 = FF
      when "0100000111010" =>  data <= "11111111";  -- 683A = FF
      when "0100000111011" =>  data <= "11111111";  -- 683B = FF
      when "0100000111100" =>  data <= "11111111";  -- 683C = FF
      when "0100000111101" =>  data <= "11111111";  -- 683D = FF
      when "0100000111110" =>  data <= "11111111";  -- 683E = FF
      when "0100000111111" =>  data <= "11111111";  -- 683F = FF
      when "0100001000000" =>  data <= "11111111";  -- 6840 = FF
      when "0100001000001" =>  data <= "11111111";  -- 6841 = FF
      when "0100001000010" =>  data <= "11111111";  -- 6842 = FF
      when "0100001000011" =>  data <= "11111111";  -- 6843 = FF
      when "0100001000100" =>  data <= "11111111";  -- 6844 = FF
      when "0100001000101" =>  data <= "11111111";  -- 6845 = FF
      when "0100001000110" =>  data <= "11111111";  -- 6846 = FF
      when "0100001000111" =>  data <= "11111111";  -- 6847 = FF
      when "0100001001000" =>  data <= "11111111";  -- 6848 = FF
      when "0100001001001" =>  data <= "11111111";  -- 6849 = FF
      when "0100001001010" =>  data <= "11111111";  -- 684A = FF
      when "0100001001011" =>  data <= "11111111";  -- 684B = FF
      when "0100001001100" =>  data <= "11111111";  -- 684C = FF
      when "0100001001101" =>  data <= "11111111";  -- 684D = FF
      when "0100001001110" =>  data <= "11111111";  -- 684E = FF
      when "0100001001111" =>  data <= "11111111";  -- 684F = FF
      when "0100001010000" =>  data <= "11111111";  -- 6850 = FF
      when "0100001010001" =>  data <= "11111111";  -- 6851 = FF
      when "0100001010010" =>  data <= "11111111";  -- 6852 = FF
      when "0100001010011" =>  data <= "11111111";  -- 6853 = FF
      when "0100001010100" =>  data <= "11111111";  -- 6854 = FF
      when "0100001010101" =>  data <= "11111111";  -- 6855 = FF
      when "0100001010110" =>  data <= "11111111";  -- 6856 = FF
      when "0100001010111" =>  data <= "11111111";  -- 6857 = FF
      when "0100001011000" =>  data <= "11111111";  -- 6858 = FF
      when "0100001011001" =>  data <= "11111111";  -- 6859 = FF
      when "0100001011010" =>  data <= "11111111";  -- 685A = FF
      when "0100001011011" =>  data <= "11111111";  -- 685B = FF
      when "0100001011100" =>  data <= "11111111";  -- 685C = FF
      when "0100001011101" =>  data <= "11111111";  -- 685D = FF
      when "0100001011110" =>  data <= "11111111";  -- 685E = FF
      when "0100001011111" =>  data <= "11111111";  -- 685F = FF
      when "0100001100000" =>  data <= "11111111";  -- 6860 = FF
      when "0100001100001" =>  data <= "11111111";  -- 6861 = FF
      when "0100001100010" =>  data <= "11111111";  -- 6862 = FF
      when "0100001100011" =>  data <= "11111111";  -- 6863 = FF
      when "0100001100100" =>  data <= "11111111";  -- 6864 = FF
      when "0100001100101" =>  data <= "11111111";  -- 6865 = FF
      when "0100001100110" =>  data <= "11111111";  -- 6866 = FF
      when "0100001100111" =>  data <= "11111111";  -- 6867 = FF
      when "0100001101000" =>  data <= "11111111";  -- 6868 = FF
      when "0100001101001" =>  data <= "11111111";  -- 6869 = FF
      when "0100001101010" =>  data <= "11111111";  -- 686A = FF
      when "0100001101011" =>  data <= "11111111";  -- 686B = FF
      when "0100001101100" =>  data <= "11111111";  -- 686C = FF
      when "0100001101101" =>  data <= "11111111";  -- 686D = FF
      when "0100001101110" =>  data <= "11111111";  -- 686E = FF
      when "0100001101111" =>  data <= "11111111";  -- 686F = FF
      when "0100001110000" =>  data <= "11111111";  -- 6870 = FF
      when "0100001110001" =>  data <= "11111111";  -- 6871 = FF
      when "0100001110010" =>  data <= "11111111";  -- 6872 = FF
      when "0100001110011" =>  data <= "11111111";  -- 6873 = FF
      when "0100001110100" =>  data <= "11111111";  -- 6874 = FF
      when "0100001110101" =>  data <= "11111111";  -- 6875 = FF
      when "0100001110110" =>  data <= "11111111";  -- 6876 = FF
      when "0100001110111" =>  data <= "11111111";  -- 6877 = FF
      when "0100001111000" =>  data <= "11111111";  -- 6878 = FF
      when "0100001111001" =>  data <= "11111111";  -- 6879 = FF
      when "0100001111010" =>  data <= "11111111";  -- 687A = FF
      when "0100001111011" =>  data <= "11111111";  -- 687B = FF
      when "0100001111100" =>  data <= "11111111";  -- 687C = FF
      when "0100001111101" =>  data <= "11111111";  -- 687D = FF
      when "0100001111110" =>  data <= "11111111";  -- 687E = FF
      when "0100001111111" =>  data <= "11111111";  -- 687F = FF
      when "0100010000000" =>  data <= "11111111";  -- 6880 = FF
      when "0100010000001" =>  data <= "11111111";  -- 6881 = FF
      when "0100010000010" =>  data <= "11111111";  -- 6882 = FF
      when "0100010000011" =>  data <= "11111111";  -- 6883 = FF
      when "0100010000100" =>  data <= "11111111";  -- 6884 = FF
      when "0100010000101" =>  data <= "11111111";  -- 6885 = FF
      when "0100010000110" =>  data <= "11111111";  -- 6886 = FF
      when "0100010000111" =>  data <= "11111111";  -- 6887 = FF
      when "0100010001000" =>  data <= "11111111";  -- 6888 = FF
      when "0100010001001" =>  data <= "11111111";  -- 6889 = FF
      when "0100010001010" =>  data <= "11111111";  -- 688A = FF
      when "0100010001011" =>  data <= "11111111";  -- 688B = FF
      when "0100010001100" =>  data <= "11111111";  -- 688C = FF
      when "0100010001101" =>  data <= "11111111";  -- 688D = FF
      when "0100010001110" =>  data <= "11111111";  -- 688E = FF
      when "0100010001111" =>  data <= "11111111";  -- 688F = FF
      when "0100010010000" =>  data <= "11111111";  -- 6890 = FF
      when "0100010010001" =>  data <= "11111111";  -- 6891 = FF
      when "0100010010010" =>  data <= "11111111";  -- 6892 = FF
      when "0100010010011" =>  data <= "11111111";  -- 6893 = FF
      when "0100010010100" =>  data <= "11111111";  -- 6894 = FF
      when "0100010010101" =>  data <= "11111111";  -- 6895 = FF
      when "0100010010110" =>  data <= "11111111";  -- 6896 = FF
      when "0100010010111" =>  data <= "11111111";  -- 6897 = FF
      when "0100010011000" =>  data <= "11111111";  -- 6898 = FF
      when "0100010011001" =>  data <= "11111111";  -- 6899 = FF
      when "0100010011010" =>  data <= "11111111";  -- 689A = FF
      when "0100010011011" =>  data <= "11111111";  -- 689B = FF
      when "0100010011100" =>  data <= "11111111";  -- 689C = FF
      when "0100010011101" =>  data <= "11111111";  -- 689D = FF
      when "0100010011110" =>  data <= "11111111";  -- 689E = FF
      when "0100010011111" =>  data <= "11111111";  -- 689F = FF
      when "0100010100000" =>  data <= "11111111";  -- 68A0 = FF
      when "0100010100001" =>  data <= "11111111";  -- 68A1 = FF
      when "0100010100010" =>  data <= "11111111";  -- 68A2 = FF
      when "0100010100011" =>  data <= "11111111";  -- 68A3 = FF
      when "0100010100100" =>  data <= "11111111";  -- 68A4 = FF
      when "0100010100101" =>  data <= "11111111";  -- 68A5 = FF
      when "0100010100110" =>  data <= "11111111";  -- 68A6 = FF
      when "0100010100111" =>  data <= "11111111";  -- 68A7 = FF
      when "0100010101000" =>  data <= "11111111";  -- 68A8 = FF
      when "0100010101001" =>  data <= "11111111";  -- 68A9 = FF
      when "0100010101010" =>  data <= "11111111";  -- 68AA = FF
      when "0100010101011" =>  data <= "11111111";  -- 68AB = FF
      when "0100010101100" =>  data <= "11111111";  -- 68AC = FF
      when "0100010101101" =>  data <= "11111111";  -- 68AD = FF
      when "0100010101110" =>  data <= "11111111";  -- 68AE = FF
      when "0100010101111" =>  data <= "11111111";  -- 68AF = FF
      when "0100010110000" =>  data <= "11111111";  -- 68B0 = FF
      when "0100010110001" =>  data <= "11111111";  -- 68B1 = FF
      when "0100010110010" =>  data <= "11111111";  -- 68B2 = FF
      when "0100010110011" =>  data <= "11111111";  -- 68B3 = FF
      when "0100010110100" =>  data <= "11111111";  -- 68B4 = FF
      when "0100010110101" =>  data <= "11111111";  -- 68B5 = FF
      when "0100010110110" =>  data <= "11111111";  -- 68B6 = FF
      when "0100010110111" =>  data <= "11111111";  -- 68B7 = FF
      when "0100010111000" =>  data <= "11111111";  -- 68B8 = FF
      when "0100010111001" =>  data <= "11111111";  -- 68B9 = FF
      when "0100010111010" =>  data <= "11111111";  -- 68BA = FF
      when "0100010111011" =>  data <= "11111111";  -- 68BB = FF
      when "0100010111100" =>  data <= "11111111";  -- 68BC = FF
      when "0100010111101" =>  data <= "11111111";  -- 68BD = FF
      when "0100010111110" =>  data <= "11111111";  -- 68BE = FF
      when "0100010111111" =>  data <= "11111111";  -- 68BF = FF
      when "0100011000000" =>  data <= "11111111";  -- 68C0 = FF
      when "0100011000001" =>  data <= "11111111";  -- 68C1 = FF
      when "0100011000010" =>  data <= "11111111";  -- 68C2 = FF
      when "0100011000011" =>  data <= "11111111";  -- 68C3 = FF
      when "0100011000100" =>  data <= "11111111";  -- 68C4 = FF
      when "0100011000101" =>  data <= "11111111";  -- 68C5 = FF
      when "0100011000110" =>  data <= "11111111";  -- 68C6 = FF
      when "0100011000111" =>  data <= "11111111";  -- 68C7 = FF
      when "0100011001000" =>  data <= "11111111";  -- 68C8 = FF
      when "0100011001001" =>  data <= "11111111";  -- 68C9 = FF
      when "0100011001010" =>  data <= "11111111";  -- 68CA = FF
      when "0100011001011" =>  data <= "11111111";  -- 68CB = FF
      when "0100011001100" =>  data <= "11111111";  -- 68CC = FF
      when "0100011001101" =>  data <= "11111111";  -- 68CD = FF
      when "0100011001110" =>  data <= "11111111";  -- 68CE = FF
      when "0100011001111" =>  data <= "11111111";  -- 68CF = FF
      when "0100011010000" =>  data <= "11111111";  -- 68D0 = FF
      when "0100011010001" =>  data <= "11111111";  -- 68D1 = FF
      when "0100011010010" =>  data <= "11111111";  -- 68D2 = FF
      when "0100011010011" =>  data <= "11111111";  -- 68D3 = FF
      when "0100011010100" =>  data <= "11111111";  -- 68D4 = FF
      when "0100011010101" =>  data <= "11111111";  -- 68D5 = FF
      when "0100011010110" =>  data <= "11111111";  -- 68D6 = FF
      when "0100011010111" =>  data <= "11111111";  -- 68D7 = FF
      when "0100011011000" =>  data <= "11111111";  -- 68D8 = FF
      when "0100011011001" =>  data <= "11111111";  -- 68D9 = FF
      when "0100011011010" =>  data <= "11111111";  -- 68DA = FF
      when "0100011011011" =>  data <= "11111111";  -- 68DB = FF
      when "0100011011100" =>  data <= "11111111";  -- 68DC = FF
      when "0100011011101" =>  data <= "11111111";  -- 68DD = FF
      when "0100011011110" =>  data <= "11111111";  -- 68DE = FF
      when "0100011011111" =>  data <= "11111111";  -- 68DF = FF
      when "0100011100000" =>  data <= "11111111";  -- 68E0 = FF
      when "0100011100001" =>  data <= "11111111";  -- 68E1 = FF
      when "0100011100010" =>  data <= "11111111";  -- 68E2 = FF
      when "0100011100011" =>  data <= "11111111";  -- 68E3 = FF
      when "0100011100100" =>  data <= "11111111";  -- 68E4 = FF
      when "0100011100101" =>  data <= "11111111";  -- 68E5 = FF
      when "0100011100110" =>  data <= "11111111";  -- 68E6 = FF
      when "0100011100111" =>  data <= "11111111";  -- 68E7 = FF
      when "0100011101000" =>  data <= "11111111";  -- 68E8 = FF
      when "0100011101001" =>  data <= "11111111";  -- 68E9 = FF
      when "0100011101010" =>  data <= "11111111";  -- 68EA = FF
      when "0100011101011" =>  data <= "11111111";  -- 68EB = FF
      when "0100011101100" =>  data <= "11111111";  -- 68EC = FF
      when "0100011101101" =>  data <= "11111111";  -- 68ED = FF
      when "0100011101110" =>  data <= "11111111";  -- 68EE = FF
      when "0100011101111" =>  data <= "11111111";  -- 68EF = FF
      when "0100011110000" =>  data <= "11111111";  -- 68F0 = FF
      when "0100011110001" =>  data <= "11111111";  -- 68F1 = FF
      when "0100011110010" =>  data <= "11111111";  -- 68F2 = FF
      when "0100011110011" =>  data <= "11111111";  -- 68F3 = FF
      when "0100011110100" =>  data <= "11111111";  -- 68F4 = FF
      when "0100011110101" =>  data <= "11111111";  -- 68F5 = FF
      when "0100011110110" =>  data <= "11111111";  -- 68F6 = FF
      when "0100011110111" =>  data <= "11111111";  -- 68F7 = FF
      when "0100011111000" =>  data <= "11111111";  -- 68F8 = FF
      when "0100011111001" =>  data <= "11111111";  -- 68F9 = FF
      when "0100011111010" =>  data <= "11111111";  -- 68FA = FF
      when "0100011111011" =>  data <= "11111111";  -- 68FB = FF
      when "0100011111100" =>  data <= "11111111";  -- 68FC = FF
      when "0100011111101" =>  data <= "11111111";  -- 68FD = FF
      when "0100011111110" =>  data <= "11111111";  -- 68FE = FF
      when "0100011111111" =>  data <= "11111111";  -- 68FF = FF
      when "0100100000000" =>  data <= "11111111";  -- 6900 = FF
      when "0100100000001" =>  data <= "11111111";  -- 6901 = FF
      when "0100100000010" =>  data <= "11111111";  -- 6902 = FF
      when "0100100000011" =>  data <= "11111111";  -- 6903 = FF
      when "0100100000100" =>  data <= "11111111";  -- 6904 = FF
      when "0100100000101" =>  data <= "11111111";  -- 6905 = FF
      when "0100100000110" =>  data <= "11111111";  -- 6906 = FF
      when "0100100000111" =>  data <= "11111111";  -- 6907 = FF
      when "0100100001000" =>  data <= "11111111";  -- 6908 = FF
      when "0100100001001" =>  data <= "11111111";  -- 6909 = FF
      when "0100100001010" =>  data <= "11111111";  -- 690A = FF
      when "0100100001011" =>  data <= "11111111";  -- 690B = FF
      when "0100100001100" =>  data <= "11111111";  -- 690C = FF
      when "0100100001101" =>  data <= "11111111";  -- 690D = FF
      when "0100100001110" =>  data <= "11111111";  -- 690E = FF
      when "0100100001111" =>  data <= "11111111";  -- 690F = FF
      when "0100100010000" =>  data <= "11111111";  -- 6910 = FF
      when "0100100010001" =>  data <= "11111111";  -- 6911 = FF
      when "0100100010010" =>  data <= "11111111";  -- 6912 = FF
      when "0100100010011" =>  data <= "11111111";  -- 6913 = FF
      when "0100100010100" =>  data <= "11111111";  -- 6914 = FF
      when "0100100010101" =>  data <= "11111111";  -- 6915 = FF
      when "0100100010110" =>  data <= "11111111";  -- 6916 = FF
      when "0100100010111" =>  data <= "11111111";  -- 6917 = FF
      when "0100100011000" =>  data <= "11111111";  -- 6918 = FF
      when "0100100011001" =>  data <= "11111111";  -- 6919 = FF
      when "0100100011010" =>  data <= "11111111";  -- 691A = FF
      when "0100100011011" =>  data <= "11111111";  -- 691B = FF
      when "0100100011100" =>  data <= "11111111";  -- 691C = FF
      when "0100100011101" =>  data <= "11111111";  -- 691D = FF
      when "0100100011110" =>  data <= "11111111";  -- 691E = FF
      when "0100100011111" =>  data <= "11111111";  -- 691F = FF
      when "0100100100000" =>  data <= "11111111";  -- 6920 = FF
      when "0100100100001" =>  data <= "11111111";  -- 6921 = FF
      when "0100100100010" =>  data <= "11111111";  -- 6922 = FF
      when "0100100100011" =>  data <= "11111111";  -- 6923 = FF
      when "0100100100100" =>  data <= "11111111";  -- 6924 = FF
      when "0100100100101" =>  data <= "11111111";  -- 6925 = FF
      when "0100100100110" =>  data <= "11111111";  -- 6926 = FF
      when "0100100100111" =>  data <= "11111111";  -- 6927 = FF
      when "0100100101000" =>  data <= "11111111";  -- 6928 = FF
      when "0100100101001" =>  data <= "11111111";  -- 6929 = FF
      when "0100100101010" =>  data <= "11111111";  -- 692A = FF
      when "0100100101011" =>  data <= "11111111";  -- 692B = FF
      when "0100100101100" =>  data <= "11111111";  -- 692C = FF
      when "0100100101101" =>  data <= "11111111";  -- 692D = FF
      when "0100100101110" =>  data <= "11111111";  -- 692E = FF
      when "0100100101111" =>  data <= "11111111";  -- 692F = FF
      when "0100100110000" =>  data <= "11111111";  -- 6930 = FF
      when "0100100110001" =>  data <= "11111111";  -- 6931 = FF
      when "0100100110010" =>  data <= "11111111";  -- 6932 = FF
      when "0100100110011" =>  data <= "11111111";  -- 6933 = FF
      when "0100100110100" =>  data <= "11111111";  -- 6934 = FF
      when "0100100110101" =>  data <= "11111111";  -- 6935 = FF
      when "0100100110110" =>  data <= "11111111";  -- 6936 = FF
      when "0100100110111" =>  data <= "11111111";  -- 6937 = FF
      when "0100100111000" =>  data <= "11111111";  -- 6938 = FF
      when "0100100111001" =>  data <= "11111111";  -- 6939 = FF
      when "0100100111010" =>  data <= "11111111";  -- 693A = FF
      when "0100100111011" =>  data <= "11111111";  -- 693B = FF
      when "0100100111100" =>  data <= "11111111";  -- 693C = FF
      when "0100100111101" =>  data <= "11111111";  -- 693D = FF
      when "0100100111110" =>  data <= "11111111";  -- 693E = FF
      when "0100100111111" =>  data <= "11111111";  -- 693F = FF
      when "0100101000000" =>  data <= "11111111";  -- 6940 = FF
      when "0100101000001" =>  data <= "11111111";  -- 6941 = FF
      when "0100101000010" =>  data <= "11111111";  -- 6942 = FF
      when "0100101000011" =>  data <= "11111111";  -- 6943 = FF
      when "0100101000100" =>  data <= "11111111";  -- 6944 = FF
      when "0100101000101" =>  data <= "11111111";  -- 6945 = FF
      when "0100101000110" =>  data <= "11111111";  -- 6946 = FF
      when "0100101000111" =>  data <= "11111111";  -- 6947 = FF
      when "0100101001000" =>  data <= "11111111";  -- 6948 = FF
      when "0100101001001" =>  data <= "11111111";  -- 6949 = FF
      when "0100101001010" =>  data <= "11111111";  -- 694A = FF
      when "0100101001011" =>  data <= "11111111";  -- 694B = FF
      when "0100101001100" =>  data <= "11111111";  -- 694C = FF
      when "0100101001101" =>  data <= "11111111";  -- 694D = FF
      when "0100101001110" =>  data <= "11111111";  -- 694E = FF
      when "0100101001111" =>  data <= "11111111";  -- 694F = FF
      when "0100101010000" =>  data <= "11111111";  -- 6950 = FF
      when "0100101010001" =>  data <= "11111111";  -- 6951 = FF
      when "0100101010010" =>  data <= "11111111";  -- 6952 = FF
      when "0100101010011" =>  data <= "11111111";  -- 6953 = FF
      when "0100101010100" =>  data <= "11111111";  -- 6954 = FF
      when "0100101010101" =>  data <= "11111111";  -- 6955 = FF
      when "0100101010110" =>  data <= "11111111";  -- 6956 = FF
      when "0100101010111" =>  data <= "11111111";  -- 6957 = FF
      when "0100101011000" =>  data <= "11111111";  -- 6958 = FF
      when "0100101011001" =>  data <= "11111111";  -- 6959 = FF
      when "0100101011010" =>  data <= "11111111";  -- 695A = FF
      when "0100101011011" =>  data <= "11111111";  -- 695B = FF
      when "0100101011100" =>  data <= "11111111";  -- 695C = FF
      when "0100101011101" =>  data <= "11111111";  -- 695D = FF
      when "0100101011110" =>  data <= "11111111";  -- 695E = FF
      when "0100101011111" =>  data <= "11111111";  -- 695F = FF
      when "0100101100000" =>  data <= "11111111";  -- 6960 = FF
      when "0100101100001" =>  data <= "11111111";  -- 6961 = FF
      when "0100101100010" =>  data <= "11111111";  -- 6962 = FF
      when "0100101100011" =>  data <= "11111111";  -- 6963 = FF
      when "0100101100100" =>  data <= "11111111";  -- 6964 = FF
      when "0100101100101" =>  data <= "11111111";  -- 6965 = FF
      when "0100101100110" =>  data <= "11111111";  -- 6966 = FF
      when "0100101100111" =>  data <= "11111111";  -- 6967 = FF
      when "0100101101000" =>  data <= "11111111";  -- 6968 = FF
      when "0100101101001" =>  data <= "11111111";  -- 6969 = FF
      when "0100101101010" =>  data <= "11111111";  -- 696A = FF
      when "0100101101011" =>  data <= "11111111";  -- 696B = FF
      when "0100101101100" =>  data <= "11111111";  -- 696C = FF
      when "0100101101101" =>  data <= "11111111";  -- 696D = FF
      when "0100101101110" =>  data <= "11111111";  -- 696E = FF
      when "0100101101111" =>  data <= "11111111";  -- 696F = FF
      when "0100101110000" =>  data <= "11111111";  -- 6970 = FF
      when "0100101110001" =>  data <= "11111111";  -- 6971 = FF
      when "0100101110010" =>  data <= "11111111";  -- 6972 = FF
      when "0100101110011" =>  data <= "11111111";  -- 6973 = FF
      when "0100101110100" =>  data <= "11111111";  -- 6974 = FF
      when "0100101110101" =>  data <= "11111111";  -- 6975 = FF
      when "0100101110110" =>  data <= "11111111";  -- 6976 = FF
      when "0100101110111" =>  data <= "11111111";  -- 6977 = FF
      when "0100101111000" =>  data <= "11111111";  -- 6978 = FF
      when "0100101111001" =>  data <= "11111111";  -- 6979 = FF
      when "0100101111010" =>  data <= "11111111";  -- 697A = FF
      when "0100101111011" =>  data <= "11111111";  -- 697B = FF
      when "0100101111100" =>  data <= "11111111";  -- 697C = FF
      when "0100101111101" =>  data <= "11111111";  -- 697D = FF
      when "0100101111110" =>  data <= "11111111";  -- 697E = FF
      when "0100101111111" =>  data <= "11111111";  -- 697F = FF
      when "0100110000000" =>  data <= "11111111";  -- 6980 = FF
      when "0100110000001" =>  data <= "11111111";  -- 6981 = FF
      when "0100110000010" =>  data <= "11111111";  -- 6982 = FF
      when "0100110000011" =>  data <= "11111111";  -- 6983 = FF
      when "0100110000100" =>  data <= "11111111";  -- 6984 = FF
      when "0100110000101" =>  data <= "11111111";  -- 6985 = FF
      when "0100110000110" =>  data <= "11111111";  -- 6986 = FF
      when "0100110000111" =>  data <= "11111111";  -- 6987 = FF
      when "0100110001000" =>  data <= "11111111";  -- 6988 = FF
      when "0100110001001" =>  data <= "11111111";  -- 6989 = FF
      when "0100110001010" =>  data <= "11111111";  -- 698A = FF
      when "0100110001011" =>  data <= "11111111";  -- 698B = FF
      when "0100110001100" =>  data <= "11111111";  -- 698C = FF
      when "0100110001101" =>  data <= "11111111";  -- 698D = FF
      when "0100110001110" =>  data <= "11111111";  -- 698E = FF
      when "0100110001111" =>  data <= "11111111";  -- 698F = FF
      when "0100110010000" =>  data <= "11111111";  -- 6990 = FF
      when "0100110010001" =>  data <= "11111111";  -- 6991 = FF
      when "0100110010010" =>  data <= "11111111";  -- 6992 = FF
      when "0100110010011" =>  data <= "11111111";  -- 6993 = FF
      when "0100110010100" =>  data <= "11111111";  -- 6994 = FF
      when "0100110010101" =>  data <= "11111111";  -- 6995 = FF
      when "0100110010110" =>  data <= "11111111";  -- 6996 = FF
      when "0100110010111" =>  data <= "11111111";  -- 6997 = FF
      when "0100110011000" =>  data <= "11111111";  -- 6998 = FF
      when "0100110011001" =>  data <= "11111111";  -- 6999 = FF
      when "0100110011010" =>  data <= "11111111";  -- 699A = FF
      when "0100110011011" =>  data <= "11111111";  -- 699B = FF
      when "0100110011100" =>  data <= "11111111";  -- 699C = FF
      when "0100110011101" =>  data <= "11111111";  -- 699D = FF
      when "0100110011110" =>  data <= "11111111";  -- 699E = FF
      when "0100110011111" =>  data <= "11111111";  -- 699F = FF
      when "0100110100000" =>  data <= "11111111";  -- 69A0 = FF
      when "0100110100001" =>  data <= "11111111";  -- 69A1 = FF
      when "0100110100010" =>  data <= "11111111";  -- 69A2 = FF
      when "0100110100011" =>  data <= "11111111";  -- 69A3 = FF
      when "0100110100100" =>  data <= "11111111";  -- 69A4 = FF
      when "0100110100101" =>  data <= "11111111";  -- 69A5 = FF
      when "0100110100110" =>  data <= "11111111";  -- 69A6 = FF
      when "0100110100111" =>  data <= "11111111";  -- 69A7 = FF
      when "0100110101000" =>  data <= "11111111";  -- 69A8 = FF
      when "0100110101001" =>  data <= "11111111";  -- 69A9 = FF
      when "0100110101010" =>  data <= "11111111";  -- 69AA = FF
      when "0100110101011" =>  data <= "11111111";  -- 69AB = FF
      when "0100110101100" =>  data <= "11111111";  -- 69AC = FF
      when "0100110101101" =>  data <= "11111111";  -- 69AD = FF
      when "0100110101110" =>  data <= "11111111";  -- 69AE = FF
      when "0100110101111" =>  data <= "11111111";  -- 69AF = FF
      when "0100110110000" =>  data <= "11111111";  -- 69B0 = FF
      when "0100110110001" =>  data <= "11111111";  -- 69B1 = FF
      when "0100110110010" =>  data <= "11111111";  -- 69B2 = FF
      when "0100110110011" =>  data <= "11111111";  -- 69B3 = FF
      when "0100110110100" =>  data <= "11111111";  -- 69B4 = FF
      when "0100110110101" =>  data <= "11111111";  -- 69B5 = FF
      when "0100110110110" =>  data <= "11111111";  -- 69B6 = FF
      when "0100110110111" =>  data <= "11111111";  -- 69B7 = FF
      when "0100110111000" =>  data <= "11111111";  -- 69B8 = FF
      when "0100110111001" =>  data <= "11111111";  -- 69B9 = FF
      when "0100110111010" =>  data <= "11111111";  -- 69BA = FF
      when "0100110111011" =>  data <= "11111111";  -- 69BB = FF
      when "0100110111100" =>  data <= "11111111";  -- 69BC = FF
      when "0100110111101" =>  data <= "11111111";  -- 69BD = FF
      when "0100110111110" =>  data <= "11111111";  -- 69BE = FF
      when "0100110111111" =>  data <= "11111111";  -- 69BF = FF
      when "0100111000000" =>  data <= "11111111";  -- 69C0 = FF
      when "0100111000001" =>  data <= "11111111";  -- 69C1 = FF
      when "0100111000010" =>  data <= "11111111";  -- 69C2 = FF
      when "0100111000011" =>  data <= "11111111";  -- 69C3 = FF
      when "0100111000100" =>  data <= "11111111";  -- 69C4 = FF
      when "0100111000101" =>  data <= "11111111";  -- 69C5 = FF
      when "0100111000110" =>  data <= "11111111";  -- 69C6 = FF
      when "0100111000111" =>  data <= "11111111";  -- 69C7 = FF
      when "0100111001000" =>  data <= "11111111";  -- 69C8 = FF
      when "0100111001001" =>  data <= "11111111";  -- 69C9 = FF
      when "0100111001010" =>  data <= "11111111";  -- 69CA = FF
      when "0100111001011" =>  data <= "11111111";  -- 69CB = FF
      when "0100111001100" =>  data <= "11111111";  -- 69CC = FF
      when "0100111001101" =>  data <= "11111111";  -- 69CD = FF
      when "0100111001110" =>  data <= "11111111";  -- 69CE = FF
      when "0100111001111" =>  data <= "11111111";  -- 69CF = FF
      when "0100111010000" =>  data <= "11111111";  -- 69D0 = FF
      when "0100111010001" =>  data <= "11111111";  -- 69D1 = FF
      when "0100111010010" =>  data <= "11111111";  -- 69D2 = FF
      when "0100111010011" =>  data <= "11111111";  -- 69D3 = FF
      when "0100111010100" =>  data <= "11111111";  -- 69D4 = FF
      when "0100111010101" =>  data <= "11111111";  -- 69D5 = FF
      when "0100111010110" =>  data <= "11111111";  -- 69D6 = FF
      when "0100111010111" =>  data <= "11111111";  -- 69D7 = FF
      when "0100111011000" =>  data <= "11111111";  -- 69D8 = FF
      when "0100111011001" =>  data <= "11111111";  -- 69D9 = FF
      when "0100111011010" =>  data <= "11111111";  -- 69DA = FF
      when "0100111011011" =>  data <= "11111111";  -- 69DB = FF
      when "0100111011100" =>  data <= "11111111";  -- 69DC = FF
      when "0100111011101" =>  data <= "11111111";  -- 69DD = FF
      when "0100111011110" =>  data <= "11111111";  -- 69DE = FF
      when "0100111011111" =>  data <= "11111111";  -- 69DF = FF
      when "0100111100000" =>  data <= "11111111";  -- 69E0 = FF
      when "0100111100001" =>  data <= "11111111";  -- 69E1 = FF
      when "0100111100010" =>  data <= "11111111";  -- 69E2 = FF
      when "0100111100011" =>  data <= "11111111";  -- 69E3 = FF
      when "0100111100100" =>  data <= "11111111";  -- 69E4 = FF
      when "0100111100101" =>  data <= "11111111";  -- 69E5 = FF
      when "0100111100110" =>  data <= "11111111";  -- 69E6 = FF
      when "0100111100111" =>  data <= "11111111";  -- 69E7 = FF
      when "0100111101000" =>  data <= "11111111";  -- 69E8 = FF
      when "0100111101001" =>  data <= "11111111";  -- 69E9 = FF
      when "0100111101010" =>  data <= "11111111";  -- 69EA = FF
      when "0100111101011" =>  data <= "11111111";  -- 69EB = FF
      when "0100111101100" =>  data <= "11111111";  -- 69EC = FF
      when "0100111101101" =>  data <= "11111111";  -- 69ED = FF
      when "0100111101110" =>  data <= "11111111";  -- 69EE = FF
      when "0100111101111" =>  data <= "11111111";  -- 69EF = FF
      when "0100111110000" =>  data <= "11111111";  -- 69F0 = FF
      when "0100111110001" =>  data <= "11111111";  -- 69F1 = FF
      when "0100111110010" =>  data <= "11111111";  -- 69F2 = FF
      when "0100111110011" =>  data <= "11111111";  -- 69F3 = FF
      when "0100111110100" =>  data <= "11111111";  -- 69F4 = FF
      when "0100111110101" =>  data <= "11111111";  -- 69F5 = FF
      when "0100111110110" =>  data <= "11111111";  -- 69F6 = FF
      when "0100111110111" =>  data <= "11111111";  -- 69F7 = FF
      when "0100111111000" =>  data <= "11111111";  -- 69F8 = FF
      when "0100111111001" =>  data <= "11111111";  -- 69F9 = FF
      when "0100111111010" =>  data <= "11111111";  -- 69FA = FF
      when "0100111111011" =>  data <= "11111111";  -- 69FB = FF
      when "0100111111100" =>  data <= "11111111";  -- 69FC = FF
      when "0100111111101" =>  data <= "11111111";  -- 69FD = FF
      when "0100111111110" =>  data <= "11111111";  -- 69FE = FF
      when "0100111111111" =>  data <= "11111111";  -- 69FF = FF
      when "0101000000000" =>  data <= "11111111";  -- 6A00 = FF
      when "0101000000001" =>  data <= "11111111";  -- 6A01 = FF
      when "0101000000010" =>  data <= "11111111";  -- 6A02 = FF
      when "0101000000011" =>  data <= "11111111";  -- 6A03 = FF
      when "0101000000100" =>  data <= "11111111";  -- 6A04 = FF
      when "0101000000101" =>  data <= "11111111";  -- 6A05 = FF
      when "0101000000110" =>  data <= "11111111";  -- 6A06 = FF
      when "0101000000111" =>  data <= "11111111";  -- 6A07 = FF
      when "0101000001000" =>  data <= "11111111";  -- 6A08 = FF
      when "0101000001001" =>  data <= "11111111";  -- 6A09 = FF
      when "0101000001010" =>  data <= "11111111";  -- 6A0A = FF
      when "0101000001011" =>  data <= "11111111";  -- 6A0B = FF
      when "0101000001100" =>  data <= "11111111";  -- 6A0C = FF
      when "0101000001101" =>  data <= "11111111";  -- 6A0D = FF
      when "0101000001110" =>  data <= "11111111";  -- 6A0E = FF
      when "0101000001111" =>  data <= "11111111";  -- 6A0F = FF
      when "0101000010000" =>  data <= "11111111";  -- 6A10 = FF
      when "0101000010001" =>  data <= "11111111";  -- 6A11 = FF
      when "0101000010010" =>  data <= "11111111";  -- 6A12 = FF
      when "0101000010011" =>  data <= "11111111";  -- 6A13 = FF
      when "0101000010100" =>  data <= "11111111";  -- 6A14 = FF
      when "0101000010101" =>  data <= "11111111";  -- 6A15 = FF
      when "0101000010110" =>  data <= "11111111";  -- 6A16 = FF
      when "0101000010111" =>  data <= "11111111";  -- 6A17 = FF
      when "0101000011000" =>  data <= "11111111";  -- 6A18 = FF
      when "0101000011001" =>  data <= "11111111";  -- 6A19 = FF
      when "0101000011010" =>  data <= "11111111";  -- 6A1A = FF
      when "0101000011011" =>  data <= "11111111";  -- 6A1B = FF
      when "0101000011100" =>  data <= "11111111";  -- 6A1C = FF
      when "0101000011101" =>  data <= "11111111";  -- 6A1D = FF
      when "0101000011110" =>  data <= "11111111";  -- 6A1E = FF
      when "0101000011111" =>  data <= "11111111";  -- 6A1F = FF
      when "0101000100000" =>  data <= "11111111";  -- 6A20 = FF
      when "0101000100001" =>  data <= "11111111";  -- 6A21 = FF
      when "0101000100010" =>  data <= "11111111";  -- 6A22 = FF
      when "0101000100011" =>  data <= "11111111";  -- 6A23 = FF
      when "0101000100100" =>  data <= "11111111";  -- 6A24 = FF
      when "0101000100101" =>  data <= "11111111";  -- 6A25 = FF
      when "0101000100110" =>  data <= "11111111";  -- 6A26 = FF
      when "0101000100111" =>  data <= "11111111";  -- 6A27 = FF
      when "0101000101000" =>  data <= "11111111";  -- 6A28 = FF
      when "0101000101001" =>  data <= "11111111";  -- 6A29 = FF
      when "0101000101010" =>  data <= "11111111";  -- 6A2A = FF
      when "0101000101011" =>  data <= "11111111";  -- 6A2B = FF
      when "0101000101100" =>  data <= "11111111";  -- 6A2C = FF
      when "0101000101101" =>  data <= "11111111";  -- 6A2D = FF
      when "0101000101110" =>  data <= "11111111";  -- 6A2E = FF
      when "0101000101111" =>  data <= "11111111";  -- 6A2F = FF
      when "0101000110000" =>  data <= "11111111";  -- 6A30 = FF
      when "0101000110001" =>  data <= "11111111";  -- 6A31 = FF
      when "0101000110010" =>  data <= "11111111";  -- 6A32 = FF
      when "0101000110011" =>  data <= "11111111";  -- 6A33 = FF
      when "0101000110100" =>  data <= "11111111";  -- 6A34 = FF
      when "0101000110101" =>  data <= "11111111";  -- 6A35 = FF
      when "0101000110110" =>  data <= "11111111";  -- 6A36 = FF
      when "0101000110111" =>  data <= "11111111";  -- 6A37 = FF
      when "0101000111000" =>  data <= "11111111";  -- 6A38 = FF
      when "0101000111001" =>  data <= "11111111";  -- 6A39 = FF
      when "0101000111010" =>  data <= "11111111";  -- 6A3A = FF
      when "0101000111011" =>  data <= "11111111";  -- 6A3B = FF
      when "0101000111100" =>  data <= "11111111";  -- 6A3C = FF
      when "0101000111101" =>  data <= "11111111";  -- 6A3D = FF
      when "0101000111110" =>  data <= "11111111";  -- 6A3E = FF
      when "0101000111111" =>  data <= "11111111";  -- 6A3F = FF
      when "0101001000000" =>  data <= "11111111";  -- 6A40 = FF
      when "0101001000001" =>  data <= "11111111";  -- 6A41 = FF
      when "0101001000010" =>  data <= "11111111";  -- 6A42 = FF
      when "0101001000011" =>  data <= "11111111";  -- 6A43 = FF
      when "0101001000100" =>  data <= "11111111";  -- 6A44 = FF
      when "0101001000101" =>  data <= "11111111";  -- 6A45 = FF
      when "0101001000110" =>  data <= "11111111";  -- 6A46 = FF
      when "0101001000111" =>  data <= "11111111";  -- 6A47 = FF
      when "0101001001000" =>  data <= "11111111";  -- 6A48 = FF
      when "0101001001001" =>  data <= "11111111";  -- 6A49 = FF
      when "0101001001010" =>  data <= "11111111";  -- 6A4A = FF
      when "0101001001011" =>  data <= "11111111";  -- 6A4B = FF
      when "0101001001100" =>  data <= "11111111";  -- 6A4C = FF
      when "0101001001101" =>  data <= "11111111";  -- 6A4D = FF
      when "0101001001110" =>  data <= "11111111";  -- 6A4E = FF
      when "0101001001111" =>  data <= "11111111";  -- 6A4F = FF
      when "0101001010000" =>  data <= "11111111";  -- 6A50 = FF
      when "0101001010001" =>  data <= "11111111";  -- 6A51 = FF
      when "0101001010010" =>  data <= "11111111";  -- 6A52 = FF
      when "0101001010011" =>  data <= "11111111";  -- 6A53 = FF
      when "0101001010100" =>  data <= "11111111";  -- 6A54 = FF
      when "0101001010101" =>  data <= "11111111";  -- 6A55 = FF
      when "0101001010110" =>  data <= "11111111";  -- 6A56 = FF
      when "0101001010111" =>  data <= "11111111";  -- 6A57 = FF
      when "0101001011000" =>  data <= "11111111";  -- 6A58 = FF
      when "0101001011001" =>  data <= "11111111";  -- 6A59 = FF
      when "0101001011010" =>  data <= "11111111";  -- 6A5A = FF
      when "0101001011011" =>  data <= "11111111";  -- 6A5B = FF
      when "0101001011100" =>  data <= "11111111";  -- 6A5C = FF
      when "0101001011101" =>  data <= "11111111";  -- 6A5D = FF
      when "0101001011110" =>  data <= "11111111";  -- 6A5E = FF
      when "0101001011111" =>  data <= "11111111";  -- 6A5F = FF
      when "0101001100000" =>  data <= "11111111";  -- 6A60 = FF
      when "0101001100001" =>  data <= "11111111";  -- 6A61 = FF
      when "0101001100010" =>  data <= "11111111";  -- 6A62 = FF
      when "0101001100011" =>  data <= "11111111";  -- 6A63 = FF
      when "0101001100100" =>  data <= "11111111";  -- 6A64 = FF
      when "0101001100101" =>  data <= "11111111";  -- 6A65 = FF
      when "0101001100110" =>  data <= "11111111";  -- 6A66 = FF
      when "0101001100111" =>  data <= "11111111";  -- 6A67 = FF
      when "0101001101000" =>  data <= "11111111";  -- 6A68 = FF
      when "0101001101001" =>  data <= "11111111";  -- 6A69 = FF
      when "0101001101010" =>  data <= "11111111";  -- 6A6A = FF
      when "0101001101011" =>  data <= "11111111";  -- 6A6B = FF
      when "0101001101100" =>  data <= "11111111";  -- 6A6C = FF
      when "0101001101101" =>  data <= "11111111";  -- 6A6D = FF
      when "0101001101110" =>  data <= "11111111";  -- 6A6E = FF
      when "0101001101111" =>  data <= "11111111";  -- 6A6F = FF
      when "0101001110000" =>  data <= "11111111";  -- 6A70 = FF
      when "0101001110001" =>  data <= "11111111";  -- 6A71 = FF
      when "0101001110010" =>  data <= "11111111";  -- 6A72 = FF
      when "0101001110011" =>  data <= "11111111";  -- 6A73 = FF
      when "0101001110100" =>  data <= "11111111";  -- 6A74 = FF
      when "0101001110101" =>  data <= "11111111";  -- 6A75 = FF
      when "0101001110110" =>  data <= "11111111";  -- 6A76 = FF
      when "0101001110111" =>  data <= "11111111";  -- 6A77 = FF
      when "0101001111000" =>  data <= "11111111";  -- 6A78 = FF
      when "0101001111001" =>  data <= "11111111";  -- 6A79 = FF
      when "0101001111010" =>  data <= "11111111";  -- 6A7A = FF
      when "0101001111011" =>  data <= "11111111";  -- 6A7B = FF
      when "0101001111100" =>  data <= "11111111";  -- 6A7C = FF
      when "0101001111101" =>  data <= "11111111";  -- 6A7D = FF
      when "0101001111110" =>  data <= "11111111";  -- 6A7E = FF
      when "0101001111111" =>  data <= "11111111";  -- 6A7F = FF
      when "0101010000000" =>  data <= "11111111";  -- 6A80 = FF
      when "0101010000001" =>  data <= "11111111";  -- 6A81 = FF
      when "0101010000010" =>  data <= "11111111";  -- 6A82 = FF
      when "0101010000011" =>  data <= "11111111";  -- 6A83 = FF
      when "0101010000100" =>  data <= "11111111";  -- 6A84 = FF
      when "0101010000101" =>  data <= "11111111";  -- 6A85 = FF
      when "0101010000110" =>  data <= "11111111";  -- 6A86 = FF
      when "0101010000111" =>  data <= "11111111";  -- 6A87 = FF
      when "0101010001000" =>  data <= "11111111";  -- 6A88 = FF
      when "0101010001001" =>  data <= "11111111";  -- 6A89 = FF
      when "0101010001010" =>  data <= "11111111";  -- 6A8A = FF
      when "0101010001011" =>  data <= "11111111";  -- 6A8B = FF
      when "0101010001100" =>  data <= "11111111";  -- 6A8C = FF
      when "0101010001101" =>  data <= "11111111";  -- 6A8D = FF
      when "0101010001110" =>  data <= "11111111";  -- 6A8E = FF
      when "0101010001111" =>  data <= "11111111";  -- 6A8F = FF
      when "0101010010000" =>  data <= "11111111";  -- 6A90 = FF
      when "0101010010001" =>  data <= "11111111";  -- 6A91 = FF
      when "0101010010010" =>  data <= "11111111";  -- 6A92 = FF
      when "0101010010011" =>  data <= "11111111";  -- 6A93 = FF
      when "0101010010100" =>  data <= "11111111";  -- 6A94 = FF
      when "0101010010101" =>  data <= "11111111";  -- 6A95 = FF
      when "0101010010110" =>  data <= "11111111";  -- 6A96 = FF
      when "0101010010111" =>  data <= "11111111";  -- 6A97 = FF
      when "0101010011000" =>  data <= "11111111";  -- 6A98 = FF
      when "0101010011001" =>  data <= "11111111";  -- 6A99 = FF
      when "0101010011010" =>  data <= "11111111";  -- 6A9A = FF
      when "0101010011011" =>  data <= "11111111";  -- 6A9B = FF
      when "0101010011100" =>  data <= "11111111";  -- 6A9C = FF
      when "0101010011101" =>  data <= "11111111";  -- 6A9D = FF
      when "0101010011110" =>  data <= "11111111";  -- 6A9E = FF
      when "0101010011111" =>  data <= "11111111";  -- 6A9F = FF
      when "0101010100000" =>  data <= "11111111";  -- 6AA0 = FF
      when "0101010100001" =>  data <= "11111111";  -- 6AA1 = FF
      when "0101010100010" =>  data <= "11111111";  -- 6AA2 = FF
      when "0101010100011" =>  data <= "11111111";  -- 6AA3 = FF
      when "0101010100100" =>  data <= "11111111";  -- 6AA4 = FF
      when "0101010100101" =>  data <= "11111111";  -- 6AA5 = FF
      when "0101010100110" =>  data <= "11111111";  -- 6AA6 = FF
      when "0101010100111" =>  data <= "11111111";  -- 6AA7 = FF
      when "0101010101000" =>  data <= "11111111";  -- 6AA8 = FF
      when "0101010101001" =>  data <= "11111111";  -- 6AA9 = FF
      when "0101010101010" =>  data <= "11111111";  -- 6AAA = FF
      when "0101010101011" =>  data <= "11111111";  -- 6AAB = FF
      when "0101010101100" =>  data <= "11111111";  -- 6AAC = FF
      when "0101010101101" =>  data <= "11111111";  -- 6AAD = FF
      when "0101010101110" =>  data <= "11111111";  -- 6AAE = FF
      when "0101010101111" =>  data <= "11111111";  -- 6AAF = FF
      when "0101010110000" =>  data <= "11111111";  -- 6AB0 = FF
      when "0101010110001" =>  data <= "11111111";  -- 6AB1 = FF
      when "0101010110010" =>  data <= "11111111";  -- 6AB2 = FF
      when "0101010110011" =>  data <= "11111111";  -- 6AB3 = FF
      when "0101010110100" =>  data <= "11111111";  -- 6AB4 = FF
      when "0101010110101" =>  data <= "11111111";  -- 6AB5 = FF
      when "0101010110110" =>  data <= "11111111";  -- 6AB6 = FF
      when "0101010110111" =>  data <= "11111111";  -- 6AB7 = FF
      when "0101010111000" =>  data <= "11111111";  -- 6AB8 = FF
      when "0101010111001" =>  data <= "11111111";  -- 6AB9 = FF
      when "0101010111010" =>  data <= "11111111";  -- 6ABA = FF
      when "0101010111011" =>  data <= "11111111";  -- 6ABB = FF
      when "0101010111100" =>  data <= "11111111";  -- 6ABC = FF
      when "0101010111101" =>  data <= "11111111";  -- 6ABD = FF
      when "0101010111110" =>  data <= "11111111";  -- 6ABE = FF
      when "0101010111111" =>  data <= "11111111";  -- 6ABF = FF
      when "0101011000000" =>  data <= "11111111";  -- 6AC0 = FF
      when "0101011000001" =>  data <= "11111111";  -- 6AC1 = FF
      when "0101011000010" =>  data <= "11111111";  -- 6AC2 = FF
      when "0101011000011" =>  data <= "11111111";  -- 6AC3 = FF
      when "0101011000100" =>  data <= "11111111";  -- 6AC4 = FF
      when "0101011000101" =>  data <= "11111111";  -- 6AC5 = FF
      when "0101011000110" =>  data <= "11111111";  -- 6AC6 = FF
      when "0101011000111" =>  data <= "11111111";  -- 6AC7 = FF
      when "0101011001000" =>  data <= "11111111";  -- 6AC8 = FF
      when "0101011001001" =>  data <= "11111111";  -- 6AC9 = FF
      when "0101011001010" =>  data <= "11111111";  -- 6ACA = FF
      when "0101011001011" =>  data <= "11111111";  -- 6ACB = FF
      when "0101011001100" =>  data <= "11111111";  -- 6ACC = FF
      when "0101011001101" =>  data <= "11111111";  -- 6ACD = FF
      when "0101011001110" =>  data <= "11111111";  -- 6ACE = FF
      when "0101011001111" =>  data <= "11111111";  -- 6ACF = FF
      when "0101011010000" =>  data <= "11111111";  -- 6AD0 = FF
      when "0101011010001" =>  data <= "11111111";  -- 6AD1 = FF
      when "0101011010010" =>  data <= "11111111";  -- 6AD2 = FF
      when "0101011010011" =>  data <= "11111111";  -- 6AD3 = FF
      when "0101011010100" =>  data <= "11111111";  -- 6AD4 = FF
      when "0101011010101" =>  data <= "11111111";  -- 6AD5 = FF
      when "0101011010110" =>  data <= "11111111";  -- 6AD6 = FF
      when "0101011010111" =>  data <= "11111111";  -- 6AD7 = FF
      when "0101011011000" =>  data <= "11111111";  -- 6AD8 = FF
      when "0101011011001" =>  data <= "11111111";  -- 6AD9 = FF
      when "0101011011010" =>  data <= "11111111";  -- 6ADA = FF
      when "0101011011011" =>  data <= "11111111";  -- 6ADB = FF
      when "0101011011100" =>  data <= "11111111";  -- 6ADC = FF
      when "0101011011101" =>  data <= "11111111";  -- 6ADD = FF
      when "0101011011110" =>  data <= "11111111";  -- 6ADE = FF
      when "0101011011111" =>  data <= "11111111";  -- 6ADF = FF
      when "0101011100000" =>  data <= "11111111";  -- 6AE0 = FF
      when "0101011100001" =>  data <= "11111111";  -- 6AE1 = FF
      when "0101011100010" =>  data <= "11111111";  -- 6AE2 = FF
      when "0101011100011" =>  data <= "11111111";  -- 6AE3 = FF
      when "0101011100100" =>  data <= "11111111";  -- 6AE4 = FF
      when "0101011100101" =>  data <= "11111111";  -- 6AE5 = FF
      when "0101011100110" =>  data <= "11111111";  -- 6AE6 = FF
      when "0101011100111" =>  data <= "11111111";  -- 6AE7 = FF
      when "0101011101000" =>  data <= "11111111";  -- 6AE8 = FF
      when "0101011101001" =>  data <= "11111111";  -- 6AE9 = FF
      when "0101011101010" =>  data <= "11111111";  -- 6AEA = FF
      when "0101011101011" =>  data <= "11111111";  -- 6AEB = FF
      when "0101011101100" =>  data <= "11111111";  -- 6AEC = FF
      when "0101011101101" =>  data <= "11111111";  -- 6AED = FF
      when "0101011101110" =>  data <= "11111111";  -- 6AEE = FF
      when "0101011101111" =>  data <= "11111111";  -- 6AEF = FF
      when "0101011110000" =>  data <= "11111111";  -- 6AF0 = FF
      when "0101011110001" =>  data <= "11111111";  -- 6AF1 = FF
      when "0101011110010" =>  data <= "11111111";  -- 6AF2 = FF
      when "0101011110011" =>  data <= "11111111";  -- 6AF3 = FF
      when "0101011110100" =>  data <= "11111111";  -- 6AF4 = FF
      when "0101011110101" =>  data <= "11111111";  -- 6AF5 = FF
      when "0101011110110" =>  data <= "11111111";  -- 6AF6 = FF
      when "0101011110111" =>  data <= "11111111";  -- 6AF7 = FF
      when "0101011111000" =>  data <= "11111111";  -- 6AF8 = FF
      when "0101011111001" =>  data <= "11111111";  -- 6AF9 = FF
      when "0101011111010" =>  data <= "11111111";  -- 6AFA = FF
      when "0101011111011" =>  data <= "11111111";  -- 6AFB = FF
      when "0101011111100" =>  data <= "11111111";  -- 6AFC = FF
      when "0101011111101" =>  data <= "11111111";  -- 6AFD = FF
      when "0101011111110" =>  data <= "11111111";  -- 6AFE = FF
      when "0101011111111" =>  data <= "11111111";  -- 6AFF = FF
      when "0101100000000" =>  data <= "11111111";  -- 6B00 = FF
      when "0101100000001" =>  data <= "11111111";  -- 6B01 = FF
      when "0101100000010" =>  data <= "11111111";  -- 6B02 = FF
      when "0101100000011" =>  data <= "11111111";  -- 6B03 = FF
      when "0101100000100" =>  data <= "11111111";  -- 6B04 = FF
      when "0101100000101" =>  data <= "11111111";  -- 6B05 = FF
      when "0101100000110" =>  data <= "11111111";  -- 6B06 = FF
      when "0101100000111" =>  data <= "11111111";  -- 6B07 = FF
      when "0101100001000" =>  data <= "11111111";  -- 6B08 = FF
      when "0101100001001" =>  data <= "11111111";  -- 6B09 = FF
      when "0101100001010" =>  data <= "11111111";  -- 6B0A = FF
      when "0101100001011" =>  data <= "11111111";  -- 6B0B = FF
      when "0101100001100" =>  data <= "11111111";  -- 6B0C = FF
      when "0101100001101" =>  data <= "11111111";  -- 6B0D = FF
      when "0101100001110" =>  data <= "11111111";  -- 6B0E = FF
      when "0101100001111" =>  data <= "11111111";  -- 6B0F = FF
      when "0101100010000" =>  data <= "11111111";  -- 6B10 = FF
      when "0101100010001" =>  data <= "11111111";  -- 6B11 = FF
      when "0101100010010" =>  data <= "11111111";  -- 6B12 = FF
      when "0101100010011" =>  data <= "11111111";  -- 6B13 = FF
      when "0101100010100" =>  data <= "11111111";  -- 6B14 = FF
      when "0101100010101" =>  data <= "11111111";  -- 6B15 = FF
      when "0101100010110" =>  data <= "11111111";  -- 6B16 = FF
      when "0101100010111" =>  data <= "11111111";  -- 6B17 = FF
      when "0101100011000" =>  data <= "11111111";  -- 6B18 = FF
      when "0101100011001" =>  data <= "11111111";  -- 6B19 = FF
      when "0101100011010" =>  data <= "11111111";  -- 6B1A = FF
      when "0101100011011" =>  data <= "11111111";  -- 6B1B = FF
      when "0101100011100" =>  data <= "11111111";  -- 6B1C = FF
      when "0101100011101" =>  data <= "11111111";  -- 6B1D = FF
      when "0101100011110" =>  data <= "11111111";  -- 6B1E = FF
      when "0101100011111" =>  data <= "11111111";  -- 6B1F = FF
      when "0101100100000" =>  data <= "11111111";  -- 6B20 = FF
      when "0101100100001" =>  data <= "11111111";  -- 6B21 = FF
      when "0101100100010" =>  data <= "11111111";  -- 6B22 = FF
      when "0101100100011" =>  data <= "11111111";  -- 6B23 = FF
      when "0101100100100" =>  data <= "11111111";  -- 6B24 = FF
      when "0101100100101" =>  data <= "11111111";  -- 6B25 = FF
      when "0101100100110" =>  data <= "11111111";  -- 6B26 = FF
      when "0101100100111" =>  data <= "11111111";  -- 6B27 = FF
      when "0101100101000" =>  data <= "11111111";  -- 6B28 = FF
      when "0101100101001" =>  data <= "11111111";  -- 6B29 = FF
      when "0101100101010" =>  data <= "11111111";  -- 6B2A = FF
      when "0101100101011" =>  data <= "11111111";  -- 6B2B = FF
      when "0101100101100" =>  data <= "11111111";  -- 6B2C = FF
      when "0101100101101" =>  data <= "11111111";  -- 6B2D = FF
      when "0101100101110" =>  data <= "11111111";  -- 6B2E = FF
      when "0101100101111" =>  data <= "11111111";  -- 6B2F = FF
      when "0101100110000" =>  data <= "11111111";  -- 6B30 = FF
      when "0101100110001" =>  data <= "11111111";  -- 6B31 = FF
      when "0101100110010" =>  data <= "11111111";  -- 6B32 = FF
      when "0101100110011" =>  data <= "11111111";  -- 6B33 = FF
      when "0101100110100" =>  data <= "11111111";  -- 6B34 = FF
      when "0101100110101" =>  data <= "11111111";  -- 6B35 = FF
      when "0101100110110" =>  data <= "11111111";  -- 6B36 = FF
      when "0101100110111" =>  data <= "11111111";  -- 6B37 = FF
      when "0101100111000" =>  data <= "11111111";  -- 6B38 = FF
      when "0101100111001" =>  data <= "11111111";  -- 6B39 = FF
      when "0101100111010" =>  data <= "11111111";  -- 6B3A = FF
      when "0101100111011" =>  data <= "11111111";  -- 6B3B = FF
      when "0101100111100" =>  data <= "11111111";  -- 6B3C = FF
      when "0101100111101" =>  data <= "11111111";  -- 6B3D = FF
      when "0101100111110" =>  data <= "11111111";  -- 6B3E = FF
      when "0101100111111" =>  data <= "11111111";  -- 6B3F = FF
      when "0101101000000" =>  data <= "11111111";  -- 6B40 = FF
      when "0101101000001" =>  data <= "11111111";  -- 6B41 = FF
      when "0101101000010" =>  data <= "11111111";  -- 6B42 = FF
      when "0101101000011" =>  data <= "11111111";  -- 6B43 = FF
      when "0101101000100" =>  data <= "11111111";  -- 6B44 = FF
      when "0101101000101" =>  data <= "11111111";  -- 6B45 = FF
      when "0101101000110" =>  data <= "11111111";  -- 6B46 = FF
      when "0101101000111" =>  data <= "11111111";  -- 6B47 = FF
      when "0101101001000" =>  data <= "11111111";  -- 6B48 = FF
      when "0101101001001" =>  data <= "11111111";  -- 6B49 = FF
      when "0101101001010" =>  data <= "11111111";  -- 6B4A = FF
      when "0101101001011" =>  data <= "11111111";  -- 6B4B = FF
      when "0101101001100" =>  data <= "11111111";  -- 6B4C = FF
      when "0101101001101" =>  data <= "11111111";  -- 6B4D = FF
      when "0101101001110" =>  data <= "11111111";  -- 6B4E = FF
      when "0101101001111" =>  data <= "11111111";  -- 6B4F = FF
      when "0101101010000" =>  data <= "11111111";  -- 6B50 = FF
      when "0101101010001" =>  data <= "11111111";  -- 6B51 = FF
      when "0101101010010" =>  data <= "11111111";  -- 6B52 = FF
      when "0101101010011" =>  data <= "11111111";  -- 6B53 = FF
      when "0101101010100" =>  data <= "11111111";  -- 6B54 = FF
      when "0101101010101" =>  data <= "11111111";  -- 6B55 = FF
      when "0101101010110" =>  data <= "11111111";  -- 6B56 = FF
      when "0101101010111" =>  data <= "11111111";  -- 6B57 = FF
      when "0101101011000" =>  data <= "11111111";  -- 6B58 = FF
      when "0101101011001" =>  data <= "11111111";  -- 6B59 = FF
      when "0101101011010" =>  data <= "11111111";  -- 6B5A = FF
      when "0101101011011" =>  data <= "11111111";  -- 6B5B = FF
      when "0101101011100" =>  data <= "11111111";  -- 6B5C = FF
      when "0101101011101" =>  data <= "11111111";  -- 6B5D = FF
      when "0101101011110" =>  data <= "11111111";  -- 6B5E = FF
      when "0101101011111" =>  data <= "11111111";  -- 6B5F = FF
      when "0101101100000" =>  data <= "11111111";  -- 6B60 = FF
      when "0101101100001" =>  data <= "11111111";  -- 6B61 = FF
      when "0101101100010" =>  data <= "11111111";  -- 6B62 = FF
      when "0101101100011" =>  data <= "11111111";  -- 6B63 = FF
      when "0101101100100" =>  data <= "11111111";  -- 6B64 = FF
      when "0101101100101" =>  data <= "11111111";  -- 6B65 = FF
      when "0101101100110" =>  data <= "11111111";  -- 6B66 = FF
      when "0101101100111" =>  data <= "11111111";  -- 6B67 = FF
      when "0101101101000" =>  data <= "11111111";  -- 6B68 = FF
      when "0101101101001" =>  data <= "11111111";  -- 6B69 = FF
      when "0101101101010" =>  data <= "11111111";  -- 6B6A = FF
      when "0101101101011" =>  data <= "11111111";  -- 6B6B = FF
      when "0101101101100" =>  data <= "11111111";  -- 6B6C = FF
      when "0101101101101" =>  data <= "11111111";  -- 6B6D = FF
      when "0101101101110" =>  data <= "11111111";  -- 6B6E = FF
      when "0101101101111" =>  data <= "11111111";  -- 6B6F = FF
      when "0101101110000" =>  data <= "11111111";  -- 6B70 = FF
      when "0101101110001" =>  data <= "11111111";  -- 6B71 = FF
      when "0101101110010" =>  data <= "11111111";  -- 6B72 = FF
      when "0101101110011" =>  data <= "11111111";  -- 6B73 = FF
      when "0101101110100" =>  data <= "11111111";  -- 6B74 = FF
      when "0101101110101" =>  data <= "11111111";  -- 6B75 = FF
      when "0101101110110" =>  data <= "11111111";  -- 6B76 = FF
      when "0101101110111" =>  data <= "11111111";  -- 6B77 = FF
      when "0101101111000" =>  data <= "11111111";  -- 6B78 = FF
      when "0101101111001" =>  data <= "11111111";  -- 6B79 = FF
      when "0101101111010" =>  data <= "11111111";  -- 6B7A = FF
      when "0101101111011" =>  data <= "11111111";  -- 6B7B = FF
      when "0101101111100" =>  data <= "11111111";  -- 6B7C = FF
      when "0101101111101" =>  data <= "11111111";  -- 6B7D = FF
      when "0101101111110" =>  data <= "11111111";  -- 6B7E = FF
      when "0101101111111" =>  data <= "11111111";  -- 6B7F = FF
      when "0101110000000" =>  data <= "11111111";  -- 6B80 = FF
      when "0101110000001" =>  data <= "11111111";  -- 6B81 = FF
      when "0101110000010" =>  data <= "11111111";  -- 6B82 = FF
      when "0101110000011" =>  data <= "11111111";  -- 6B83 = FF
      when "0101110000100" =>  data <= "11111111";  -- 6B84 = FF
      when "0101110000101" =>  data <= "11111111";  -- 6B85 = FF
      when "0101110000110" =>  data <= "11111111";  -- 6B86 = FF
      when "0101110000111" =>  data <= "11111111";  -- 6B87 = FF
      when "0101110001000" =>  data <= "11111111";  -- 6B88 = FF
      when "0101110001001" =>  data <= "11111111";  -- 6B89 = FF
      when "0101110001010" =>  data <= "11111111";  -- 6B8A = FF
      when "0101110001011" =>  data <= "11111111";  -- 6B8B = FF
      when "0101110001100" =>  data <= "11111111";  -- 6B8C = FF
      when "0101110001101" =>  data <= "11111111";  -- 6B8D = FF
      when "0101110001110" =>  data <= "11111111";  -- 6B8E = FF
      when "0101110001111" =>  data <= "11111111";  -- 6B8F = FF
      when "0101110010000" =>  data <= "11111111";  -- 6B90 = FF
      when "0101110010001" =>  data <= "11111111";  -- 6B91 = FF
      when "0101110010010" =>  data <= "11111111";  -- 6B92 = FF
      when "0101110010011" =>  data <= "11111111";  -- 6B93 = FF
      when "0101110010100" =>  data <= "11111111";  -- 6B94 = FF
      when "0101110010101" =>  data <= "11111111";  -- 6B95 = FF
      when "0101110010110" =>  data <= "11111111";  -- 6B96 = FF
      when "0101110010111" =>  data <= "11111111";  -- 6B97 = FF
      when "0101110011000" =>  data <= "11111111";  -- 6B98 = FF
      when "0101110011001" =>  data <= "11111111";  -- 6B99 = FF
      when "0101110011010" =>  data <= "11111111";  -- 6B9A = FF
      when "0101110011011" =>  data <= "11111111";  -- 6B9B = FF
      when "0101110011100" =>  data <= "11111111";  -- 6B9C = FF
      when "0101110011101" =>  data <= "11111111";  -- 6B9D = FF
      when "0101110011110" =>  data <= "11111111";  -- 6B9E = FF
      when "0101110011111" =>  data <= "11111111";  -- 6B9F = FF
      when "0101110100000" =>  data <= "11111111";  -- 6BA0 = FF
      when "0101110100001" =>  data <= "11111111";  -- 6BA1 = FF
      when "0101110100010" =>  data <= "11111111";  -- 6BA2 = FF
      when "0101110100011" =>  data <= "11111111";  -- 6BA3 = FF
      when "0101110100100" =>  data <= "11111111";  -- 6BA4 = FF
      when "0101110100101" =>  data <= "11111111";  -- 6BA5 = FF
      when "0101110100110" =>  data <= "11111111";  -- 6BA6 = FF
      when "0101110100111" =>  data <= "11111111";  -- 6BA7 = FF
      when "0101110101000" =>  data <= "11111111";  -- 6BA8 = FF
      when "0101110101001" =>  data <= "11111111";  -- 6BA9 = FF
      when "0101110101010" =>  data <= "11111111";  -- 6BAA = FF
      when "0101110101011" =>  data <= "11111111";  -- 6BAB = FF
      when "0101110101100" =>  data <= "11111111";  -- 6BAC = FF
      when "0101110101101" =>  data <= "11111111";  -- 6BAD = FF
      when "0101110101110" =>  data <= "11111111";  -- 6BAE = FF
      when "0101110101111" =>  data <= "11111111";  -- 6BAF = FF
      when "0101110110000" =>  data <= "11111111";  -- 6BB0 = FF
      when "0101110110001" =>  data <= "11111111";  -- 6BB1 = FF
      when "0101110110010" =>  data <= "11111111";  -- 6BB2 = FF
      when "0101110110011" =>  data <= "11111111";  -- 6BB3 = FF
      when "0101110110100" =>  data <= "11111111";  -- 6BB4 = FF
      when "0101110110101" =>  data <= "11111111";  -- 6BB5 = FF
      when "0101110110110" =>  data <= "11111111";  -- 6BB6 = FF
      when "0101110110111" =>  data <= "11111111";  -- 6BB7 = FF
      when "0101110111000" =>  data <= "11111111";  -- 6BB8 = FF
      when "0101110111001" =>  data <= "11111111";  -- 6BB9 = FF
      when "0101110111010" =>  data <= "11111111";  -- 6BBA = FF
      when "0101110111011" =>  data <= "11111111";  -- 6BBB = FF
      when "0101110111100" =>  data <= "11111111";  -- 6BBC = FF
      when "0101110111101" =>  data <= "11111111";  -- 6BBD = FF
      when "0101110111110" =>  data <= "11111111";  -- 6BBE = FF
      when "0101110111111" =>  data <= "11111111";  -- 6BBF = FF
      when "0101111000000" =>  data <= "11111111";  -- 6BC0 = FF
      when "0101111000001" =>  data <= "11111111";  -- 6BC1 = FF
      when "0101111000010" =>  data <= "11111111";  -- 6BC2 = FF
      when "0101111000011" =>  data <= "11111111";  -- 6BC3 = FF
      when "0101111000100" =>  data <= "11111111";  -- 6BC4 = FF
      when "0101111000101" =>  data <= "11111111";  -- 6BC5 = FF
      when "0101111000110" =>  data <= "11111111";  -- 6BC6 = FF
      when "0101111000111" =>  data <= "11111111";  -- 6BC7 = FF
      when "0101111001000" =>  data <= "11111111";  -- 6BC8 = FF
      when "0101111001001" =>  data <= "11111111";  -- 6BC9 = FF
      when "0101111001010" =>  data <= "11111111";  -- 6BCA = FF
      when "0101111001011" =>  data <= "11111111";  -- 6BCB = FF
      when "0101111001100" =>  data <= "11111111";  -- 6BCC = FF
      when "0101111001101" =>  data <= "11111111";  -- 6BCD = FF
      when "0101111001110" =>  data <= "11111111";  -- 6BCE = FF
      when "0101111001111" =>  data <= "11111111";  -- 6BCF = FF
      when "0101111010000" =>  data <= "11111111";  -- 6BD0 = FF
      when "0101111010001" =>  data <= "11111111";  -- 6BD1 = FF
      when "0101111010010" =>  data <= "11111111";  -- 6BD2 = FF
      when "0101111010011" =>  data <= "11111111";  -- 6BD3 = FF
      when "0101111010100" =>  data <= "11111111";  -- 6BD4 = FF
      when "0101111010101" =>  data <= "11111111";  -- 6BD5 = FF
      when "0101111010110" =>  data <= "11111111";  -- 6BD6 = FF
      when "0101111010111" =>  data <= "11111111";  -- 6BD7 = FF
      when "0101111011000" =>  data <= "11111111";  -- 6BD8 = FF
      when "0101111011001" =>  data <= "11111111";  -- 6BD9 = FF
      when "0101111011010" =>  data <= "11111111";  -- 6BDA = FF
      when "0101111011011" =>  data <= "11111111";  -- 6BDB = FF
      when "0101111011100" =>  data <= "11111111";  -- 6BDC = FF
      when "0101111011101" =>  data <= "11111111";  -- 6BDD = FF
      when "0101111011110" =>  data <= "11111111";  -- 6BDE = FF
      when "0101111011111" =>  data <= "11111111";  -- 6BDF = FF
      when "0101111100000" =>  data <= "11111111";  -- 6BE0 = FF
      when "0101111100001" =>  data <= "11111111";  -- 6BE1 = FF
      when "0101111100010" =>  data <= "11111111";  -- 6BE2 = FF
      when "0101111100011" =>  data <= "11111111";  -- 6BE3 = FF
      when "0101111100100" =>  data <= "11111111";  -- 6BE4 = FF
      when "0101111100101" =>  data <= "11111111";  -- 6BE5 = FF
      when "0101111100110" =>  data <= "11111111";  -- 6BE6 = FF
      when "0101111100111" =>  data <= "11111111";  -- 6BE7 = FF
      when "0101111101000" =>  data <= "11111111";  -- 6BE8 = FF
      when "0101111101001" =>  data <= "11111111";  -- 6BE9 = FF
      when "0101111101010" =>  data <= "11111111";  -- 6BEA = FF
      when "0101111101011" =>  data <= "11111111";  -- 6BEB = FF
      when "0101111101100" =>  data <= "11111111";  -- 6BEC = FF
      when "0101111101101" =>  data <= "11111111";  -- 6BED = FF
      when "0101111101110" =>  data <= "11111111";  -- 6BEE = FF
      when "0101111101111" =>  data <= "11111111";  -- 6BEF = FF
      when "0101111110000" =>  data <= "11111111";  -- 6BF0 = FF
      when "0101111110001" =>  data <= "11111111";  -- 6BF1 = FF
      when "0101111110010" =>  data <= "11111111";  -- 6BF2 = FF
      when "0101111110011" =>  data <= "11111111";  -- 6BF3 = FF
      when "0101111110100" =>  data <= "11111111";  -- 6BF4 = FF
      when "0101111110101" =>  data <= "11111111";  -- 6BF5 = FF
      when "0101111110110" =>  data <= "11111111";  -- 6BF6 = FF
      when "0101111110111" =>  data <= "11111111";  -- 6BF7 = FF
      when "0101111111000" =>  data <= "11111111";  -- 6BF8 = FF
      when "0101111111001" =>  data <= "11111111";  -- 6BF9 = FF
      when "0101111111010" =>  data <= "11111111";  -- 6BFA = FF
      when "0101111111011" =>  data <= "11111111";  -- 6BFB = FF
      when "0101111111100" =>  data <= "11111111";  -- 6BFC = FF
      when "0101111111101" =>  data <= "11111111";  -- 6BFD = FF
      when "0101111111110" =>  data <= "11111111";  -- 6BFE = FF
      when "0101111111111" =>  data <= "11111111";  -- 6BFF = FF
      when "0110000000000" =>  data <= "11111111";  -- 6C00 = FF
      when "0110000000001" =>  data <= "11111111";  -- 6C01 = FF
      when "0110000000010" =>  data <= "11111111";  -- 6C02 = FF
      when "0110000000011" =>  data <= "11111111";  -- 6C03 = FF
      when "0110000000100" =>  data <= "11111111";  -- 6C04 = FF
      when "0110000000101" =>  data <= "11111111";  -- 6C05 = FF
      when "0110000000110" =>  data <= "11111111";  -- 6C06 = FF
      when "0110000000111" =>  data <= "11111111";  -- 6C07 = FF
      when "0110000001000" =>  data <= "11111111";  -- 6C08 = FF
      when "0110000001001" =>  data <= "11111111";  -- 6C09 = FF
      when "0110000001010" =>  data <= "11111111";  -- 6C0A = FF
      when "0110000001011" =>  data <= "11111111";  -- 6C0B = FF
      when "0110000001100" =>  data <= "11111111";  -- 6C0C = FF
      when "0110000001101" =>  data <= "11111111";  -- 6C0D = FF
      when "0110000001110" =>  data <= "11111111";  -- 6C0E = FF
      when "0110000001111" =>  data <= "11111111";  -- 6C0F = FF
      when "0110000010000" =>  data <= "11111111";  -- 6C10 = FF
      when "0110000010001" =>  data <= "11111111";  -- 6C11 = FF
      when "0110000010010" =>  data <= "11111111";  -- 6C12 = FF
      when "0110000010011" =>  data <= "11111111";  -- 6C13 = FF
      when "0110000010100" =>  data <= "11111111";  -- 6C14 = FF
      when "0110000010101" =>  data <= "11111111";  -- 6C15 = FF
      when "0110000010110" =>  data <= "11111111";  -- 6C16 = FF
      when "0110000010111" =>  data <= "11111111";  -- 6C17 = FF
      when "0110000011000" =>  data <= "11111111";  -- 6C18 = FF
      when "0110000011001" =>  data <= "11111111";  -- 6C19 = FF
      when "0110000011010" =>  data <= "11111111";  -- 6C1A = FF
      when "0110000011011" =>  data <= "11111111";  -- 6C1B = FF
      when "0110000011100" =>  data <= "11111111";  -- 6C1C = FF
      when "0110000011101" =>  data <= "11111111";  -- 6C1D = FF
      when "0110000011110" =>  data <= "11111111";  -- 6C1E = FF
      when "0110000011111" =>  data <= "11111111";  -- 6C1F = FF
      when "0110000100000" =>  data <= "11111111";  -- 6C20 = FF
      when "0110000100001" =>  data <= "11111111";  -- 6C21 = FF
      when "0110000100010" =>  data <= "11111111";  -- 6C22 = FF
      when "0110000100011" =>  data <= "11111111";  -- 6C23 = FF
      when "0110000100100" =>  data <= "11111111";  -- 6C24 = FF
      when "0110000100101" =>  data <= "11111111";  -- 6C25 = FF
      when "0110000100110" =>  data <= "11111111";  -- 6C26 = FF
      when "0110000100111" =>  data <= "11111111";  -- 6C27 = FF
      when "0110000101000" =>  data <= "11111111";  -- 6C28 = FF
      when "0110000101001" =>  data <= "11111111";  -- 6C29 = FF
      when "0110000101010" =>  data <= "11111111";  -- 6C2A = FF
      when "0110000101011" =>  data <= "11111111";  -- 6C2B = FF
      when "0110000101100" =>  data <= "11111111";  -- 6C2C = FF
      when "0110000101101" =>  data <= "11111111";  -- 6C2D = FF
      when "0110000101110" =>  data <= "11111111";  -- 6C2E = FF
      when "0110000101111" =>  data <= "11111111";  -- 6C2F = FF
      when "0110000110000" =>  data <= "11111111";  -- 6C30 = FF
      when "0110000110001" =>  data <= "11111111";  -- 6C31 = FF
      when "0110000110010" =>  data <= "11111111";  -- 6C32 = FF
      when "0110000110011" =>  data <= "11111111";  -- 6C33 = FF
      when "0110000110100" =>  data <= "11111111";  -- 6C34 = FF
      when "0110000110101" =>  data <= "11111111";  -- 6C35 = FF
      when "0110000110110" =>  data <= "11111111";  -- 6C36 = FF
      when "0110000110111" =>  data <= "11111111";  -- 6C37 = FF
      when "0110000111000" =>  data <= "11111111";  -- 6C38 = FF
      when "0110000111001" =>  data <= "11111111";  -- 6C39 = FF
      when "0110000111010" =>  data <= "11111111";  -- 6C3A = FF
      when "0110000111011" =>  data <= "11111111";  -- 6C3B = FF
      when "0110000111100" =>  data <= "11111111";  -- 6C3C = FF
      when "0110000111101" =>  data <= "11111111";  -- 6C3D = FF
      when "0110000111110" =>  data <= "11111111";  -- 6C3E = FF
      when "0110000111111" =>  data <= "11111111";  -- 6C3F = FF
      when "0110001000000" =>  data <= "11111111";  -- 6C40 = FF
      when "0110001000001" =>  data <= "11111111";  -- 6C41 = FF
      when "0110001000010" =>  data <= "11111111";  -- 6C42 = FF
      when "0110001000011" =>  data <= "11111111";  -- 6C43 = FF
      when "0110001000100" =>  data <= "11111111";  -- 6C44 = FF
      when "0110001000101" =>  data <= "11111111";  -- 6C45 = FF
      when "0110001000110" =>  data <= "11111111";  -- 6C46 = FF
      when "0110001000111" =>  data <= "11111111";  -- 6C47 = FF
      when "0110001001000" =>  data <= "11111111";  -- 6C48 = FF
      when "0110001001001" =>  data <= "11111111";  -- 6C49 = FF
      when "0110001001010" =>  data <= "11111111";  -- 6C4A = FF
      when "0110001001011" =>  data <= "11111111";  -- 6C4B = FF
      when "0110001001100" =>  data <= "11111111";  -- 6C4C = FF
      when "0110001001101" =>  data <= "11111111";  -- 6C4D = FF
      when "0110001001110" =>  data <= "11111111";  -- 6C4E = FF
      when "0110001001111" =>  data <= "11111111";  -- 6C4F = FF
      when "0110001010000" =>  data <= "11111111";  -- 6C50 = FF
      when "0110001010001" =>  data <= "11111111";  -- 6C51 = FF
      when "0110001010010" =>  data <= "11111111";  -- 6C52 = FF
      when "0110001010011" =>  data <= "11111111";  -- 6C53 = FF
      when "0110001010100" =>  data <= "11111111";  -- 6C54 = FF
      when "0110001010101" =>  data <= "11111111";  -- 6C55 = FF
      when "0110001010110" =>  data <= "11111111";  -- 6C56 = FF
      when "0110001010111" =>  data <= "11111111";  -- 6C57 = FF
      when "0110001011000" =>  data <= "11111111";  -- 6C58 = FF
      when "0110001011001" =>  data <= "11111111";  -- 6C59 = FF
      when "0110001011010" =>  data <= "11111111";  -- 6C5A = FF
      when "0110001011011" =>  data <= "11111111";  -- 6C5B = FF
      when "0110001011100" =>  data <= "11111111";  -- 6C5C = FF
      when "0110001011101" =>  data <= "11111111";  -- 6C5D = FF
      when "0110001011110" =>  data <= "11111111";  -- 6C5E = FF
      when "0110001011111" =>  data <= "11111111";  -- 6C5F = FF
      when "0110001100000" =>  data <= "11111111";  -- 6C60 = FF
      when "0110001100001" =>  data <= "11111111";  -- 6C61 = FF
      when "0110001100010" =>  data <= "11111111";  -- 6C62 = FF
      when "0110001100011" =>  data <= "11111111";  -- 6C63 = FF
      when "0110001100100" =>  data <= "11111111";  -- 6C64 = FF
      when "0110001100101" =>  data <= "11111111";  -- 6C65 = FF
      when "0110001100110" =>  data <= "11111111";  -- 6C66 = FF
      when "0110001100111" =>  data <= "11111111";  -- 6C67 = FF
      when "0110001101000" =>  data <= "11111111";  -- 6C68 = FF
      when "0110001101001" =>  data <= "11111111";  -- 6C69 = FF
      when "0110001101010" =>  data <= "11111111";  -- 6C6A = FF
      when "0110001101011" =>  data <= "11111111";  -- 6C6B = FF
      when "0110001101100" =>  data <= "11111111";  -- 6C6C = FF
      when "0110001101101" =>  data <= "11111111";  -- 6C6D = FF
      when "0110001101110" =>  data <= "11111111";  -- 6C6E = FF
      when "0110001101111" =>  data <= "11111111";  -- 6C6F = FF
      when "0110001110000" =>  data <= "11111111";  -- 6C70 = FF
      when "0110001110001" =>  data <= "11111111";  -- 6C71 = FF
      when "0110001110010" =>  data <= "11111111";  -- 6C72 = FF
      when "0110001110011" =>  data <= "11111111";  -- 6C73 = FF
      when "0110001110100" =>  data <= "11111111";  -- 6C74 = FF
      when "0110001110101" =>  data <= "11111111";  -- 6C75 = FF
      when "0110001110110" =>  data <= "11111111";  -- 6C76 = FF
      when "0110001110111" =>  data <= "11111111";  -- 6C77 = FF
      when "0110001111000" =>  data <= "11111111";  -- 6C78 = FF
      when "0110001111001" =>  data <= "11111111";  -- 6C79 = FF
      when "0110001111010" =>  data <= "11111111";  -- 6C7A = FF
      when "0110001111011" =>  data <= "11111111";  -- 6C7B = FF
      when "0110001111100" =>  data <= "11111111";  -- 6C7C = FF
      when "0110001111101" =>  data <= "11111111";  -- 6C7D = FF
      when "0110001111110" =>  data <= "11111111";  -- 6C7E = FF
      when "0110001111111" =>  data <= "11111111";  -- 6C7F = FF
      when "0110010000000" =>  data <= "11111111";  -- 6C80 = FF
      when "0110010000001" =>  data <= "11111111";  -- 6C81 = FF
      when "0110010000010" =>  data <= "11111111";  -- 6C82 = FF
      when "0110010000011" =>  data <= "11111111";  -- 6C83 = FF
      when "0110010000100" =>  data <= "11111111";  -- 6C84 = FF
      when "0110010000101" =>  data <= "11111111";  -- 6C85 = FF
      when "0110010000110" =>  data <= "11111111";  -- 6C86 = FF
      when "0110010000111" =>  data <= "11111111";  -- 6C87 = FF
      when "0110010001000" =>  data <= "11111111";  -- 6C88 = FF
      when "0110010001001" =>  data <= "11111111";  -- 6C89 = FF
      when "0110010001010" =>  data <= "11111111";  -- 6C8A = FF
      when "0110010001011" =>  data <= "11111111";  -- 6C8B = FF
      when "0110010001100" =>  data <= "11111111";  -- 6C8C = FF
      when "0110010001101" =>  data <= "11111111";  -- 6C8D = FF
      when "0110010001110" =>  data <= "11111111";  -- 6C8E = FF
      when "0110010001111" =>  data <= "11111111";  -- 6C8F = FF
      when "0110010010000" =>  data <= "11111111";  -- 6C90 = FF
      when "0110010010001" =>  data <= "11111111";  -- 6C91 = FF
      when "0110010010010" =>  data <= "11111111";  -- 6C92 = FF
      when "0110010010011" =>  data <= "11111111";  -- 6C93 = FF
      when "0110010010100" =>  data <= "11111111";  -- 6C94 = FF
      when "0110010010101" =>  data <= "11111111";  -- 6C95 = FF
      when "0110010010110" =>  data <= "11111111";  -- 6C96 = FF
      when "0110010010111" =>  data <= "11111111";  -- 6C97 = FF
      when "0110010011000" =>  data <= "11111111";  -- 6C98 = FF
      when "0110010011001" =>  data <= "11111111";  -- 6C99 = FF
      when "0110010011010" =>  data <= "11111111";  -- 6C9A = FF
      when "0110010011011" =>  data <= "11111111";  -- 6C9B = FF
      when "0110010011100" =>  data <= "11111111";  -- 6C9C = FF
      when "0110010011101" =>  data <= "11111111";  -- 6C9D = FF
      when "0110010011110" =>  data <= "11111111";  -- 6C9E = FF
      when "0110010011111" =>  data <= "11111111";  -- 6C9F = FF
      when "0110010100000" =>  data <= "11111111";  -- 6CA0 = FF
      when "0110010100001" =>  data <= "11111111";  -- 6CA1 = FF
      when "0110010100010" =>  data <= "11111111";  -- 6CA2 = FF
      when "0110010100011" =>  data <= "11111111";  -- 6CA3 = FF
      when "0110010100100" =>  data <= "11111111";  -- 6CA4 = FF
      when "0110010100101" =>  data <= "11111111";  -- 6CA5 = FF
      when "0110010100110" =>  data <= "11111111";  -- 6CA6 = FF
      when "0110010100111" =>  data <= "11111111";  -- 6CA7 = FF
      when "0110010101000" =>  data <= "11111111";  -- 6CA8 = FF
      when "0110010101001" =>  data <= "11111111";  -- 6CA9 = FF
      when "0110010101010" =>  data <= "11111111";  -- 6CAA = FF
      when "0110010101011" =>  data <= "11111111";  -- 6CAB = FF
      when "0110010101100" =>  data <= "11111111";  -- 6CAC = FF
      when "0110010101101" =>  data <= "11111111";  -- 6CAD = FF
      when "0110010101110" =>  data <= "11111111";  -- 6CAE = FF
      when "0110010101111" =>  data <= "11111111";  -- 6CAF = FF
      when "0110010110000" =>  data <= "11111111";  -- 6CB0 = FF
      when "0110010110001" =>  data <= "11111111";  -- 6CB1 = FF
      when "0110010110010" =>  data <= "11111111";  -- 6CB2 = FF
      when "0110010110011" =>  data <= "11111111";  -- 6CB3 = FF
      when "0110010110100" =>  data <= "11111111";  -- 6CB4 = FF
      when "0110010110101" =>  data <= "11111111";  -- 6CB5 = FF
      when "0110010110110" =>  data <= "11111111";  -- 6CB6 = FF
      when "0110010110111" =>  data <= "11111111";  -- 6CB7 = FF
      when "0110010111000" =>  data <= "11111111";  -- 6CB8 = FF
      when "0110010111001" =>  data <= "11111111";  -- 6CB9 = FF
      when "0110010111010" =>  data <= "11111111";  -- 6CBA = FF
      when "0110010111011" =>  data <= "11111111";  -- 6CBB = FF
      when "0110010111100" =>  data <= "11111111";  -- 6CBC = FF
      when "0110010111101" =>  data <= "11111111";  -- 6CBD = FF
      when "0110010111110" =>  data <= "11111111";  -- 6CBE = FF
      when "0110010111111" =>  data <= "11111111";  -- 6CBF = FF
      when "0110011000000" =>  data <= "11111111";  -- 6CC0 = FF
      when "0110011000001" =>  data <= "11111111";  -- 6CC1 = FF
      when "0110011000010" =>  data <= "11111111";  -- 6CC2 = FF
      when "0110011000011" =>  data <= "11111111";  -- 6CC3 = FF
      when "0110011000100" =>  data <= "11111111";  -- 6CC4 = FF
      when "0110011000101" =>  data <= "11111111";  -- 6CC5 = FF
      when "0110011000110" =>  data <= "11111111";  -- 6CC6 = FF
      when "0110011000111" =>  data <= "11111111";  -- 6CC7 = FF
      when "0110011001000" =>  data <= "11111111";  -- 6CC8 = FF
      when "0110011001001" =>  data <= "11111111";  -- 6CC9 = FF
      when "0110011001010" =>  data <= "11111111";  -- 6CCA = FF
      when "0110011001011" =>  data <= "11111111";  -- 6CCB = FF
      when "0110011001100" =>  data <= "11111111";  -- 6CCC = FF
      when "0110011001101" =>  data <= "11111111";  -- 6CCD = FF
      when "0110011001110" =>  data <= "11111111";  -- 6CCE = FF
      when "0110011001111" =>  data <= "11111111";  -- 6CCF = FF
      when "0110011010000" =>  data <= "11111111";  -- 6CD0 = FF
      when "0110011010001" =>  data <= "11111111";  -- 6CD1 = FF
      when "0110011010010" =>  data <= "11111111";  -- 6CD2 = FF
      when "0110011010011" =>  data <= "11111111";  -- 6CD3 = FF
      when "0110011010100" =>  data <= "11111111";  -- 6CD4 = FF
      when "0110011010101" =>  data <= "11111111";  -- 6CD5 = FF
      when "0110011010110" =>  data <= "11111111";  -- 6CD6 = FF
      when "0110011010111" =>  data <= "11111111";  -- 6CD7 = FF
      when "0110011011000" =>  data <= "11111111";  -- 6CD8 = FF
      when "0110011011001" =>  data <= "11111111";  -- 6CD9 = FF
      when "0110011011010" =>  data <= "11111111";  -- 6CDA = FF
      when "0110011011011" =>  data <= "11111111";  -- 6CDB = FF
      when "0110011011100" =>  data <= "11111111";  -- 6CDC = FF
      when "0110011011101" =>  data <= "11111111";  -- 6CDD = FF
      when "0110011011110" =>  data <= "11111111";  -- 6CDE = FF
      when "0110011011111" =>  data <= "11111111";  -- 6CDF = FF
      when "0110011100000" =>  data <= "11111111";  -- 6CE0 = FF
      when "0110011100001" =>  data <= "11111111";  -- 6CE1 = FF
      when "0110011100010" =>  data <= "11111111";  -- 6CE2 = FF
      when "0110011100011" =>  data <= "11111111";  -- 6CE3 = FF
      when "0110011100100" =>  data <= "11111111";  -- 6CE4 = FF
      when "0110011100101" =>  data <= "11111111";  -- 6CE5 = FF
      when "0110011100110" =>  data <= "11111111";  -- 6CE6 = FF
      when "0110011100111" =>  data <= "11111111";  -- 6CE7 = FF
      when "0110011101000" =>  data <= "11111111";  -- 6CE8 = FF
      when "0110011101001" =>  data <= "11111111";  -- 6CE9 = FF
      when "0110011101010" =>  data <= "11111111";  -- 6CEA = FF
      when "0110011101011" =>  data <= "11111111";  -- 6CEB = FF
      when "0110011101100" =>  data <= "11111111";  -- 6CEC = FF
      when "0110011101101" =>  data <= "11111111";  -- 6CED = FF
      when "0110011101110" =>  data <= "11111111";  -- 6CEE = FF
      when "0110011101111" =>  data <= "11111111";  -- 6CEF = FF
      when "0110011110000" =>  data <= "11111111";  -- 6CF0 = FF
      when "0110011110001" =>  data <= "11111111";  -- 6CF1 = FF
      when "0110011110010" =>  data <= "11111111";  -- 6CF2 = FF
      when "0110011110011" =>  data <= "11111111";  -- 6CF3 = FF
      when "0110011110100" =>  data <= "11111111";  -- 6CF4 = FF
      when "0110011110101" =>  data <= "11111111";  -- 6CF5 = FF
      when "0110011110110" =>  data <= "11111111";  -- 6CF6 = FF
      when "0110011110111" =>  data <= "11111111";  -- 6CF7 = FF
      when "0110011111000" =>  data <= "11111111";  -- 6CF8 = FF
      when "0110011111001" =>  data <= "11111111";  -- 6CF9 = FF
      when "0110011111010" =>  data <= "11111111";  -- 6CFA = FF
      when "0110011111011" =>  data <= "11111111";  -- 6CFB = FF
      when "0110011111100" =>  data <= "11111111";  -- 6CFC = FF
      when "0110011111101" =>  data <= "11111111";  -- 6CFD = FF
      when "0110011111110" =>  data <= "11111111";  -- 6CFE = FF
      when "0110011111111" =>  data <= "11111111";  -- 6CFF = FF
      when "0110100000000" =>  data <= "11111111";  -- 6D00 = FF
      when "0110100000001" =>  data <= "11111111";  -- 6D01 = FF
      when "0110100000010" =>  data <= "11111111";  -- 6D02 = FF
      when "0110100000011" =>  data <= "11111111";  -- 6D03 = FF
      when "0110100000100" =>  data <= "11111111";  -- 6D04 = FF
      when "0110100000101" =>  data <= "11111111";  -- 6D05 = FF
      when "0110100000110" =>  data <= "11111111";  -- 6D06 = FF
      when "0110100000111" =>  data <= "11111111";  -- 6D07 = FF
      when "0110100001000" =>  data <= "11111111";  -- 6D08 = FF
      when "0110100001001" =>  data <= "11111111";  -- 6D09 = FF
      when "0110100001010" =>  data <= "11111111";  -- 6D0A = FF
      when "0110100001011" =>  data <= "11111111";  -- 6D0B = FF
      when "0110100001100" =>  data <= "11111111";  -- 6D0C = FF
      when "0110100001101" =>  data <= "11111111";  -- 6D0D = FF
      when "0110100001110" =>  data <= "11111111";  -- 6D0E = FF
      when "0110100001111" =>  data <= "11111111";  -- 6D0F = FF
      when "0110100010000" =>  data <= "11111111";  -- 6D10 = FF
      when "0110100010001" =>  data <= "11111111";  -- 6D11 = FF
      when "0110100010010" =>  data <= "11111111";  -- 6D12 = FF
      when "0110100010011" =>  data <= "11111111";  -- 6D13 = FF
      when "0110100010100" =>  data <= "11111111";  -- 6D14 = FF
      when "0110100010101" =>  data <= "11111111";  -- 6D15 = FF
      when "0110100010110" =>  data <= "11111111";  -- 6D16 = FF
      when "0110100010111" =>  data <= "11111111";  -- 6D17 = FF
      when "0110100011000" =>  data <= "11111111";  -- 6D18 = FF
      when "0110100011001" =>  data <= "11111111";  -- 6D19 = FF
      when "0110100011010" =>  data <= "11111111";  -- 6D1A = FF
      when "0110100011011" =>  data <= "11111111";  -- 6D1B = FF
      when "0110100011100" =>  data <= "11111111";  -- 6D1C = FF
      when "0110100011101" =>  data <= "11111111";  -- 6D1D = FF
      when "0110100011110" =>  data <= "11111111";  -- 6D1E = FF
      when "0110100011111" =>  data <= "11111111";  -- 6D1F = FF
      when "0110100100000" =>  data <= "11111111";  -- 6D20 = FF
      when "0110100100001" =>  data <= "11111111";  -- 6D21 = FF
      when "0110100100010" =>  data <= "11111111";  -- 6D22 = FF
      when "0110100100011" =>  data <= "11111111";  -- 6D23 = FF
      when "0110100100100" =>  data <= "11111111";  -- 6D24 = FF
      when "0110100100101" =>  data <= "11111111";  -- 6D25 = FF
      when "0110100100110" =>  data <= "11111111";  -- 6D26 = FF
      when "0110100100111" =>  data <= "11111111";  -- 6D27 = FF
      when "0110100101000" =>  data <= "11111111";  -- 6D28 = FF
      when "0110100101001" =>  data <= "11111111";  -- 6D29 = FF
      when "0110100101010" =>  data <= "11111111";  -- 6D2A = FF
      when "0110100101011" =>  data <= "11111111";  -- 6D2B = FF
      when "0110100101100" =>  data <= "11111111";  -- 6D2C = FF
      when "0110100101101" =>  data <= "11111111";  -- 6D2D = FF
      when "0110100101110" =>  data <= "11111111";  -- 6D2E = FF
      when "0110100101111" =>  data <= "11111111";  -- 6D2F = FF
      when "0110100110000" =>  data <= "11111111";  -- 6D30 = FF
      when "0110100110001" =>  data <= "11111111";  -- 6D31 = FF
      when "0110100110010" =>  data <= "11111111";  -- 6D32 = FF
      when "0110100110011" =>  data <= "11111111";  -- 6D33 = FF
      when "0110100110100" =>  data <= "11111111";  -- 6D34 = FF
      when "0110100110101" =>  data <= "11111111";  -- 6D35 = FF
      when "0110100110110" =>  data <= "11111111";  -- 6D36 = FF
      when "0110100110111" =>  data <= "11111111";  -- 6D37 = FF
      when "0110100111000" =>  data <= "11111111";  -- 6D38 = FF
      when "0110100111001" =>  data <= "11111111";  -- 6D39 = FF
      when "0110100111010" =>  data <= "11111111";  -- 6D3A = FF
      when "0110100111011" =>  data <= "11111111";  -- 6D3B = FF
      when "0110100111100" =>  data <= "11111111";  -- 6D3C = FF
      when "0110100111101" =>  data <= "11111111";  -- 6D3D = FF
      when "0110100111110" =>  data <= "11111111";  -- 6D3E = FF
      when "0110100111111" =>  data <= "11111111";  -- 6D3F = FF
      when "0110101000000" =>  data <= "11111111";  -- 6D40 = FF
      when "0110101000001" =>  data <= "11111111";  -- 6D41 = FF
      when "0110101000010" =>  data <= "11111111";  -- 6D42 = FF
      when "0110101000011" =>  data <= "11111111";  -- 6D43 = FF
      when "0110101000100" =>  data <= "11111111";  -- 6D44 = FF
      when "0110101000101" =>  data <= "11111111";  -- 6D45 = FF
      when "0110101000110" =>  data <= "11111111";  -- 6D46 = FF
      when "0110101000111" =>  data <= "11111111";  -- 6D47 = FF
      when "0110101001000" =>  data <= "11111111";  -- 6D48 = FF
      when "0110101001001" =>  data <= "11111111";  -- 6D49 = FF
      when "0110101001010" =>  data <= "11111111";  -- 6D4A = FF
      when "0110101001011" =>  data <= "11111111";  -- 6D4B = FF
      when "0110101001100" =>  data <= "11111111";  -- 6D4C = FF
      when "0110101001101" =>  data <= "11111111";  -- 6D4D = FF
      when "0110101001110" =>  data <= "11111111";  -- 6D4E = FF
      when "0110101001111" =>  data <= "11111111";  -- 6D4F = FF
      when "0110101010000" =>  data <= "11111111";  -- 6D50 = FF
      when "0110101010001" =>  data <= "11111111";  -- 6D51 = FF
      when "0110101010010" =>  data <= "11111111";  -- 6D52 = FF
      when "0110101010011" =>  data <= "11111111";  -- 6D53 = FF
      when "0110101010100" =>  data <= "11111111";  -- 6D54 = FF
      when "0110101010101" =>  data <= "11111111";  -- 6D55 = FF
      when "0110101010110" =>  data <= "11111111";  -- 6D56 = FF
      when "0110101010111" =>  data <= "11111111";  -- 6D57 = FF
      when "0110101011000" =>  data <= "11111111";  -- 6D58 = FF
      when "0110101011001" =>  data <= "11111111";  -- 6D59 = FF
      when "0110101011010" =>  data <= "11111111";  -- 6D5A = FF
      when "0110101011011" =>  data <= "11111111";  -- 6D5B = FF
      when "0110101011100" =>  data <= "11111111";  -- 6D5C = FF
      when "0110101011101" =>  data <= "11111111";  -- 6D5D = FF
      when "0110101011110" =>  data <= "11111111";  -- 6D5E = FF
      when "0110101011111" =>  data <= "11111111";  -- 6D5F = FF
      when "0110101100000" =>  data <= "11111111";  -- 6D60 = FF
      when "0110101100001" =>  data <= "11111111";  -- 6D61 = FF
      when "0110101100010" =>  data <= "11111111";  -- 6D62 = FF
      when "0110101100011" =>  data <= "11111111";  -- 6D63 = FF
      when "0110101100100" =>  data <= "11111111";  -- 6D64 = FF
      when "0110101100101" =>  data <= "11111111";  -- 6D65 = FF
      when "0110101100110" =>  data <= "11111111";  -- 6D66 = FF
      when "0110101100111" =>  data <= "11111111";  -- 6D67 = FF
      when "0110101101000" =>  data <= "11111111";  -- 6D68 = FF
      when "0110101101001" =>  data <= "11111111";  -- 6D69 = FF
      when "0110101101010" =>  data <= "11111111";  -- 6D6A = FF
      when "0110101101011" =>  data <= "11111111";  -- 6D6B = FF
      when "0110101101100" =>  data <= "11111111";  -- 6D6C = FF
      when "0110101101101" =>  data <= "11111111";  -- 6D6D = FF
      when "0110101101110" =>  data <= "11111111";  -- 6D6E = FF
      when "0110101101111" =>  data <= "11111111";  -- 6D6F = FF
      when "0110101110000" =>  data <= "11111111";  -- 6D70 = FF
      when "0110101110001" =>  data <= "11111111";  -- 6D71 = FF
      when "0110101110010" =>  data <= "11111111";  -- 6D72 = FF
      when "0110101110011" =>  data <= "11111111";  -- 6D73 = FF
      when "0110101110100" =>  data <= "11111111";  -- 6D74 = FF
      when "0110101110101" =>  data <= "11111111";  -- 6D75 = FF
      when "0110101110110" =>  data <= "11111111";  -- 6D76 = FF
      when "0110101110111" =>  data <= "11111111";  -- 6D77 = FF
      when "0110101111000" =>  data <= "11111111";  -- 6D78 = FF
      when "0110101111001" =>  data <= "11111111";  -- 6D79 = FF
      when "0110101111010" =>  data <= "11111111";  -- 6D7A = FF
      when "0110101111011" =>  data <= "11111111";  -- 6D7B = FF
      when "0110101111100" =>  data <= "11111111";  -- 6D7C = FF
      when "0110101111101" =>  data <= "11111111";  -- 6D7D = FF
      when "0110101111110" =>  data <= "11111111";  -- 6D7E = FF
      when "0110101111111" =>  data <= "11111111";  -- 6D7F = FF
      when "0110110000000" =>  data <= "11111111";  -- 6D80 = FF
      when "0110110000001" =>  data <= "11111111";  -- 6D81 = FF
      when "0110110000010" =>  data <= "11111111";  -- 6D82 = FF
      when "0110110000011" =>  data <= "11111111";  -- 6D83 = FF
      when "0110110000100" =>  data <= "11111111";  -- 6D84 = FF
      when "0110110000101" =>  data <= "11111111";  -- 6D85 = FF
      when "0110110000110" =>  data <= "11111111";  -- 6D86 = FF
      when "0110110000111" =>  data <= "11111111";  -- 6D87 = FF
      when "0110110001000" =>  data <= "11111111";  -- 6D88 = FF
      when "0110110001001" =>  data <= "11111111";  -- 6D89 = FF
      when "0110110001010" =>  data <= "11111111";  -- 6D8A = FF
      when "0110110001011" =>  data <= "11111111";  -- 6D8B = FF
      when "0110110001100" =>  data <= "11111111";  -- 6D8C = FF
      when "0110110001101" =>  data <= "11111111";  -- 6D8D = FF
      when "0110110001110" =>  data <= "11111111";  -- 6D8E = FF
      when "0110110001111" =>  data <= "11111111";  -- 6D8F = FF
      when "0110110010000" =>  data <= "11111111";  -- 6D90 = FF
      when "0110110010001" =>  data <= "11111111";  -- 6D91 = FF
      when "0110110010010" =>  data <= "11111111";  -- 6D92 = FF
      when "0110110010011" =>  data <= "11111111";  -- 6D93 = FF
      when "0110110010100" =>  data <= "11111111";  -- 6D94 = FF
      when "0110110010101" =>  data <= "11111111";  -- 6D95 = FF
      when "0110110010110" =>  data <= "11111111";  -- 6D96 = FF
      when "0110110010111" =>  data <= "11111111";  -- 6D97 = FF
      when "0110110011000" =>  data <= "11111111";  -- 6D98 = FF
      when "0110110011001" =>  data <= "11111111";  -- 6D99 = FF
      when "0110110011010" =>  data <= "11111111";  -- 6D9A = FF
      when "0110110011011" =>  data <= "11111111";  -- 6D9B = FF
      when "0110110011100" =>  data <= "11111111";  -- 6D9C = FF
      when "0110110011101" =>  data <= "11111111";  -- 6D9D = FF
      when "0110110011110" =>  data <= "11111111";  -- 6D9E = FF
      when "0110110011111" =>  data <= "11111111";  -- 6D9F = FF
      when "0110110100000" =>  data <= "11111111";  -- 6DA0 = FF
      when "0110110100001" =>  data <= "11111111";  -- 6DA1 = FF
      when "0110110100010" =>  data <= "11111111";  -- 6DA2 = FF
      when "0110110100011" =>  data <= "11111111";  -- 6DA3 = FF
      when "0110110100100" =>  data <= "11111111";  -- 6DA4 = FF
      when "0110110100101" =>  data <= "11111111";  -- 6DA5 = FF
      when "0110110100110" =>  data <= "11111111";  -- 6DA6 = FF
      when "0110110100111" =>  data <= "11111111";  -- 6DA7 = FF
      when "0110110101000" =>  data <= "11111111";  -- 6DA8 = FF
      when "0110110101001" =>  data <= "11111111";  -- 6DA9 = FF
      when "0110110101010" =>  data <= "11111111";  -- 6DAA = FF
      when "0110110101011" =>  data <= "11111111";  -- 6DAB = FF
      when "0110110101100" =>  data <= "11111111";  -- 6DAC = FF
      when "0110110101101" =>  data <= "11111111";  -- 6DAD = FF
      when "0110110101110" =>  data <= "11111111";  -- 6DAE = FF
      when "0110110101111" =>  data <= "11111111";  -- 6DAF = FF
      when "0110110110000" =>  data <= "11111111";  -- 6DB0 = FF
      when "0110110110001" =>  data <= "11111111";  -- 6DB1 = FF
      when "0110110110010" =>  data <= "11111111";  -- 6DB2 = FF
      when "0110110110011" =>  data <= "11111111";  -- 6DB3 = FF
      when "0110110110100" =>  data <= "11111111";  -- 6DB4 = FF
      when "0110110110101" =>  data <= "11111111";  -- 6DB5 = FF
      when "0110110110110" =>  data <= "11111111";  -- 6DB6 = FF
      when "0110110110111" =>  data <= "11111111";  -- 6DB7 = FF
      when "0110110111000" =>  data <= "11111111";  -- 6DB8 = FF
      when "0110110111001" =>  data <= "11111111";  -- 6DB9 = FF
      when "0110110111010" =>  data <= "11111111";  -- 6DBA = FF
      when "0110110111011" =>  data <= "11111111";  -- 6DBB = FF
      when "0110110111100" =>  data <= "11111111";  -- 6DBC = FF
      when "0110110111101" =>  data <= "11111111";  -- 6DBD = FF
      when "0110110111110" =>  data <= "11111111";  -- 6DBE = FF
      when "0110110111111" =>  data <= "11111111";  -- 6DBF = FF
      when "0110111000000" =>  data <= "11111111";  -- 6DC0 = FF
      when "0110111000001" =>  data <= "11111111";  -- 6DC1 = FF
      when "0110111000010" =>  data <= "11111111";  -- 6DC2 = FF
      when "0110111000011" =>  data <= "11111111";  -- 6DC3 = FF
      when "0110111000100" =>  data <= "11111111";  -- 6DC4 = FF
      when "0110111000101" =>  data <= "11111111";  -- 6DC5 = FF
      when "0110111000110" =>  data <= "11111111";  -- 6DC6 = FF
      when "0110111000111" =>  data <= "11111111";  -- 6DC7 = FF
      when "0110111001000" =>  data <= "11111111";  -- 6DC8 = FF
      when "0110111001001" =>  data <= "11111111";  -- 6DC9 = FF
      when "0110111001010" =>  data <= "11111111";  -- 6DCA = FF
      when "0110111001011" =>  data <= "11111111";  -- 6DCB = FF
      when "0110111001100" =>  data <= "11111111";  -- 6DCC = FF
      when "0110111001101" =>  data <= "11111111";  -- 6DCD = FF
      when "0110111001110" =>  data <= "11111111";  -- 6DCE = FF
      when "0110111001111" =>  data <= "11111111";  -- 6DCF = FF
      when "0110111010000" =>  data <= "11111111";  -- 6DD0 = FF
      when "0110111010001" =>  data <= "11111111";  -- 6DD1 = FF
      when "0110111010010" =>  data <= "11111111";  -- 6DD2 = FF
      when "0110111010011" =>  data <= "11111111";  -- 6DD3 = FF
      when "0110111010100" =>  data <= "11111111";  -- 6DD4 = FF
      when "0110111010101" =>  data <= "11111111";  -- 6DD5 = FF
      when "0110111010110" =>  data <= "11111111";  -- 6DD6 = FF
      when "0110111010111" =>  data <= "11111111";  -- 6DD7 = FF
      when "0110111011000" =>  data <= "11111111";  -- 6DD8 = FF
      when "0110111011001" =>  data <= "11111111";  -- 6DD9 = FF
      when "0110111011010" =>  data <= "11111111";  -- 6DDA = FF
      when "0110111011011" =>  data <= "11111111";  -- 6DDB = FF
      when "0110111011100" =>  data <= "11111111";  -- 6DDC = FF
      when "0110111011101" =>  data <= "11111111";  -- 6DDD = FF
      when "0110111011110" =>  data <= "11111111";  -- 6DDE = FF
      when "0110111011111" =>  data <= "11111111";  -- 6DDF = FF
      when "0110111100000" =>  data <= "11111111";  -- 6DE0 = FF
      when "0110111100001" =>  data <= "11111111";  -- 6DE1 = FF
      when "0110111100010" =>  data <= "11111111";  -- 6DE2 = FF
      when "0110111100011" =>  data <= "11111111";  -- 6DE3 = FF
      when "0110111100100" =>  data <= "11111111";  -- 6DE4 = FF
      when "0110111100101" =>  data <= "11111111";  -- 6DE5 = FF
      when "0110111100110" =>  data <= "11111111";  -- 6DE6 = FF
      when "0110111100111" =>  data <= "11111111";  -- 6DE7 = FF
      when "0110111101000" =>  data <= "11111111";  -- 6DE8 = FF
      when "0110111101001" =>  data <= "11111111";  -- 6DE9 = FF
      when "0110111101010" =>  data <= "11111111";  -- 6DEA = FF
      when "0110111101011" =>  data <= "11111111";  -- 6DEB = FF
      when "0110111101100" =>  data <= "11111111";  -- 6DEC = FF
      when "0110111101101" =>  data <= "11111111";  -- 6DED = FF
      when "0110111101110" =>  data <= "11111111";  -- 6DEE = FF
      when "0110111101111" =>  data <= "11111111";  -- 6DEF = FF
      when "0110111110000" =>  data <= "11111111";  -- 6DF0 = FF
      when "0110111110001" =>  data <= "11111111";  -- 6DF1 = FF
      when "0110111110010" =>  data <= "11111111";  -- 6DF2 = FF
      when "0110111110011" =>  data <= "11111111";  -- 6DF3 = FF
      when "0110111110100" =>  data <= "11111111";  -- 6DF4 = FF
      when "0110111110101" =>  data <= "11111111";  -- 6DF5 = FF
      when "0110111110110" =>  data <= "11111111";  -- 6DF6 = FF
      when "0110111110111" =>  data <= "11111111";  -- 6DF7 = FF
      when "0110111111000" =>  data <= "11111111";  -- 6DF8 = FF
      when "0110111111001" =>  data <= "11111111";  -- 6DF9 = FF
      when "0110111111010" =>  data <= "11111111";  -- 6DFA = FF
      when "0110111111011" =>  data <= "11111111";  -- 6DFB = FF
      when "0110111111100" =>  data <= "11111111";  -- 6DFC = FF
      when "0110111111101" =>  data <= "11111111";  -- 6DFD = FF
      when "0110111111110" =>  data <= "11111111";  -- 6DFE = FF
      when "0110111111111" =>  data <= "11111111";  -- 6DFF = FF
      when "0111000000000" =>  data <= "11111111";  -- 6E00 = FF
      when "0111000000001" =>  data <= "11111111";  -- 6E01 = FF
      when "0111000000010" =>  data <= "11111111";  -- 6E02 = FF
      when "0111000000011" =>  data <= "11111111";  -- 6E03 = FF
      when "0111000000100" =>  data <= "11111111";  -- 6E04 = FF
      when "0111000000101" =>  data <= "11111111";  -- 6E05 = FF
      when "0111000000110" =>  data <= "11111111";  -- 6E06 = FF
      when "0111000000111" =>  data <= "11111111";  -- 6E07 = FF
      when "0111000001000" =>  data <= "11111111";  -- 6E08 = FF
      when "0111000001001" =>  data <= "11111111";  -- 6E09 = FF
      when "0111000001010" =>  data <= "11111111";  -- 6E0A = FF
      when "0111000001011" =>  data <= "11111111";  -- 6E0B = FF
      when "0111000001100" =>  data <= "11111111";  -- 6E0C = FF
      when "0111000001101" =>  data <= "11111111";  -- 6E0D = FF
      when "0111000001110" =>  data <= "11111111";  -- 6E0E = FF
      when "0111000001111" =>  data <= "11111111";  -- 6E0F = FF
      when "0111000010000" =>  data <= "11111111";  -- 6E10 = FF
      when "0111000010001" =>  data <= "11111111";  -- 6E11 = FF
      when "0111000010010" =>  data <= "11111111";  -- 6E12 = FF
      when "0111000010011" =>  data <= "11111111";  -- 6E13 = FF
      when "0111000010100" =>  data <= "11111111";  -- 6E14 = FF
      when "0111000010101" =>  data <= "11111111";  -- 6E15 = FF
      when "0111000010110" =>  data <= "11111111";  -- 6E16 = FF
      when "0111000010111" =>  data <= "11111111";  -- 6E17 = FF
      when "0111000011000" =>  data <= "11111111";  -- 6E18 = FF
      when "0111000011001" =>  data <= "11111111";  -- 6E19 = FF
      when "0111000011010" =>  data <= "11111111";  -- 6E1A = FF
      when "0111000011011" =>  data <= "11111111";  -- 6E1B = FF
      when "0111000011100" =>  data <= "11111111";  -- 6E1C = FF
      when "0111000011101" =>  data <= "11111111";  -- 6E1D = FF
      when "0111000011110" =>  data <= "11111111";  -- 6E1E = FF
      when "0111000011111" =>  data <= "11111111";  -- 6E1F = FF
      when "0111000100000" =>  data <= "11111111";  -- 6E20 = FF
      when "0111000100001" =>  data <= "11111111";  -- 6E21 = FF
      when "0111000100010" =>  data <= "11111111";  -- 6E22 = FF
      when "0111000100011" =>  data <= "11111111";  -- 6E23 = FF
      when "0111000100100" =>  data <= "11111111";  -- 6E24 = FF
      when "0111000100101" =>  data <= "11111111";  -- 6E25 = FF
      when "0111000100110" =>  data <= "11111111";  -- 6E26 = FF
      when "0111000100111" =>  data <= "11111111";  -- 6E27 = FF
      when "0111000101000" =>  data <= "11111111";  -- 6E28 = FF
      when "0111000101001" =>  data <= "11111111";  -- 6E29 = FF
      when "0111000101010" =>  data <= "11111111";  -- 6E2A = FF
      when "0111000101011" =>  data <= "11111111";  -- 6E2B = FF
      when "0111000101100" =>  data <= "11111111";  -- 6E2C = FF
      when "0111000101101" =>  data <= "11111111";  -- 6E2D = FF
      when "0111000101110" =>  data <= "11111111";  -- 6E2E = FF
      when "0111000101111" =>  data <= "11111111";  -- 6E2F = FF
      when "0111000110000" =>  data <= "11111111";  -- 6E30 = FF
      when "0111000110001" =>  data <= "11111111";  -- 6E31 = FF
      when "0111000110010" =>  data <= "11111111";  -- 6E32 = FF
      when "0111000110011" =>  data <= "11111111";  -- 6E33 = FF
      when "0111000110100" =>  data <= "11111111";  -- 6E34 = FF
      when "0111000110101" =>  data <= "11111111";  -- 6E35 = FF
      when "0111000110110" =>  data <= "11111111";  -- 6E36 = FF
      when "0111000110111" =>  data <= "11111111";  -- 6E37 = FF
      when "0111000111000" =>  data <= "11111111";  -- 6E38 = FF
      when "0111000111001" =>  data <= "11111111";  -- 6E39 = FF
      when "0111000111010" =>  data <= "11111111";  -- 6E3A = FF
      when "0111000111011" =>  data <= "11111111";  -- 6E3B = FF
      when "0111000111100" =>  data <= "11111111";  -- 6E3C = FF
      when "0111000111101" =>  data <= "11111111";  -- 6E3D = FF
      when "0111000111110" =>  data <= "11111111";  -- 6E3E = FF
      when "0111000111111" =>  data <= "11111111";  -- 6E3F = FF
      when "0111001000000" =>  data <= "11111111";  -- 6E40 = FF
      when "0111001000001" =>  data <= "11111111";  -- 6E41 = FF
      when "0111001000010" =>  data <= "11111111";  -- 6E42 = FF
      when "0111001000011" =>  data <= "11111111";  -- 6E43 = FF
      when "0111001000100" =>  data <= "11111111";  -- 6E44 = FF
      when "0111001000101" =>  data <= "11111111";  -- 6E45 = FF
      when "0111001000110" =>  data <= "11111111";  -- 6E46 = FF
      when "0111001000111" =>  data <= "11111111";  -- 6E47 = FF
      when "0111001001000" =>  data <= "11111111";  -- 6E48 = FF
      when "0111001001001" =>  data <= "11111111";  -- 6E49 = FF
      when "0111001001010" =>  data <= "11111111";  -- 6E4A = FF
      when "0111001001011" =>  data <= "11111111";  -- 6E4B = FF
      when "0111001001100" =>  data <= "11111111";  -- 6E4C = FF
      when "0111001001101" =>  data <= "11111111";  -- 6E4D = FF
      when "0111001001110" =>  data <= "11111111";  -- 6E4E = FF
      when "0111001001111" =>  data <= "11111111";  -- 6E4F = FF
      when "0111001010000" =>  data <= "11111111";  -- 6E50 = FF
      when "0111001010001" =>  data <= "11111111";  -- 6E51 = FF
      when "0111001010010" =>  data <= "11111111";  -- 6E52 = FF
      when "0111001010011" =>  data <= "11111111";  -- 6E53 = FF
      when "0111001010100" =>  data <= "11111111";  -- 6E54 = FF
      when "0111001010101" =>  data <= "11111111";  -- 6E55 = FF
      when "0111001010110" =>  data <= "11111111";  -- 6E56 = FF
      when "0111001010111" =>  data <= "11111111";  -- 6E57 = FF
      when "0111001011000" =>  data <= "11111111";  -- 6E58 = FF
      when "0111001011001" =>  data <= "11111111";  -- 6E59 = FF
      when "0111001011010" =>  data <= "11111111";  -- 6E5A = FF
      when "0111001011011" =>  data <= "11111111";  -- 6E5B = FF
      when "0111001011100" =>  data <= "11111111";  -- 6E5C = FF
      when "0111001011101" =>  data <= "11111111";  -- 6E5D = FF
      when "0111001011110" =>  data <= "11111111";  -- 6E5E = FF
      when "0111001011111" =>  data <= "11111111";  -- 6E5F = FF
      when "0111001100000" =>  data <= "11111111";  -- 6E60 = FF
      when "0111001100001" =>  data <= "11111111";  -- 6E61 = FF
      when "0111001100010" =>  data <= "11111111";  -- 6E62 = FF
      when "0111001100011" =>  data <= "11111111";  -- 6E63 = FF
      when "0111001100100" =>  data <= "11111111";  -- 6E64 = FF
      when "0111001100101" =>  data <= "11111111";  -- 6E65 = FF
      when "0111001100110" =>  data <= "11111111";  -- 6E66 = FF
      when "0111001100111" =>  data <= "11111111";  -- 6E67 = FF
      when "0111001101000" =>  data <= "11111111";  -- 6E68 = FF
      when "0111001101001" =>  data <= "11111111";  -- 6E69 = FF
      when "0111001101010" =>  data <= "11111111";  -- 6E6A = FF
      when "0111001101011" =>  data <= "11111111";  -- 6E6B = FF
      when "0111001101100" =>  data <= "11111111";  -- 6E6C = FF
      when "0111001101101" =>  data <= "11111111";  -- 6E6D = FF
      when "0111001101110" =>  data <= "11111111";  -- 6E6E = FF
      when "0111001101111" =>  data <= "11111111";  -- 6E6F = FF
      when "0111001110000" =>  data <= "11111111";  -- 6E70 = FF
      when "0111001110001" =>  data <= "11111111";  -- 6E71 = FF
      when "0111001110010" =>  data <= "11111111";  -- 6E72 = FF
      when "0111001110011" =>  data <= "11111111";  -- 6E73 = FF
      when "0111001110100" =>  data <= "11111111";  -- 6E74 = FF
      when "0111001110101" =>  data <= "11111111";  -- 6E75 = FF
      when "0111001110110" =>  data <= "11111111";  -- 6E76 = FF
      when "0111001110111" =>  data <= "11111111";  -- 6E77 = FF
      when "0111001111000" =>  data <= "11111111";  -- 6E78 = FF
      when "0111001111001" =>  data <= "11111111";  -- 6E79 = FF
      when "0111001111010" =>  data <= "11111111";  -- 6E7A = FF
      when "0111001111011" =>  data <= "11111111";  -- 6E7B = FF
      when "0111001111100" =>  data <= "11111111";  -- 6E7C = FF
      when "0111001111101" =>  data <= "11111111";  -- 6E7D = FF
      when "0111001111110" =>  data <= "11111111";  -- 6E7E = FF
      when "0111001111111" =>  data <= "11111111";  -- 6E7F = FF
      when "0111010000000" =>  data <= "11111111";  -- 6E80 = FF
      when "0111010000001" =>  data <= "11111111";  -- 6E81 = FF
      when "0111010000010" =>  data <= "11111111";  -- 6E82 = FF
      when "0111010000011" =>  data <= "11111111";  -- 6E83 = FF
      when "0111010000100" =>  data <= "11111111";  -- 6E84 = FF
      when "0111010000101" =>  data <= "11111111";  -- 6E85 = FF
      when "0111010000110" =>  data <= "11111111";  -- 6E86 = FF
      when "0111010000111" =>  data <= "11111111";  -- 6E87 = FF
      when "0111010001000" =>  data <= "11111111";  -- 6E88 = FF
      when "0111010001001" =>  data <= "11111111";  -- 6E89 = FF
      when "0111010001010" =>  data <= "11111111";  -- 6E8A = FF
      when "0111010001011" =>  data <= "11111111";  -- 6E8B = FF
      when "0111010001100" =>  data <= "11111111";  -- 6E8C = FF
      when "0111010001101" =>  data <= "11111111";  -- 6E8D = FF
      when "0111010001110" =>  data <= "11111111";  -- 6E8E = FF
      when "0111010001111" =>  data <= "11111111";  -- 6E8F = FF
      when "0111010010000" =>  data <= "11111111";  -- 6E90 = FF
      when "0111010010001" =>  data <= "11111111";  -- 6E91 = FF
      when "0111010010010" =>  data <= "11111111";  -- 6E92 = FF
      when "0111010010011" =>  data <= "11111111";  -- 6E93 = FF
      when "0111010010100" =>  data <= "11111111";  -- 6E94 = FF
      when "0111010010101" =>  data <= "11111111";  -- 6E95 = FF
      when "0111010010110" =>  data <= "11111111";  -- 6E96 = FF
      when "0111010010111" =>  data <= "11111111";  -- 6E97 = FF
      when "0111010011000" =>  data <= "11111111";  -- 6E98 = FF
      when "0111010011001" =>  data <= "11111111";  -- 6E99 = FF
      when "0111010011010" =>  data <= "11111111";  -- 6E9A = FF
      when "0111010011011" =>  data <= "11111111";  -- 6E9B = FF
      when "0111010011100" =>  data <= "11111111";  -- 6E9C = FF
      when "0111010011101" =>  data <= "11111111";  -- 6E9D = FF
      when "0111010011110" =>  data <= "11111111";  -- 6E9E = FF
      when "0111010011111" =>  data <= "11111111";  -- 6E9F = FF
      when "0111010100000" =>  data <= "11111111";  -- 6EA0 = FF
      when "0111010100001" =>  data <= "11111111";  -- 6EA1 = FF
      when "0111010100010" =>  data <= "11111111";  -- 6EA2 = FF
      when "0111010100011" =>  data <= "11111111";  -- 6EA3 = FF
      when "0111010100100" =>  data <= "11111111";  -- 6EA4 = FF
      when "0111010100101" =>  data <= "11111111";  -- 6EA5 = FF
      when "0111010100110" =>  data <= "11111111";  -- 6EA6 = FF
      when "0111010100111" =>  data <= "11111111";  -- 6EA7 = FF
      when "0111010101000" =>  data <= "11111111";  -- 6EA8 = FF
      when "0111010101001" =>  data <= "11111111";  -- 6EA9 = FF
      when "0111010101010" =>  data <= "11111111";  -- 6EAA = FF
      when "0111010101011" =>  data <= "11111111";  -- 6EAB = FF
      when "0111010101100" =>  data <= "11111111";  -- 6EAC = FF
      when "0111010101101" =>  data <= "11111111";  -- 6EAD = FF
      when "0111010101110" =>  data <= "11111111";  -- 6EAE = FF
      when "0111010101111" =>  data <= "11111111";  -- 6EAF = FF
      when "0111010110000" =>  data <= "11111111";  -- 6EB0 = FF
      when "0111010110001" =>  data <= "11111111";  -- 6EB1 = FF
      when "0111010110010" =>  data <= "11111111";  -- 6EB2 = FF
      when "0111010110011" =>  data <= "11111111";  -- 6EB3 = FF
      when "0111010110100" =>  data <= "11111111";  -- 6EB4 = FF
      when "0111010110101" =>  data <= "11111111";  -- 6EB5 = FF
      when "0111010110110" =>  data <= "11111111";  -- 6EB6 = FF
      when "0111010110111" =>  data <= "11111111";  -- 6EB7 = FF
      when "0111010111000" =>  data <= "11111111";  -- 6EB8 = FF
      when "0111010111001" =>  data <= "11111111";  -- 6EB9 = FF
      when "0111010111010" =>  data <= "11111111";  -- 6EBA = FF
      when "0111010111011" =>  data <= "11111111";  -- 6EBB = FF
      when "0111010111100" =>  data <= "11111111";  -- 6EBC = FF
      when "0111010111101" =>  data <= "11111111";  -- 6EBD = FF
      when "0111010111110" =>  data <= "11111111";  -- 6EBE = FF
      when "0111010111111" =>  data <= "11111111";  -- 6EBF = FF
      when "0111011000000" =>  data <= "11111111";  -- 6EC0 = FF
      when "0111011000001" =>  data <= "11111111";  -- 6EC1 = FF
      when "0111011000010" =>  data <= "11111111";  -- 6EC2 = FF
      when "0111011000011" =>  data <= "11111111";  -- 6EC3 = FF
      when "0111011000100" =>  data <= "11111111";  -- 6EC4 = FF
      when "0111011000101" =>  data <= "11111111";  -- 6EC5 = FF
      when "0111011000110" =>  data <= "11111111";  -- 6EC6 = FF
      when "0111011000111" =>  data <= "11111111";  -- 6EC7 = FF
      when "0111011001000" =>  data <= "11111111";  -- 6EC8 = FF
      when "0111011001001" =>  data <= "11111111";  -- 6EC9 = FF
      when "0111011001010" =>  data <= "11111111";  -- 6ECA = FF
      when "0111011001011" =>  data <= "11111111";  -- 6ECB = FF
      when "0111011001100" =>  data <= "11111111";  -- 6ECC = FF
      when "0111011001101" =>  data <= "11111111";  -- 6ECD = FF
      when "0111011001110" =>  data <= "11111111";  -- 6ECE = FF
      when "0111011001111" =>  data <= "11111111";  -- 6ECF = FF
      when "0111011010000" =>  data <= "11111111";  -- 6ED0 = FF
      when "0111011010001" =>  data <= "11111111";  -- 6ED1 = FF
      when "0111011010010" =>  data <= "11111111";  -- 6ED2 = FF
      when "0111011010011" =>  data <= "11111111";  -- 6ED3 = FF
      when "0111011010100" =>  data <= "11111111";  -- 6ED4 = FF
      when "0111011010101" =>  data <= "11111111";  -- 6ED5 = FF
      when "0111011010110" =>  data <= "11111111";  -- 6ED6 = FF
      when "0111011010111" =>  data <= "11111111";  -- 6ED7 = FF
      when "0111011011000" =>  data <= "11111111";  -- 6ED8 = FF
      when "0111011011001" =>  data <= "11111111";  -- 6ED9 = FF
      when "0111011011010" =>  data <= "11111111";  -- 6EDA = FF
      when "0111011011011" =>  data <= "11111111";  -- 6EDB = FF
      when "0111011011100" =>  data <= "11111111";  -- 6EDC = FF
      when "0111011011101" =>  data <= "11111111";  -- 6EDD = FF
      when "0111011011110" =>  data <= "11111111";  -- 6EDE = FF
      when "0111011011111" =>  data <= "11111111";  -- 6EDF = FF
      when "0111011100000" =>  data <= "11111111";  -- 6EE0 = FF
      when "0111011100001" =>  data <= "11111111";  -- 6EE1 = FF
      when "0111011100010" =>  data <= "11111111";  -- 6EE2 = FF
      when "0111011100011" =>  data <= "11111111";  -- 6EE3 = FF
      when "0111011100100" =>  data <= "11111111";  -- 6EE4 = FF
      when "0111011100101" =>  data <= "11111111";  -- 6EE5 = FF
      when "0111011100110" =>  data <= "11111111";  -- 6EE6 = FF
      when "0111011100111" =>  data <= "11111111";  -- 6EE7 = FF
      when "0111011101000" =>  data <= "11111111";  -- 6EE8 = FF
      when "0111011101001" =>  data <= "11111111";  -- 6EE9 = FF
      when "0111011101010" =>  data <= "11111111";  -- 6EEA = FF
      when "0111011101011" =>  data <= "11111111";  -- 6EEB = FF
      when "0111011101100" =>  data <= "11111111";  -- 6EEC = FF
      when "0111011101101" =>  data <= "11111111";  -- 6EED = FF
      when "0111011101110" =>  data <= "11111111";  -- 6EEE = FF
      when "0111011101111" =>  data <= "11111111";  -- 6EEF = FF
      when "0111011110000" =>  data <= "11111111";  -- 6EF0 = FF
      when "0111011110001" =>  data <= "11111111";  -- 6EF1 = FF
      when "0111011110010" =>  data <= "11111111";  -- 6EF2 = FF
      when "0111011110011" =>  data <= "11111111";  -- 6EF3 = FF
      when "0111011110100" =>  data <= "11111111";  -- 6EF4 = FF
      when "0111011110101" =>  data <= "11111111";  -- 6EF5 = FF
      when "0111011110110" =>  data <= "11111111";  -- 6EF6 = FF
      when "0111011110111" =>  data <= "11111111";  -- 6EF7 = FF
      when "0111011111000" =>  data <= "11111111";  -- 6EF8 = FF
      when "0111011111001" =>  data <= "11111111";  -- 6EF9 = FF
      when "0111011111010" =>  data <= "11111111";  -- 6EFA = FF
      when "0111011111011" =>  data <= "11111111";  -- 6EFB = FF
      when "0111011111100" =>  data <= "11111111";  -- 6EFC = FF
      when "0111011111101" =>  data <= "11111111";  -- 6EFD = FF
      when "0111011111110" =>  data <= "11111111";  -- 6EFE = FF
      when "0111011111111" =>  data <= "11111111";  -- 6EFF = FF
      when "0111100000000" =>  data <= "11111111";  -- 6F00 = FF
      when "0111100000001" =>  data <= "11111111";  -- 6F01 = FF
      when "0111100000010" =>  data <= "11111111";  -- 6F02 = FF
      when "0111100000011" =>  data <= "11111111";  -- 6F03 = FF
      when "0111100000100" =>  data <= "11111111";  -- 6F04 = FF
      when "0111100000101" =>  data <= "11111111";  -- 6F05 = FF
      when "0111100000110" =>  data <= "11111111";  -- 6F06 = FF
      when "0111100000111" =>  data <= "11111111";  -- 6F07 = FF
      when "0111100001000" =>  data <= "11111111";  -- 6F08 = FF
      when "0111100001001" =>  data <= "11111111";  -- 6F09 = FF
      when "0111100001010" =>  data <= "11111111";  -- 6F0A = FF
      when "0111100001011" =>  data <= "11111111";  -- 6F0B = FF
      when "0111100001100" =>  data <= "11111111";  -- 6F0C = FF
      when "0111100001101" =>  data <= "11111111";  -- 6F0D = FF
      when "0111100001110" =>  data <= "11111111";  -- 6F0E = FF
      when "0111100001111" =>  data <= "11111111";  -- 6F0F = FF
      when "0111100010000" =>  data <= "11111111";  -- 6F10 = FF
      when "0111100010001" =>  data <= "11111111";  -- 6F11 = FF
      when "0111100010010" =>  data <= "11111111";  -- 6F12 = FF
      when "0111100010011" =>  data <= "11111111";  -- 6F13 = FF
      when "0111100010100" =>  data <= "11111111";  -- 6F14 = FF
      when "0111100010101" =>  data <= "11111111";  -- 6F15 = FF
      when "0111100010110" =>  data <= "11111111";  -- 6F16 = FF
      when "0111100010111" =>  data <= "11111111";  -- 6F17 = FF
      when "0111100011000" =>  data <= "11111111";  -- 6F18 = FF
      when "0111100011001" =>  data <= "11111111";  -- 6F19 = FF
      when "0111100011010" =>  data <= "11111111";  -- 6F1A = FF
      when "0111100011011" =>  data <= "11111111";  -- 6F1B = FF
      when "0111100011100" =>  data <= "11111111";  -- 6F1C = FF
      when "0111100011101" =>  data <= "11111111";  -- 6F1D = FF
      when "0111100011110" =>  data <= "11111111";  -- 6F1E = FF
      when "0111100011111" =>  data <= "11111111";  -- 6F1F = FF
      when "0111100100000" =>  data <= "11111111";  -- 6F20 = FF
      when "0111100100001" =>  data <= "11111111";  -- 6F21 = FF
      when "0111100100010" =>  data <= "11111111";  -- 6F22 = FF
      when "0111100100011" =>  data <= "11111111";  -- 6F23 = FF
      when "0111100100100" =>  data <= "11111111";  -- 6F24 = FF
      when "0111100100101" =>  data <= "11111111";  -- 6F25 = FF
      when "0111100100110" =>  data <= "11111111";  -- 6F26 = FF
      when "0111100100111" =>  data <= "11111111";  -- 6F27 = FF
      when "0111100101000" =>  data <= "11111111";  -- 6F28 = FF
      when "0111100101001" =>  data <= "11111111";  -- 6F29 = FF
      when "0111100101010" =>  data <= "11111111";  -- 6F2A = FF
      when "0111100101011" =>  data <= "11111111";  -- 6F2B = FF
      when "0111100101100" =>  data <= "11111111";  -- 6F2C = FF
      when "0111100101101" =>  data <= "11111111";  -- 6F2D = FF
      when "0111100101110" =>  data <= "11111111";  -- 6F2E = FF
      when "0111100101111" =>  data <= "11111111";  -- 6F2F = FF
      when "0111100110000" =>  data <= "11111111";  -- 6F30 = FF
      when "0111100110001" =>  data <= "11111111";  -- 6F31 = FF
      when "0111100110010" =>  data <= "11111111";  -- 6F32 = FF
      when "0111100110011" =>  data <= "11111111";  -- 6F33 = FF
      when "0111100110100" =>  data <= "11111111";  -- 6F34 = FF
      when "0111100110101" =>  data <= "11111111";  -- 6F35 = FF
      when "0111100110110" =>  data <= "11111111";  -- 6F36 = FF
      when "0111100110111" =>  data <= "11111111";  -- 6F37 = FF
      when "0111100111000" =>  data <= "11111111";  -- 6F38 = FF
      when "0111100111001" =>  data <= "11111111";  -- 6F39 = FF
      when "0111100111010" =>  data <= "11111111";  -- 6F3A = FF
      when "0111100111011" =>  data <= "11111111";  -- 6F3B = FF
      when "0111100111100" =>  data <= "11111111";  -- 6F3C = FF
      when "0111100111101" =>  data <= "11111111";  -- 6F3D = FF
      when "0111100111110" =>  data <= "11111111";  -- 6F3E = FF
      when "0111100111111" =>  data <= "11111111";  -- 6F3F = FF
      when "0111101000000" =>  data <= "11111111";  -- 6F40 = FF
      when "0111101000001" =>  data <= "11111111";  -- 6F41 = FF
      when "0111101000010" =>  data <= "11111111";  -- 6F42 = FF
      when "0111101000011" =>  data <= "11111111";  -- 6F43 = FF
      when "0111101000100" =>  data <= "11111111";  -- 6F44 = FF
      when "0111101000101" =>  data <= "11111111";  -- 6F45 = FF
      when "0111101000110" =>  data <= "11111111";  -- 6F46 = FF
      when "0111101000111" =>  data <= "11111111";  -- 6F47 = FF
      when "0111101001000" =>  data <= "11111111";  -- 6F48 = FF
      when "0111101001001" =>  data <= "11111111";  -- 6F49 = FF
      when "0111101001010" =>  data <= "11111111";  -- 6F4A = FF
      when "0111101001011" =>  data <= "11111111";  -- 6F4B = FF
      when "0111101001100" =>  data <= "11111111";  -- 6F4C = FF
      when "0111101001101" =>  data <= "11111111";  -- 6F4D = FF
      when "0111101001110" =>  data <= "11111111";  -- 6F4E = FF
      when "0111101001111" =>  data <= "11111111";  -- 6F4F = FF
      when "0111101010000" =>  data <= "11111111";  -- 6F50 = FF
      when "0111101010001" =>  data <= "11111111";  -- 6F51 = FF
      when "0111101010010" =>  data <= "11111111";  -- 6F52 = FF
      when "0111101010011" =>  data <= "11111111";  -- 6F53 = FF
      when "0111101010100" =>  data <= "11111111";  -- 6F54 = FF
      when "0111101010101" =>  data <= "11111111";  -- 6F55 = FF
      when "0111101010110" =>  data <= "11111111";  -- 6F56 = FF
      when "0111101010111" =>  data <= "11111111";  -- 6F57 = FF
      when "0111101011000" =>  data <= "11111111";  -- 6F58 = FF
      when "0111101011001" =>  data <= "11111111";  -- 6F59 = FF
      when "0111101011010" =>  data <= "11111111";  -- 6F5A = FF
      when "0111101011011" =>  data <= "11111111";  -- 6F5B = FF
      when "0111101011100" =>  data <= "11111111";  -- 6F5C = FF
      when "0111101011101" =>  data <= "11111111";  -- 6F5D = FF
      when "0111101011110" =>  data <= "11111111";  -- 6F5E = FF
      when "0111101011111" =>  data <= "11111111";  -- 6F5F = FF
      when "0111101100000" =>  data <= "11111111";  -- 6F60 = FF
      when "0111101100001" =>  data <= "11111111";  -- 6F61 = FF
      when "0111101100010" =>  data <= "11111111";  -- 6F62 = FF
      when "0111101100011" =>  data <= "11111111";  -- 6F63 = FF
      when "0111101100100" =>  data <= "11111111";  -- 6F64 = FF
      when "0111101100101" =>  data <= "11111111";  -- 6F65 = FF
      when "0111101100110" =>  data <= "11111111";  -- 6F66 = FF
      when "0111101100111" =>  data <= "11111111";  -- 6F67 = FF
      when "0111101101000" =>  data <= "11111111";  -- 6F68 = FF
      when "0111101101001" =>  data <= "11111111";  -- 6F69 = FF
      when "0111101101010" =>  data <= "11111111";  -- 6F6A = FF
      when "0111101101011" =>  data <= "11111111";  -- 6F6B = FF
      when "0111101101100" =>  data <= "11111111";  -- 6F6C = FF
      when "0111101101101" =>  data <= "11111111";  -- 6F6D = FF
      when "0111101101110" =>  data <= "11111111";  -- 6F6E = FF
      when "0111101101111" =>  data <= "11111111";  -- 6F6F = FF
      when "0111101110000" =>  data <= "11111111";  -- 6F70 = FF
      when "0111101110001" =>  data <= "11111111";  -- 6F71 = FF
      when "0111101110010" =>  data <= "11111111";  -- 6F72 = FF
      when "0111101110011" =>  data <= "11111111";  -- 6F73 = FF
      when "0111101110100" =>  data <= "11111111";  -- 6F74 = FF
      when "0111101110101" =>  data <= "11111111";  -- 6F75 = FF
      when "0111101110110" =>  data <= "11111111";  -- 6F76 = FF
      when "0111101110111" =>  data <= "11111111";  -- 6F77 = FF
      when "0111101111000" =>  data <= "11111111";  -- 6F78 = FF
      when "0111101111001" =>  data <= "11111111";  -- 6F79 = FF
      when "0111101111010" =>  data <= "11111111";  -- 6F7A = FF
      when "0111101111011" =>  data <= "11111111";  -- 6F7B = FF
      when "0111101111100" =>  data <= "11111111";  -- 6F7C = FF
      when "0111101111101" =>  data <= "11111111";  -- 6F7D = FF
      when "0111101111110" =>  data <= "11111111";  -- 6F7E = FF
      when "0111101111111" =>  data <= "11111111";  -- 6F7F = FF
      when "0111110000000" =>  data <= "11111111";  -- 6F80 = FF
      when "0111110000001" =>  data <= "11111111";  -- 6F81 = FF
      when "0111110000010" =>  data <= "11111111";  -- 6F82 = FF
      when "0111110000011" =>  data <= "11111111";  -- 6F83 = FF
      when "0111110000100" =>  data <= "11111111";  -- 6F84 = FF
      when "0111110000101" =>  data <= "11111111";  -- 6F85 = FF
      when "0111110000110" =>  data <= "11111111";  -- 6F86 = FF
      when "0111110000111" =>  data <= "11111111";  -- 6F87 = FF
      when "0111110001000" =>  data <= "11111111";  -- 6F88 = FF
      when "0111110001001" =>  data <= "11111111";  -- 6F89 = FF
      when "0111110001010" =>  data <= "11111111";  -- 6F8A = FF
      when "0111110001011" =>  data <= "11111111";  -- 6F8B = FF
      when "0111110001100" =>  data <= "11111111";  -- 6F8C = FF
      when "0111110001101" =>  data <= "11111111";  -- 6F8D = FF
      when "0111110001110" =>  data <= "11111111";  -- 6F8E = FF
      when "0111110001111" =>  data <= "11111111";  -- 6F8F = FF
      when "0111110010000" =>  data <= "11111111";  -- 6F90 = FF
      when "0111110010001" =>  data <= "11111111";  -- 6F91 = FF
      when "0111110010010" =>  data <= "11111111";  -- 6F92 = FF
      when "0111110010011" =>  data <= "11111111";  -- 6F93 = FF
      when "0111110010100" =>  data <= "11111111";  -- 6F94 = FF
      when "0111110010101" =>  data <= "11111111";  -- 6F95 = FF
      when "0111110010110" =>  data <= "11111111";  -- 6F96 = FF
      when "0111110010111" =>  data <= "11111111";  -- 6F97 = FF
      when "0111110011000" =>  data <= "11111111";  -- 6F98 = FF
      when "0111110011001" =>  data <= "11111111";  -- 6F99 = FF
      when "0111110011010" =>  data <= "11111111";  -- 6F9A = FF
      when "0111110011011" =>  data <= "11111111";  -- 6F9B = FF
      when "0111110011100" =>  data <= "11111111";  -- 6F9C = FF
      when "0111110011101" =>  data <= "11111111";  -- 6F9D = FF
      when "0111110011110" =>  data <= "11111111";  -- 6F9E = FF
      when "0111110011111" =>  data <= "11111111";  -- 6F9F = FF
      when "0111110100000" =>  data <= "11111111";  -- 6FA0 = FF
      when "0111110100001" =>  data <= "11111111";  -- 6FA1 = FF
      when "0111110100010" =>  data <= "11111111";  -- 6FA2 = FF
      when "0111110100011" =>  data <= "11111111";  -- 6FA3 = FF
      when "0111110100100" =>  data <= "11111111";  -- 6FA4 = FF
      when "0111110100101" =>  data <= "11111111";  -- 6FA5 = FF
      when "0111110100110" =>  data <= "11111111";  -- 6FA6 = FF
      when "0111110100111" =>  data <= "11111111";  -- 6FA7 = FF
      when "0111110101000" =>  data <= "11111111";  -- 6FA8 = FF
      when "0111110101001" =>  data <= "11111111";  -- 6FA9 = FF
      when "0111110101010" =>  data <= "11111111";  -- 6FAA = FF
      when "0111110101011" =>  data <= "11111111";  -- 6FAB = FF
      when "0111110101100" =>  data <= "11111111";  -- 6FAC = FF
      when "0111110101101" =>  data <= "11111111";  -- 6FAD = FF
      when "0111110101110" =>  data <= "11111111";  -- 6FAE = FF
      when "0111110101111" =>  data <= "11111111";  -- 6FAF = FF
      when "0111110110000" =>  data <= "11111111";  -- 6FB0 = FF
      when "0111110110001" =>  data <= "11111111";  -- 6FB1 = FF
      when "0111110110010" =>  data <= "11111111";  -- 6FB2 = FF
      when "0111110110011" =>  data <= "11111111";  -- 6FB3 = FF
      when "0111110110100" =>  data <= "11111111";  -- 6FB4 = FF
      when "0111110110101" =>  data <= "11111111";  -- 6FB5 = FF
      when "0111110110110" =>  data <= "11111111";  -- 6FB6 = FF
      when "0111110110111" =>  data <= "11111111";  -- 6FB7 = FF
      when "0111110111000" =>  data <= "11111111";  -- 6FB8 = FF
      when "0111110111001" =>  data <= "11111111";  -- 6FB9 = FF
      when "0111110111010" =>  data <= "11111111";  -- 6FBA = FF
      when "0111110111011" =>  data <= "11111111";  -- 6FBB = FF
      when "0111110111100" =>  data <= "11111111";  -- 6FBC = FF
      when "0111110111101" =>  data <= "11111111";  -- 6FBD = FF
      when "0111110111110" =>  data <= "11111111";  -- 6FBE = FF
      when "0111110111111" =>  data <= "11111111";  -- 6FBF = FF
      when "0111111000000" =>  data <= "11111111";  -- 6FC0 = FF
      when "0111111000001" =>  data <= "11111111";  -- 6FC1 = FF
      when "0111111000010" =>  data <= "11111111";  -- 6FC2 = FF
      when "0111111000011" =>  data <= "11111111";  -- 6FC3 = FF
      when "0111111000100" =>  data <= "11111111";  -- 6FC4 = FF
      when "0111111000101" =>  data <= "11111111";  -- 6FC5 = FF
      when "0111111000110" =>  data <= "11111111";  -- 6FC6 = FF
      when "0111111000111" =>  data <= "11111111";  -- 6FC7 = FF
      when "0111111001000" =>  data <= "11111111";  -- 6FC8 = FF
      when "0111111001001" =>  data <= "11111111";  -- 6FC9 = FF
      when "0111111001010" =>  data <= "11111111";  -- 6FCA = FF
      when "0111111001011" =>  data <= "11111111";  -- 6FCB = FF
      when "0111111001100" =>  data <= "11111111";  -- 6FCC = FF
      when "0111111001101" =>  data <= "11111111";  -- 6FCD = FF
      when "0111111001110" =>  data <= "11111111";  -- 6FCE = FF
      when "0111111001111" =>  data <= "11111111";  -- 6FCF = FF
      when "0111111010000" =>  data <= "11111111";  -- 6FD0 = FF
      when "0111111010001" =>  data <= "11111111";  -- 6FD1 = FF
      when "0111111010010" =>  data <= "11111111";  -- 6FD2 = FF
      when "0111111010011" =>  data <= "11111111";  -- 6FD3 = FF
      when "0111111010100" =>  data <= "11111111";  -- 6FD4 = FF
      when "0111111010101" =>  data <= "11111111";  -- 6FD5 = FF
      when "0111111010110" =>  data <= "11111111";  -- 6FD6 = FF
      when "0111111010111" =>  data <= "11111111";  -- 6FD7 = FF
      when "0111111011000" =>  data <= "11111111";  -- 6FD8 = FF
      when "0111111011001" =>  data <= "11111111";  -- 6FD9 = FF
      when "0111111011010" =>  data <= "11111111";  -- 6FDA = FF
      when "0111111011011" =>  data <= "11111111";  -- 6FDB = FF
      when "0111111011100" =>  data <= "11111111";  -- 6FDC = FF
      when "0111111011101" =>  data <= "11111111";  -- 6FDD = FF
      when "0111111011110" =>  data <= "11111111";  -- 6FDE = FF
      when "0111111011111" =>  data <= "11111111";  -- 6FDF = FF
      when "0111111100000" =>  data <= "11111111";  -- 6FE0 = FF
      when "0111111100001" =>  data <= "11111111";  -- 6FE1 = FF
      when "0111111100010" =>  data <= "11111111";  -- 6FE2 = FF
      when "0111111100011" =>  data <= "11111111";  -- 6FE3 = FF
      when "0111111100100" =>  data <= "11111111";  -- 6FE4 = FF
      when "0111111100101" =>  data <= "11111111";  -- 6FE5 = FF
      when "0111111100110" =>  data <= "11111111";  -- 6FE6 = FF
      when "0111111100111" =>  data <= "11111111";  -- 6FE7 = FF
      when "0111111101000" =>  data <= "11111111";  -- 6FE8 = FF
      when "0111111101001" =>  data <= "11111111";  -- 6FE9 = FF
      when "0111111101010" =>  data <= "11111111";  -- 6FEA = FF
      when "0111111101011" =>  data <= "11111111";  -- 6FEB = FF
      when "0111111101100" =>  data <= "11111111";  -- 6FEC = FF
      when "0111111101101" =>  data <= "11111111";  -- 6FED = FF
      when "0111111101110" =>  data <= "11111111";  -- 6FEE = FF
      when "0111111101111" =>  data <= "11111111";  -- 6FEF = FF
      when "0111111110000" =>  data <= "11111111";  -- 6FF0 = FF
      when "0111111110001" =>  data <= "11111111";  -- 6FF1 = FF
      when "0111111110010" =>  data <= "11111111";  -- 6FF2 = FF
      when "0111111110011" =>  data <= "11111111";  -- 6FF3 = FF
      when "0111111110100" =>  data <= "11111111";  -- 6FF4 = FF
      when "0111111110101" =>  data <= "11111111";  -- 6FF5 = FF
      when "0111111110110" =>  data <= "11111111";  -- 6FF6 = FF
      when "0111111110111" =>  data <= "11111111";  -- 6FF7 = FF
      when "0111111111000" =>  data <= "11111111";  -- 6FF8 = FF
      when "0111111111001" =>  data <= "11111111";  -- 6FF9 = FF
      when "0111111111010" =>  data <= "11111111";  -- 6FFA = FF
      when "0111111111011" =>  data <= "11111111";  -- 6FFB = FF
      when "0111111111100" =>  data <= "11111111";  -- 6FFC = FF
      when "0111111111101" =>  data <= "11111111";  -- 6FFD = FF
      when "0111111111110" =>  data <= "11111111";  -- 6FFE = FF
      when "0111111111111" =>  data <= "11111111";  -- 6FFF = FF
      when "1000000000000" =>  data <= "01010100";  -- 7000 = 54
      when "1000000000001" =>  data <= "01001111";  -- 7001 = 4F
      when "1000000000010" =>  data <= "01001111";  -- 7002 = 4F
      when "1000000000011" =>  data <= "00100000";  -- 7003 = 20
      when "1000000000100" =>  data <= "01001101";  -- 7004 = 4D
      when "1000000000101" =>  data <= "01000001";  -- 7005 = 41
      when "1000000000110" =>  data <= "01001110";  -- 7006 = 4E
      when "1000000000111" =>  data <= "01011001";  -- 7007 = 59
      when "1000000001000" =>  data <= "00100000";  -- 7008 = 20
      when "1000000001001" =>  data <= "01000110";  -- 7009 = 46
      when "1000000001010" =>  data <= "01001001";  -- 700A = 49
      when "1000000001011" =>  data <= "01001100";  -- 700B = 4C
      when "1000000001100" =>  data <= "01000101";  -- 700C = 45
      when "1000000001101" =>  data <= "11010011";  -- 700D = D3
      when "1000000001110" =>  data <= "01000110";  -- 700E = 46
      when "1000000001111" =>  data <= "01001001";  -- 700F = 49
      when "1000000010000" =>  data <= "01001100";  -- 7010 = 4C
      when "1000000010001" =>  data <= "01000101";  -- 7011 = 45
      when "1000000010010" =>  data <= "00100000";  -- 7012 = 20
      when "1000000010011" =>  data <= "01001111";  -- 7013 = 4F
      when "1000000010100" =>  data <= "01010000";  -- 7014 = 50
      when "1000000010101" =>  data <= "01000101";  -- 7015 = 45
      when "1000000010110" =>  data <= "11001110";  -- 7016 = CE
      when "1000000010111" =>  data <= "01000110";  -- 7017 = 46
      when "1000000011000" =>  data <= "01001001";  -- 7018 = 49
      when "1000000011001" =>  data <= "01001100";  -- 7019 = 4C
      when "1000000011010" =>  data <= "01000101";  -- 701A = 45
      when "1000000011011" =>  data <= "00100000";  -- 701B = 20
      when "1000000011100" =>  data <= "01001110";  -- 701C = 4E
      when "1000000011101" =>  data <= "01001111";  -- 701D = 4F
      when "1000000011110" =>  data <= "01010100";  -- 701E = 54
      when "1000000011111" =>  data <= "00100000";  -- 701F = 20
      when "1000000100000" =>  data <= "01001111";  -- 7020 = 4F
      when "1000000100001" =>  data <= "01010000";  -- 7021 = 50
      when "1000000100010" =>  data <= "01000101";  -- 7022 = 45
      when "1000000100011" =>  data <= "11001110";  -- 7023 = CE
      when "1000000100100" =>  data <= "01000110";  -- 7024 = 46
      when "1000000100101" =>  data <= "01001001";  -- 7025 = 49
      when "1000000100110" =>  data <= "01001100";  -- 7026 = 4C
      when "1000000100111" =>  data <= "01000101";  -- 7027 = 45
      when "1000000101000" =>  data <= "00100000";  -- 7028 = 20
      when "1000000101001" =>  data <= "01001110";  -- 7029 = 4E
      when "1000000101010" =>  data <= "01001111";  -- 702A = 4F
      when "1000000101011" =>  data <= "01010100";  -- 702B = 54
      when "1000000101100" =>  data <= "00100000";  -- 702C = 20
      when "1000000101101" =>  data <= "01000110";  -- 702D = 46
      when "1000000101110" =>  data <= "01001111";  -- 702E = 4F
      when "1000000101111" =>  data <= "01010101";  -- 702F = 55
      when "1000000110000" =>  data <= "01001110";  -- 7030 = 4E
      when "1000000110001" =>  data <= "11000100";  -- 7031 = C4
      when "1000000110010" =>  data <= "00001101";  -- 7032 = D
      when "1000000110011" =>  data <= "01010011";  -- 7033 = 53
      when "1000000110100" =>  data <= "01000101";  -- 7034 = 45
      when "1000000110101" =>  data <= "01000001";  -- 7035 = 41
      when "1000000110110" =>  data <= "01010010";  -- 7036 = 52
      when "1000000110111" =>  data <= "01000011";  -- 7037 = 43
      when "1000000111000" =>  data <= "01001000";  -- 7038 = 48
      when "1000000111001" =>  data <= "01001001";  -- 7039 = 49
      when "1000000111010" =>  data <= "01001110";  -- 703A = 4E
      when "1000000111011" =>  data <= "01000111";  -- 703B = 47
      when "1000000111100" =>  data <= "10100000";  -- 703C = A0
      when "1000000111101" =>  data <= "01000110";  -- 703D = 46
      when "1000000111110" =>  data <= "01001111";  -- 703E = 4F
      when "1000000111111" =>  data <= "01010010";  -- 703F = 52
      when "1000001000000" =>  data <= "10100000";  -- 7040 = A0
      when "1000001000001" =>  data <= "00001101";  -- 7041 = D
      when "1000001000010" =>  data <= "01010000";  -- 7042 = 50
      when "1000001000011" =>  data <= "01010010";  -- 7043 = 52
      when "1000001000100" =>  data <= "01000101";  -- 7044 = 45
      when "1000001000101" =>  data <= "01010011";  -- 7045 = 53
      when "1000001000110" =>  data <= "01010011";  -- 7046 = 53
      when "1000001000111" =>  data <= "00100000";  -- 7047 = 20
      when "1000001001000" =>  data <= "01010000";  -- 7048 = 50
      when "1000001001001" =>  data <= "01001100";  -- 7049 = 4C
      when "1000001001010" =>  data <= "01000001";  -- 704A = 41
      when "1000001001011" =>  data <= "01011001";  -- 704B = 59
      when "1000001001100" =>  data <= "10100000";  -- 704C = A0
      when "1000001001101" =>  data <= "00100110";  -- 704D = 26
      when "1000001001110" =>  data <= "00100000";  -- 704E = 20
      when "1000001001111" =>  data <= "01010010";  -- 704F = 52
      when "1000001010000" =>  data <= "01000101";  -- 7050 = 45
      when "1000001010001" =>  data <= "01000011";  -- 7051 = 43
      when "1000001010010" =>  data <= "01001111";  -- 7052 = 4F
      when "1000001010011" =>  data <= "01010010";  -- 7053 = 52
      when "1000001010100" =>  data <= "01000100";  -- 7054 = 44
      when "1000001010101" =>  data <= "10100000";  -- 7055 = A0
      when "1000001010110" =>  data <= "01001111";  -- 7056 = 4F
      when "1000001010111" =>  data <= "01001110";  -- 7057 = 4E
      when "1000001011000" =>  data <= "00100000";  -- 7058 = 20
      when "1000001011001" =>  data <= "01010100";  -- 7059 = 54
      when "1000001011010" =>  data <= "01000001";  -- 705A = 41
      when "1000001011011" =>  data <= "01010000";  -- 705B = 50
      when "1000001011100" =>  data <= "01000101";  -- 705C = 45
      when "1000001011101" =>  data <= "00100000";  -- 705D = 20
      when "1000001011110" =>  data <= "10100011";  -- 705E = A3
      when "1000001011111" =>  data <= "00001101";  -- 705F = D
      when "1000001100000" =>  data <= "01001100";  -- 7060 = 4C
      when "1000001100001" =>  data <= "01001111";  -- 7061 = 4F
      when "1000001100010" =>  data <= "01000001";  -- 7062 = 41
      when "1000001100011" =>  data <= "11000100";  -- 7063 = C4
      when "1000001100100" =>  data <= "00001101";  -- 7064 = D
      when "1000001100101" =>  data <= "01010111";  -- 7065 = 57
      when "1000001100110" =>  data <= "01010010";  -- 7066 = 52
      when "1000001100111" =>  data <= "01001001";  -- 7067 = 49
      when "1000001101000" =>  data <= "01010100";  -- 7068 = 54
      when "1000001101001" =>  data <= "01001001";  -- 7069 = 49
      when "1000001101010" =>  data <= "01001110";  -- 706A = 4E
      when "1000001101011" =>  data <= "01000111";  -- 706B = 47
      when "1000001101100" =>  data <= "10100000";  -- 706C = A0
      when "1000001101101" =>  data <= "00001101";  -- 706D = D
      when "1000001101110" =>  data <= "01010110";  -- 706E = 56
      when "1000001101111" =>  data <= "01000101";  -- 706F = 45
      when "1000001110000" =>  data <= "01010010";  -- 7070 = 52
      when "1000001110001" =>  data <= "01001001";  -- 7071 = 49
      when "1000001110010" =>  data <= "01000110";  -- 7072 = 46
      when "1000001110011" =>  data <= "11011001";  -- 7073 = D9
      when "1000001110100" =>  data <= "01000100";  -- 7074 = 44
      when "1000001110101" =>  data <= "01000101";  -- 7075 = 45
      when "1000001110110" =>  data <= "01010110";  -- 7076 = 56
      when "1000001110111" =>  data <= "01001001";  -- 7077 = 49
      when "1000001111000" =>  data <= "01000011";  -- 7078 = 43
      when "1000001111001" =>  data <= "01000101";  -- 7079 = 45
      when "1000001111010" =>  data <= "00100000";  -- 707A = 20
      when "1000001111011" =>  data <= "01001110";  -- 707B = 4E
      when "1000001111100" =>  data <= "01001111";  -- 707C = 4F
      when "1000001111101" =>  data <= "01010100";  -- 707D = 54
      when "1000001111110" =>  data <= "00100000";  -- 707E = 20
      when "1000001111111" =>  data <= "01010000";  -- 707F = 50
      when "1000010000000" =>  data <= "01010010";  -- 7080 = 52
      when "1000010000001" =>  data <= "01000101";  -- 7081 = 45
      when "1000010000010" =>  data <= "01010011";  -- 7082 = 53
      when "1000010000011" =>  data <= "01000101";  -- 7083 = 45
      when "1000010000100" =>  data <= "01001110";  -- 7084 = 4E
      when "1000010000101" =>  data <= "11010100";  -- 7085 = D4
      when "1000010000110" =>  data <= "01001110";  -- 7086 = 4E
      when "1000010000111" =>  data <= "01001111";  -- 7087 = 4F
      when "1000010001000" =>  data <= "01010100";  -- 7088 = 54
      when "1000010001001" =>  data <= "00100000";  -- 7089 = 20
      when "1000010001010" =>  data <= "01001001";  -- 708A = 49
      when "1000010001011" =>  data <= "01001110";  -- 708B = 4E
      when "1000010001100" =>  data <= "01010000";  -- 708C = 50
      when "1000010001101" =>  data <= "01010101";  -- 708D = 55
      when "1000010001110" =>  data <= "01010100";  -- 708E = 54
      when "1000010001111" =>  data <= "00100000";  -- 708F = 20
      when "1000010010000" =>  data <= "01000110";  -- 7090 = 46
      when "1000010010001" =>  data <= "01001001";  -- 7091 = 49
      when "1000010010010" =>  data <= "01001100";  -- 7092 = 4C
      when "1000010010011" =>  data <= "11000101";  -- 7093 = C5
      when "1000010010100" =>  data <= "01001110";  -- 7094 = 4E
      when "1000010010101" =>  data <= "01001111";  -- 7095 = 4F
      when "1000010010110" =>  data <= "01010100";  -- 7096 = 54
      when "1000010010111" =>  data <= "00100000";  -- 7097 = 20
      when "1000010011000" =>  data <= "01001111";  -- 7098 = 4F
      when "1000010011001" =>  data <= "01010101";  -- 7099 = 55
      when "1000010011010" =>  data <= "01010100";  -- 709A = 54
      when "1000010011011" =>  data <= "01010000";  -- 709B = 50
      when "1000010011100" =>  data <= "01010101";  -- 709C = 55
      when "1000010011101" =>  data <= "01010100";  -- 709D = 54
      when "1000010011110" =>  data <= "00100000";  -- 709E = 20
      when "1000010011111" =>  data <= "01000110";  -- 709F = 46
      when "1000010100000" =>  data <= "01001001";  -- 70A0 = 49
      when "1000010100001" =>  data <= "01001100";  -- 70A1 = 4C
      when "1000010100010" =>  data <= "11000101";  -- 70A2 = C5
      when "1000010100011" =>  data <= "00001101";  -- 70A3 = D
      when "1000010100100" =>  data <= "01000110";  -- 70A4 = 46
      when "1000010100101" =>  data <= "01001111";  -- 70A5 = 4F
      when "1000010100110" =>  data <= "01010101";  -- 70A6 = 55
      when "1000010100111" =>  data <= "01001110";  -- 70A7 = 4E
      when "1000010101000" =>  data <= "01000100";  -- 70A8 = 44
      when "1000010101001" =>  data <= "10100000";  -- 70A9 = A0
      when "1000010101010" =>  data <= "00001101";  -- 70AA = D
      when "1000010101011" =>  data <= "01001111";  -- 70AB = 4F
      when "1000010101100" =>  data <= "01001011";  -- 70AC = 4B
      when "1000010101101" =>  data <= "10001101";  -- 70AD = 8D
      when "1000010101110" =>  data <= "00001101";  -- 70AE = D
      when "1000010101111" =>  data <= "01010010";  -- 70AF = 52
      when "1000010110000" =>  data <= "01000101";  -- 70B0 = 45
      when "1000010110001" =>  data <= "01000001";  -- 70B1 = 41
      when "1000010110010" =>  data <= "01000100";  -- 70B2 = 44
      when "1000010110011" =>  data <= "01011001";  -- 70B3 = 59
      when "1000010110100" =>  data <= "00101110";  -- 70B4 = 2E
      when "1000010110101" =>  data <= "10001101";  -- 70B5 = 8D
      when "1000010110110" =>  data <= "00001101";  -- 70B6 = D
      when "1000010110111" =>  data <= "01000001";  -- 70B7 = 41
      when "1000010111000" =>  data <= "01010010";  -- 70B8 = 52
      when "1000010111001" =>  data <= "01000101";  -- 70B9 = 45
      when "1000010111010" =>  data <= "00100000";  -- 70BA = 20
      when "1000010111011" =>  data <= "01011001";  -- 70BB = 59
      when "1000010111100" =>  data <= "01001111";  -- 70BC = 4F
      when "1000010111101" =>  data <= "01010101";  -- 70BD = 55
      when "1000010111110" =>  data <= "00100000";  -- 70BE = 20
      when "1000010111111" =>  data <= "01010011";  -- 70BF = 53
      when "1000011000000" =>  data <= "01010101";  -- 70C0 = 55
      when "1000011000001" =>  data <= "01010010";  -- 70C1 = 52
      when "1000011000010" =>  data <= "01000101";  -- 70C2 = 45
      when "1000011000011" =>  data <= "00100000";  -- 70C3 = 20
      when "1000011000100" =>  data <= "10111111";  -- 70C4 = BF
      when "1000011000101" =>  data <= "00001101";  -- 70C5 = D
      when "1000011000110" =>  data <= "00111111";  -- 70C6 = 3F
      when "1000011000111" =>  data <= "00100000";  -- 70C7 = 20
      when "1000011001000" =>  data <= "01000010";  -- 70C8 = 42
      when "1000011001001" =>  data <= "01000001";  -- 70C9 = 41
      when "1000011001010" =>  data <= "01000100";  -- 70CA = 44
      when "1000011001011" =>  data <= "00100000";  -- 70CB = 20
      when "1000011001100" =>  data <= "01000100";  -- 70CC = 44
      when "1000011001101" =>  data <= "01001001";  -- 70CD = 49
      when "1000011001110" =>  data <= "01010011";  -- 70CE = 53
      when "1000011001111" =>  data <= "01001011";  -- 70CF = 4B
      when "1000011010000" =>  data <= "00100000";  -- 70D0 = 20
      when "1000011010001" =>  data <= "10001101";  -- 70D1 = 8D
      when "1000011010010" =>  data <= "10101001";  -- 70D2 = A9
      when "1000011010011" =>  data <= "01000000";  -- 70D3 = 40
      when "1000011010100" =>  data <= "00101100";  -- 70D4 = 2C
      when "1000011010101" =>  data <= "10101001";  -- 70D5 = A9
      when "1000011010110" =>  data <= "00100000";  -- 70D6 = 20
      when "1000011010111" =>  data <= "01001000";  -- 70D7 = 48
      when "1000011011000" =>  data <= "10101101";  -- 70D8 = AD
      when "1000011011001" =>  data <= "01000000";  -- 70D9 = 40
      when "1000011011010" =>  data <= "11101000";  -- 70DA = E8
      when "1000011011011" =>  data <= "00001001";  -- 70DB = 9
      when "1000011011100" =>  data <= "00000010";  -- 70DC = 2
      when "1000011011101" =>  data <= "10001101";  -- 70DD = 8D
      when "1000011011110" =>  data <= "01000000";  -- 70DE = 40
      when "1000011011111" =>  data <= "11101000";  -- 70DF = E8
      when "1000011100000" =>  data <= "10101001";  -- 70E0 = A9
      when "1000011100001" =>  data <= "00111100";  -- 70E1 = 3C
      when "1000011100010" =>  data <= "10001101";  -- 70E2 = 8D
      when "1000011100011" =>  data <= "00100001";  -- 70E3 = 21
      when "1000011100100" =>  data <= "11101000";  -- 70E4 = E8
      when "1000011100101" =>  data <= "00100100";  -- 70E5 = 24
      when "1000011100110" =>  data <= "10100000";  -- 70E6 = A0
      when "1000011100111" =>  data <= "11110000";  -- 70E7 = F0
      when "1000011101000" =>  data <= "00010001";  -- 70E8 = 11
      when "1000011101001" =>  data <= "10101001";  -- 70E9 = A9
      when "1000011101010" =>  data <= "00110100";  -- 70EA = 34
      when "1000011101011" =>  data <= "10001101";  -- 70EB = 8D
      when "1000011101100" =>  data <= "00010001";  -- 70EC = 11
      when "1000011101101" =>  data <= "11101000";  -- 70ED = E8
      when "1000011101110" =>  data <= "00100000";  -- 70EE = 20
      when "1000011101111" =>  data <= "00001001";  -- 70EF = 9
      when "1000011110000" =>  data <= "11110001";  -- 70F0 = F1
      when "1000011110001" =>  data <= "10101001";  -- 70F1 = A9
      when "1000011110010" =>  data <= "00000000";  -- 70F2 = 0
      when "1000011110011" =>  data <= "10000101";  -- 70F3 = 85
      when "1000011110100" =>  data <= "10100000";  -- 70F4 = A0
      when "1000011110101" =>  data <= "10101001";  -- 70F5 = A9
      when "1000011110110" =>  data <= "00111100";  -- 70F6 = 3C
      when "1000011110111" =>  data <= "10001101";  -- 70F7 = 8D
      when "1000011111000" =>  data <= "00010001";  -- 70F8 = 11
      when "1000011111001" =>  data <= "11101000";  -- 70F9 = E8
      when "1000011111010" =>  data <= "01101000";  -- 70FA = 68
      when "1000011111011" =>  data <= "00000101";  -- 70FB = 5
      when "1000011111100" =>  data <= "11010100";  -- 70FC = D4
      when "1000011111101" =>  data <= "10000101";  -- 70FD = 85
      when "1000011111110" =>  data <= "10100101";  -- 70FE = A5
      when "1000011111111" =>  data <= "10101101";  -- 70FF = AD
      when "1000100000000" =>  data <= "01000000";  -- 7100 = 40
      when "1000100000001" =>  data <= "11101000";  -- 7101 = E8
      when "1000100000010" =>  data <= "00010000";  -- 7102 = 10
      when "1000100000011" =>  data <= "11111011";  -- 7103 = FB
      when "1000100000100" =>  data <= "00101001";  -- 7104 = 29
      when "1000100000101" =>  data <= "11111011";  -- 7105 = FB
      when "1000100000110" =>  data <= "10001101";  -- 7106 = 8D
      when "1000100000111" =>  data <= "01000000";  -- 7107 = 40
      when "1000100001000" =>  data <= "11101000";  -- 7108 = E8
      when "1000100001001" =>  data <= "10101001";  -- 7109 = A9
      when "1000100001010" =>  data <= "00111100";  -- 710A = 3C
      when "1000100001011" =>  data <= "10001101";  -- 710B = 8D
      when "1000100001100" =>  data <= "00100011";  -- 710C = 23
      when "1000100001101" =>  data <= "11101000";  -- 710D = E8
      when "1000100001110" =>  data <= "10101101";  -- 710E = AD
      when "1000100001111" =>  data <= "01000000";  -- 710F = 40
      when "1000100010000" =>  data <= "11101000";  -- 7110 = E8
      when "1000100010001" =>  data <= "00101001";  -- 7111 = 29
      when "1000100010010" =>  data <= "01000001";  -- 7112 = 41
      when "1000100010011" =>  data <= "11001001";  -- 7113 = C9
      when "1000100010100" =>  data <= "01000001";  -- 7114 = 41
      when "1000100010101" =>  data <= "11110000";  -- 7115 = F0
      when "1000100010110" =>  data <= "01010101";  -- 7116 = 55
      when "1000100010111" =>  data <= "10100101";  -- 7117 = A5
      when "1000100011000" =>  data <= "10100101";  -- 7118 = A5
      when "1000100011001" =>  data <= "01001001";  -- 7119 = 49
      when "1000100011010" =>  data <= "11111111";  -- 711A = FF
      when "1000100011011" =>  data <= "10001101";  -- 711B = 8D
      when "1000100011100" =>  data <= "00100010";  -- 711C = 22
      when "1000100011101" =>  data <= "11101000";  -- 711D = E8
      when "1000100011110" =>  data <= "00101100";  -- 711E = 2C
      when "1000100011111" =>  data <= "01000000";  -- 711F = 40
      when "1000100100000" =>  data <= "11101000";  -- 7120 = E8
      when "1000100100001" =>  data <= "01010000";  -- 7121 = 50
      when "1000100100010" =>  data <= "11111011";  -- 7122 = FB
      when "1000100100011" =>  data <= "10101001";  -- 7123 = A9
      when "1000100100100" =>  data <= "00110100";  -- 7124 = 34
      when "1000100100101" =>  data <= "10001101";  -- 7125 = 8D
      when "1000100100110" =>  data <= "00100011";  -- 7126 = 23
      when "1000100100111" =>  data <= "11101000";  -- 7127 = E8
      when "1000100101000" =>  data <= "10101001";  -- 7128 = A9
      when "1000100101001" =>  data <= "11111111";  -- 7129 = FF
      when "1000100101010" =>  data <= "10001101";  -- 712A = 8D
      when "1000100101011" =>  data <= "01000101";  -- 712B = 45
      when "1000100101100" =>  data <= "11101000";  -- 712C = E8
      when "1000100101101" =>  data <= "10101101";  -- 712D = AD
      when "1000100101110" =>  data <= "01000000";  -- 712E = 40
      when "1000100101111" =>  data <= "11101000";  -- 712F = E8
      when "1000100110000" =>  data <= "00101100";  -- 7130 = 2C
      when "1000100110001" =>  data <= "01001101";  -- 7131 = 4D
      when "1000100110010" =>  data <= "11101000";  -- 7132 = E8
      when "1000100110011" =>  data <= "01110000";  -- 7133 = 70
      when "1000100110100" =>  data <= "00011100";  -- 7134 = 1C
      when "1000100110101" =>  data <= "01001010";  -- 7135 = 4A
      when "1000100110110" =>  data <= "10010000";  -- 7136 = 90
      when "1000100110111" =>  data <= "11110101";  -- 7137 = F5
      when "1000100111000" =>  data <= "10101001";  -- 7138 = A9
      when "1000100111001" =>  data <= "00111100";  -- 7139 = 3C
      when "1000100111010" =>  data <= "10001101";  -- 713A = 8D
      when "1000100111011" =>  data <= "00100011";  -- 713B = 23
      when "1000100111100" =>  data <= "11101000";  -- 713C = E8
      when "1000100111101" =>  data <= "10101001";  -- 713D = A9
      when "1000100111110" =>  data <= "11111111";  -- 713E = FF
      when "1000100111111" =>  data <= "10001101";  -- 713F = 8D
      when "1000101000000" =>  data <= "00100010";  -- 7140 = 22
      when "1000101000001" =>  data <= "11101000";  -- 7141 = E8
      when "1000101000010" =>  data <= "01100000";  -- 7142 = 60
      when "1000101000011" =>  data <= "10000101";  -- 7143 = 85
      when "1000101000100" =>  data <= "10100101";  -- 7144 = A5
      when "1000101000101" =>  data <= "00100000";  -- 7145 = 20
      when "1000101000110" =>  data <= "00001001";  -- 7146 = 9
      when "1000101000111" =>  data <= "11110001";  -- 7147 = F1
      when "1000101001000" =>  data <= "10101101";  -- 7148 = AD
      when "1000101001001" =>  data <= "01000000";  -- 7149 = 40
      when "1000101001010" =>  data <= "11101000";  -- 714A = E8
      when "1000101001011" =>  data <= "00001001";  -- 714B = 9
      when "1000101001100" =>  data <= "00000100";  -- 714C = 4
      when "1000101001101" =>  data <= "10001101";  -- 714D = 8D
      when "1000101001110" =>  data <= "01000000";  -- 714E = 40
      when "1000101001111" =>  data <= "11101000";  -- 714F = E8
      when "1000101010000" =>  data <= "01100000";  -- 7150 = 60
      when "1000101010001" =>  data <= "10101101";  -- 7151 = AD
      when "1000101010010" =>  data <= "11111100";  -- 7152 = FC
      when "1000101010011" =>  data <= "00000011";  -- 7153 = 3
      when "1000101010100" =>  data <= "00010000";  -- 7154 = 10
      when "1000101010101" =>  data <= "00001111";  -- 7155 = F
      when "1000101010110" =>  data <= "00100000";  -- 7156 = 20
      when "1000101010111" =>  data <= "01000011";  -- 7157 = 43
      when "1000101011000" =>  data <= "11110011";  -- 7158 = F3
      when "1000101011001" =>  data <= "11010000";  -- 7159 = D0
      when "1000101011010" =>  data <= "11001101";  -- 715A = CD
      when "1000101011011" =>  data <= "10101101";  -- 715B = AD
      when "1000101011100" =>  data <= "11111100";  -- 715C = FC
      when "1000101011101" =>  data <= "00000011";  -- 715D = 3
      when "1000101011110" =>  data <= "00010000";  -- 715E = 10
      when "1000101011111" =>  data <= "00010000";  -- 715F = 10
      when "1000101100000" =>  data <= "00100000";  -- 7160 = 20
      when "1000101100001" =>  data <= "01000011";  -- 7161 = 43
      when "1000101100010" =>  data <= "11110011";  -- 7162 = F3
      when "1000101100011" =>  data <= "11010000";  -- 7163 = D0
      when "1000101100100" =>  data <= "01101000";  -- 7164 = 68
      when "1000101100101" =>  data <= "10101001";  -- 7165 = A9
      when "1000101100110" =>  data <= "00000001";  -- 7166 = 1
      when "1000101100111" =>  data <= "00100000";  -- 7167 = 20
      when "1000101101000" =>  data <= "11000100";  -- 7168 = C4
      when "1000101101001" =>  data <= "11111011";  -- 7169 = FB
      when "1000101101010" =>  data <= "11010000";  -- 716A = D0
      when "1000101101011" =>  data <= "11001100";  -- 716B = CC
      when "1000101101100" =>  data <= "10101001";  -- 716C = A9
      when "1000101101101" =>  data <= "10000000";  -- 716D = 80
      when "1000101101110" =>  data <= "00110000";  -- 716E = 30
      when "1000101101111" =>  data <= "11110111";  -- 716F = F7
      when "1000101110000" =>  data <= "10101001";  -- 7170 = A9
      when "1000101110001" =>  data <= "00000010";  -- 7171 = 2
      when "1000101110010" =>  data <= "00100000";  -- 7172 = 20
      when "1000101110011" =>  data <= "11000100";  -- 7173 = C4
      when "1000101110100" =>  data <= "11111011";  -- 7174 = FB
      when "1000101110101" =>  data <= "10101101";  -- 7175 = AD
      when "1000101110110" =>  data <= "01000000";  -- 7176 = 40
      when "1000101110111" =>  data <= "11101000";  -- 7177 = E8
      when "1000101111000" =>  data <= "00101001";  -- 7178 = 29
      when "1000101111001" =>  data <= "11111101";  -- 7179 = FD
      when "1000101111010" =>  data <= "10001101";  -- 717A = 8D
      when "1000101111011" =>  data <= "01000000";  -- 717B = 40
      when "1000101111100" =>  data <= "11101000";  -- 717C = E8
      when "1000101111101" =>  data <= "10101001";  -- 717D = A9
      when "1000101111110" =>  data <= "00110100";  -- 717E = 34
      when "1000101111111" =>  data <= "10001101";  -- 717F = 8D
      when "1000110000000" =>  data <= "00100001";  -- 7180 = 21
      when "1000110000001" =>  data <= "11101000";  -- 7181 = E8
      when "1000110000010" =>  data <= "10101001";  -- 7182 = A9
      when "1000110000011" =>  data <= "00001101";  -- 7183 = D
      when "1000110000100" =>  data <= "01100000";  -- 7184 = 60
      when "1000110000101" =>  data <= "10111001";  -- 7185 = B9
      when "1000110000110" =>  data <= "00000000";  -- 7186 = 0
      when "1000110000111" =>  data <= "11110000";  -- 7187 = F0
      when "1000110001000" =>  data <= "00001000";  -- 7188 = 8
      when "1000110001001" =>  data <= "00101001";  -- 7189 = 29
      when "1000110001010" =>  data <= "01111111";  -- 718A = 7F
      when "1000110001011" =>  data <= "00100000";  -- 718B = 20
      when "1000110001100" =>  data <= "00000010";  -- 718C = 2
      when "1000110001101" =>  data <= "11100010";  -- 718D = E2
      when "1000110001110" =>  data <= "11001000";  -- 718E = C8
      when "1000110001111" =>  data <= "00101000";  -- 718F = 28
      when "1000110010000" =>  data <= "00010000";  -- 7190 = 10
      when "1000110010001" =>  data <= "11110011";  -- 7191 = F3
      when "1000110010010" =>  data <= "01100000";  -- 7192 = 60
      when "1000110010011" =>  data <= "10000101";  -- 7193 = 85
      when "1000110010100" =>  data <= "10100101";  -- 7194 = A5
      when "1000110010101" =>  data <= "00100000";  -- 7195 = 20
      when "1000110010110" =>  data <= "00001001";  -- 7196 = 9
      when "1000110010111" =>  data <= "11110001";  -- 7197 = F1
      when "1000110011000" =>  data <= "00100000";  -- 7198 = 20
      when "1000110011001" =>  data <= "01110101";  -- 7199 = 75
      when "1000110011010" =>  data <= "11110001";  -- 719A = F1
      when "1000110011011" =>  data <= "01001100";  -- 719B = 4C
      when "1000110011100" =>  data <= "01001000";  -- 719C = 48
      when "1000110011101" =>  data <= "11110001";  -- 719D = F1
      when "1000110011110" =>  data <= "00100100";  -- 719E = 24
      when "1000110011111" =>  data <= "10100000";  -- 719F = A0
      when "1000110100000" =>  data <= "00110000";  -- 71A0 = 30
      when "1000110100001" =>  data <= "00000100";  -- 71A1 = 4
      when "1000110100010" =>  data <= "11000110";  -- 71A2 = C6
      when "1000110100011" =>  data <= "10100000";  -- 71A3 = A0
      when "1000110100100" =>  data <= "11010000";  -- 71A4 = D0
      when "1000110100101" =>  data <= "00000101";  -- 71A5 = 5
      when "1000110100110" =>  data <= "01001000";  -- 71A6 = 48
      when "1000110100111" =>  data <= "00100000";  -- 71A7 = 20
      when "1000110101000" =>  data <= "00001001";  -- 71A8 = 9
      when "1000110101001" =>  data <= "11110001";  -- 71A9 = F1
      when "1000110101010" =>  data <= "01101000";  -- 71AA = 68
      when "1000110101011" =>  data <= "10000101";  -- 71AB = 85
      when "1000110101100" =>  data <= "10100101";  -- 71AC = A5
      when "1000110101101" =>  data <= "01100000";  -- 71AD = 60
      when "1000110101110" =>  data <= "10101101";  -- 71AE = AD
      when "1000110101111" =>  data <= "01000000";  -- 71AF = 40
      when "1000110110000" =>  data <= "11101000";  -- 71B0 = E8
      when "1000110110001" =>  data <= "00101001";  -- 71B1 = 29
      when "1000110110010" =>  data <= "11111011";  -- 71B2 = FB
      when "1000110110011" =>  data <= "10001101";  -- 71B3 = 8D
      when "1000110110100" =>  data <= "01000000";  -- 71B4 = 40
      when "1000110110101" =>  data <= "11101000";  -- 71B5 = E8
      when "1000110110110" =>  data <= "10101001";  -- 71B6 = A9
      when "1000110110111" =>  data <= "01011111";  -- 71B7 = 5F
      when "1000110111000" =>  data <= "00101100";  -- 71B8 = 2C
      when "1000110111001" =>  data <= "10101001";  -- 71B9 = A9
      when "1000110111010" =>  data <= "00111111";  -- 71BA = 3F
      when "1000110111011" =>  data <= "00100000";  -- 71BB = 20
      when "1000110111100" =>  data <= "11010111";  -- 71BC = D7
      when "1000110111101" =>  data <= "11110000";  -- 71BD = F0
      when "1000110111110" =>  data <= "11010000";  -- 71BE = D0
      when "1000110111111" =>  data <= "10001000";  -- 71BF = 88
      when "1000111000000" =>  data <= "10101001";  -- 71C0 = A9
      when "1000111000001" =>  data <= "00110100";  -- 71C1 = 34
      when "1000111000010" =>  data <= "10001101";  -- 71C2 = 8D
      when "1000111000011" =>  data <= "00100001";  -- 71C3 = 21
      when "1000111000100" =>  data <= "11101000";  -- 71C4 = E8
      when "1000111000101" =>  data <= "10101101";  -- 71C5 = AD
      when "1000111000110" =>  data <= "01000000";  -- 71C6 = 40
      when "1000111000111" =>  data <= "11101000";  -- 71C7 = E8
      when "1000111001000" =>  data <= "00001001";  -- 71C8 = 9
      when "1000111001001" =>  data <= "00000010";  -- 71C9 = 2
      when "1000111001010" =>  data <= "10001101";  -- 71CA = 8D
      when "1000111001011" =>  data <= "01000000";  -- 71CB = 40
      when "1000111001100" =>  data <= "11101000";  -- 71CC = E8
      when "1000111001101" =>  data <= "10101001";  -- 71CD = A9
      when "1000111001110" =>  data <= "11111111";  -- 71CE = FF
      when "1000111001111" =>  data <= "10001101";  -- 71CF = 8D
      when "1000111010000" =>  data <= "01000101";  -- 71D0 = 45
      when "1000111010001" =>  data <= "11101000";  -- 71D1 = E8
      when "1000111010010" =>  data <= "00101100";  -- 71D2 = 2C
      when "1000111010011" =>  data <= "01001101";  -- 71D3 = 4D
      when "1000111010100" =>  data <= "11101000";  -- 71D4 = E8
      when "1000111010101" =>  data <= "01110000";  -- 71D5 = 70
      when "1000111010110" =>  data <= "10000100";  -- 71D6 = 84
      when "1000111010111" =>  data <= "00101100";  -- 71D7 = 2C
      when "1000111011000" =>  data <= "01000000";  -- 71D8 = 40
      when "1000111011001" =>  data <= "11101000";  -- 71D9 = E8
      when "1000111011010" =>  data <= "00110000";  -- 71DA = 30
      when "1000111011011" =>  data <= "11110110";  -- 71DB = F6
      when "1000111011100" =>  data <= "10101101";  -- 71DC = AD
      when "1000111011101" =>  data <= "01000000";  -- 71DD = 40
      when "1000111011110" =>  data <= "11101000";  -- 71DE = E8
      when "1000111011111" =>  data <= "00101001";  -- 71DF = 29
      when "1000111100000" =>  data <= "11111101";  -- 71E0 = FD
      when "1000111100001" =>  data <= "10001101";  -- 71E1 = 8D
      when "1000111100010" =>  data <= "01000000";  -- 71E2 = 40
      when "1000111100011" =>  data <= "11101000";  -- 71E3 = E8
      when "1000111100100" =>  data <= "00101100";  -- 71E4 = 2C
      when "1000111100101" =>  data <= "00010000";  -- 71E5 = 10
      when "1000111100110" =>  data <= "11101000";  -- 71E6 = E8
      when "1000111100111" =>  data <= "01110000";  -- 71E7 = 70
      when "1000111101000" =>  data <= "00000101";  -- 71E8 = 5
      when "1000111101001" =>  data <= "10101001";  -- 71E9 = A9
      when "1000111101010" =>  data <= "01000000";  -- 71EA = 40
      when "1000111101011" =>  data <= "00100000";  -- 71EB = 20
      when "1000111101100" =>  data <= "11000100";  -- 71EC = C4
      when "1000111101101" =>  data <= "11111011";  -- 71ED = FB
      when "1000111101110" =>  data <= "10101101";  -- 71EE = AD
      when "1000111101111" =>  data <= "00100000";  -- 71EF = 20
      when "1000111110000" =>  data <= "11101000";  -- 71F0 = E8
      when "1000111110001" =>  data <= "01001001";  -- 71F1 = 49
      when "1000111110010" =>  data <= "11111111";  -- 71F2 = FF
      when "1000111110011" =>  data <= "01001000";  -- 71F3 = 48
      when "1000111110100" =>  data <= "10101001";  -- 71F4 = A9
      when "1000111110101" =>  data <= "00111100";  -- 71F5 = 3C
      when "1000111110110" =>  data <= "10001101";  -- 71F6 = 8D
      when "1000111110111" =>  data <= "00100001";  -- 71F7 = 21
      when "1000111111000" =>  data <= "11101000";  -- 71F8 = E8
      when "1000111111001" =>  data <= "00101100";  -- 71F9 = 2C
      when "1000111111010" =>  data <= "01000000";  -- 71FA = 40
      when "1000111111011" =>  data <= "11101000";  -- 71FB = E8
      when "1000111111100" =>  data <= "00010000";  -- 71FC = 10
      when "1000111111101" =>  data <= "11111011";  -- 71FD = FB
      when "1000111111110" =>  data <= "10101001";  -- 71FE = A9
      when "1000111111111" =>  data <= "00110100";  -- 71FF = 34
      when "1001000000000" =>  data <= "10001101";  -- 7200 = 8D
      when "1001000000001" =>  data <= "00100001";  -- 7201 = 21
      when "1001000000010" =>  data <= "11101000";  -- 7202 = E8
      when "1001000000011" =>  data <= "01101000";  -- 7203 = 68
      when "1001000000100" =>  data <= "01100000";  -- 7204 = 60
      when "1001000000101" =>  data <= "10101001";  -- 7205 = A9
      when "1001000000110" =>  data <= "00000000";  -- 7206 = 0
      when "1001000000111" =>  data <= "10000101";  -- 7207 = 85
      when "1001000001000" =>  data <= "10010110";  -- 7208 = 96
      when "1001000001001" =>  data <= "10100101";  -- 7209 = A5
      when "1001000001010" =>  data <= "10101111";  -- 720A = AF
      when "1001000001011" =>  data <= "11010000";  -- 720B = D0
      when "1001000001100" =>  data <= "00010111";  -- 720C = 17
      when "1001000001101" =>  data <= "10100101";  -- 720D = A5
      when "1001000001110" =>  data <= "10011110";  -- 720E = 9E
      when "1001000001111" =>  data <= "11110000";  -- 720F = F0
      when "1001000010000" =>  data <= "01010001";  -- 7210 = 51
      when "1001000010001" =>  data <= "01111000";  -- 7211 = 78
      when "1001000010010" =>  data <= "01001100";  -- 7212 = 4C
      when "1001000010011" =>  data <= "10100111";  -- 7213 = A7
      when "1001000010100" =>  data <= "11100000";  -- 7214 = E0
      when "1001000010101" =>  data <= "10100101";  -- 7215 = A5
      when "1001000010110" =>  data <= "10101111";  -- 7216 = AF
      when "1001000010111" =>  data <= "11010000";  -- 7217 = D0
      when "1001000011000" =>  data <= "00001011";  -- 7218 = B
      when "1001000011001" =>  data <= "10100101";  -- 7219 = A5
      when "1001000011010" =>  data <= "11000110";  -- 721A = C6
      when "1001000011011" =>  data <= "10000101";  -- 721B = 85
      when "1001000011100" =>  data <= "10100100";  -- 721C = A4
      when "1001000011101" =>  data <= "10100101";  -- 721D = A5
      when "1001000011110" =>  data <= "11011000";  -- 721E = D8
      when "1001000011111" =>  data <= "10000101";  -- 721F = 85
      when "1001000100000" =>  data <= "10100011";  -- 7220 = A3
      when "1001000100001" =>  data <= "01001100";  -- 7221 = 4C
      when "1001000100010" =>  data <= "00010110";  -- 7222 = 16
      when "1001000100011" =>  data <= "11100001";  -- 7223 = E1
      when "1001000100100" =>  data <= "11001001";  -- 7224 = C9
      when "1001000100101" =>  data <= "00000011";  -- 7225 = 3
      when "1001000100110" =>  data <= "11010000";  -- 7226 = D0
      when "1001000100111" =>  data <= "00001001";  -- 7227 = 9
      when "1001000101000" =>  data <= "10000101";  -- 7228 = 85
      when "1001000101001" =>  data <= "10101100";  -- 7229 = AC
      when "1001000101010" =>  data <= "10100101";  -- 722A = A5
      when "1001000101011" =>  data <= "11010101";  -- 722B = D5
      when "1001000101100" =>  data <= "10000101";  -- 722C = 85
      when "1001000101101" =>  data <= "10100001";  -- 722D = A1
      when "1001000101110" =>  data <= "01001100";  -- 722E = 4C
      when "1001000101111" =>  data <= "00010110";  -- 722F = 16
      when "1001000110000" =>  data <= "11100001";  -- 7230 = E1
      when "1001000110001" =>  data <= "10110000";  -- 7231 = B0
      when "1001000110010" =>  data <= "00101001";  -- 7232 = 29
      when "1001000110011" =>  data <= "10000110";  -- 7233 = 86
      when "1001000110100" =>  data <= "10101101";  -- 7234 = AD
      when "1001000110101" =>  data <= "00100000";  -- 7235 = 20
      when "1001000110110" =>  data <= "01001001";  -- 7236 = 49
      when "1001000110111" =>  data <= "11110010";  -- 7237 = F2
      when "1001000111000" =>  data <= "01001000";  -- 7238 = 48
      when "1001000111001" =>  data <= "00100000";  -- 7239 = 20
      when "1001000111010" =>  data <= "01001001";  -- 723A = 49
      when "1001000111011" =>  data <= "11110010";  -- 723B = F2
      when "1001000111100" =>  data <= "11010000";  -- 723C = D0
      when "1001000111101" =>  data <= "00000101";  -- 723D = 5
      when "1001000111110" =>  data <= "10101001";  -- 723E = A9
      when "1001000111111" =>  data <= "01000000";  -- 723F = 40
      when "1001001000000" =>  data <= "00100000";  -- 7240 = 20
      when "1001001000001" =>  data <= "11000100";  -- 7241 = C4
      when "1001001000010" =>  data <= "11111011";  -- 7242 = FB
      when "1001001000011" =>  data <= "11010110";  -- 7243 = D6
      when "1001001000100" =>  data <= "10111010";  -- 7244 = BA
      when "1001001000101" =>  data <= "10100110";  -- 7245 = A6
      when "1001001000110" =>  data <= "10101101";  -- 7246 = AD
      when "1001001000111" =>  data <= "01101000";  -- 7247 = 68
      when "1001001001000" =>  data <= "01100000";  -- 7248 = 60
      when "1001001001001" =>  data <= "00100000";  -- 7249 = 20
      when "1001001001010" =>  data <= "01001011";  -- 724A = 4B
      when "1001001001011" =>  data <= "11111000";  -- 724B = F8
      when "1001001001100" =>  data <= "11010000";  -- 724C = D0
      when "1001001001101" =>  data <= "00001011";  -- 724D = B
      when "1001001001110" =>  data <= "00100000";  -- 724E = 20
      when "1001001001111" =>  data <= "10011010";  -- 724F = 9A
      when "1001001010000" =>  data <= "11111000";  -- 7250 = F8
      when "1001001010001" =>  data <= "10100110";  -- 7251 = A6
      when "1001001010010" =>  data <= "11010100";  -- 7252 = D4
      when "1001001010011" =>  data <= "10101001";  -- 7253 = A9
      when "1001001010100" =>  data <= "00000000";  -- 7254 = 0
      when "1001001010101" =>  data <= "10010101";  -- 7255 = 95
      when "1001001010110" =>  data <= "10111010";  -- 7256 = BA
      when "1001001010111" =>  data <= "11110000";  -- 7257 = F0
      when "1001001011000" =>  data <= "11110000";  -- 7258 = F0
      when "1001001011001" =>  data <= "10110001";  -- 7259 = B1
      when "1001001011010" =>  data <= "11010110";  -- 725A = D6
      when "1001001011011" =>  data <= "01100000";  -- 725B = 60
      when "1001001011100" =>  data <= "10100101";  -- 725C = A5
      when "1001001011101" =>  data <= "10010110";  -- 725D = 96
      when "1001001011110" =>  data <= "11110000";  -- 725E = F0
      when "1001001011111" =>  data <= "00000011";  -- 725F = 3
      when "1001001100000" =>  data <= "10101001";  -- 7260 = A9
      when "1001001100001" =>  data <= "00001101";  -- 7261 = D
      when "1001001100010" =>  data <= "01100000";  -- 7262 = 60
      when "1001001100011" =>  data <= "01001100";  -- 7263 = 4C
      when "1001001100100" =>  data <= "11000000";  -- 7264 = C0
      when "1001001100101" =>  data <= "11110001";  -- 7265 = F1
      when "1001001100110" =>  data <= "01001000";  -- 7266 = 48
      when "1001001100111" =>  data <= "10100101";  -- 7267 = A5
      when "1001001101000" =>  data <= "10110000";  -- 7268 = B0
      when "1001001101001" =>  data <= "11001001";  -- 7269 = C9
      when "1001001101010" =>  data <= "00000011";  -- 726A = 3
      when "1001001101011" =>  data <= "11010000";  -- 726B = D0
      when "1001001101100" =>  data <= "00000100";  -- 726C = 4
      when "1001001101101" =>  data <= "01101000";  -- 726D = 68
      when "1001001101110" =>  data <= "01001100";  -- 726E = 4C
      when "1001001101111" =>  data <= "00000010";  -- 726F = 2
      when "1001001110000" =>  data <= "11100010";  -- 7270 = E2
      when "1001001110001" =>  data <= "00110000";  -- 7271 = 30
      when "1001001110010" =>  data <= "00000100";  -- 7272 = 4
      when "1001001110011" =>  data <= "01101000";  -- 7273 = 68
      when "1001001110100" =>  data <= "01001100";  -- 7274 = 4C
      when "1001001110101" =>  data <= "10011110";  -- 7275 = 9E
      when "1001001110110" =>  data <= "11110001";  -- 7276 = F1
      when "1001001110111" =>  data <= "01101000";  -- 7277 = 68
      when "1001001111000" =>  data <= "10000101";  -- 7278 = 85
      when "1001001111001" =>  data <= "10110100";  -- 7279 = B4
      when "1001001111010" =>  data <= "11001001";  -- 727A = C9
      when "1001001111011" =>  data <= "00001010";  -- 727B = A
      when "1001001111100" =>  data <= "11110000";  -- 727C = F0
      when "1001001111101" =>  data <= "11100100";  -- 727D = E4
      when "1001001111110" =>  data <= "01001000";  -- 727E = 48
      when "1001001111111" =>  data <= "10001010";  -- 727F = 8A
      when "1001010000000" =>  data <= "01001000";  -- 7280 = 48
      when "1001010000001" =>  data <= "10011000";  -- 7281 = 98
      when "1001010000010" =>  data <= "01001000";  -- 7282 = 48
      when "1001010000011" =>  data <= "00100000";  -- 7283 = 20
      when "1001010000100" =>  data <= "01001011";  -- 7284 = 4B
      when "1001010000101" =>  data <= "11111000";  -- 7285 = F8
      when "1001010000110" =>  data <= "11010000";  -- 7286 = D0
      when "1001010000111" =>  data <= "00010000";  -- 7287 = 10
      when "1001010001000" =>  data <= "00100000";  -- 7288 = 20
      when "1001010001001" =>  data <= "11001011";  -- 7289 = CB
      when "1001010001010" =>  data <= "11111000";  -- 728A = F8
      when "1001010001011" =>  data <= "10100110";  -- 728B = A6
      when "1001010001100" =>  data <= "11010100";  -- 728C = D4
      when "1001010001101" =>  data <= "10101001";  -- 728D = A9
      when "1001010001110" =>  data <= "00000001";  -- 728E = 1
      when "1001010001111" =>  data <= "10010101";  -- 728F = 95
      when "1001010010000" =>  data <= "10111010";  -- 7290 = BA
      when "1001010010001" =>  data <= "10100000";  -- 7291 = A0
      when "1001010010010" =>  data <= "00000000";  -- 7292 = 0
      when "1001010010011" =>  data <= "10101001";  -- 7293 = A9
      when "1001010010100" =>  data <= "00000010";  -- 7294 = 2
      when "1001010010101" =>  data <= "10010001";  -- 7295 = 91
      when "1001010010110" =>  data <= "11010110";  -- 7296 = D6
      when "1001010010111" =>  data <= "11001000";  -- 7297 = C8
      when "1001010011000" =>  data <= "10100101";  -- 7298 = A5
      when "1001010011001" =>  data <= "10110100";  -- 7299 = B4
      when "1001010011010" =>  data <= "10010001";  -- 729A = 91
      when "1001010011011" =>  data <= "11010110";  -- 729B = D6
      when "1001010011100" =>  data <= "01101000";  -- 729C = 68
      when "1001010011101" =>  data <= "10101000";  -- 729D = A8
      when "1001010011110" =>  data <= "01101000";  -- 729E = 68
      when "1001010011111" =>  data <= "10101010";  -- 729F = AA
      when "1001010100000" =>  data <= "01101000";  -- 72A0 = 68
      when "1001010100001" =>  data <= "01100000";  -- 72A1 = 60
      when "1001010100010" =>  data <= "10101001";  -- 72A2 = A9
      when "1001010100011" =>  data <= "00000000";  -- 72A3 = 0
      when "1001010100100" =>  data <= "10000101";  -- 72A4 = 85
      when "1001010100101" =>  data <= "10101110";  -- 72A5 = AE
      when "1001010100110" =>  data <= "10100101";  -- 72A6 = A5
      when "1001010100111" =>  data <= "10110000";  -- 72A7 = B0
      when "1001010101000" =>  data <= "11001001";  -- 72A8 = C9
      when "1001010101001" =>  data <= "00000100";  -- 72A9 = 4
      when "1001010101010" =>  data <= "10010000";  -- 72AA = 90
      when "1001010101011" =>  data <= "00000011";  -- 72AB = 3
      when "1001010101100" =>  data <= "00100000";  -- 72AC = 20
      when "1001010101101" =>  data <= "10111001";  -- 72AD = B9
      when "1001010101110" =>  data <= "11110001";  -- 72AE = F1
      when "1001010101111" =>  data <= "10100101";  -- 72AF = A5
      when "1001010110000" =>  data <= "10101111";  -- 72B0 = AF
      when "1001010110001" =>  data <= "11001001";  -- 72B1 = C9
      when "1001010110010" =>  data <= "00000100";  -- 72B2 = 4
      when "1001010110011" =>  data <= "10010000";  -- 72B3 = 90
      when "1001010110100" =>  data <= "00000011";  -- 72B4 = 3
      when "1001010110101" =>  data <= "00100000";  -- 72B5 = 20
      when "1001010110110" =>  data <= "10101110";  -- 72B6 = AE
      when "1001010110111" =>  data <= "11110001";  -- 72B7 = F1
      when "1001010111000" =>  data <= "10101001";  -- 72B8 = A9
      when "1001010111001" =>  data <= "00000011";  -- 72B9 = 3
      when "1001010111010" =>  data <= "10000101";  -- 72BA = 85
      when "1001010111011" =>  data <= "10110000";  -- 72BB = B0
      when "1001010111100" =>  data <= "10101001";  -- 72BC = A9
      when "1001010111101" =>  data <= "00000000";  -- 72BD = 0
      when "1001010111110" =>  data <= "10000101";  -- 72BE = 85
      when "1001010111111" =>  data <= "10101111";  -- 72BF = AF
      when "1001011000000" =>  data <= "01100000";  -- 72C0 = 60
      when "1001011000001" =>  data <= "10100110";  -- 72C1 = A6
      when "1001011000010" =>  data <= "10101110";  -- 72C2 = AE
      when "1001011000011" =>  data <= "11001010";  -- 72C3 = CA
      when "1001011000100" =>  data <= "00110000";  -- 72C4 = 30
      when "1001011000101" =>  data <= "00010110";  -- 72C5 = 16
      when "1001011000110" =>  data <= "11011101";  -- 72C6 = DD
      when "1001011000111" =>  data <= "01010001";  -- 72C7 = 51
      when "1001011001000" =>  data <= "00000010";  -- 72C8 = 2
      when "1001011001001" =>  data <= "11110000";  -- 72C9 = F0
      when "1001011001010" =>  data <= "00010001";  -- 72CA = 11
      when "1001011001011" =>  data <= "11010000";  -- 72CB = D0
      when "1001011001100" =>  data <= "11110110";  -- 72CC = F6
      when "1001011001101" =>  data <= "10111101";  -- 72CD = BD
      when "1001011001110" =>  data <= "01010001";  -- 72CE = 51
      when "1001011001111" =>  data <= "00000010";  -- 72CF = 2
      when "1001011010000" =>  data <= "10000101";  -- 72D0 = 85
      when "1001011010001" =>  data <= "11010010";  -- 72D1 = D2
      when "1001011010010" =>  data <= "10111101";  -- 72D2 = BD
      when "1001011010011" =>  data <= "01011011";  -- 72D3 = 5B
      when "1001011010100" =>  data <= "00000010";  -- 72D4 = 2
      when "1001011010101" =>  data <= "10000101";  -- 72D5 = 85
      when "1001011010110" =>  data <= "11010100";  -- 72D6 = D4
      when "1001011010111" =>  data <= "10111101";  -- 72D7 = BD
      when "1001011011000" =>  data <= "01100101";  -- 72D8 = 65
      when "1001011011001" =>  data <= "00000010";  -- 72D9 = 2
      when "1001011011010" =>  data <= "10000101";  -- 72DA = 85
      when "1001011011011" =>  data <= "11010011";  -- 72DB = D3
      when "1001011011100" =>  data <= "01100000";  -- 72DC = 60
      when "1001011011101" =>  data <= "00100000";  -- 72DD = 20
      when "1001011011110" =>  data <= "00001101";  -- 72DE = D
      when "1001011011111" =>  data <= "11110101";  -- 72DF = F5
      when "1001011100000" =>  data <= "10100101";  -- 72E0 = A5
      when "1001011100001" =>  data <= "11010010";  -- 72E1 = D2
      when "1001011100010" =>  data <= "00100000";  -- 72E2 = 20
      when "1001011100011" =>  data <= "11000001";  -- 72E3 = C1
      when "1001011100100" =>  data <= "11110010";  -- 72E4 = F2
      when "1001011100101" =>  data <= "11010000";  -- 72E5 = D0
      when "1001011100110" =>  data <= "01001101";  -- 72E6 = 4D
      when "1001011100111" =>  data <= "00100000";  -- 72E7 = 20
      when "1001011101000" =>  data <= "11001101";  -- 72E8 = CD
      when "1001011101001" =>  data <= "11110010";  -- 72E9 = F2
      when "1001011101010" =>  data <= "10001010";  -- 72EA = 8A
      when "1001011101011" =>  data <= "01001000";  -- 72EB = 48
      when "1001011101100" =>  data <= "10100101";  -- 72EC = A5
      when "1001011101101" =>  data <= "11010100";  -- 72ED = D4
      when "1001011101110" =>  data <= "11110000";  -- 72EE = F0
      when "1001011101111" =>  data <= "00101000";  -- 72EF = 28
      when "1001011110000" =>  data <= "11001001";  -- 72F0 = C9
      when "1001011110001" =>  data <= "00000011";  -- 72F1 = 3
      when "1001011110010" =>  data <= "11110000";  -- 72F2 = F0
      when "1001011110011" =>  data <= "00100100";  -- 72F3 = 24
      when "1001011110100" =>  data <= "10110000";  -- 72F4 = B0
      when "1001011110101" =>  data <= "00011111";  -- 72F5 = 1F
      when "1001011110110" =>  data <= "10100101";  -- 72F6 = A5
      when "1001011110111" =>  data <= "11010011";  -- 72F7 = D3
      when "1001011111000" =>  data <= "00101001";  -- 72F8 = 29
      when "1001011111001" =>  data <= "00001111";  -- 72F9 = F
      when "1001011111010" =>  data <= "11110000";  -- 72FA = F0
      when "1001011111011" =>  data <= "00011100";  -- 72FB = 1C
      when "1001011111100" =>  data <= "00100000";  -- 72FC = 20
      when "1001011111101" =>  data <= "10010101";  -- 72FD = 95
      when "1001011111110" =>  data <= "11110110";  -- 72FE = F6
      when "1001011111111" =>  data <= "10101001";  -- 72FF = A9
      when "1001100000000" =>  data <= "00000000";  -- 7300 = 0
      when "1001100000001" =>  data <= "00100000";  -- 7301 = 20
      when "1001100000010" =>  data <= "01111000";  -- 7302 = 78
      when "1001100000011" =>  data <= "11110010";  -- 7303 = F2
      when "1001100000100" =>  data <= "00100000";  -- 7304 = 20
      when "1001100000101" =>  data <= "11001011";  -- 7305 = CB
      when "1001100000110" =>  data <= "11111000";  -- 7306 = F8
      when "1001100000111" =>  data <= "10100101";  -- 7307 = A5
      when "1001100001000" =>  data <= "11010011";  -- 7308 = D3
      when "1001100001001" =>  data <= "11001001";  -- 7309 = C9
      when "1001100001010" =>  data <= "01100010";  -- 730A = 62
      when "1001100001011" =>  data <= "11010000";  -- 730B = D0
      when "1001100001100" =>  data <= "00001011";  -- 730C = B
      when "1001100001101" =>  data <= "10101001";  -- 730D = A9
      when "1001100001110" =>  data <= "00000101";  -- 730E = 5
      when "1001100001111" =>  data <= "00100000";  -- 730F = 20
      when "1001100010000" =>  data <= "00011001";  -- 7310 = 19
      when "1001100010001" =>  data <= "11110110";  -- 7311 = F6
      when "1001100010010" =>  data <= "01001100";  -- 7312 = 4C
      when "1001100010011" =>  data <= "00011000";  -- 7313 = 18
      when "1001100010100" =>  data <= "11110011";  -- 7314 = F3
      when "1001100010101" =>  data <= "00100000";  -- 7315 = 20
      when "1001100010110" =>  data <= "00101111";  -- 7316 = 2F
      when "1001100010111" =>  data <= "11110111";  -- 7317 = F7
      when "1001100011000" =>  data <= "01101000";  -- 7318 = 68
      when "1001100011001" =>  data <= "10101010";  -- 7319 = AA
      when "1001100011010" =>  data <= "11000110";  -- 731A = C6
      when "1001100011011" =>  data <= "10101110";  -- 731B = AE
      when "1001100011100" =>  data <= "11100100";  -- 731C = E4
      when "1001100011101" =>  data <= "10101110";  -- 731D = AE
      when "1001100011110" =>  data <= "11110000";  -- 731E = F0
      when "1001100011111" =>  data <= "00010100";  -- 731F = 14
      when "1001100100000" =>  data <= "10100100";  -- 7320 = A4
      when "1001100100001" =>  data <= "10101110";  -- 7321 = AE
      when "1001100100010" =>  data <= "10111001";  -- 7322 = B9
      when "1001100100011" =>  data <= "01010001";  -- 7323 = 51
      when "1001100100100" =>  data <= "00000010";  -- 7324 = 2
      when "1001100100101" =>  data <= "10011101";  -- 7325 = 9D
      when "1001100100110" =>  data <= "01010001";  -- 7326 = 51
      when "1001100100111" =>  data <= "00000010";  -- 7327 = 2
      when "1001100101000" =>  data <= "10111001";  -- 7328 = B9
      when "1001100101001" =>  data <= "01011011";  -- 7329 = 5B
      when "1001100101010" =>  data <= "00000010";  -- 732A = 2
      when "1001100101011" =>  data <= "10011101";  -- 732B = 9D
      when "1001100101100" =>  data <= "01011011";  -- 732C = 5B
      when "1001100101101" =>  data <= "00000010";  -- 732D = 2
      when "1001100101110" =>  data <= "10111001";  -- 732E = B9
      when "1001100101111" =>  data <= "01100101";  -- 732F = 65
      when "1001100110000" =>  data <= "00000010";  -- 7330 = 2
      when "1001100110001" =>  data <= "10011101";  -- 7331 = 9D
      when "1001100110010" =>  data <= "01100101";  -- 7332 = 65
      when "1001100110011" =>  data <= "00000010";  -- 7333 = 2
      when "1001100110100" =>  data <= "01100000";  -- 7334 = 60
      when "1001100110101" =>  data <= "10100101";  -- 7335 = A5
      when "1001100110110" =>  data <= "10011011";  -- 7336 = 9B
      when "1001100110111" =>  data <= "11001001";  -- 7337 = C9
      when "1001100111000" =>  data <= "11101111";  -- 7338 = EF
      when "1001100111001" =>  data <= "11010000";  -- 7339 = D0
      when "1001100111010" =>  data <= "00000111";  -- 733A = 7
      when "1001100111011" =>  data <= "00001000";  -- 733B = 8
      when "1001100111100" =>  data <= "00100000";  -- 733C = 20
      when "1001100111101" =>  data <= "10100110";  -- 733D = A6
      when "1001100111110" =>  data <= "11110010";  -- 733E = F2
      when "1001100111111" =>  data <= "10000101";  -- 733F = 85
      when "1001101000000" =>  data <= "10011110";  -- 7340 = 9E
      when "1001101000001" =>  data <= "00101000";  -- 7341 = 28
      when "1001101000010" =>  data <= "01100000";  -- 7342 = 60
      when "1001101000011" =>  data <= "00100000";  -- 7343 = 20
      when "1001101000100" =>  data <= "00110101";  -- 7344 = 35
      when "1001101000101" =>  data <= "11110011";  -- 7345 = F3
      when "1001101000110" =>  data <= "01001100";  -- 7346 = 4C
      when "1001101000111" =>  data <= "11000110";  -- 7347 = C6
      when "1001101001000" =>  data <= "10110111";  -- 7348 = B7
      when "1001101001001" =>  data <= "00100000";  -- 7349 = 20
      when "1001101001010" =>  data <= "01010001";  -- 734A = 51
      when "1001101001011" =>  data <= "11110011";  -- 734B = F3
      when "1001101001100" =>  data <= "11010000";  -- 734C = D0
      when "1001101001101" =>  data <= "11110100";  -- 734D = F4
      when "1001101001110" =>  data <= "01001100";  -- 734E = 4C
      when "1001101001111" =>  data <= "10000101";  -- 734F = 85
      when "1001101010000" =>  data <= "11110001";  -- 7350 = F1
      when "1001101010001" =>  data <= "10100101";  -- 7351 = A5
      when "1001101010010" =>  data <= "01111000";  -- 7352 = 78
      when "1001101010011" =>  data <= "11001001";  -- 7353 = C9
      when "1001101010100" =>  data <= "00000010";  -- 7354 = 2
      when "1001101010101" =>  data <= "01100000";  -- 7355 = 60
      when "1001101010110" =>  data <= "10100101";  -- 7356 = A5
      when "1001101010111" =>  data <= "11010100";  -- 7357 = D4
      when "1001101011000" =>  data <= "11010000";  -- 7358 = D0
      when "1001101011001" =>  data <= "00000011";  -- 7359 = 3
      when "1001101011010" =>  data <= "01001100";  -- 735A = 4C
      when "1001101011011" =>  data <= "00000000";  -- 735B = 0
      when "1001101011100" =>  data <= "10111111";  -- 735C = BF
      when "1001101011101" =>  data <= "11001001";  -- 735D = C9
      when "1001101011110" =>  data <= "00000011";  -- 735E = 3
      when "1001101011111" =>  data <= "11110000";  -- 735F = F0
      when "1001101100000" =>  data <= "11111001";  -- 7360 = F9
      when "1001101100001" =>  data <= "10010000";  -- 7361 = 90
      when "1001101100010" =>  data <= "01110001";  -- 7362 = 71
      when "1001101100011" =>  data <= "10101001";  -- 7363 = A9
      when "1001101100100" =>  data <= "01100000";  -- 7364 = 60
      when "1001101100101" =>  data <= "10000101";  -- 7365 = 85
      when "1001101100110" =>  data <= "11010011";  -- 7366 = D3
      when "1001101100111" =>  data <= "10100100";  -- 7367 = A4
      when "1001101101000" =>  data <= "11010001";  -- 7368 = D1
      when "1001101101001" =>  data <= "11010000";  -- 7369 = D0
      when "1001101101010" =>  data <= "00000011";  -- 736A = 3
      when "1001101101011" =>  data <= "01001100";  -- 736B = 4C
      when "1001101101100" =>  data <= "00000000";  -- 736C = 0
      when "1001101101101" =>  data <= "10111111";  -- 736D = BF
      when "1001101101110" =>  data <= "00100000";  -- 736E = 20
      when "1001101101111" =>  data <= "01001001";  -- 736F = 49
      when "1001101110000" =>  data <= "11110100";  -- 7370 = F4
      when "1001101110001" =>  data <= "00100000";  -- 7371 = 20
      when "1001101110010" =>  data <= "10100101";  -- 7372 = A5
      when "1001101110011" =>  data <= "11110100";  -- 7373 = F4
      when "1001101110100" =>  data <= "00100000";  -- 7374 = 20
      when "1001101110101" =>  data <= "11010010";  -- 7375 = D2
      when "1001101110110" =>  data <= "11110000";  -- 7376 = F0
      when "1001101110111" =>  data <= "10100101";  -- 7377 = A5
      when "1001101111000" =>  data <= "11010011";  -- 7378 = D3
      when "1001101111001" =>  data <= "00100000";  -- 7379 = 20
      when "1001101111010" =>  data <= "10010011";  -- 737A = 93
      when "1001101111011" =>  data <= "11110001";  -- 737B = F1
      when "1001101111100" =>  data <= "00100000";  -- 737C = 20
      when "1001101111101" =>  data <= "11000000";  -- 737D = C0
      when "1001101111110" =>  data <= "11110001";  -- 737E = F1
      when "1001101111111" =>  data <= "10000101";  -- 737F = 85
      when "1001110000000" =>  data <= "11111011";  -- 7380 = FB
      when "1001110000001" =>  data <= "10100101";  -- 7381 = A5
      when "1001110000010" =>  data <= "10010110";  -- 7382 = 96
      when "1001110000011" =>  data <= "01001010";  -- 7383 = 4A
      when "1001110000100" =>  data <= "01001010";  -- 7384 = 4A
      when "1001110000101" =>  data <= "10110000";  -- 7385 = B0
      when "1001110000110" =>  data <= "00111010";  -- 7386 = 3A
      when "1001110000111" =>  data <= "00100000";  -- 7387 = 20
      when "1001110001000" =>  data <= "11000000";  -- 7388 = C0
      when "1001110001001" =>  data <= "11110001";  -- 7389 = F1
      when "1001110001010" =>  data <= "10000101";  -- 738A = 85
      when "1001110001011" =>  data <= "11111100";  -- 738B = FC
      when "1001110001100" =>  data <= "00100000";  -- 738C = 20
      when "1001110001101" =>  data <= "01101101";  -- 738D = 6D
      when "1001110001110" =>  data <= "11110100";  -- 738E = F4
      when "1001110001111" =>  data <= "10101001";  -- 738F = A9
      when "1001110010000" =>  data <= "11111101";  -- 7390 = FD
      when "1001110010001" =>  data <= "00100101";  -- 7391 = 25
      when "1001110010010" =>  data <= "10010110";  -- 7392 = 96
      when "1001110010011" =>  data <= "10000101";  -- 7393 = 85
      when "1001110010100" =>  data <= "10010110";  -- 7394 = 96
      when "1001110010101" =>  data <= "00100000";  -- 7395 = 20
      when "1001110010110" =>  data <= "01000011";  -- 7396 = 43
      when "1001110010111" =>  data <= "11110011";  -- 7397 = F3
      when "1001110011000" =>  data <= "00100000";  -- 7398 = 20
      when "1001110011001" =>  data <= "11000000";  -- 7399 = C0
      when "1001110011010" =>  data <= "11110001";  -- 739A = F1
      when "1001110011011" =>  data <= "10101010";  -- 739B = AA
      when "1001110011100" =>  data <= "10100101";  -- 739C = A5
      when "1001110011101" =>  data <= "10010110";  -- 739D = 96
      when "1001110011110" =>  data <= "01001010";  -- 739E = 4A
      when "1001110011111" =>  data <= "01001010";  -- 739F = 4A
      when "1001110100000" =>  data <= "10110000";  -- 73A0 = B0
      when "1001110100001" =>  data <= "11101101";  -- 73A1 = ED
      when "1001110100010" =>  data <= "10001010";  -- 73A2 = 8A
      when "1001110100011" =>  data <= "10100100";  -- 73A3 = A4
      when "1001110100100" =>  data <= "10011101";  -- 73A4 = 9D
      when "1001110100101" =>  data <= "11110000";  -- 73A5 = F0
      when "1001110100110" =>  data <= "00001100";  -- 73A6 = C
      when "1001110100111" =>  data <= "10001000";  -- 73A7 = 88
      when "1001110101000" =>  data <= "11010001";  -- 73A8 = D1
      when "1001110101001" =>  data <= "11111011";  -- 73A9 = FB
      when "1001110101010" =>  data <= "11110000";  -- 73AA = F0
      when "1001110101011" =>  data <= "00001001";  -- 73AB = 9
      when "1001110101100" =>  data <= "10101001";  -- 73AC = A9
      when "1001110101101" =>  data <= "00010000";  -- 73AD = 10
      when "1001110101110" =>  data <= "00000101";  -- 73AE = 5
      when "1001110101111" =>  data <= "10010110";  -- 73AF = 96
      when "1001110110000" =>  data <= "10000101";  -- 73B0 = 85
      when "1001110110001" =>  data <= "10010110";  -- 73B1 = 96
      when "1001110110010" =>  data <= "00101100";  -- 73B2 = 2C
      when "1001110110011" =>  data <= "10010001";  -- 73B3 = 91
      when "1001110110100" =>  data <= "11111011";  -- 73B4 = FB
      when "1001110110101" =>  data <= "11100110";  -- 73B5 = E6
      when "1001110110110" =>  data <= "11111011";  -- 73B6 = FB
      when "1001110110111" =>  data <= "11010000";  -- 73B7 = D0
      when "1001110111000" =>  data <= "00000010";  -- 73B8 = 2
      when "1001110111001" =>  data <= "11100110";  -- 73B9 = E6
      when "1001110111010" =>  data <= "11111100";  -- 73BA = FC
      when "1001110111011" =>  data <= "00100100";  -- 73BB = 24
      when "1001110111100" =>  data <= "10010110";  -- 73BC = 96
      when "1001110111101" =>  data <= "01110000";  -- 73BD = 70
      when "1001110111110" =>  data <= "00000111";  -- 73BE = 7
      when "1001110111111" =>  data <= "01010000";  -- 73BF = 50
      when "1001111000000" =>  data <= "11001110";  -- 73C0 = CE
      when "1001111000001" =>  data <= "10100000";  -- 73C1 = A0
      when "1001111000010" =>  data <= "00100100";  -- 73C2 = 24
      when "1001111000011" =>  data <= "01001100";  -- 73C3 = 4C
      when "1001111000100" =>  data <= "10101111";  -- 73C4 = AF
      when "1001111000101" =>  data <= "11110101";  -- 73C5 = F5
      when "1001111000110" =>  data <= "10100101";  -- 73C6 = A5
      when "1001111000111" =>  data <= "11111011";  -- 73C7 = FB
      when "1001111001000" =>  data <= "10000101";  -- 73C8 = 85
      when "1001111001001" =>  data <= "11001001";  -- 73C9 = C9
      when "1001111001010" =>  data <= "10100101";  -- 73CA = A5
      when "1001111001011" =>  data <= "11111100";  -- 73CB = FC
      when "1001111001100" =>  data <= "10000101";  -- 73CC = 85
      when "1001111001101" =>  data <= "11001010";  -- 73CD = CA
      when "1001111001110" =>  data <= "00100000";  -- 73CE = 20
      when "1001111001111" =>  data <= "10101110";  -- 73CF = AE
      when "1001111010000" =>  data <= "11110001";  -- 73D0 = F1
      when "1001111010001" =>  data <= "01001100";  -- 73D1 = 4C
      when "1001111010010" =>  data <= "00101111";  -- 73D2 = 2F
      when "1001111010011" =>  data <= "11110111";  -- 73D3 = F7
      when "1001111010100" =>  data <= "00100000";  -- 73D4 = 20
      when "1001111010101" =>  data <= "10010101";  -- 73D5 = 95
      when "1001111010110" =>  data <= "11110110";  -- 73D6 = F6
      when "1001111010111" =>  data <= "00100000";  -- 73D7 = 20
      when "1001111011000" =>  data <= "01010111";  -- 73D8 = 57
      when "1001111011001" =>  data <= "11111000";  -- 73D9 = F8
      when "1001111011010" =>  data <= "00100000";  -- 73DA = 20
      when "1001111011011" =>  data <= "01001001";  -- 73DB = 49
      when "1001111011100" =>  data <= "11110100";  -- 73DC = F4
      when "1001111011101" =>  data <= "10100101";  -- 73DD = A5
      when "1001111011110" =>  data <= "11010001";  -- 73DE = D1
      when "1001111011111" =>  data <= "11110000";  -- 73DF = F0
      when "1001111100000" =>  data <= "00001000";  -- 73E0 = 8
      when "1001111100001" =>  data <= "00100000";  -- 73E1 = 20
      when "1001111100010" =>  data <= "11010011";  -- 73E2 = D3
      when "1001111100011" =>  data <= "11110100";  -- 73E3 = F4
      when "1001111100100" =>  data <= "11010000";  -- 73E4 = D0
      when "1001111100101" =>  data <= "00001000";  -- 73E5 = 8
      when "1001111100110" =>  data <= "01001100";  -- 73E6 = 4C
      when "1001111100111" =>  data <= "10101101";  -- 73E7 = AD
      when "1001111101000" =>  data <= "11110101";  -- 73E8 = F5
      when "1001111101001" =>  data <= "00100000";  -- 73E9 = 20
      when "1001111101010" =>  data <= "11100101";  -- 73EA = E5
      when "1001111101011" =>  data <= "11110101";  -- 73EB = F5
      when "1001111101100" =>  data <= "11110000";  -- 73EC = F0
      when "1001111101101" =>  data <= "11111000";  -- 73ED = F8
      when "1001111101110" =>  data <= "11100000";  -- 73EE = E0
      when "1001111101111" =>  data <= "00000001";  -- 73EF = 1
      when "1001111110000" =>  data <= "11010000";  -- 73F0 = D0
      when "1001111110001" =>  data <= "11101011";  -- 73F1 = EB
      when "1001111110010" =>  data <= "10100101";  -- 73F2 = A5
      when "1001111110011" =>  data <= "10010110";  -- 73F3 = 96
      when "1001111110100" =>  data <= "00101001";  -- 73F4 = 29
      when "1001111110101" =>  data <= "00010000";  -- 73F5 = 10
      when "1001111110110" =>  data <= "11010000";  -- 73F6 = D0
      when "1001111110111" =>  data <= "01110100";  -- 73F7 = 74
      when "1001111111000" =>  data <= "00100000";  -- 73F8 = 20
      when "1001111111001" =>  data <= "01111011";  -- 73F9 = 7B
      when "1001111111010" =>  data <= "11110110";  -- 73FA = F6
      when "1001111111011" =>  data <= "00100000";  -- 73FB = 20
      when "1001111111100" =>  data <= "01101101";  -- 73FC = 6D
      when "1001111111101" =>  data <= "11110100";  -- 73FD = F4
      when "1001111111110" =>  data <= "01001100";  -- 73FE = 4C
      when "1001111111111" =>  data <= "10100011";  -- 73FF = A3
      when "1010000000000" =>  data <= "11111000";  -- 7400 = F8
      when "1010000000001" =>  data <= "10101001";  -- 7401 = A9
      when "1010000000010" =>  data <= "00000000";  -- 7402 = 0
      when "1010000000011" =>  data <= "10000101";  -- 7403 = 85
      when "1010000000100" =>  data <= "10011101";  -- 7404 = 9D
      when "1010000000101" =>  data <= "00100000";  -- 7405 = 20
      when "1010000000110" =>  data <= "01111101";  -- 7406 = 7D
      when "1010000000111" =>  data <= "11110100";  -- 7407 = F4
      when "1010000001000" =>  data <= "00100000";  -- 7408 = 20
      when "1010000001001" =>  data <= "11001100";  -- 7409 = CC
      when "1010000001010" =>  data <= "11110110";  -- 740A = F6
      when "1010000001011" =>  data <= "10101001";  -- 740B = A9
      when "1010000001100" =>  data <= "11111111";  -- 740C = FF
      when "1010000001101" =>  data <= "11000101";  -- 740D = C5
      when "1010000001110" =>  data <= "10011011";  -- 740E = 9B
      when "1010000001111" =>  data <= "11010000";  -- 740F = D0
      when "1010000010000" =>  data <= "11111100";  -- 7410 = FC
      when "1010000010001" =>  data <= "11000101";  -- 7411 = C5
      when "1010000010010" =>  data <= "10011011";  -- 7412 = 9B
      when "1010000010011" =>  data <= "11010000";  -- 7413 = D0
      when "1010000010100" =>  data <= "11111000";  -- 7414 = F8
      when "1010000010101" =>  data <= "00100000";  -- 7415 = 20
      when "1010000010110" =>  data <= "01010110";  -- 7416 = 56
      when "1010000010111" =>  data <= "11110011";  -- 7417 = F3
      when "1010000011000" =>  data <= "10100101";  -- 7418 = A5
      when "1010000011001" =>  data <= "10011101";  -- 7419 = 9D
      when "1010000011010" =>  data <= "11010000";  -- 741A = D0
      when "1010000011011" =>  data <= "01010000";  -- 741B = 50
      when "1010000011100" =>  data <= "00100000";  -- 741C = 20
      when "1010000011101" =>  data <= "00101011";  -- 741D = 2B
      when "1010000011110" =>  data <= "11111001";  -- 741E = F9
      when "1010000011111" =>  data <= "10100101";  -- 741F = A5
      when "1010000100000" =>  data <= "10010110";  -- 7420 = 96
      when "1010000100001" =>  data <= "00101001";  -- 7421 = 29
      when "1010000100010" =>  data <= "00010000";  -- 7422 = 10
      when "1010000100011" =>  data <= "11110000";  -- 7423 = F0
      when "1010000100100" =>  data <= "00001001";  -- 7424 = 9
      when "1010000100101" =>  data <= "10100000";  -- 7425 = A0
      when "1010000100110" =>  data <= "00000000";  -- 7426 = 0
      when "1010000100111" =>  data <= "10000100";  -- 7427 = 84
      when "1010000101000" =>  data <= "10011110";  -- 7428 = 9E
      when "1010000101001" =>  data <= "10100000";  -- 7429 = A0
      when "1010000101010" =>  data <= "01100000";  -- 742A = 60
      when "1010000101011" =>  data <= "01001100";  -- 742B = 4C
      when "1010000101100" =>  data <= "10101111";  -- 742C = AF
      when "1010000101101" =>  data <= "11110101";  -- 742D = F5
      when "1010000101110" =>  data <= "10100000";  -- 742E = A0
      when "1010000101111" =>  data <= "10101110";  -- 742F = AE
      when "1010000110000" =>  data <= "00100000";  -- 7430 = 20
      when "1010000110001" =>  data <= "01001001";  -- 7431 = 49
      when "1010000110010" =>  data <= "11110011";  -- 7432 = F3
      when "1010000110011" =>  data <= "00100000";  -- 7433 = 20
      when "1010000110100" =>  data <= "01010001";  -- 7434 = 51
      when "1010000110101" =>  data <= "11110011";  -- 7435 = F3
      when "1010000110110" =>  data <= "11010000";  -- 7436 = D0
      when "1010000110111" =>  data <= "00001011";  -- 7437 = B
      when "1010000111000" =>  data <= "10100101";  -- 7438 = A5
      when "1010000111001" =>  data <= "11001010";  -- 7439 = CA
      when "1010000111010" =>  data <= "10000101";  -- 743A = 85
      when "1010000111011" =>  data <= "00101011";  -- 743B = 2B
      when "1010000111100" =>  data <= "10100101";  -- 743C = A5
      when "1010000111101" =>  data <= "11001001";  -- 743D = C9
      when "1010000111110" =>  data <= "10000101";  -- 743E = 85
      when "1010000111111" =>  data <= "00101010";  -- 743F = 2A
      when "1010001000000" =>  data <= "01001100";  -- 7440 = 4C
      when "1010001000001" =>  data <= "10101101";  -- 7441 = AD
      when "1010001000010" =>  data <= "10110100";  -- 7442 = B4
      when "1010001000011" =>  data <= "00100000";  -- 7443 = 20
      when "1010001000100" =>  data <= "00100010";  -- 7444 = 22
      when "1010001000101" =>  data <= "10110110";  -- 7445 = B6
      when "1010001000110" =>  data <= "01001100";  -- 7446 = 4C
      when "1010001000111" =>  data <= "00001011";  -- 7447 = B
      when "1010001001000" =>  data <= "10110110";  -- 7448 = B6
      when "1010001001001" =>  data <= "00100000";  -- 7449 = 20
      when "1010001001010" =>  data <= "01010001";  -- 744A = 51
      when "1010001001011" =>  data <= "11110011";  -- 744B = F3
      when "1010001001100" =>  data <= "11010000";  -- 744C = D0
      when "1010001001101" =>  data <= "00011110";  -- 744D = 1E
      when "1010001001110" =>  data <= "10100000";  -- 744E = A0
      when "1010001001111" =>  data <= "00110010";  -- 744F = 32
      when "1010001010000" =>  data <= "00100000";  -- 7450 = 20
      when "1010001010001" =>  data <= "10000101";  -- 7451 = 85
      when "1010001010010" =>  data <= "11110001";  -- 7452 = F1
      when "1010001010011" =>  data <= "10100101";  -- 7453 = A5
      when "1010001010100" =>  data <= "11010001";  -- 7454 = D1
      when "1010001010101" =>  data <= "11110000";  -- 7455 = F0
      when "1010001010110" =>  data <= "00010101";  -- 7456 = 15
      when "1010001010111" =>  data <= "10100000";  -- 7457 = A0
      when "1010001011000" =>  data <= "00111101";  -- 7458 = 3D
      when "1010001011001" =>  data <= "00100000";  -- 7459 = 20
      when "1010001011010" =>  data <= "10000101";  -- 745A = 85
      when "1010001011011" =>  data <= "11110001";  -- 745B = F1
      when "1010001011100" =>  data <= "10100100";  -- 745C = A4
      when "1010001011101" =>  data <= "11010001";  -- 745D = D1
      when "1010001011110" =>  data <= "11110000";  -- 745E = F0
      when "1010001011111" =>  data <= "00001100";  -- 745F = C
      when "1010001100000" =>  data <= "10100000";  -- 7460 = A0
      when "1010001100001" =>  data <= "00000000";  -- 7461 = 0
      when "1010001100010" =>  data <= "10110001";  -- 7462 = B1
      when "1010001100011" =>  data <= "11011010";  -- 7463 = DA
      when "1010001100100" =>  data <= "00100000";  -- 7464 = 20
      when "1010001100101" =>  data <= "01100110";  -- 7465 = 66
      when "1010001100110" =>  data <= "11110010";  -- 7466 = F2
      when "1010001100111" =>  data <= "11001000";  -- 7467 = C8
      when "1010001101000" =>  data <= "11000100";  -- 7468 = C4
      when "1010001101001" =>  data <= "11010001";  -- 7469 = D1
      when "1010001101010" =>  data <= "11010000";  -- 746A = D0
      when "1010001101011" =>  data <= "11110110";  -- 746B = F6
      when "1010001101100" =>  data <= "01100000";  -- 746C = 60
      when "1010001101101" =>  data <= "10100000";  -- 746D = A0
      when "1010001101110" =>  data <= "01011111";  -- 746E = 5F
      when "1010001101111" =>  data <= "10100101";  -- 746F = A5
      when "1010001110000" =>  data <= "10011101";  -- 7470 = 9D
      when "1010001110001" =>  data <= "11110000";  -- 7471 = F0
      when "1010001110010" =>  data <= "00000010";  -- 7472 = 2
      when "1010001110011" =>  data <= "10100000";  -- 7473 = A0
      when "1010001110100" =>  data <= "01101101";  -- 7474 = 6D
      when "1010001110101" =>  data <= "00100000";  -- 7475 = 20
      when "1010001110110" =>  data <= "01001001";  -- 7476 = 49
      when "1010001110111" =>  data <= "11110011";  -- 7477 = F3
      when "1010001111000" =>  data <= "10100000";  -- 7478 = A0
      when "1010001111001" =>  data <= "00111001";  -- 7479 = 39
      when "1010001111010" =>  data <= "01001100";  -- 747A = 4C
      when "1010001111011" =>  data <= "01001001";  -- 747B = 49
      when "1010001111100" =>  data <= "11110011";  -- 747C = F3
      when "1010001111101" =>  data <= "10100010";  -- 747D = A2
      when "1010001111110" =>  data <= "00000000";  -- 747E = 0
      when "1010001111111" =>  data <= "10000110";  -- 747F = 86
      when "1010010000000" =>  data <= "10010110";  -- 7480 = 96
      when "1010010000001" =>  data <= "10000110";  -- 7481 = 86
      when "1010010000010" =>  data <= "11010001";  -- 7482 = D1
      when "1010010000011" =>  data <= "10000110";  -- 7483 = 86
      when "1010010000100" =>  data <= "11010011";  -- 7484 = D3
      when "1010010000101" =>  data <= "11101000";  -- 7485 = E8
      when "1010010000110" =>  data <= "10000110";  -- 7486 = 86
      when "1010010000111" =>  data <= "11010100";  -- 7487 = D4
      when "1010010001000" =>  data <= "00100000";  -- 7488 = 20
      when "1010010001001" =>  data <= "01001101";  -- 7489 = 4D
      when "1010010001010" =>  data <= "11110101";  -- 748A = F5
      when "1010010001011" =>  data <= "00100000";  -- 748B = 20
      when "1010010001100" =>  data <= "00111100";  -- 748C = 3C
      when "1010010001101" =>  data <= "11110101";  -- 748D = F5
      when "1010010001110" =>  data <= "00100000";  -- 748E = 20
      when "1010010001111" =>  data <= "01001101";  -- 748F = 4D
      when "1010010010000" =>  data <= "11110101";  -- 7490 = F5
      when "1010010010001" =>  data <= "00100000";  -- 7491 = 20
      when "1010010010010" =>  data <= "10011111";  -- 7492 = 9F
      when "1010010010011" =>  data <= "11110100";  -- 7493 = F4
      when "1010010010100" =>  data <= "10000110";  -- 7494 = 86
      when "1010010010101" =>  data <= "11010100";  -- 7495 = D4
      when "1010010010110" =>  data <= "00100000";  -- 7496 = 20
      when "1010010010111" =>  data <= "01001101";  -- 7497 = 4D
      when "1010010011000" =>  data <= "11110101";  -- 7498 = F5
      when "1010010011001" =>  data <= "00100000";  -- 7499 = 20
      when "1010010011010" =>  data <= "10011111";  -- 749A = 9F
      when "1010010011011" =>  data <= "11110100";  -- 749B = F4
      when "1010010011100" =>  data <= "10000110";  -- 749C = 86
      when "1010010011101" =>  data <= "11010011";  -- 749D = D3
      when "1010010011110" =>  data <= "01100000";  -- 749E = 60
      when "1010010011111" =>  data <= "00100000";  -- 749F = 20
      when "1010010100000" =>  data <= "01010101";  -- 74A0 = 55
      when "1010010100001" =>  data <= "11110101";  -- 74A1 = F5
      when "1010010100010" =>  data <= "01001100";  -- 74A2 = 4C
      when "1010010100011" =>  data <= "11010100";  -- 74A3 = D4
      when "1010010100100" =>  data <= "11001000";  -- 74A4 = C8
      when "1010010100101" =>  data <= "10100101";  -- 74A5 = A5
      when "1010010100110" =>  data <= "11010011";  -- 74A6 = D3
      when "1010010100111" =>  data <= "00110000";  -- 74A7 = 30
      when "1010010101000" =>  data <= "11110101";  -- 74A8 = F5
      when "1010010101001" =>  data <= "10100100";  -- 74A9 = A4
      when "1010010101010" =>  data <= "11010001";  -- 74AA = D1
      when "1010010101011" =>  data <= "11110000";  -- 74AB = F0
      when "1010010101100" =>  data <= "11110001";  -- 74AC = F1
      when "1010010101101" =>  data <= "00100000";  -- 74AD = 20
      when "1010010101110" =>  data <= "11010101";  -- 74AE = D5
      when "1010010101111" =>  data <= "11110000";  -- 74AF = F0
      when "1010010110000" =>  data <= "10100101";  -- 74B0 = A5
      when "1010010110001" =>  data <= "11010011";  -- 74B1 = D3
      when "1010010110010" =>  data <= "00001001";  -- 74B2 = 9
      when "1010010110011" =>  data <= "11110000";  -- 74B3 = F0
      when "1010010110100" =>  data <= "00100000";  -- 74B4 = 20
      when "1010010110101" =>  data <= "01000011";  -- 74B5 = 43
      when "1010010110110" =>  data <= "11110001";  -- 74B6 = F1
      when "1010010110111" =>  data <= "10100101";  -- 74B7 = A5
      when "1010010111000" =>  data <= "10010110";  -- 74B8 = 96
      when "1010010111001" =>  data <= "00010000";  -- 74B9 = 10
      when "1010010111010" =>  data <= "00000101";  -- 74BA = 5
      when "1010010111011" =>  data <= "10100000";  -- 74BB = A0
      when "1010010111100" =>  data <= "01110100";  -- 74BC = 74
      when "1010010111101" =>  data <= "01001100";  -- 74BD = 4C
      when "1010010111110" =>  data <= "10101111";  -- 74BE = AF
      when "1010010111111" =>  data <= "11110101";  -- 74BF = F5
      when "1010011000000" =>  data <= "10100101";  -- 74C0 = A5
      when "1010011000001" =>  data <= "11010001";  -- 74C1 = D1
      when "1010011000010" =>  data <= "11110000";  -- 74C2 = F0
      when "1010011000011" =>  data <= "00001100";  -- 74C3 = C
      when "1010011000100" =>  data <= "10100000";  -- 74C4 = A0
      when "1010011000101" =>  data <= "00000000";  -- 74C5 = 0
      when "1010011000110" =>  data <= "10110001";  -- 74C6 = B1
      when "1010011000111" =>  data <= "11011010";  -- 74C7 = DA
      when "1010011001000" =>  data <= "00100000";  -- 74C8 = 20
      when "1010011001001" =>  data <= "10011110";  -- 74C9 = 9E
      when "1010011001010" =>  data <= "11110001";  -- 74CA = F1
      when "1010011001011" =>  data <= "11001000";  -- 74CB = C8
      when "1010011001100" =>  data <= "11000100";  -- 74CC = C4
      when "1010011001101" =>  data <= "11010001";  -- 74CD = D1
      when "1010011001110" =>  data <= "11010000";  -- 74CE = D0
      when "1010011001111" =>  data <= "11110110";  -- 74CF = F6
      when "1010011010000" =>  data <= "01001100";  -- 74D0 = 4C
      when "1010011010001" =>  data <= "10111001";  -- 74D1 = B9
      when "1010011010010" =>  data <= "11110001";  -- 74D2 = F1
      when "1010011010011" =>  data <= "00100000";  -- 74D3 = 20
      when "1010011010100" =>  data <= "11100101";  -- 74D4 = E5
      when "1010011010101" =>  data <= "11110101";  -- 74D5 = F5
      when "1010011010110" =>  data <= "11110000";  -- 74D6 = F0
      when "1010011010111" =>  data <= "00011101";  -- 74D7 = 1D
      when "1010011011000" =>  data <= "10100000";  -- 74D8 = A0
      when "1010011011001" =>  data <= "00000101";  -- 74D9 = 5
      when "1010011011010" =>  data <= "10000100";  -- 74DA = 84
      when "1010011011011" =>  data <= "10110101";  -- 74DB = B5
      when "1010011011100" =>  data <= "10100000";  -- 74DC = A0
      when "1010011011101" =>  data <= "00000000";  -- 74DD = 0
      when "1010011011110" =>  data <= "10000100";  -- 74DE = 84
      when "1010011011111" =>  data <= "10110100";  -- 74DF = B4
      when "1010011100000" =>  data <= "11000100";  -- 74E0 = C4
      when "1010011100001" =>  data <= "11010001";  -- 74E1 = D1
      when "1010011100010" =>  data <= "11110000";  -- 74E2 = F0
      when "1010011100011" =>  data <= "00010000";  -- 74E3 = 10
      when "1010011100100" =>  data <= "10110001";  -- 74E4 = B1
      when "1010011100101" =>  data <= "11011010";  -- 74E5 = DA
      when "1010011100110" =>  data <= "10100100";  -- 74E6 = A4
      when "1010011100111" =>  data <= "10110101";  -- 74E7 = B5
      when "1010011101000" =>  data <= "11010001";  -- 74E8 = D1
      when "1010011101001" =>  data <= "11010110";  -- 74E9 = D6
      when "1010011101010" =>  data <= "11010000";  -- 74EA = D0
      when "1010011101011" =>  data <= "11100111";  -- 74EB = E7
      when "1010011101100" =>  data <= "11100110";  -- 74EC = E6
      when "1010011101101" =>  data <= "10110100";  -- 74ED = B4
      when "1010011101110" =>  data <= "11100110";  -- 74EE = E6
      when "1010011101111" =>  data <= "10110101";  -- 74EF = B5
      when "1010011110000" =>  data <= "10100100";  -- 74F0 = A4
      when "1010011110001" =>  data <= "10110100";  -- 74F1 = B4
      when "1010011110010" =>  data <= "11010000";  -- 74F2 = D0
      when "1010011110011" =>  data <= "11101100";  -- 74F3 = EC
      when "1010011110100" =>  data <= "10011000";  -- 74F4 = 98
      when "1010011110101" =>  data <= "01100000";  -- 74F5 = 60
      when "1010011110110" =>  data <= "10101001";  -- 74F6 = A9
      when "1010011110111" =>  data <= "00000001";  -- 74F7 = 1
      when "1010011111000" =>  data <= "10000101";  -- 74F8 = 85
      when "1010011111001" =>  data <= "10011101";  -- 74F9 = 9D
      when "1010011111010" =>  data <= "00100000";  -- 74FA = 20
      when "1010011111011" =>  data <= "00000101";  -- 74FB = 5
      when "1010011111100" =>  data <= "11110100";  -- 74FC = F4
      when "1010011111101" =>  data <= "10100101";  -- 74FD = A5
      when "1010011111110" =>  data <= "10010110";  -- 74FE = 96
      when "1010011111111" =>  data <= "00101001";  -- 74FF = 29
      when "1010100000000" =>  data <= "00010000";  -- 7500 = 10
      when "1010100000001" =>  data <= "11110000";  -- 7501 = F0
      when "1010100000010" =>  data <= "00000101";  -- 7502 = 5
      when "1010100000011" =>  data <= "10100000";  -- 7503 = A0
      when "1010100000100" =>  data <= "01101110";  -- 7504 = 6E
      when "1010100000101" =>  data <= "01001100";  -- 7505 = 4C
      when "1010100000110" =>  data <= "10101111";  -- 7506 = AF
      when "1010100000111" =>  data <= "11110101";  -- 7507 = F5
      when "1010100001000" =>  data <= "10100000";  -- 7508 = A0
      when "1010100001001" =>  data <= "10101010";  -- 7509 = AA
      when "1010100001010" =>  data <= "01001100";  -- 750A = 4C
      when "1010100001011" =>  data <= "10000101";  -- 750B = 85
      when "1010100001100" =>  data <= "11110001";  -- 750C = F1
      when "1010100001101" =>  data <= "10100010";  -- 750D = A2
      when "1010100001110" =>  data <= "00000000";  -- 750E = 0
      when "1010100001111" =>  data <= "10000110";  -- 750F = 86
      when "1010100010000" =>  data <= "11010011";  -- 7510 = D3
      when "1010100010001" =>  data <= "10000110";  -- 7511 = 86
      when "1010100010010" =>  data <= "10010110";  -- 7512 = 96
      when "1010100010011" =>  data <= "10000110";  -- 7513 = 86
      when "1010100010100" =>  data <= "11010001";  -- 7514 = D1
      when "1010100010101" =>  data <= "11101000";  -- 7515 = E8
      when "1010100010110" =>  data <= "10000110";  -- 7516 = 86
      when "1010100010111" =>  data <= "11010100";  -- 7517 = D4
      when "1010100011000" =>  data <= "00100000";  -- 7518 = 20
      when "1010100011001" =>  data <= "01011000";  -- 7519 = 58
      when "1010100011010" =>  data <= "11110101";  -- 751A = F5
      when "1010100011011" =>  data <= "00100000";  -- 751B = 20
      when "1010100011100" =>  data <= "11010100";  -- 751C = D4
      when "1010100011101" =>  data <= "11001000";  -- 751D = C8
      when "1010100011110" =>  data <= "10000110";  -- 751E = 86
      when "1010100011111" =>  data <= "11010010";  -- 751F = D2
      when "1010100100000" =>  data <= "00100000";  -- 7520 = 20
      when "1010100100001" =>  data <= "01001101";  -- 7521 = 4D
      when "1010100100010" =>  data <= "11110101";  -- 7522 = F5
      when "1010100100011" =>  data <= "00100000";  -- 7523 = 20
      when "1010100100100" =>  data <= "10011111";  -- 7524 = 9F
      when "1010100100101" =>  data <= "11110100";  -- 7525 = F4
      when "1010100100110" =>  data <= "10000110";  -- 7526 = 86
      when "1010100100111" =>  data <= "11010100";  -- 7527 = D4
      when "1010100101000" =>  data <= "11100000";  -- 7528 = E0
      when "1010100101001" =>  data <= "00000011";  -- 7529 = 3
      when "1010100101010" =>  data <= "10010000";  -- 752A = 90
      when "1010100101011" =>  data <= "00000010";  -- 752B = 2
      when "1010100101100" =>  data <= "11000110";  -- 752C = C6
      when "1010100101101" =>  data <= "11010011";  -- 752D = D3
      when "1010100101110" =>  data <= "00100000";  -- 752E = 20
      when "1010100101111" =>  data <= "01001101";  -- 752F = 4D
      when "1010100110000" =>  data <= "11110101";  -- 7530 = F5
      when "1010100110001" =>  data <= "00100000";  -- 7531 = 20
      when "1010100110010" =>  data <= "10011111";  -- 7532 = 9F
      when "1010100110011" =>  data <= "11110100";  -- 7533 = F4
      when "1010100110100" =>  data <= "10000110";  -- 7534 = 86
      when "1010100110101" =>  data <= "11010011";  -- 7535 = D3
      when "1010100110110" =>  data <= "00100000";  -- 7536 = 20
      when "1010100110111" =>  data <= "01001101";  -- 7537 = 4D
      when "1010100111000" =>  data <= "11110101";  -- 7538 = F5
      when "1010100111001" =>  data <= "00100000";  -- 7539 = 20
      when "1010100111010" =>  data <= "01010101";  -- 753A = 55
      when "1010100111011" =>  data <= "11110101";  -- 753B = F5
      when "1010100111100" =>  data <= "00100000";  -- 753C = 20
      when "1010100111101" =>  data <= "10011000";  -- 753D = 98
      when "1010100111110" =>  data <= "10111101";  -- 753E = BD
      when "1010100111111" =>  data <= "00100000";  -- 753F = 20
      when "1010101000000" =>  data <= "10110101";  -- 7540 = B5
      when "1010101000001" =>  data <= "11000111";  -- 7541 = C7
      when "1010101000010" =>  data <= "10000101";  -- 7542 = 85
      when "1010101000011" =>  data <= "11010001";  -- 7543 = D1
      when "1010101000100" =>  data <= "10100101";  -- 7544 = A5
      when "1010101000101" =>  data <= "00011111";  -- 7545 = 1F
      when "1010101000110" =>  data <= "10000101";  -- 7546 = 85
      when "1010101000111" =>  data <= "11011010";  -- 7547 = DA
      when "1010101001000" =>  data <= "10100101";  -- 7548 = A5
      when "1010101001001" =>  data <= "00100000";  -- 7549 = 20
      when "1010101001010" =>  data <= "10000101";  -- 754A = 85
      when "1010101001011" =>  data <= "11011011";  -- 754B = DB
      when "1010101001100" =>  data <= "01100000";  -- 754C = 60
      when "1010101001101" =>  data <= "00100000";  -- 754D = 20
      when "1010101001110" =>  data <= "01110110";  -- 754E = 76
      when "1010101001111" =>  data <= "00000000";  -- 754F = 0
      when "1010101010000" =>  data <= "11010000";  -- 7550 = D0
      when "1010101010001" =>  data <= "00000010";  -- 7551 = 2
      when "1010101010010" =>  data <= "01101000";  -- 7552 = 68
      when "1010101010011" =>  data <= "01101000";  -- 7553 = 68
      when "1010101010100" =>  data <= "01100000";  -- 7554 = 60
      when "1010101010101" =>  data <= "00100000";  -- 7555 = 20
      when "1010101010110" =>  data <= "11110101";  -- 7556 = F5
      when "1010101010111" =>  data <= "10111110";  -- 7557 = BE
      when "1010101011000" =>  data <= "00100000";  -- 7558 = 20
      when "1010101011001" =>  data <= "01110110";  -- 7559 = 76
      when "1010101011010" =>  data <= "00000000";  -- 755A = 0
      when "1010101011011" =>  data <= "11010000";  -- 755B = D0
      when "1010101011100" =>  data <= "11110111";  -- 755C = F7
      when "1010101011101" =>  data <= "01001100";  -- 755D = 4C
      when "1010101011110" =>  data <= "00000000";  -- 755E = 0
      when "1010101011111" =>  data <= "10111111";  -- 755F = BF
      when "1010101100000" =>  data <= "00100000";  -- 7560 = 20
      when "1010101100001" =>  data <= "00001101";  -- 7561 = D
      when "1010101100010" =>  data <= "11110101";  -- 7562 = F5
      when "1010101100011" =>  data <= "10100101";  -- 7563 = A5
      when "1010101100100" =>  data <= "11010010";  -- 7564 = D2
      when "1010101100101" =>  data <= "11110000";  -- 7565 = F0
      when "1010101100110" =>  data <= "11110110";  -- 7566 = F6
      when "1010101100111" =>  data <= "10100000";  -- 7567 = A0
      when "1010101101000" =>  data <= "00001110";  -- 7568 = E
      when "1010101101001" =>  data <= "00100000";  -- 7569 = 20
      when "1010101101010" =>  data <= "11000001";  -- 756A = C1
      when "1010101101011" =>  data <= "11110010";  -- 756B = F2
      when "1010101101100" =>  data <= "11110000";  -- 756C = F0
      when "1010101101101" =>  data <= "01000001";  -- 756D = 41
      when "1010101101110" =>  data <= "10100110";  -- 756E = A6
      when "1010101101111" =>  data <= "10101110";  -- 756F = AE
      when "1010101110000" =>  data <= "10100000";  -- 7570 = A0
      when "1010101110001" =>  data <= "00000000";  -- 7571 = 0
      when "1010101110010" =>  data <= "10000100";  -- 7572 = 84
      when "1010101110011" =>  data <= "10010110";  -- 7573 = 96
      when "1010101110100" =>  data <= "11100000";  -- 7574 = E0
      when "1010101110101" =>  data <= "00001010";  -- 7575 = A
      when "1010101110110" =>  data <= "11110000";  -- 7576 = F0
      when "1010101110111" =>  data <= "00110111";  -- 7577 = 37
      when "1010101111000" =>  data <= "11100110";  -- 7578 = E6
      when "1010101111001" =>  data <= "10101110";  -- 7579 = AE
      when "1010101111010" =>  data <= "10100101";  -- 757A = A5
      when "1010101111011" =>  data <= "11010010";  -- 757B = D2
      when "1010101111100" =>  data <= "10011101";  -- 757C = 9D
      when "1010101111101" =>  data <= "01010001";  -- 757D = 51
      when "1010101111110" =>  data <= "00000010";  -- 757E = 2
      when "1010101111111" =>  data <= "10100101";  -- 757F = A5
      when "1010110000000" =>  data <= "11010011";  -- 7580 = D3
      when "1010110000001" =>  data <= "00001001";  -- 7581 = 9
      when "1010110000010" =>  data <= "01100000";  -- 7582 = 60
      when "1010110000011" =>  data <= "10000101";  -- 7583 = 85
      when "1010110000100" =>  data <= "11010011";  -- 7584 = D3
      when "1010110000101" =>  data <= "10011101";  -- 7585 = 9D
      when "1010110000110" =>  data <= "01100101";  -- 7586 = 65
      when "1010110000111" =>  data <= "00000010";  -- 7587 = 2
      when "1010110001000" =>  data <= "10100101";  -- 7588 = A5
      when "1010110001001" =>  data <= "11010100";  -- 7589 = D4
      when "1010110001010" =>  data <= "10011101";  -- 758A = 9D
      when "1010110001011" =>  data <= "01011011";  -- 758B = 5B
      when "1010110001100" =>  data <= "00000010";  -- 758C = 2
      when "1010110001101" =>  data <= "11110000";  -- 758D = F0
      when "1010110001110" =>  data <= "01010101";  -- 758E = 55
      when "1010110001111" =>  data <= "11001001";  -- 758F = C9
      when "1010110010000" =>  data <= "00000011";  -- 7590 = 3
      when "1010110010001" =>  data <= "11110000";  -- 7591 = F0
      when "1010110010010" =>  data <= "01010001";  -- 7592 = 51
      when "1010110010011" =>  data <= "10010000";  -- 7593 = 90
      when "1010110010100" =>  data <= "00000011";  -- 7594 = 3
      when "1010110010101" =>  data <= "01001100";  -- 7595 = 4C
      when "1010110010110" =>  data <= "10100101";  -- 7596 = A5
      when "1010110010111" =>  data <= "11110100";  -- 7597 = F4
      when "1010110011000" =>  data <= "10100101";  -- 7598 = A5
      when "1010110011001" =>  data <= "11010011";  -- 7599 = D3
      when "1010110011010" =>  data <= "00101001";  -- 759A = 29
      when "1010110011011" =>  data <= "00001111";  -- 759B = F
      when "1010110011100" =>  data <= "11010000";  -- 759C = D0
      when "1010110011101" =>  data <= "00101011";  -- 759D = 2B
      when "1010110011110" =>  data <= "00100000";  -- 759E = 20
      when "1010110011111" =>  data <= "01010111";  -- 759F = 57
      when "1010110100000" =>  data <= "11111000";  -- 75A0 = F8
      when "1010110100001" =>  data <= "00100000";  -- 75A1 = 20
      when "1010110100010" =>  data <= "01001001";  -- 75A2 = 49
      when "1010110100011" =>  data <= "11110100";  -- 75A3 = F4
      when "1010110100100" =>  data <= "10100101";  -- 75A4 = A5
      when "1010110100101" =>  data <= "11010001";  -- 75A5 = D1
      when "1010110100110" =>  data <= "11110000";  -- 75A6 = F0
      when "1010110100111" =>  data <= "00011010";  -- 75A7 = 1A
      when "1010110101000" =>  data <= "00100000";  -- 75A8 = 20
      when "1010110101001" =>  data <= "11010011";  -- 75A9 = D3
      when "1010110101010" =>  data <= "11110100";  -- 75AA = F4
      when "1010110101011" =>  data <= "11010000";  -- 75AB = D0
      when "1010110101100" =>  data <= "00100100";  -- 75AC = 24
      when "1010110101101" =>  data <= "10100000";  -- 75AD = A0
      when "1010110101110" =>  data <= "00100100";  -- 75AE = 24
      when "1010110101111" =>  data <= "00100000";  -- 75AF = 20
      when "1010110110000" =>  data <= "10100010";  -- 75B0 = A2
      when "1010110110001" =>  data <= "11110010";  -- 75B1 = F2
      when "1010110110010" =>  data <= "10101001";  -- 75B2 = A9
      when "1010110110011" =>  data <= "00001101";  -- 75B3 = D
      when "1010110110100" =>  data <= "00100000";  -- 75B4 = 20
      when "1010110110101" =>  data <= "01100110";  -- 75B5 = 66
      when "1010110110110" =>  data <= "11110010";  -- 75B6 = F2
      when "1010110110111" =>  data <= "10101001";  -- 75B7 = A9
      when "1010110111000" =>  data <= "00111111";  -- 75B8 = 3F
      when "1010110111001" =>  data <= "00100000";  -- 75B9 = 20
      when "1010110111010" =>  data <= "01100110";  -- 75BA = 66
      when "1010110111011" =>  data <= "11110010";  -- 75BB = F2
      when "1010110111100" =>  data <= "00100000";  -- 75BC = 20
      when "1010110111101" =>  data <= "10000101";  -- 75BD = 85
      when "1010110111110" =>  data <= "11110001";  -- 75BE = F1
      when "1010110111111" =>  data <= "01001100";  -- 75BF = 4C
      when "1010111000000" =>  data <= "11101101";  -- 75C0 = ED
      when "1010111000001" =>  data <= "10110011";  -- 75C1 = B3
      when "1010111000010" =>  data <= "00100000";  -- 75C2 = 20
      when "1010111000011" =>  data <= "11100101";  -- 75C3 = E5
      when "1010111000100" =>  data <= "11110101";  -- 75C4 = F5
      when "1010111000101" =>  data <= "11110000";  -- 75C5 = F0
      when "1010111000110" =>  data <= "11100110";  -- 75C6 = E6
      when "1010111000111" =>  data <= "11010000";  -- 75C7 = D0
      when "1010111001000" =>  data <= "00001000";  -- 75C8 = 8
      when "1010111001001" =>  data <= "00100000";  -- 75C9 = 20
      when "1010111001010" =>  data <= "10001100";  -- 75CA = 8C
      when "1010111001011" =>  data <= "11111000";  -- 75CB = F8
      when "1010111001100" =>  data <= "10101001";  -- 75CC = A9
      when "1010111001101" =>  data <= "00000100";  -- 75CD = 4
      when "1010111001110" =>  data <= "00100000";  -- 75CE = 20
      when "1010111001111" =>  data <= "00011001";  -- 75CF = 19
      when "1010111010000" =>  data <= "11110110";  -- 75D0 = F6
      when "1010111010001" =>  data <= "10100110";  -- 75D1 = A6
      when "1010111010010" =>  data <= "11010100";  -- 75D2 = D4
      when "1010111010011" =>  data <= "10101001";  -- 75D3 = A9
      when "1010111010100" =>  data <= "10111111";  -- 75D4 = BF
      when "1010111010101" =>  data <= "10100100";  -- 75D5 = A4
      when "1010111010110" =>  data <= "11010011";  -- 75D6 = D3
      when "1010111010111" =>  data <= "11000000";  -- 75D7 = C0
      when "1010111011000" =>  data <= "01100000";  -- 75D8 = 60
      when "1010111011001" =>  data <= "11110000";  -- 75D9 = F0
      when "1010111011010" =>  data <= "00000111";  -- 75DA = 7
      when "1010111011011" =>  data <= "10100000";  -- 75DB = A0
      when "1010111011100" =>  data <= "00000000";  -- 75DC = 0
      when "1010111011101" =>  data <= "10101001";  -- 75DD = A9
      when "1010111011110" =>  data <= "00000010";  -- 75DE = 2
      when "1010111011111" =>  data <= "10010001";  -- 75DF = 91
      when "1010111100000" =>  data <= "11010110";  -- 75E0 = D6
      when "1010111100001" =>  data <= "10011000";  -- 75E1 = 98
      when "1010111100010" =>  data <= "10010101";  -- 75E2 = 95
      when "1010111100011" =>  data <= "10111010";  -- 75E3 = BA
      when "1010111100100" =>  data <= "01100000";  -- 75E4 = 60
      when "1010111100101" =>  data <= "10100101";  -- 75E5 = A5
      when "1010111100110" =>  data <= "10011101";  -- 75E6 = 9D
      when "1010111100111" =>  data <= "01001000";  -- 75E7 = 48
      when "1010111101000" =>  data <= "00100000";  -- 75E8 = 20
      when "1010111101001" =>  data <= "10011010";  -- 75E9 = 9A
      when "1010111101010" =>  data <= "11111000";  -- 75EA = F8
      when "1010111101011" =>  data <= "10100000";  -- 75EB = A0
      when "1010111101100" =>  data <= "00000000";  -- 75EC = 0
      when "1010111101101" =>  data <= "10110001";  -- 75ED = B1
      when "1010111101110" =>  data <= "11010110";  -- 75EE = D6
      when "1010111101111" =>  data <= "11001001";  -- 75EF = C9
      when "1010111110000" =>  data <= "00000101";  -- 75F0 = 5
      when "1010111110001" =>  data <= "11110000";  -- 75F1 = F0
      when "1010111110010" =>  data <= "00100001";  -- 75F2 = 21
      when "1010111110011" =>  data <= "11001001";  -- 75F3 = C9
      when "1010111110100" =>  data <= "00000001";  -- 75F4 = 1
      when "1010111110101" =>  data <= "11110000";  -- 75F5 = F0
      when "1010111110110" =>  data <= "00000100";  -- 75F6 = 4
      when "1010111110111" =>  data <= "11001001";  -- 75F7 = C9
      when "1010111111000" =>  data <= "00000100";  -- 75F8 = 4
      when "1010111111001" =>  data <= "11010000";  -- 75F9 = D0
      when "1010111111010" =>  data <= "11101101";  -- 75FA = ED
      when "1010111111011" =>  data <= "10101010";  -- 75FB = AA
      when "1010111111100" =>  data <= "00100000";  -- 75FC = 20
      when "1010111111101" =>  data <= "01010001";  -- 75FD = 51
      when "1010111111110" =>  data <= "11110011";  -- 75FE = F3
      when "1010111111111" =>  data <= "11010000";  -- 75FF = D0
      when "1011000000000" =>  data <= "00010001";  -- 7600 = 11
      when "1011000000001" =>  data <= "10100000";  -- 7601 = A0
      when "1011000000010" =>  data <= "10100011";  -- 7602 = A3
      when "1011000000011" =>  data <= "00100000";  -- 7603 = 20
      when "1011000000100" =>  data <= "10000101";  -- 7604 = 85
      when "1011000000101" =>  data <= "11110001";  -- 7605 = F1
      when "1011000000110" =>  data <= "10100000";  -- 7606 = A0
      when "1011000000111" =>  data <= "00000101";  -- 7607 = 5
      when "1011000001000" =>  data <= "10110001";  -- 7608 = B1
      when "1011000001001" =>  data <= "11010110";  -- 7609 = D6
      when "1011000001010" =>  data <= "00100000";  -- 760A = 20
      when "1011000001011" =>  data <= "11010010";  -- 760B = D2
      when "1011000001100" =>  data <= "11111111";  -- 760C = FF
      when "1011000001101" =>  data <= "11001000";  -- 760D = C8
      when "1011000001110" =>  data <= "11000000";  -- 760E = C0
      when "1011000001111" =>  data <= "00010101";  -- 760F = 15
      when "1011000010000" =>  data <= "11010000";  -- 7610 = D0
      when "1011000010001" =>  data <= "11110110";  -- 7611 = F6
      when "1011000010010" =>  data <= "10100000";  -- 7612 = A0
      when "1011000010011" =>  data <= "00000001";  -- 7613 = 1
      when "1011000010100" =>  data <= "01101000";  -- 7614 = 68
      when "1011000010101" =>  data <= "10000101";  -- 7615 = 85
      when "1011000010110" =>  data <= "10011101";  -- 7616 = 9D
      when "1011000010111" =>  data <= "10011000";  -- 7617 = 98
      when "1011000011000" =>  data <= "01100000";  -- 7618 = 60
      when "1011000011001" =>  data <= "10000101";  -- 7619 = 85
      when "1011000011010" =>  data <= "10110100";  -- 761A = B4
      when "1011000011011" =>  data <= "00100000";  -- 761B = 20
      when "1011000011100" =>  data <= "10010101";  -- 761C = 95
      when "1011000011101" =>  data <= "11110110";  -- 761D = F6
      when "1011000011110" =>  data <= "10100101";  -- 761E = A5
      when "1011000011111" =>  data <= "11111100";  -- 761F = FC
      when "1011000100000" =>  data <= "01001000";  -- 7620 = 48
      when "1011000100001" =>  data <= "10100101";  -- 7621 = A5
      when "1011000100010" =>  data <= "11111011";  -- 7622 = FB
      when "1011000100011" =>  data <= "01001000";  -- 7623 = 48
      when "1011000100100" =>  data <= "10100101";  -- 7624 = A5
      when "1011000100101" =>  data <= "11001010";  -- 7625 = CA
      when "1011000100110" =>  data <= "01001000";  -- 7626 = 48
      when "1011000100111" =>  data <= "10100101";  -- 7627 = A5
      when "1011000101000" =>  data <= "11001001";  -- 7628 = C9
      when "1011000101001" =>  data <= "01001000";  -- 7629 = 48
      when "1011000101010" =>  data <= "10100000";  -- 762A = A0
      when "1011000101011" =>  data <= "10111111";  -- 762B = BF
      when "1011000101100" =>  data <= "10101001";  -- 762C = A9
      when "1011000101101" =>  data <= "00100000";  -- 762D = 20
      when "1011000101110" =>  data <= "10010001";  -- 762E = 91
      when "1011000101111" =>  data <= "11010110";  -- 762F = D6
      when "1011000110000" =>  data <= "10001000";  -- 7630 = 88
      when "1011000110001" =>  data <= "11010000";  -- 7631 = D0
      when "1011000110010" =>  data <= "11111011";  -- 7632 = FB
      when "1011000110011" =>  data <= "10100101";  -- 7633 = A5
      when "1011000110100" =>  data <= "10110100";  -- 7634 = B4
      when "1011000110101" =>  data <= "10010001";  -- 7635 = 91
      when "1011000110110" =>  data <= "11010110";  -- 7636 = D6
      when "1011000110111" =>  data <= "11001000";  -- 7637 = C8
      when "1011000111000" =>  data <= "10100101";  -- 7638 = A5
      when "1011000111001" =>  data <= "11111011";  -- 7639 = FB
      when "1011000111010" =>  data <= "10010001";  -- 763A = 91
      when "1011000111011" =>  data <= "11010110";  -- 763B = D6
      when "1011000111100" =>  data <= "11001000";  -- 763C = C8
      when "1011000111101" =>  data <= "10100101";  -- 763D = A5
      when "1011000111110" =>  data <= "11111100";  -- 763E = FC
      when "1011000111111" =>  data <= "10010001";  -- 763F = 91
      when "1011001000000" =>  data <= "11010110";  -- 7640 = D6
      when "1011001000001" =>  data <= "11001000";  -- 7641 = C8
      when "1011001000010" =>  data <= "10100101";  -- 7642 = A5
      when "1011001000011" =>  data <= "11001001";  -- 7643 = C9
      when "1011001000100" =>  data <= "10010001";  -- 7644 = 91
      when "1011001000101" =>  data <= "11010110";  -- 7645 = D6
      when "1011001000110" =>  data <= "11001000";  -- 7646 = C8
      when "1011001000111" =>  data <= "10100101";  -- 7647 = A5
      when "1011001001000" =>  data <= "11001010";  -- 7648 = CA
      when "1011001001001" =>  data <= "10010001";  -- 7649 = 91
      when "1011001001010" =>  data <= "11010110";  -- 764A = D6
      when "1011001001011" =>  data <= "11001000";  -- 764B = C8
      when "1011001001100" =>  data <= "10000100";  -- 764C = 84
      when "1011001001101" =>  data <= "10110101";  -- 764D = B5
      when "1011001001110" =>  data <= "10100000";  -- 764E = A0
      when "1011001001111" =>  data <= "00000000";  -- 764F = 0
      when "1011001010000" =>  data <= "10000100";  -- 7650 = 84
      when "1011001010001" =>  data <= "10110100";  -- 7651 = B4
      when "1011001010010" =>  data <= "10100100";  -- 7652 = A4
      when "1011001010011" =>  data <= "10110100";  -- 7653 = B4
      when "1011001010100" =>  data <= "11000100";  -- 7654 = C4
      when "1011001010101" =>  data <= "11010001";  -- 7655 = D1
      when "1011001010110" =>  data <= "11110000";  -- 7656 = F0
      when "1011001010111" =>  data <= "00001100";  -- 7657 = C
      when "1011001011000" =>  data <= "10110001";  -- 7658 = B1
      when "1011001011001" =>  data <= "11011010";  -- 7659 = DA
      when "1011001011010" =>  data <= "10100100";  -- 765A = A4
      when "1011001011011" =>  data <= "10110101";  -- 765B = B5
      when "1011001011100" =>  data <= "10010001";  -- 765C = 91
      when "1011001011101" =>  data <= "11010110";  -- 765D = D6
      when "1011001011110" =>  data <= "11100110";  -- 765E = E6
      when "1011001011111" =>  data <= "10110100";  -- 765F = B4
      when "1011001100000" =>  data <= "11100110";  -- 7660 = E6
      when "1011001100001" =>  data <= "10110101";  -- 7661 = B5
      when "1011001100010" =>  data <= "11010000";  -- 7662 = D0
      when "1011001100011" =>  data <= "11101110";  -- 7663 = EE
      when "1011001100100" =>  data <= "00100000";  -- 7664 = 20
      when "1011001100101" =>  data <= "10101011";  -- 7665 = AB
      when "1011001100110" =>  data <= "11110110";  -- 7666 = F6
      when "1011001100111" =>  data <= "10101001";  -- 7667 = A9
      when "1011001101000" =>  data <= "01101001";  -- 7668 = 69
      when "1011001101001" =>  data <= "10000101";  -- 7669 = 85
      when "1011001101010" =>  data <= "11000011";  -- 766A = C3
      when "1011001101011" =>  data <= "00100000";  -- 766B = 20
      when "1011001101100" =>  data <= "11010101";  -- 766C = D5
      when "1011001101101" =>  data <= "11111000";  -- 766D = F8
      when "1011001101110" =>  data <= "01101000";  -- 766E = 68
      when "1011001101111" =>  data <= "10000101";  -- 766F = 85
      when "1011001110000" =>  data <= "11001001";  -- 7670 = C9
      when "1011001110001" =>  data <= "01101000";  -- 7671 = 68
      when "1011001110010" =>  data <= "10000101";  -- 7672 = 85
      when "1011001110011" =>  data <= "11001010";  -- 7673 = CA
      when "1011001110100" =>  data <= "01101000";  -- 7674 = 68
      when "1011001110101" =>  data <= "10000101";  -- 7675 = 85
      when "1011001110110" =>  data <= "11111011";  -- 7676 = FB
      when "1011001110111" =>  data <= "01101000";  -- 7677 = 68
      when "1011001111000" =>  data <= "10000101";  -- 7678 = 85
      when "1011001111001" =>  data <= "11111100";  -- 7679 = FC
      when "1011001111010" =>  data <= "01100000";  -- 767A = 60
      when "1011001111011" =>  data <= "00100000";  -- 767B = 20
      when "1011001111100" =>  data <= "00101011";  -- 767C = 2B
      when "1011001111101" =>  data <= "11111001";  -- 767D = F9
      when "1011001111110" =>  data <= "10100010";  -- 767E = A2
      when "1011001111111" =>  data <= "00000000";  -- 767F = 0
      when "1011010000000" =>  data <= "10100000";  -- 7680 = A0
      when "1011010000001" =>  data <= "00000001";  -- 7681 = 1
      when "1011010000010" =>  data <= "10110001";  -- 7682 = B1
      when "1011010000011" =>  data <= "11010110";  -- 7683 = D6
      when "1011010000100" =>  data <= "10010101";  -- 7684 = 95
      when "1011010000101" =>  data <= "11000111";  -- 7685 = C7
      when "1011010000110" =>  data <= "11101000";  -- 7686 = E8
      when "1011010000111" =>  data <= "11001000";  -- 7687 = C8
      when "1011010001000" =>  data <= "11100000";  -- 7688 = E0
      when "1011010001001" =>  data <= "00000100";  -- 7689 = 4
      when "1011010001010" =>  data <= "11010000";  -- 768A = D0
      when "1011010001011" =>  data <= "11110110";  -- 768B = F6
      when "1011010001100" =>  data <= "10100101";  -- 768C = A5
      when "1011010001101" =>  data <= "11000111";  -- 768D = C7
      when "1011010001110" =>  data <= "10000101";  -- 768E = 85
      when "1011010001111" =>  data <= "11111011";  -- 768F = FB
      when "1011010010000" =>  data <= "10100101";  -- 7690 = A5
      when "1011010010001" =>  data <= "11001000";  -- 7691 = C8
      when "1011010010010" =>  data <= "10000101";  -- 7692 = 85
      when "1011010010011" =>  data <= "11111100";  -- 7693 = FC
      when "1011010010100" =>  data <= "01100000";  -- 7694 = 60
      when "1011010010101" =>  data <= "10101001";  -- 7695 = A9
      when "1011010010110" =>  data <= "01111010";  -- 7696 = 7A
      when "1011010010111" =>  data <= "10000101";  -- 7697 = 85
      when "1011010011000" =>  data <= "11010110";  -- 7698 = D6
      when "1011010011001" =>  data <= "10101001";  -- 7699 = A9
      when "1011010011010" =>  data <= "00000010";  -- 769A = 2
      when "1011010011011" =>  data <= "10000101";  -- 769B = 85
      when "1011010011100" =>  data <= "11010111";  -- 769C = D7
      when "1011010011101" =>  data <= "10100101";  -- 769D = A5
      when "1011010011110" =>  data <= "11010100";  -- 769E = D4
      when "1011010011111" =>  data <= "01001010";  -- 769F = 4A
      when "1011010100000" =>  data <= "10110000";  -- 76A0 = B0
      when "1011010100001" =>  data <= "00001000";  -- 76A1 = 8
      when "1011010100010" =>  data <= "10101001";  -- 76A2 = A9
      when "1011010100011" =>  data <= "00111010";  -- 76A3 = 3A
      when "1011010100100" =>  data <= "10000101";  -- 76A4 = 85
      when "1011010100101" =>  data <= "11010110";  -- 76A5 = D6
      when "1011010100110" =>  data <= "10101001";  -- 76A6 = A9
      when "1011010100111" =>  data <= "00000011";  -- 76A7 = 3
      when "1011010101000" =>  data <= "10000101";  -- 76A8 = 85
      when "1011010101001" =>  data <= "11010111";  -- 76A9 = D7
      when "1011010101010" =>  data <= "01100000";  -- 76AA = 60
      when "1011010101011" =>  data <= "00100000";  -- 76AB = 20
      when "1011010101100" =>  data <= "00101011";  -- 76AC = 2B
      when "1011010101101" =>  data <= "11111001";  -- 76AD = F9
      when "1011010101110" =>  data <= "00100000";  -- 76AE = 20
      when "1011010101111" =>  data <= "10010101";  -- 76AF = 95
      when "1011010110000" =>  data <= "11110110";  -- 76B0 = F6
      when "1011010110001" =>  data <= "10100101";  -- 76B1 = A5
      when "1011010110010" =>  data <= "11010110";  -- 76B2 = D6
      when "1011010110011" =>  data <= "10000101";  -- 76B3 = 85
      when "1011010110100" =>  data <= "11111011";  -- 76B4 = FB
      when "1011010110101" =>  data <= "00011000";  -- 76B5 = 18
      when "1011010110110" =>  data <= "01101001";  -- 76B6 = 69
      when "1011010110111" =>  data <= "11000000";  -- 76B7 = C0
      when "1011010111000" =>  data <= "10000101";  -- 76B8 = 85
      when "1011010111001" =>  data <= "11001001";  -- 76B9 = C9
      when "1011010111010" =>  data <= "10100101";  -- 76BA = A5
      when "1011010111011" =>  data <= "11010111";  -- 76BB = D7
      when "1011010111100" =>  data <= "10000101";  -- 76BC = 85
      when "1011010111101" =>  data <= "11111100";  -- 76BD = FC
      when "1011010111110" =>  data <= "01101001";  -- 76BE = 69
      when "1011010111111" =>  data <= "00000000";  -- 76BF = 0
      when "1011011000000" =>  data <= "10000101";  -- 76C0 = 85
      when "1011011000001" =>  data <= "11001010";  -- 76C1 = CA
      when "1011011000010" =>  data <= "01100000";  -- 76C2 = 60
      when "1011011000011" =>  data <= "00100000";  -- 76C3 = 20
      when "1011011000100" =>  data <= "10000100";  -- 76C4 = 84
      when "1011011000101" =>  data <= "10111101";  -- 76C5 = BD
      when "1011011000110" =>  data <= "00100000";  -- 76C6 = 20
      when "1011011000111" =>  data <= "00101101";  -- 76C7 = 2D
      when "1011011001000" =>  data <= "11001001";  -- 76C8 = C9
      when "1011011001001" =>  data <= "01101100";  -- 76C9 = 6C
      when "1011011001010" =>  data <= "00010001";  -- 76CA = 11
      when "1011011001011" =>  data <= "00000000";  -- 76CB = 0
      when "1011011001100" =>  data <= "10100101";  -- 76CC = A5
      when "1011011001101" =>  data <= "00101010";  -- 76CD = 2A
      when "1011011001110" =>  data <= "10000101";  -- 76CE = 85
      when "1011011001111" =>  data <= "11001001";  -- 76CF = C9
      when "1011011010000" =>  data <= "10100101";  -- 76D0 = A5
      when "1011011010001" =>  data <= "00101011";  -- 76D1 = 2B
      when "1011011010010" =>  data <= "10000101";  -- 76D2 = 85
      when "1011011010011" =>  data <= "11001010";  -- 76D3 = CA
      when "1011011010100" =>  data <= "10100101";  -- 76D4 = A5
      when "1011011010101" =>  data <= "00101001";  -- 76D5 = 29
      when "1011011010110" =>  data <= "10000101";  -- 76D6 = 85
      when "1011011010111" =>  data <= "11111100";  -- 76D7 = FC
      when "1011011011000" =>  data <= "10100101";  -- 76D8 = A5
      when "1011011011001" =>  data <= "00101000";  -- 76D9 = 28
      when "1011011011010" =>  data <= "10000101";  -- 76DA = 85
      when "1011011011011" =>  data <= "11111011";  -- 76DB = FB
      when "1011011011100" =>  data <= "01100000";  -- 76DC = 60
      when "1011011011101" =>  data <= "00100000";  -- 76DD = 20
      when "1011011011110" =>  data <= "01111101";  -- 76DE = 7D
      when "1011011011111" =>  data <= "11110100";  -- 76DF = F4
      when "1011011100000" =>  data <= "00100000";  -- 76E0 = 20
      when "1011011100001" =>  data <= "11001100";  -- 76E1 = CC
      when "1011011100010" =>  data <= "11110110";  -- 76E2 = F6
      when "1011011100011" =>  data <= "10100101";  -- 76E3 = A5
      when "1011011100100" =>  data <= "11010100";  -- 76E4 = D4
      when "1011011100101" =>  data <= "11010000";  -- 76E5 = D0
      when "1011011100110" =>  data <= "00000101";  -- 76E6 = 5
      when "1011011100111" =>  data <= "10100000";  -- 76E7 = A0
      when "1011011101000" =>  data <= "01110100";  -- 76E8 = 74
      when "1011011101001" =>  data <= "01001100";  -- 76E9 = 4C
      when "1011011101010" =>  data <= "10101111";  -- 76EA = AF
      when "1011011101011" =>  data <= "11110101";  -- 76EB = F5
      when "1011011101100" =>  data <= "11001001";  -- 76EC = C9
      when "1011011101101" =>  data <= "00000011";  -- 76ED = 3
      when "1011011101110" =>  data <= "11110000";  -- 76EE = F0
      when "1011011101111" =>  data <= "11110111";  -- 76EF = F7
      when "1011011110000" =>  data <= "10010000";  -- 76F0 = 90
      when "1011011110001" =>  data <= "01010000";  -- 76F1 = 50
      when "1011011110010" =>  data <= "10101001";  -- 76F2 = A9
      when "1011011110011" =>  data <= "01100001";  -- 76F3 = 61
      when "1011011110100" =>  data <= "10000101";  -- 76F4 = 85
      when "1011011110101" =>  data <= "11010011";  -- 76F5 = D3
      when "1011011110110" =>  data <= "10100100";  -- 76F6 = A4
      when "1011011110111" =>  data <= "11010001";  -- 76F7 = D1
      when "1011011111000" =>  data <= "11010000";  -- 76F8 = D0
      when "1011011111001" =>  data <= "00000011";  -- 76F9 = 3
      when "1011011111010" =>  data <= "01001100";  -- 76FA = 4C
      when "1011011111011" =>  data <= "00000000";  -- 76FB = 0
      when "1011011111100" =>  data <= "10111111";  -- 76FC = BF
      when "1011011111101" =>  data <= "00100000";  -- 76FD = 20
      when "1011011111110" =>  data <= "10100101";  -- 76FE = A5
      when "1011011111111" =>  data <= "11110100";  -- 76FF = F4
      when "1011100000000" =>  data <= "00100000";  -- 7700 = 20
      when "1011100000001" =>  data <= "11010101";  -- 7701 = D5
      when "1011100000010" =>  data <= "11110000";  -- 7702 = F0
      when "1011100000011" =>  data <= "10100101";  -- 7703 = A5
      when "1011100000100" =>  data <= "11010011";  -- 7704 = D3
      when "1011100000101" =>  data <= "00100000";  -- 7705 = 20
      when "1011100000110" =>  data <= "01000011";  -- 7706 = 43
      when "1011100000111" =>  data <= "11110001";  -- 7707 = F1
      when "1011100001000" =>  data <= "10100000";  -- 7708 = A0
      when "1011100001001" =>  data <= "00000000";  -- 7709 = 0
      when "1011100001010" =>  data <= "00100000";  -- 770A = 20
      when "1011100001011" =>  data <= "10111011";  -- 770B = BB
      when "1011100001100" =>  data <= "11111011";  -- 770C = FB
      when "1011100001101" =>  data <= "10100101";  -- 770D = A5
      when "1011100001110" =>  data <= "11000111";  -- 770E = C7
      when "1011100001111" =>  data <= "00100000";  -- 770F = 20
      when "1011100010000" =>  data <= "10011110";  -- 7710 = 9E
      when "1011100010001" =>  data <= "11110001";  -- 7711 = F1
      when "1011100010010" =>  data <= "10100101";  -- 7712 = A5
      when "1011100010011" =>  data <= "11001000";  -- 7713 = C8
      when "1011100010100" =>  data <= "00100000";  -- 7714 = 20
      when "1011100010101" =>  data <= "10011110";  -- 7715 = 9E
      when "1011100010110" =>  data <= "11110001";  -- 7716 = F1
      when "1011100010111" =>  data <= "00100000";  -- 7717 = 20
      when "1011100011000" =>  data <= "00001011";  -- 7718 = B
      when "1011100011001" =>  data <= "11111101";  -- 7719 = FD
      when "1011100011010" =>  data <= "11110000";  -- 771A = F0
      when "1011100011011" =>  data <= "00010000";  -- 771B = 10
      when "1011100011100" =>  data <= "10110001";  -- 771C = B1
      when "1011100011101" =>  data <= "11000111";  -- 771D = C7
      when "1011100011110" =>  data <= "00100000";  -- 771E = 20
      when "1011100011111" =>  data <= "10011110";  -- 771F = 9E
      when "1011100100000" =>  data <= "11110001";  -- 7720 = F1
      when "1011100100001" =>  data <= "00100000";  -- 7721 = 20
      when "1011100100010" =>  data <= "01000011";  -- 7722 = 43
      when "1011100100011" =>  data <= "11110011";  -- 7723 = F3
      when "1011100100100" =>  data <= "11100110";  -- 7724 = E6
      when "1011100100101" =>  data <= "11000111";  -- 7725 = C7
      when "1011100100110" =>  data <= "11010000";  -- 7726 = D0
      when "1011100100111" =>  data <= "11101111";  -- 7727 = EF
      when "1011100101000" =>  data <= "11100110";  -- 7728 = E6
      when "1011100101001" =>  data <= "11001000";  -- 7729 = C8
      when "1011100101010" =>  data <= "11010000";  -- 772A = D0
      when "1011100101011" =>  data <= "11101011";  -- 772B = EB
      when "1011100101100" =>  data <= "00100000";  -- 772C = 20
      when "1011100101101" =>  data <= "10111001";  -- 772D = B9
      when "1011100101110" =>  data <= "11110001";  -- 772E = F1
      when "1011100101111" =>  data <= "00100100";  -- 772F = 24
      when "1011100110000" =>  data <= "11010011";  -- 7730 = D3
      when "1011100110001" =>  data <= "00110000";  -- 7731 = 30
      when "1011100110010" =>  data <= "01111000";  -- 7732 = 78
      when "1011100110011" =>  data <= "00100000";  -- 7733 = 20
      when "1011100110100" =>  data <= "11010101";  -- 7734 = D5
      when "1011100110101" =>  data <= "11110000";  -- 7735 = F0
      when "1011100110110" =>  data <= "10100101";  -- 7736 = A5
      when "1011100110111" =>  data <= "11010011";  -- 7737 = D3
      when "1011100111000" =>  data <= "00101001";  -- 7738 = 29
      when "1011100111001" =>  data <= "11101111";  -- 7739 = EF
      when "1011100111010" =>  data <= "00001001";  -- 773A = 9
      when "1011100111011" =>  data <= "11100000";  -- 773B = E0
      when "1011100111100" =>  data <= "00100000";  -- 773C = 20
      when "1011100111101" =>  data <= "01000011";  -- 773D = 43
      when "1011100111110" =>  data <= "11110001";  -- 773E = F1
      when "1011100111111" =>  data <= "01001100";  -- 773F = 4C
      when "1011101000000" =>  data <= "10111001";  -- 7740 = B9
      when "1011101000001" =>  data <= "11110001";  -- 7741 = F1
      when "1011101000010" =>  data <= "00100000";  -- 7742 = 20
      when "1011101000011" =>  data <= "10010101";  -- 7743 = 95
      when "1011101000100" =>  data <= "11110110";  -- 7744 = F6
      when "1011101000101" =>  data <= "00100000";  -- 7745 = 20
      when "1011101000110" =>  data <= "10001100";  -- 7746 = 8C
      when "1011101000111" =>  data <= "11111000";  -- 7747 = F8
      when "1011101001000" =>  data <= "00100000";  -- 7748 = 20
      when "1011101001001" =>  data <= "01010001";  -- 7749 = 51
      when "1011101001010" =>  data <= "11110011";  -- 774A = F3
      when "1011101001011" =>  data <= "11010000";  -- 774B = D0
      when "1011101001100" =>  data <= "00001000";  -- 774C = 8
      when "1011101001101" =>  data <= "10100000";  -- 774D = A0
      when "1011101001110" =>  data <= "01100100";  -- 774E = 64
      when "1011101001111" =>  data <= "00100000";  -- 774F = 20
      when "1011101010000" =>  data <= "10000101";  -- 7750 = 85
      when "1011101010001" =>  data <= "11110001";  -- 7751 = F1
      when "1011101010010" =>  data <= "00100000";  -- 7752 = 20
      when "1011101010011" =>  data <= "01011100";  -- 7753 = 5C
      when "1011101010100" =>  data <= "11110100";  -- 7754 = F4
      when "1011101010101" =>  data <= "10101001";  -- 7755 = A9
      when "1011101010110" =>  data <= "00000001";  -- 7756 = 1
      when "1011101010111" =>  data <= "00100000";  -- 7757 = 20
      when "1011101011000" =>  data <= "00011001";  -- 7758 = 19
      when "1011101011001" =>  data <= "11110110";  -- 7759 = F6
      when "1011101011010" =>  data <= "00100000";  -- 775A = 20
      when "1011101011011" =>  data <= "11001110";  -- 775B = CE
      when "1011101011100" =>  data <= "11111000";  -- 775C = F8
      when "1011101011101" =>  data <= "10100101";  -- 775D = A5
      when "1011101011110" =>  data <= "11010011";  -- 775E = D3
      when "1011101011111" =>  data <= "00101001";  -- 775F = 29
      when "1011101100000" =>  data <= "00000010";  -- 7760 = 2
      when "1011101100001" =>  data <= "11110000";  -- 7761 = F0
      when "1011101100010" =>  data <= "01001000";  -- 7762 = 48
      when "1011101100011" =>  data <= "10101001";  -- 7763 = A9
      when "1011101100100" =>  data <= "00000101";  -- 7764 = 5
      when "1011101100101" =>  data <= "01001100";  -- 7765 = 4C
      when "1011101100110" =>  data <= "00011001";  -- 7766 = 19
      when "1011101100111" =>  data <= "11110110";  -- 7767 = F6
      when "1011101101000" =>  data <= "11100110";  -- 7768 = E6
      when "1011101101001" =>  data <= "10011001";  -- 7769 = 99
      when "1011101101010" =>  data <= "10100101";  -- 776A = A5
      when "1011101101011" =>  data <= "10011001";  -- 776B = 99
      when "1011101101100" =>  data <= "11010000";  -- 776C = D0
      when "1011101101101" =>  data <= "00000010";  -- 776D = 2
      when "1011101101110" =>  data <= "11100110";  -- 776E = E6
      when "1011101101111" =>  data <= "10011010";  -- 776F = 9A
      when "1011101110000" =>  data <= "11001001";  -- 7770 = C9
      when "1011101110001" =>  data <= "01101111";  -- 7771 = 6F
      when "1011101110010" =>  data <= "11010000";  -- 7772 = D0
      when "1011101110011" =>  data <= "00000110";  -- 7773 = 6
      when "1011101110100" =>  data <= "10100101";  -- 7774 = A5
      when "1011101110101" =>  data <= "10011010";  -- 7775 = 9A
      when "1011101110110" =>  data <= "11001001";  -- 7776 = C9
      when "1011101110111" =>  data <= "00000010";  -- 7777 = 2
      when "1011101111000" =>  data <= "11110000";  -- 7778 = F0
      when "1011101111001" =>  data <= "00100001";  -- 7779 = 21
      when "1011101111010" =>  data <= "11100110";  -- 777A = E6
      when "1011101111011" =>  data <= "10001111";  -- 777B = 8F
      when "1011101111100" =>  data <= "11010000";  -- 777C = D0
      when "1011101111101" =>  data <= "00000110";  -- 777D = 6
      when "1011101111110" =>  data <= "11100110";  -- 777E = E6
      when "1011101111111" =>  data <= "10001110";  -- 777F = 8E
      when "1011110000000" =>  data <= "11010000";  -- 7780 = D0
      when "1011110000001" =>  data <= "00000010";  -- 7781 = 2
      when "1011110000010" =>  data <= "11100110";  -- 7782 = E6
      when "1011110000011" =>  data <= "10001101";  -- 7783 = 8D
      when "1011110000100" =>  data <= "10100010";  -- 7784 = A2
      when "1011110000101" =>  data <= "00000000";  -- 7785 = 0
      when "1011110000110" =>  data <= "10110101";  -- 7786 = B5
      when "1011110000111" =>  data <= "10001101";  -- 7787 = 8D
      when "1011110001000" =>  data <= "11011101";  -- 7788 = DD
      when "1011110001001" =>  data <= "10101100";  -- 7789 = AC
      when "1011110001010" =>  data <= "11110111";  -- 778A = F7
      when "1011110001011" =>  data <= "10010000";  -- 778B = 90
      when "1011110001100" =>  data <= "00010100";  -- 778C = 14
      when "1011110001101" =>  data <= "11101000";  -- 778D = E8
      when "1011110001110" =>  data <= "11100000";  -- 778E = E0
      when "1011110001111" =>  data <= "00000011";  -- 778F = 3
      when "1011110010000" =>  data <= "11010000";  -- 7790 = D0
      when "1011110010001" =>  data <= "11110100";  -- 7791 = F4
      when "1011110010010" =>  data <= "10101001";  -- 7792 = A9
      when "1011110010011" =>  data <= "00000000";  -- 7793 = 0
      when "1011110010100" =>  data <= "10010101";  -- 7794 = 95
      when "1011110010101" =>  data <= "10001100";  -- 7795 = 8C
      when "1011110010110" =>  data <= "11001010";  -- 7796 = CA
      when "1011110010111" =>  data <= "11010000";  -- 7797 = D0
      when "1011110011000" =>  data <= "11111011";  -- 7798 = FB
      when "1011110011001" =>  data <= "11110000";  -- 7799 = F0
      when "1011110011010" =>  data <= "00000110";  -- 779A = 6
      when "1011110011011" =>  data <= "10101001";  -- 779B = A9
      when "1011110011100" =>  data <= "00000000";  -- 779C = 0
      when "1011110011101" =>  data <= "10000101";  -- 779D = 85
      when "1011110011110" =>  data <= "10011001";  -- 779E = 99
      when "1011110011111" =>  data <= "10000101";  -- 779F = 85
      when "1011110100000" =>  data <= "10011010";  -- 77A0 = 9A
      when "1011110100001" =>  data <= "10101101";  -- 77A1 = AD
      when "1011110100010" =>  data <= "00010010";  -- 77A2 = 12
      when "1011110100011" =>  data <= "11101000";  -- 77A3 = E8
      when "1011110100100" =>  data <= "11001101";  -- 77A4 = CD
      when "1011110100101" =>  data <= "00010010";  -- 77A5 = 12
      when "1011110100110" =>  data <= "11101000";  -- 77A6 = E8
      when "1011110100111" =>  data <= "11010000";  -- 77A7 = D0
      when "1011110101000" =>  data <= "11111000";  -- 77A8 = F8
      when "1011110101001" =>  data <= "10000101";  -- 77A9 = 85
      when "1011110101010" =>  data <= "10011011";  -- 77AA = 9B
      when "1011110101011" =>  data <= "01100000";  -- 77AB = 60
      when "1011110101100" =>  data <= "01001111";  -- 77AC = 4F
      when "1011110101101" =>  data <= "00011010";  -- 77AD = 1A
      when "1011110101110" =>  data <= "00000001";  -- 77AE = 1
      when "1011110101111" =>  data <= "01001000";  -- 77AF = 48
      when "1011110110000" =>  data <= "10001010";  -- 77B0 = 8A
      when "1011110110001" =>  data <= "01001000";  -- 77B1 = 48
      when "1011110110010" =>  data <= "10011000";  -- 77B2 = 98
      when "1011110110011" =>  data <= "01001000";  -- 77B3 = 48
      when "1011110110100" =>  data <= "10101001";  -- 77B4 = A9
      when "1011110110101" =>  data <= "00000000";  -- 77B5 = 0
      when "1011110110110" =>  data <= "10000101";  -- 77B6 = 85
      when "1011110110111" =>  data <= "10010110";  -- 77B7 = 96
      when "1011110111000" =>  data <= "10001010";  -- 77B8 = 8A
      when "1011110111001" =>  data <= "00100000";  -- 77B9 = 20
      when "1011110111010" =>  data <= "11000001";  -- 77BA = C1
      when "1011110111011" =>  data <= "11110010";  -- 77BB = F2
      when "1011110111100" =>  data <= "11110000";  -- 77BC = F0
      when "1011110111101" =>  data <= "00000101";  -- 77BD = 5
      when "1011110111110" =>  data <= "10100000";  -- 77BE = A0
      when "1011110111111" =>  data <= "00010111";  -- 77BF = 17
      when "1011111000000" =>  data <= "01001100";  -- 77C0 = 4C
      when "1011111000001" =>  data <= "10101111";  -- 77C1 = AF
      when "1011111000010" =>  data <= "11110101";  -- 77C2 = F5
      when "1011111000011" =>  data <= "00100000";  -- 77C3 = 20
      when "1011111000100" =>  data <= "11001101";  -- 77C4 = CD
      when "1011111000101" =>  data <= "11110010";  -- 77C5 = F2
      when "1011111000110" =>  data <= "10100101";  -- 77C6 = A5
      when "1011111000111" =>  data <= "11010100";  -- 77C7 = D4
      when "1011111001000" =>  data <= "11110000";  -- 77C8 = F0
      when "1011111001001" =>  data <= "00010000";  -- 77C9 = 10
      when "1011111001010" =>  data <= "11001001";  -- 77CA = C9
      when "1011111001011" =>  data <= "00000011";  -- 77CB = 3
      when "1011111001100" =>  data <= "11110000";  -- 77CC = F0
      when "1011111001101" =>  data <= "00001100";  -- 77CD = C
      when "1011111001110" =>  data <= "10110000";  -- 77CE = B0
      when "1011111001111" =>  data <= "00001111";  -- 77CF = F
      when "1011111010000" =>  data <= "10100110";  -- 77D0 = A6
      when "1011111010001" =>  data <= "11010011";  -- 77D1 = D3
      when "1011111010010" =>  data <= "11100000";  -- 77D2 = E0
      when "1011111010011" =>  data <= "01100000";  -- 77D3 = 60
      when "1011111010100" =>  data <= "11110000";  -- 77D4 = F0
      when "1011111010101" =>  data <= "00000100";  -- 77D5 = 4
      when "1011111010110" =>  data <= "10100000";  -- 77D6 = A0
      when "1011111010111" =>  data <= "10000110";  -- 77D7 = 86
      when "1011111011000" =>  data <= "11010000";  -- 77D8 = D0
      when "1011111011001" =>  data <= "11100110";  -- 77D9 = E6
      when "1011111011010" =>  data <= "10000101";  -- 77DA = 85
      when "1011111011011" =>  data <= "10101111";  -- 77DB = AF
      when "1011111011100" =>  data <= "01001100";  -- 77DC = 4C
      when "1011111011101" =>  data <= "10011100";  -- 77DD = 9C
      when "1011111011110" =>  data <= "11110010";  -- 77DE = F2
      when "1011111011111" =>  data <= "01001000";  -- 77DF = 48
      when "1011111100000" =>  data <= "00100000";  -- 77E0 = 20
      when "1011111100001" =>  data <= "11100001";  -- 77E1 = E1
      when "1011111100010" =>  data <= "11011011";  -- 77E2 = DB
      when "1011111100011" =>  data <= "00100000";  -- 77E3 = 20
      when "1011111100100" =>  data <= "11010010";  -- 77E4 = D2
      when "1011111100101" =>  data <= "11110000";  -- 77E5 = F0
      when "1011111100110" =>  data <= "10100101";  -- 77E6 = A5
      when "1011111100111" =>  data <= "11010011";  -- 77E7 = D3
      when "1011111101000" =>  data <= "00010000";  -- 77E8 = 10
      when "1011111101001" =>  data <= "00000110";  -- 77E9 = 6
      when "1011111101010" =>  data <= "00100000";  -- 77EA = 20
      when "1011111101011" =>  data <= "10011000";  -- 77EB = 98
      when "1011111101100" =>  data <= "11110001";  -- 77EC = F1
      when "1011111101101" =>  data <= "01001100";  -- 77ED = 4C
      when "1011111101110" =>  data <= "11110011";  -- 77EE = F3
      when "1011111101111" =>  data <= "11110111";  -- 77EF = F7
      when "1011111110000" =>  data <= "00100000";  -- 77F0 = 20
      when "1011111110001" =>  data <= "10010011";  -- 77F1 = 93
      when "1011111110010" =>  data <= "11110001";  -- 77F2 = F1
      when "1011111110011" =>  data <= "10100101";  -- 77F3 = A5
      when "1011111110100" =>  data <= "10010110";  -- 77F4 = 96
      when "1011111110101" =>  data <= "00010000";  -- 77F5 = 10
      when "1011111110110" =>  data <= "00000011";  -- 77F6 = 3
      when "1011111110111" =>  data <= "01001100";  -- 77F7 = 4C
      when "1011111111000" =>  data <= "10111011";  -- 77F8 = BB
      when "1011111111001" =>  data <= "11110100";  -- 77F9 = F4
      when "1011111111010" =>  data <= "01101000";  -- 77FA = 68
      when "1011111111011" =>  data <= "01001100";  -- 77FB = 4C
      when "1011111111100" =>  data <= "11011010";  -- 77FC = DA
      when "1011111111101" =>  data <= "11110111";  -- 77FD = F7
      when "1011111111110" =>  data <= "01001000";  -- 77FE = 48
      when "1011111111111" =>  data <= "10001010";  -- 77FF = 8A
      when "1100000000000" =>  data <= "01001000";  -- 7800 = 48
      when "1100000000001" =>  data <= "10011000";  -- 7801 = 98
      when "1100000000010" =>  data <= "01001000";  -- 7802 = 48
      when "1100000000011" =>  data <= "10101001";  -- 7803 = A9
      when "1100000000100" =>  data <= "00000000";  -- 7804 = 0
      when "1100000000101" =>  data <= "10000101";  -- 7805 = 85
      when "1100000000110" =>  data <= "10010110";  -- 7806 = 96
      when "1100000000111" =>  data <= "10001010";  -- 7807 = 8A
      when "1100000001000" =>  data <= "00100000";  -- 7808 = 20
      when "1100000001001" =>  data <= "11000001";  -- 7809 = C1
      when "1100000001010" =>  data <= "11110010";  -- 780A = F2
      when "1100000001011" =>  data <= "11010000";  -- 780B = D0
      when "1100000001100" =>  data <= "10110001";  -- 780C = B1
      when "1100000001101" =>  data <= "00100000";  -- 780D = 20
      when "1100000001110" =>  data <= "11001101";  -- 780E = CD
      when "1100000001111" =>  data <= "11110010";  -- 780F = F2
      when "1100000010000" =>  data <= "10100101";  -- 7810 = A5
      when "1100000010001" =>  data <= "11010100";  -- 7811 = D4
      when "1100000010010" =>  data <= "11010000";  -- 7812 = D0
      when "1100000010011" =>  data <= "00000100";  -- 7813 = 4
      when "1100000010100" =>  data <= "10100000";  -- 7814 = A0
      when "1100000010101" =>  data <= "10010100";  -- 7815 = 94
      when "1100000010110" =>  data <= "11010000";  -- 7816 = D0
      when "1100000010111" =>  data <= "10101000";  -- 7817 = A8
      when "1100000011000" =>  data <= "11001001";  -- 7818 = C9
      when "1100000011001" =>  data <= "00000011";  -- 7819 = 3
      when "1100000011010" =>  data <= "11110000";  -- 781A = F0
      when "1100000011011" =>  data <= "00001100";  -- 781B = C
      when "1100000011100" =>  data <= "10110000";  -- 781C = B0
      when "1100000011101" =>  data <= "00001111";  -- 781D = F
      when "1100000011110" =>  data <= "10100110";  -- 781E = A6
      when "1100000011111" =>  data <= "11010011";  -- 781F = D3
      when "1100000100000" =>  data <= "11100000";  -- 7820 = E0
      when "1100000100001" =>  data <= "01100000";  -- 7821 = 60
      when "1100000100010" =>  data <= "11010000";  -- 7822 = D0
      when "1100000100011" =>  data <= "00000100";  -- 7823 = 4
      when "1100000100100" =>  data <= "10100000";  -- 7824 = A0
      when "1100000100101" =>  data <= "10010100";  -- 7825 = 94
      when "1100000100110" =>  data <= "11010000";  -- 7826 = D0
      when "1100000100111" =>  data <= "10011000";  -- 7827 = 98
      when "1100000101000" =>  data <= "10000101";  -- 7828 = 85
      when "1100000101001" =>  data <= "10110000";  -- 7829 = B0
      when "1100000101010" =>  data <= "01001100";  -- 782A = 4C
      when "1100000101011" =>  data <= "10011100";  -- 782B = 9C
      when "1100000101100" =>  data <= "11110010";  -- 782C = F2
      when "1100000101101" =>  data <= "01001000";  -- 782D = 48
      when "1100000101110" =>  data <= "00100000";  -- 782E = 20
      when "1100000101111" =>  data <= "11100001";  -- 782F = E1
      when "1100000110000" =>  data <= "11011011";  -- 7830 = DB
      when "1100000110001" =>  data <= "00100000";  -- 7831 = 20
      when "1100000110010" =>  data <= "11010101";  -- 7832 = D5
      when "1100000110011" =>  data <= "11110000";  -- 7833 = F0
      when "1100000110100" =>  data <= "10100101";  -- 7834 = A5
      when "1100000110101" =>  data <= "11010011";  -- 7835 = D3
      when "1100000110110" =>  data <= "00010000";  -- 7836 = 10
      when "1100000110111" =>  data <= "00000101";  -- 7837 = 5
      when "1100000111000" =>  data <= "00100000";  -- 7838 = 20
      when "1100000111001" =>  data <= "01001000";  -- 7839 = 48
      when "1100000111010" =>  data <= "11110001";  -- 783A = F1
      when "1100000111011" =>  data <= "11010000";  -- 783B = D0
      when "1100000111100" =>  data <= "00000011";  -- 783C = 3
      when "1100000111101" =>  data <= "00100000";  -- 783D = 20
      when "1100000111110" =>  data <= "01000011";  -- 783E = 43
      when "1100000111111" =>  data <= "11110001";  -- 783F = F1
      when "1100001000000" =>  data <= "10100101";  -- 7840 = A5
      when "1100001000001" =>  data <= "10010110";  -- 7841 = 96
      when "1100001000010" =>  data <= "00010000";  -- 7842 = 10
      when "1100001000011" =>  data <= "00000011";  -- 7843 = 3
      when "1100001000100" =>  data <= "01001100";  -- 7844 = 4C
      when "1100001000101" =>  data <= "10111011";  -- 7845 = BB
      when "1100001000110" =>  data <= "11110100";  -- 7846 = F4
      when "1100001000111" =>  data <= "01101000";  -- 7847 = 68
      when "1100001001000" =>  data <= "01001100";  -- 7848 = 4C
      when "1100001001001" =>  data <= "00101000";  -- 7849 = 28
      when "1100001001010" =>  data <= "11111000";  -- 784A = F8
      when "1100001001011" =>  data <= "00100000";  -- 784B = 20
      when "1100001001100" =>  data <= "10010101";  -- 784C = 95
      when "1100001001101" =>  data <= "11110110";  -- 784D = F6
      when "1100001001110" =>  data <= "10100110";  -- 784E = A6
      when "1100001001111" =>  data <= "11010100";  -- 784F = D4
      when "1100001010000" =>  data <= "11110110";  -- 7850 = F6
      when "1100001010001" =>  data <= "10111010";  -- 7851 = BA
      when "1100001010010" =>  data <= "10110100";  -- 7852 = B4
      when "1100001010011" =>  data <= "10111010";  -- 7853 = BA
      when "1100001010100" =>  data <= "11000000";  -- 7854 = C0
      when "1100001010101" =>  data <= "11000000";  -- 7855 = C0
      when "1100001010110" =>  data <= "01100000";  -- 7856 = 60
      when "1100001010111" =>  data <= "00100000";  -- 7857 = 20
      when "1100001011000" =>  data <= "01111010";  -- 7858 = 7A
      when "1100001011001" =>  data <= "11111000";  -- 7859 = F8
      when "1100001011010" =>  data <= "11110000";  -- 785A = F0
      when "1100001011011" =>  data <= "00101111";  -- 785B = 2F
      when "1100001011100" =>  data <= "10100000";  -- 785C = A0
      when "1100001011101" =>  data <= "01000001";  -- 785D = 41
      when "1100001011110" =>  data <= "00100000";  -- 785E = 20
      when "1100001011111" =>  data <= "10000101";  -- 785F = 85
      when "1100001100000" =>  data <= "11110001";  -- 7860 = F1
      when "1100001100001" =>  data <= "10100000";  -- 7861 = A0
      when "1100001100010" =>  data <= "01010110";  -- 7862 = 56
      when "1100001100011" =>  data <= "00100000";  -- 7863 = 20
      when "1100001100100" =>  data <= "10000101";  -- 7864 = 85
      when "1100001100101" =>  data <= "11110001";  -- 7865 = F1
      when "1100001100110" =>  data <= "10100101";  -- 7866 = A5
      when "1100001100111" =>  data <= "11010100";  -- 7867 = D4
      when "1100001101000" =>  data <= "00001001";  -- 7868 = 9
      when "1100001101001" =>  data <= "00110000";  -- 7869 = 30
      when "1100001101010" =>  data <= "00100000";  -- 786A = 20
      when "1100001101011" =>  data <= "00000010";  -- 786B = 2
      when "1100001101100" =>  data <= "11100010";  -- 786C = E2
      when "1100001101101" =>  data <= "00100000";  -- 786D = 20
      when "1100001101110" =>  data <= "00110101";  -- 786E = 35
      when "1100001101111" =>  data <= "11111001";  -- 786F = F9
      when "1100001110000" =>  data <= "00100000";  -- 7870 = 20
      when "1100001110001" =>  data <= "01111010";  -- 7871 = 7A
      when "1100001110010" =>  data <= "11111000";  -- 7872 = F8
      when "1100001110011" =>  data <= "11010000";  -- 7873 = D0
      when "1100001110100" =>  data <= "11111000";  -- 7874 = F8
      when "1100001110101" =>  data <= "10100000";  -- 7875 = A0
      when "1100001110110" =>  data <= "10101010";  -- 7876 = AA
      when "1100001110111" =>  data <= "01001100";  -- 7877 = 4C
      when "1100001111000" =>  data <= "10000101";  -- 7878 = 85
      when "1100001111001" =>  data <= "11110001";  -- 7879 = F1
      when "1100001111010" =>  data <= "10101001";  -- 787A = A9
      when "1100001111011" =>  data <= "00010000";  -- 787B = 10
      when "1100001111100" =>  data <= "10100110";  -- 787C = A6
      when "1100001111101" =>  data <= "11010100";  -- 787D = D4
      when "1100001111110" =>  data <= "11001010";  -- 787E = CA
      when "1100001111111" =>  data <= "11110000";  -- 787F = F0
      when "1100010000000" =>  data <= "00000010";  -- 7880 = 2
      when "1100010000001" =>  data <= "10101001";  -- 7881 = A9
      when "1100010000010" =>  data <= "00100000";  -- 7882 = 20
      when "1100010000011" =>  data <= "00101100";  -- 7883 = 2C
      when "1100010000100" =>  data <= "00010000";  -- 7884 = 10
      when "1100010000101" =>  data <= "11101000";  -- 7885 = E8
      when "1100010000110" =>  data <= "11010000";  -- 7886 = D0
      when "1100010000111" =>  data <= "00000011";  -- 7887 = 3
      when "1100010001000" =>  data <= "00101100";  -- 7888 = 2C
      when "1100010001001" =>  data <= "00010000";  -- 7889 = 10
      when "1100010001010" =>  data <= "11101000";  -- 788A = E8
      when "1100010001011" =>  data <= "01100000";  -- 788B = 60
      when "1100010001100" =>  data <= "00100000";  -- 788C = 20
      when "1100010001101" =>  data <= "01111010";  -- 788D = 7A
      when "1100010001110" =>  data <= "11111000";  -- 788E = F8
      when "1100010001111" =>  data <= "11110000";  -- 788F = F0
      when "1100010010000" =>  data <= "11111010";  -- 7890 = FA
      when "1100010010001" =>  data <= "10100000";  -- 7891 = A0
      when "1100010010010" =>  data <= "01000001";  -- 7892 = 41
      when "1100010010011" =>  data <= "00100000";  -- 7893 = 20
      when "1100010010100" =>  data <= "10000101";  -- 7894 = 85
      when "1100010010101" =>  data <= "11110001";  -- 7895 = F1
      when "1100010010110" =>  data <= "10100000";  -- 7896 = A0
      when "1100010010111" =>  data <= "01001101";  -- 7897 = 4D
      when "1100010011000" =>  data <= "11010000";  -- 7898 = D0
      when "1100010011001" =>  data <= "11000100";  -- 7899 = C4
      when "1100010011010" =>  data <= "10101001";  -- 789A = A9
      when "1100010011011" =>  data <= "00000000";  -- 789B = 0
      when "1100010011100" =>  data <= "10000101";  -- 789C = 85
      when "1100010011101" =>  data <= "10010110";  -- 789D = 96
      when "1100010011110" =>  data <= "10000101";  -- 789E = 85
      when "1100010011111" =>  data <= "10011101";  -- 789F = 9D
      when "1100010100000" =>  data <= "00100000";  -- 78A0 = 20
      when "1100010100001" =>  data <= "10101011";  -- 78A1 = AB
      when "1100010100010" =>  data <= "11110110";  -- 78A2 = F6
      when "1100010100011" =>  data <= "00100000";  -- 78A3 = 20
      when "1100010100100" =>  data <= "00101011";  -- 78A4 = 2B
      when "1100010100101" =>  data <= "11111001";  -- 78A5 = F9
      when "1100010100110" =>  data <= "00100000";  -- 78A6 = 20
      when "1100010100111" =>  data <= "01010111";  -- 78A7 = 57
      when "1100010101000" =>  data <= "11111000";  -- 78A8 = F8
      when "1100010101001" =>  data <= "01111000";  -- 78A9 = 78
      when "1100010101010" =>  data <= "10101001";  -- 78AA = A9
      when "1100010101011" =>  data <= "00000000";  -- 78AB = 0
      when "1100010101100" =>  data <= "10000101";  -- 78AC = 85
      when "1100010101101" =>  data <= "11000010";  -- 78AD = C2
      when "1100010101110" =>  data <= "10000101";  -- 78AE = 85
      when "1100010101111" =>  data <= "11001110";  -- 78AF = CE
      when "1100010110000" =>  data <= "10000101";  -- 78B0 = 85
      when "1100010110001" =>  data <= "11001011";  -- 78B1 = CB
      when "1100010110010" =>  data <= "10000101";  -- 78B2 = 85
      when "1100010110011" =>  data <= "11000000";  -- 78B3 = C0
      when "1100010110100" =>  data <= "10000101";  -- 78B4 = 85
      when "1100010110101" =>  data <= "11000001";  -- 78B5 = C1
      when "1100010110110" =>  data <= "10000101";  -- 78B6 = 85
      when "1100010110111" =>  data <= "10110010";  -- 78B7 = B2
      when "1100010111000" =>  data <= "10100110";  -- 78B8 = A6
      when "1100010111001" =>  data <= "11010100";  -- 78B9 = D4
      when "1100010111010" =>  data <= "11001010";  -- 78BA = CA
      when "1100010111011" =>  data <= "11110000";  -- 78BB = F0
      when "1100010111100" =>  data <= "00000111";  -- 78BC = 7
      when "1100010111101" =>  data <= "10101001";  -- 78BD = A9
      when "1100010111110" =>  data <= "10010000";  -- 78BE = 90
      when "1100010111111" =>  data <= "10001101";  -- 78BF = 8D
      when "1100011000000" =>  data <= "01001110";  -- 78C0 = 4E
      when "1100011000001" =>  data <= "11101000";  -- 78C1 = E8
      when "1100011000010" =>  data <= "11010000";  -- 78C2 = D0
      when "1100011000011" =>  data <= "00000011";  -- 78C3 = 3
      when "1100011000100" =>  data <= "11101110";  -- 78C4 = EE
      when "1100011000101" =>  data <= "00010001";  -- 78C5 = 11
      when "1100011000110" =>  data <= "11101000";  -- 78C6 = E8
      when "1100011000111" =>  data <= "10100010";  -- 78C7 = A2
      when "1100011001000" =>  data <= "00001110";  -- 78C8 = E
      when "1100011001001" =>  data <= "11010000";  -- 78C9 = D0
      when "1100011001010" =>  data <= "00010101";  -- 78CA = 15
      when "1100011001011" =>  data <= "00100000";  -- 78CB = 20
      when "1100011001100" =>  data <= "10101011";  -- 78CC = AB
      when "1100011001101" =>  data <= "11110110";  -- 78CD = F6
      when "1100011001110" =>  data <= "00100000";  -- 78CE = 20
      when "1100011001111" =>  data <= "00101011";  -- 78CF = 2B
      when "1100011010000" =>  data <= "11111001";  -- 78D0 = F9
      when "1100011010001" =>  data <= "10101001";  -- 78D1 = A9
      when "1100011010010" =>  data <= "00010100";  -- 78D2 = 14
      when "1100011010011" =>  data <= "10000101";  -- 78D3 = 85
      when "1100011010100" =>  data <= "11000011";  -- 78D4 = C3
      when "1100011010101" =>  data <= "00100000";  -- 78D5 = 20
      when "1100011010110" =>  data <= "10001100";  -- 78D6 = 8C
      when "1100011010111" =>  data <= "11111000";  -- 78D7 = F8
      when "1100011011000" =>  data <= "01111000";  -- 78D8 = 78
      when "1100011011001" =>  data <= "10101001";  -- 78D9 = A9
      when "1100011011010" =>  data <= "10100000";  -- 78DA = A0
      when "1100011011011" =>  data <= "10001101";  -- 78DB = 8D
      when "1100011011100" =>  data <= "01001110";  -- 78DC = 4E
      when "1100011011101" =>  data <= "11101000";  -- 78DD = E8
      when "1100011011110" =>  data <= "10100010";  -- 78DE = A2
      when "1100011011111" =>  data <= "00001000";  -- 78DF = 8
      when "1100011100000" =>  data <= "00100000";  -- 78E0 = 20
      when "1100011100001" =>  data <= "11100000";  -- 78E1 = E0
      when "1100011100010" =>  data <= "11111100";  -- 78E2 = FC
      when "1100011100011" =>  data <= "10101001";  -- 78E3 = A9
      when "1100011100100" =>  data <= "00000010";  -- 78E4 = 2
      when "1100011100101" =>  data <= "10000101";  -- 78E5 = 85
      when "1100011100110" =>  data <= "11011110";  -- 78E6 = DE
      when "1100011100111" =>  data <= "00100000";  -- 78E7 = 20
      when "1100011101000" =>  data <= "11001001";  -- 78E8 = C9
      when "1100011101001" =>  data <= "11111011";  -- 78E9 = FB
      when "1100011101010" =>  data <= "11001110";  -- 78EA = CE
      when "1100011101011" =>  data <= "00010011";  -- 78EB = 13
      when "1100011101100" =>  data <= "11101000";  -- 78EC = E8
      when "1100011101101" =>  data <= "10100110";  -- 78ED = A6
      when "1100011101110" =>  data <= "11010100";  -- 78EE = D4
      when "1100011101111" =>  data <= "11001010";  -- 78EF = CA
      when "1100011110000" =>  data <= "11010000";  -- 78F0 = D0
      when "1100011110001" =>  data <= "00001001";  -- 78F1 = 9
      when "1100011110010" =>  data <= "10101001";  -- 78F2 = A9
      when "1100011110011" =>  data <= "00110100";  -- 78F3 = 34
      when "1100011110100" =>  data <= "10001101";  -- 78F4 = 8D
      when "1100011110101" =>  data <= "00010011";  -- 78F5 = 13
      when "1100011110110" =>  data <= "11101000";  -- 78F6 = E8
      when "1100011110111" =>  data <= "10000101";  -- 78F7 = 85
      when "1100011111000" =>  data <= "11111001";  -- 78F8 = F9
      when "1100011111001" =>  data <= "11010000";  -- 78F9 = D0
      when "1100011111010" =>  data <= "00001010";  -- 78FA = A
      when "1100011111011" =>  data <= "10101101";  -- 78FB = AD
      when "1100011111100" =>  data <= "01000000";  -- 78FC = 40
      when "1100011111101" =>  data <= "11101000";  -- 78FD = E8
      when "1100011111110" =>  data <= "10000110";  -- 78FE = 86
      when "1100011111111" =>  data <= "11111010";  -- 78FF = FA
      when "1100100000000" =>  data <= "00101001";  -- 7900 = 29
      when "1100100000001" =>  data <= "11101111";  -- 7901 = EF
      when "1100100000010" =>  data <= "10001101";  -- 7902 = 8D
      when "1100100000011" =>  data <= "01000000";  -- 7903 = 40
      when "1100100000100" =>  data <= "11101000";  -- 7904 = E8
      when "1100100000101" =>  data <= "10100010";  -- 7905 = A2
      when "1100100000110" =>  data <= "11111111";  -- 7906 = FF
      when "1100100000111" =>  data <= "10100000";  -- 7907 = A0
      when "1100100001000" =>  data <= "11111111";  -- 7908 = FF
      when "1100100001001" =>  data <= "10001000";  -- 7909 = 88
      when "1100100001010" =>  data <= "11010000";  -- 790A = D0
      when "1100100001011" =>  data <= "11111101";  -- 790B = FD
      when "1100100001100" =>  data <= "11001010";  -- 790C = CA
      when "1100100001101" =>  data <= "11010000";  -- 790D = D0
      when "1100100001110" =>  data <= "11111000";  -- 790E = F8
      when "1100100001111" =>  data <= "10001101";  -- 790F = 8D
      when "1100100010000" =>  data <= "01001001";  -- 7910 = 49
      when "1100100010001" =>  data <= "11101000";  -- 7911 = E8
      when "1100100010010" =>  data <= "01011000";  -- 7912 = 58
      when "1100100010011" =>  data <= "10101001";  -- 7913 = A9
      when "1100100010100" =>  data <= "11100100";  -- 7914 = E4
      when "1100100010101" =>  data <= "11000101";  -- 7915 = C5
      when "1100100010110" =>  data <= "10010001";  -- 7916 = 91
      when "1100100010111" =>  data <= "11110000";  -- 7917 = F0
      when "1100100011000" =>  data <= "00010001";  -- 7918 = 11
      when "1100100011001" =>  data <= "00100000";  -- 7919 = 20
      when "1100100011010" =>  data <= "00110101";  -- 791A = 35
      when "1100100011011" =>  data <= "11111001";  -- 791B = F9
      when "1100100011100" =>  data <= "00101100";  -- 791C = 2C
      when "1100100011101" =>  data <= "00010011";  -- 791D = 13
      when "1100100011110" =>  data <= "11101000";  -- 791E = E8
      when "1100100011111" =>  data <= "00010000";  -- 791F = 10
      when "1100100100000" =>  data <= "11110010";  -- 7920 = F2
      when "1100100100001" =>  data <= "00101100";  -- 7921 = 2C
      when "1100100100010" =>  data <= "00010010";  -- 7922 = 12
      when "1100100100011" =>  data <= "11101000";  -- 7923 = E8
      when "1100100100100" =>  data <= "00100000";  -- 7924 = 20
      when "1100100100101" =>  data <= "01101000";  -- 7925 = 68
      when "1100100100110" =>  data <= "11110111";  -- 7926 = F7
      when "1100100100111" =>  data <= "01001100";  -- 7927 = 4C
      when "1100100101000" =>  data <= "00010011";  -- 7928 = 13
      when "1100100101001" =>  data <= "11111001";  -- 7929 = F9
      when "1100100101010" =>  data <= "01100000";  -- 792A = 60
      when "1100100101011" =>  data <= "00100000";  -- 792B = 20
      when "1100100101100" =>  data <= "00110101";  -- 792C = 35
      when "1100100101101" =>  data <= "11111001";  -- 792D = F9
      when "1100100101110" =>  data <= "10101001";  -- 792E = A9
      when "1100100101111" =>  data <= "11100100";  -- 792F = E4
      when "1100100110000" =>  data <= "11000101";  -- 7930 = C5
      when "1100100110001" =>  data <= "10010001";  -- 7931 = 91
      when "1100100110010" =>  data <= "11010000";  -- 7932 = D0
      when "1100100110011" =>  data <= "11110111";  -- 7933 = F7
      when "1100100110100" =>  data <= "01100000";  -- 7934 = 60
      when "1100100110101" =>  data <= "00100000";  -- 7935 = 20
      when "1100100110110" =>  data <= "00110101";  -- 7936 = 35
      when "1100100110111" =>  data <= "11110011";  -- 7937 = F3
      when "1100100111000" =>  data <= "11010000";  -- 7938 = D0
      when "1100100111001" =>  data <= "00001000";  -- 7939 = 8
      when "1100100111010" =>  data <= "00100000";  -- 793A = 20
      when "1100100111011" =>  data <= "11000000";  -- 793B = C0
      when "1100100111100" =>  data <= "11111100";  -- 793C = FC
      when "1100100111101" =>  data <= "00100000";  -- 793D = 20
      when "1100100111110" =>  data <= "10111000";  -- 793E = B8
      when "1100100111111" =>  data <= "11110010";  -- 793F = F2
      when "1100101000000" =>  data <= "10000101";  -- 7940 = 85
      when "1100101000001" =>  data <= "00010000";  -- 7941 = 10
      when "1100101000010" =>  data <= "01001100";  -- 7942 = 4C
      when "1100101000011" =>  data <= "11000110";  -- 7943 = C6
      when "1100101000100" =>  data <= "10110111";  -- 7944 = B7
      when "1100101000101" =>  data <= "10000110";  -- 7945 = 86
      when "1100101000110" =>  data <= "11001100";  -- 7946 = CC
      when "1100101000111" =>  data <= "10100101";  -- 7947 = A5
      when "1100101001000" =>  data <= "11001011";  -- 7948 = CB
      when "1100101001001" =>  data <= "00001010";  -- 7949 = A
      when "1100101001010" =>  data <= "00001010";  -- 794A = A
      when "1100101001011" =>  data <= "00011000";  -- 794B = 18
      when "1100101001100" =>  data <= "01100101";  -- 794C = 65
      when "1100101001101" =>  data <= "11001011";  -- 794D = CB
      when "1100101001110" =>  data <= "00011000";  -- 794E = 18
      when "1100101001111" =>  data <= "01100101";  -- 794F = 65
      when "1100101010000" =>  data <= "11001100";  -- 7950 = CC
      when "1100101010001" =>  data <= "10000101";  -- 7951 = 85
      when "1100101010010" =>  data <= "11001100";  -- 7952 = CC
      when "1100101010011" =>  data <= "10101001";  -- 7953 = A9
      when "1100101010100" =>  data <= "00000000";  -- 7954 = 0
      when "1100101010101" =>  data <= "00100100";  -- 7955 = 24
      when "1100101010110" =>  data <= "11001011";  -- 7956 = CB
      when "1100101010111" =>  data <= "00110000";  -- 7957 = 30
      when "1100101011000" =>  data <= "00000001";  -- 7958 = 1
      when "1100101011001" =>  data <= "00101010";  -- 7959 = 2A
      when "1100101011010" =>  data <= "00000110";  -- 795A = 6
      when "1100101011011" =>  data <= "11001100";  -- 795B = CC
      when "1100101011100" =>  data <= "00101010";  -- 795C = 2A
      when "1100101011101" =>  data <= "00000110";  -- 795D = 6
      when "1100101011110" =>  data <= "11001100";  -- 795E = CC
      when "1100101011111" =>  data <= "00101010";  -- 795F = 2A
      when "1100101100000" =>  data <= "10101010";  -- 7960 = AA
      when "1100101100001" =>  data <= "10101101";  -- 7961 = AD
      when "1100101100010" =>  data <= "01001000";  -- 7962 = 48
      when "1100101100011" =>  data <= "11101000";  -- 7963 = E8
      when "1100101100100" =>  data <= "11001001";  -- 7964 = C9
      when "1100101100101" =>  data <= "00010101";  -- 7965 = 15
      when "1100101100110" =>  data <= "10010000";  -- 7966 = 90
      when "1100101100111" =>  data <= "11111001";  -- 7967 = F9
      when "1100101101000" =>  data <= "01100101";  -- 7968 = 65
      when "1100101101001" =>  data <= "11001100";  -- 7969 = CC
      when "1100101101010" =>  data <= "10001101";  -- 796A = 8D
      when "1100101101011" =>  data <= "01000100";  -- 796B = 44
      when "1100101101100" =>  data <= "11101000";  -- 796C = E8
      when "1100101101101" =>  data <= "10001010";  -- 796D = 8A
      when "1100101101110" =>  data <= "01101101";  -- 796E = 6D
      when "1100101101111" =>  data <= "01001001";  -- 796F = 49
      when "1100101110000" =>  data <= "11101000";  -- 7970 = E8
      when "1100101110001" =>  data <= "10001101";  -- 7971 = 8D
      when "1100101110010" =>  data <= "01000101";  -- 7972 = 45
      when "1100101110011" =>  data <= "11101000";  -- 7973 = E8
      when "1100101110100" =>  data <= "01011000";  -- 7974 = 58
      when "1100101110101" =>  data <= "01100000";  -- 7975 = 60
      when "1100101110110" =>  data <= "10101110";  -- 7976 = AE
      when "1100101110111" =>  data <= "01001001";  -- 7977 = 49
      when "1100101111000" =>  data <= "11101000";  -- 7978 = E8
      when "1100101111001" =>  data <= "10100000";  -- 7979 = A0
      when "1100101111010" =>  data <= "11111111";  -- 797A = FF
      when "1100101111011" =>  data <= "10011000";  -- 797B = 98
      when "1100101111100" =>  data <= "11101101";  -- 797C = ED
      when "1100101111101" =>  data <= "01001000";  -- 797D = 48
      when "1100101111110" =>  data <= "11101000";  -- 797E = E8
      when "1100101111111" =>  data <= "11101100";  -- 797F = EC
      when "1100110000000" =>  data <= "01001001";  -- 7980 = 49
      when "1100110000001" =>  data <= "11101000";  -- 7981 = E8
      when "1100110000010" =>  data <= "11010000";  -- 7982 = D0
      when "1100110000011" =>  data <= "11110010";  -- 7983 = F2
      when "1100110000100" =>  data <= "10000110";  -- 7984 = 86
      when "1100110000101" =>  data <= "11001100";  -- 7985 = CC
      when "1100110000110" =>  data <= "10101010";  -- 7986 = AA
      when "1100110000111" =>  data <= "10001100";  -- 7987 = 8C
      when "1100110001000" =>  data <= "01001000";  -- 7988 = 48
      when "1100110001001" =>  data <= "11101000";  -- 7989 = E8
      when "1100110001010" =>  data <= "10001100";  -- 798A = 8C
      when "1100110001011" =>  data <= "01001001";  -- 798B = 49
      when "1100110001100" =>  data <= "11101000";  -- 798C = E8
      when "1100110001101" =>  data <= "10011000";  -- 798D = 98
      when "1100110001110" =>  data <= "11100101";  -- 798E = E5
      when "1100110001111" =>  data <= "11001100";  -- 798F = CC
      when "1100110010000" =>  data <= "10000110";  -- 7990 = 86
      when "1100110010001" =>  data <= "11001100";  -- 7991 = CC
      when "1100110010010" =>  data <= "01001010";  -- 7992 = 4A
      when "1100110010011" =>  data <= "01100110";  -- 7993 = 66
      when "1100110010100" =>  data <= "11001100";  -- 7994 = CC
      when "1100110010101" =>  data <= "01001010";  -- 7995 = 4A
      when "1100110010110" =>  data <= "01100110";  -- 7996 = 66
      when "1100110010111" =>  data <= "11001100";  -- 7997 = CC
      when "1100110011000" =>  data <= "10100101";  -- 7998 = A5
      when "1100110011001" =>  data <= "11001011";  -- 7999 = CB
      when "1100110011010" =>  data <= "00011000";  -- 799A = 18
      when "1100110011011" =>  data <= "01101001";  -- 799B = 69
      when "1100110011100" =>  data <= "00111100";  -- 799C = 3C
      when "1100110011101" =>  data <= "00101100";  -- 799D = 2C
      when "1100110011110" =>  data <= "01000000";  -- 799E = 40
      when "1100110011111" =>  data <= "11101000";  -- 799F = E8
      when "1100110100000" =>  data <= "00101100";  -- 79A0 = 2C
      when "1100110100001" =>  data <= "00010000";  -- 79A1 = 10
      when "1100110100010" =>  data <= "11101000";  -- 79A2 = E8
      when "1100110100011" =>  data <= "11000101";  -- 79A3 = C5
      when "1100110100100" =>  data <= "11001100";  -- 79A4 = CC
      when "1100110100101" =>  data <= "10110000";  -- 79A5 = B0
      when "1100110100110" =>  data <= "01001010";  -- 79A6 = 4A
      when "1100110100111" =>  data <= "10100110";  -- 79A7 = A6
      when "1100110101000" =>  data <= "10110010";  -- 79A8 = B2
      when "1100110101001" =>  data <= "11110000";  -- 79A9 = F0
      when "1100110101010" =>  data <= "00000011";  -- 79AA = 3
      when "1100110101011" =>  data <= "01001100";  -- 79AB = 4C
      when "1100110101100" =>  data <= "10011100";  -- 79AC = 9C
      when "1100110101101" =>  data <= "11111010";  -- 79AD = FA
      when "1100110101110" =>  data <= "10100110";  -- 79AE = A6
      when "1100110101111" =>  data <= "10110111";  -- 79AF = B7
      when "1100110110000" =>  data <= "00110000";  -- 79B0 = 30
      when "1100110110001" =>  data <= "00011011";  -- 79B1 = 1B
      when "1100110110010" =>  data <= "10100010";  -- 79B2 = A2
      when "1100110110011" =>  data <= "00000000";  -- 79B3 = 0
      when "1100110110100" =>  data <= "01101001";  -- 79B4 = 69
      when "1100110110101" =>  data <= "00110000";  -- 79B5 = 30
      when "1100110110110" =>  data <= "01100101";  -- 79B6 = 65
      when "1100110110111" =>  data <= "11001011";  -- 79B7 = CB
      when "1100110111000" =>  data <= "11000101";  -- 79B8 = C5
      when "1100110111001" =>  data <= "11001100";  -- 79B9 = CC
      when "1100110111010" =>  data <= "10110000";  -- 79BA = B0
      when "1100110111011" =>  data <= "00011100";  -- 79BB = 1C
      when "1100110111100" =>  data <= "11101000";  -- 79BC = E8
      when "1100110111101" =>  data <= "01101001";  -- 79BD = 69
      when "1100110111110" =>  data <= "00100110";  -- 79BE = 26
      when "1100110111111" =>  data <= "01100101";  -- 79BF = 65
      when "1100111000000" =>  data <= "11001011";  -- 79C0 = CB
      when "1100111000001" =>  data <= "11000101";  -- 79C1 = C5
      when "1100111000010" =>  data <= "11001100";  -- 79C2 = CC
      when "1100111000011" =>  data <= "10110000";  -- 79C3 = B0
      when "1100111000100" =>  data <= "00010111";  -- 79C4 = 17
      when "1100111000101" =>  data <= "01101001";  -- 79C5 = 69
      when "1100111000110" =>  data <= "00101100";  -- 79C6 = 2C
      when "1100111000111" =>  data <= "01100101";  -- 79C7 = 65
      when "1100111001000" =>  data <= "11001011";  -- 79C8 = CB
      when "1100111001001" =>  data <= "11000101";  -- 79C9 = C5
      when "1100111001010" =>  data <= "11001100";  -- 79CA = CC
      when "1100111001011" =>  data <= "10010000";  -- 79CB = 90
      when "1100111001100" =>  data <= "00000011";  -- 79CC = 3
      when "1100111001101" =>  data <= "01001100";  -- 79CD = 4C
      when "1100111001110" =>  data <= "01001100";  -- 79CE = 4C
      when "1100111001111" =>  data <= "11111010";  -- 79CF = FA
      when "1100111010000" =>  data <= "10100101";  -- 79D0 = A5
      when "1100111010001" =>  data <= "11001110";  -- 79D1 = CE
      when "1100111010010" =>  data <= "11110000";  -- 79D2 = F0
      when "1100111010011" =>  data <= "00011101";  -- 79D3 = 1D
      when "1100111010100" =>  data <= "10000101";  -- 79D4 = 85
      when "1100111010101" =>  data <= "10111110";  -- 79D5 = BE
      when "1100111010110" =>  data <= "11010000";  -- 79D6 = D0
      when "1100111010111" =>  data <= "00011001";  -- 79D7 = 19
      when "1100111011000" =>  data <= "11100110";  -- 79D8 = E6
      when "1100111011001" =>  data <= "10111111";  -- 79D9 = BF
      when "1100111011010" =>  data <= "10110000";  -- 79DA = B0
      when "1100111011011" =>  data <= "00000010";  -- 79DB = 2
      when "1100111011100" =>  data <= "11000110";  -- 79DC = C6
      when "1100111011101" =>  data <= "10111111";  -- 79DD = BF
      when "1100111011110" =>  data <= "00111000";  -- 79DE = 38
      when "1100111011111" =>  data <= "11101001";  -- 79DF = E9
      when "1100111100000" =>  data <= "00010011";  -- 79E0 = 13
      when "1100111100001" =>  data <= "11100101";  -- 79E1 = E5
      when "1100111100010" =>  data <= "11001100";  -- 79E2 = CC
      when "1100111100011" =>  data <= "01100101";  -- 79E3 = 65
      when "1100111100100" =>  data <= "10011100";  -- 79E4 = 9C
      when "1100111100101" =>  data <= "10000101";  -- 79E5 = 85
      when "1100111100110" =>  data <= "10011100";  -- 79E6 = 9C
      when "1100111100111" =>  data <= "10100101";  -- 79E7 = A5
      when "1100111101000" =>  data <= "10111001";  -- 79E8 = B9
      when "1100111101001" =>  data <= "01001001";  -- 79E9 = 49
      when "1100111101010" =>  data <= "00000001";  -- 79EA = 1
      when "1100111101011" =>  data <= "10000101";  -- 79EB = 85
      when "1100111101100" =>  data <= "10111001";  -- 79EC = B9
      when "1100111101101" =>  data <= "11110000";  -- 79ED = F0
      when "1100111101110" =>  data <= "00100001";  -- 79EE = 21
      when "1100111101111" =>  data <= "10000110";  -- 79EF = 86
      when "1100111110000" =>  data <= "11011001";  -- 79F0 = D9
      when "1100111110001" =>  data <= "10100101";  -- 79F1 = A5
      when "1100111110010" =>  data <= "11001110";  -- 79F2 = CE
      when "1100111110011" =>  data <= "11110000";  -- 79F3 = F0
      when "1100111110100" =>  data <= "00011000";  -- 79F4 = 18
      when "1100111110101" =>  data <= "00101100";  -- 79F5 = 2C
      when "1100111110110" =>  data <= "01001101";  -- 79F6 = 4D
      when "1100111110111" =>  data <= "11101000";  -- 79F7 = E8
      when "1100111111000" =>  data <= "01010000";  -- 79F8 = 50
      when "1100111111001" =>  data <= "00010011";  -- 79F9 = 13
      when "1100111111010" =>  data <= "10101001";  -- 79FA = A9
      when "1100111111011" =>  data <= "00000000";  -- 79FB = 0
      when "1100111111100" =>  data <= "10000101";  -- 79FC = 85
      when "1100111111101" =>  data <= "10111001";  -- 79FD = B9
      when "1100111111110" =>  data <= "10100101";  -- 79FE = A5
      when "1100111111111" =>  data <= "10110111";  -- 79FF = B7
      when "1101000000000" =>  data <= "00010000";  -- 7A00 = 10
      when "1101000000001" =>  data <= "00110001";  -- 7A01 = 31
      when "1101000000010" =>  data <= "00110000";  -- 7A02 = 30
      when "1101000000011" =>  data <= "11001001";  -- 7A03 = C9
      when "1101000000100" =>  data <= "10100010";  -- 7A04 = A2
      when "1101000000101" =>  data <= "10100110";  -- 7A05 = A6
      when "1101000000110" =>  data <= "00100000";  -- 7A06 = 20
      when "1101000000111" =>  data <= "01000101";  -- 7A07 = 45
      when "1101000001000" =>  data <= "11111001";  -- 7A08 = F9
      when "1101000001001" =>  data <= "10100101";  -- 7A09 = A5
      when "1101000001010" =>  data <= "10110001";  -- 7A0A = B1
      when "1101000001011" =>  data <= "11010000";  -- 7A0B = D0
      when "1101000001100" =>  data <= "11000011";  -- 7A0C = C3
      when "1101000001101" =>  data <= "01001100";  -- 7A0D = 4C
      when "1101000001110" =>  data <= "00000000";  -- 7A0E = 0
      when "1101000001111" =>  data <= "11100110";  -- 7A0F = E6
      when "1101000010000" =>  data <= "10100101";  -- 7A10 = A5
      when "1101000010001" =>  data <= "10011100";  -- 7A11 = 9C
      when "1101000010010" =>  data <= "11110000";  -- 7A12 = F0
      when "1101000010011" =>  data <= "00001000";  -- 7A13 = 8
      when "1101000010100" =>  data <= "00110000";  -- 7A14 = 30
      when "1101000010101" =>  data <= "00000100";  -- 7A15 = 4
      when "1101000010110" =>  data <= "11000110";  -- 7A16 = C6
      when "1101000010111" =>  data <= "11001011";  -- 7A17 = CB
      when "1101000011000" =>  data <= "11000110";  -- 7A18 = C6
      when "1101000011001" =>  data <= "11001011";  -- 7A19 = CB
      when "1101000011010" =>  data <= "11100110";  -- 7A1A = E6
      when "1101000011011" =>  data <= "11001011";  -- 7A1B = CB
      when "1101000011100" =>  data <= "10101001";  -- 7A1C = A9
      when "1101000011101" =>  data <= "00000000";  -- 7A1D = 0
      when "1101000011110" =>  data <= "10000101";  -- 7A1E = 85
      when "1101000011111" =>  data <= "10011100";  -- 7A1F = 9C
      when "1101000100000" =>  data <= "11100100";  -- 7A20 = E4
      when "1101000100001" =>  data <= "11011001";  -- 7A21 = D9
      when "1101000100010" =>  data <= "11010000";  -- 7A22 = D0
      when "1101000100011" =>  data <= "00001111";  -- 7A23 = F
      when "1101000100100" =>  data <= "10001010";  -- 7A24 = 8A
      when "1101000100101" =>  data <= "11010000";  -- 7A25 = D0
      when "1101000100110" =>  data <= "10101001";  -- 7A26 = A9
      when "1101000100111" =>  data <= "10100101";  -- 7A27 = A5
      when "1101000101000" =>  data <= "10111111";  -- 7A28 = BF
      when "1101000101001" =>  data <= "00110000";  -- 7A29 = 30
      when "1101000101010" =>  data <= "11000110";  -- 7A2A = C6
      when "1101000101011" =>  data <= "11001001";  -- 7A2B = C9
      when "1101000101100" =>  data <= "00010000";  -- 7A2C = 10
      when "1101000101101" =>  data <= "10010000";  -- 7A2D = 90
      when "1101000101110" =>  data <= "11000010";  -- 7A2E = C2
      when "1101000101111" =>  data <= "10000101";  -- 7A2F = 85
      when "1101000110000" =>  data <= "10101011";  -- 7A30 = AB
      when "1101000110001" =>  data <= "10110000";  -- 7A31 = B0
      when "1101000110010" =>  data <= "10111110";  -- 7A32 = BE
      when "1101000110011" =>  data <= "10001010";  -- 7A33 = 8A
      when "1101000110100" =>  data <= "01000101";  -- 7A34 = 45
      when "1101000110101" =>  data <= "10110001";  -- 7A35 = B1
      when "1101000110110" =>  data <= "10000101";  -- 7A36 = 85
      when "1101000110111" =>  data <= "10110001";  -- 7A37 = B1
      when "1101000111000" =>  data <= "10100101";  -- 7A38 = A5
      when "1101000111001" =>  data <= "11001110";  -- 7A39 = CE
      when "1101000111010" =>  data <= "11110000";  -- 7A3A = F0
      when "1101000111011" =>  data <= "11010001";  -- 7A3B = D1
      when "1101000111100" =>  data <= "11000110";  -- 7A3C = C6
      when "1101000111101" =>  data <= "10110111";  -- 7A3D = B7
      when "1101000111110" =>  data <= "00110000";  -- 7A3E = 30
      when "1101000111111" =>  data <= "11000100";  -- 7A3F = C4
      when "1101001000000" =>  data <= "01000110";  -- 7A40 = 46
      when "1101001000001" =>  data <= "11011001";  -- 7A41 = D9
      when "1101001000010" =>  data <= "01100110";  -- 7A42 = 66
      when "1101001000011" =>  data <= "11011111";  -- 7A43 = DF
      when "1101001000100" =>  data <= "10100010";  -- 7A44 = A2
      when "1101001000101" =>  data <= "11011010";  -- 7A45 = DA
      when "1101001000110" =>  data <= "00100000";  -- 7A46 = 20
      when "1101001000111" =>  data <= "01000101";  -- 7A47 = 45
      when "1101001001000" =>  data <= "11111001";  -- 7A48 = F9
      when "1101001001001" =>  data <= "01001100";  -- 7A49 = 4C
      when "1101001001010" =>  data <= "00000000";  -- 7A4A = 0
      when "1101001001011" =>  data <= "11100110";  -- 7A4B = E6
      when "1101001001100" =>  data <= "10100101";  -- 7A4C = A5
      when "1101001001101" =>  data <= "10101011";  -- 7A4D = AB
      when "1101001001110" =>  data <= "11110000";  -- 7A4E = F0
      when "1101001001111" =>  data <= "00000100";  -- 7A4F = 4
      when "1101001010000" =>  data <= "10100101";  -- 7A50 = A5
      when "1101001010001" =>  data <= "11001110";  -- 7A51 = CE
      when "1101001010010" =>  data <= "11110000";  -- 7A52 = F0
      when "1101001010011" =>  data <= "00000111";  -- 7A53 = 7
      when "1101001010100" =>  data <= "10100101";  -- 7A54 = A5
      when "1101001010101" =>  data <= "10110111";  -- 7A55 = B7
      when "1101001010110" =>  data <= "00110000";  -- 7A56 = 30
      when "1101001010111" =>  data <= "00000011";  -- 7A57 = 3
      when "1101001011000" =>  data <= "01001100";  -- 7A58 = 4C
      when "1101001011001" =>  data <= "11011100";  -- 7A59 = DC
      when "1101001011010" =>  data <= "11111001";  -- 7A5A = F9
      when "1101001011011" =>  data <= "01000110";  -- 7A5B = 46
      when "1101001011100" =>  data <= "11001100";  -- 7A5C = CC
      when "1101001011101" =>  data <= "10101001";  -- 7A5D = A9
      when "1101001011110" =>  data <= "10010011";  -- 7A5E = 93
      when "1101001011111" =>  data <= "00111000";  -- 7A5F = 38
      when "1101001100000" =>  data <= "11100101";  -- 7A60 = E5
      when "1101001100001" =>  data <= "11001100";  -- 7A61 = CC
      when "1101001100010" =>  data <= "01100101";  -- 7A62 = 65
      when "1101001100011" =>  data <= "11001011";  -- 7A63 = CB
      when "1101001100100" =>  data <= "00001010";  -- 7A64 = A
      when "1101001100101" =>  data <= "10101010";  -- 7A65 = AA
      when "1101001100110" =>  data <= "00100000";  -- 7A66 = 20
      when "1101001100111" =>  data <= "01000101";  -- 7A67 = 45
      when "1101001101000" =>  data <= "11111001";  -- 7A68 = F9
      when "1101001101001" =>  data <= "11100110";  -- 7A69 = E6
      when "1101001101010" =>  data <= "10110010";  -- 7A6A = B2
      when "1101001101011" =>  data <= "10100101";  -- 7A6B = A5
      when "1101001101100" =>  data <= "11001110";  -- 7A6C = CE
      when "1101001101101" =>  data <= "11010000";  -- 7A6D = D0
      when "1101001101110" =>  data <= "00010001";  -- 7A6E = 11
      when "1101001101111" =>  data <= "10100101";  -- 7A6F = A5
      when "1101001110000" =>  data <= "10101011";  -- 7A70 = AB
      when "1101001110001" =>  data <= "11110000";  -- 7A71 = F0
      when "1101001110010" =>  data <= "00100110";  -- 7A72 = 26
      when "1101001110011" =>  data <= "10000101";  -- 7A73 = 85
      when "1101001110100" =>  data <= "10111110";  -- 7A74 = BE
      when "1101001110101" =>  data <= "10101001";  -- 7A75 = A9
      when "1101001110110" =>  data <= "00000000";  -- 7A76 = 0
      when "1101001110111" =>  data <= "10000101";  -- 7A77 = 85
      when "1101001111000" =>  data <= "10101011";  -- 7A78 = AB
      when "1101001111001" =>  data <= "10101001";  -- 7A79 = A9
      when "1101001111010" =>  data <= "11000000";  -- 7A7A = C0
      when "1101001111011" =>  data <= "10001101";  -- 7A7B = 8D
      when "1101001111100" =>  data <= "01001110";  -- 7A7C = 4E
      when "1101001111101" =>  data <= "11101000";  -- 7A7D = E8
      when "1101001111110" =>  data <= "10000101";  -- 7A7E = 85
      when "1101001111111" =>  data <= "11001110";  -- 7A7F = CE
      when "1101010000000" =>  data <= "10100101";  -- 7A80 = A5
      when "1101010000001" =>  data <= "10101011";  -- 7A81 = AB
      when "1101010000010" =>  data <= "10000101";  -- 7A82 = 85
      when "1101010000011" =>  data <= "11001111";  -- 7A83 = CF
      when "1101010000100" =>  data <= "11110000";  -- 7A84 = F0
      when "1101010000101" =>  data <= "00001001";  -- 7A85 = 9
      when "1101010000110" =>  data <= "10101001";  -- 7A86 = A9
      when "1101010000111" =>  data <= "00000000";  -- 7A87 = 0
      when "1101010001000" =>  data <= "10000101";  -- 7A88 = 85
      when "1101010001001" =>  data <= "11001110";  -- 7A89 = CE
      when "1101010001010" =>  data <= "10101001";  -- 7A8A = A9
      when "1101010001011" =>  data <= "01000000";  -- 7A8B = 40
      when "1101010001100" =>  data <= "10001101";  -- 7A8C = 8D
      when "1101010001101" =>  data <= "01001110";  -- 7A8D = 4E
      when "1101010001110" =>  data <= "11101000";  -- 7A8E = E8
      when "1101010001111" =>  data <= "10100101";  -- 7A8F = A5
      when "1101010010000" =>  data <= "11011111";  -- 7A90 = DF
      when "1101010010001" =>  data <= "10000101";  -- 7A91 = 85
      when "1101010010010" =>  data <= "11011101";  -- 7A92 = DD
      when "1101010010011" =>  data <= "10100101";  -- 7A93 = A5
      when "1101010010100" =>  data <= "10111110";  -- 7A94 = BE
      when "1101010010101" =>  data <= "00000101";  -- 7A95 = 5
      when "1101010010110" =>  data <= "10111111";  -- 7A96 = BF
      when "1101010010111" =>  data <= "10000101";  -- 7A97 = 85
      when "1101010011000" =>  data <= "11010000";  -- 7A98 = D0
      when "1101010011001" =>  data <= "01001100";  -- 7A99 = 4C
      when "1101010011010" =>  data <= "00000000";  -- 7A9A = 0
      when "1101010011011" =>  data <= "11100110";  -- 7A9B = E6
      when "1101010011100" =>  data <= "00100000";  -- 7A9C = 20
      when "1101010011101" =>  data <= "11001001";  -- 7A9D = C9
      when "1101010011110" =>  data <= "11111011";  -- 7A9E = FB
      when "1101010011111" =>  data <= "10000101";  -- 7A9F = 85
      when "1101010100000" =>  data <= "10110010";  -- 7AA0 = B2
      when "1101010100001" =>  data <= "10100010";  -- 7AA1 = A2
      when "1101010100010" =>  data <= "11011010";  -- 7AA2 = DA
      when "1101010100011" =>  data <= "00100000";  -- 7AA3 = 20
      when "1101010100100" =>  data <= "01000101";  -- 7AA4 = 45
      when "1101010100101" =>  data <= "11111001";  -- 7AA5 = F9
      when "1101010100110" =>  data <= "10100101";  -- 7AA6 = A5
      when "1101010100111" =>  data <= "11011110";  -- 7AA7 = DE
      when "1101010101000" =>  data <= "11110000";  -- 7AA8 = F0
      when "1101010101001" =>  data <= "00000010";  -- 7AA9 = 2
      when "1101010101010" =>  data <= "10000101";  -- 7AAA = 85
      when "1101010101011" =>  data <= "10111101";  -- 7AAB = BD
      when "1101010101100" =>  data <= "10101001";  -- 7AAC = A9
      when "1101010101101" =>  data <= "00001111";  -- 7AAD = F
      when "1101010101110" =>  data <= "00100100";  -- 7AAE = 24
      when "1101010101111" =>  data <= "11000010";  -- 7AAF = C2
      when "1101010110000" =>  data <= "00010000";  -- 7AB0 = 10
      when "1101010110001" =>  data <= "00010111";  -- 7AB1 = 17
      when "1101010110010" =>  data <= "10100101";  -- 7AB2 = A5
      when "1101010110011" =>  data <= "11001111";  -- 7AB3 = CF
      when "1101010110100" =>  data <= "11010000";  -- 7AB4 = D0
      when "1101010110101" =>  data <= "00001100";  -- 7AB5 = C
      when "1101010110110" =>  data <= "10100110";  -- 7AB6 = A6
      when "1101010110111" =>  data <= "11011110";  -- 7AB7 = DE
      when "1101010111000" =>  data <= "11001010";  -- 7AB8 = CA
      when "1101010111001" =>  data <= "11010000";  -- 7AB9 = D0
      when "1101010111010" =>  data <= "00001011";  -- 7ABA = B
      when "1101010111011" =>  data <= "10101001";  -- 7ABB = A9
      when "1101010111100" =>  data <= "00001000";  -- 7ABC = 8
      when "1101010111101" =>  data <= "00100000";  -- 7ABD = 20
      when "1101010111110" =>  data <= "11000100";  -- 7ABE = C4
      when "1101010111111" =>  data <= "11111011";  -- 7ABF = FB
      when "1101011000000" =>  data <= "11010000";  -- 7AC0 = D0
      when "1101011000001" =>  data <= "00000100";  -- 7AC1 = 4
      when "1101011000010" =>  data <= "10101001";  -- 7AC2 = A9
      when "1101011000011" =>  data <= "00000000";  -- 7AC3 = 0
      when "1101011000100" =>  data <= "10000101";  -- 7AC4 = 85
      when "1101011000101" =>  data <= "11000010";  -- 7AC5 = C2
      when "1101011000110" =>  data <= "01001100";  -- 7AC6 = 4C
      when "1101011000111" =>  data <= "00000000";  -- 7AC7 = 0
      when "1101011001000" =>  data <= "11100110";  -- 7AC8 = E6
      when "1101011001001" =>  data <= "01110000";  -- 7AC9 = 70
      when "1101011001010" =>  data <= "00110001";  -- 7ACA = 31
      when "1101011001011" =>  data <= "11010000";  -- 7ACB = D0
      when "1101011001100" =>  data <= "00011000";  -- 7ACC = 18
      when "1101011001101" =>  data <= "10100101";  -- 7ACD = A5
      when "1101011001110" =>  data <= "11001111";  -- 7ACE = CF
      when "1101011001111" =>  data <= "11010000";  -- 7ACF = D0
      when "1101011010000" =>  data <= "11110101";  -- 7AD0 = F5
      when "1101011010001" =>  data <= "10100101";  -- 7AD1 = A5
      when "1101011010010" =>  data <= "11010000";  -- 7AD2 = D0
      when "1101011010011" =>  data <= "11010000";  -- 7AD3 = D0
      when "1101011010100" =>  data <= "11110001";  -- 7AD4 = F1
      when "1101011010101" =>  data <= "10100101";  -- 7AD5 = A5
      when "1101011010110" =>  data <= "10111101";  -- 7AD6 = BD
      when "1101011010111" =>  data <= "01001010";  -- 7AD7 = 4A
      when "1101011011000" =>  data <= "10100101";  -- 7AD8 = A5
      when "1101011011001" =>  data <= "11011101";  -- 7AD9 = DD
      when "1101011011010" =>  data <= "00110000";  -- 7ADA = 30
      when "1101011011011" =>  data <= "00000011";  -- 7ADB = 3
      when "1101011011100" =>  data <= "10010000";  -- 7ADC = 90
      when "1101011011101" =>  data <= "00011000";  -- 7ADD = 18
      when "1101011011110" =>  data <= "00011000";  -- 7ADE = 18
      when "1101011011111" =>  data <= "10110000";  -- 7ADF = B0
      when "1101011100000" =>  data <= "00010101";  -- 7AE0 = 15
      when "1101011100001" =>  data <= "00101001";  -- 7AE1 = 29
      when "1101011100010" =>  data <= "00001111";  -- 7AE2 = F
      when "1101011100011" =>  data <= "10000101";  -- 7AE3 = 85
      when "1101011100100" =>  data <= "11000010";  -- 7AE4 = C2
      when "1101011100101" =>  data <= "11000110";  -- 7AE5 = C6
      when "1101011100110" =>  data <= "11000010";  -- 7AE6 = C2
      when "1101011100111" =>  data <= "11010000";  -- 7AE7 = D0
      when "1101011101000" =>  data <= "11011101";  -- 7AE8 = DD
      when "1101011101001" =>  data <= "10101001";  -- 7AE9 = A9
      when "1101011101010" =>  data <= "01000000";  -- 7AEA = 40
      when "1101011101011" =>  data <= "10000101";  -- 7AEB = 85
      when "1101011101100" =>  data <= "11000010";  -- 7AEC = C2
      when "1101011101101" =>  data <= "00100000";  -- 7AED = 20
      when "1101011101110" =>  data <= "10111011";  -- 7AEE = BB
      when "1101011101111" =>  data <= "11111011";  -- 7AEF = FB
      when "1101011110000" =>  data <= "10101001";  -- 7AF0 = A9
      when "1101011110001" =>  data <= "00000000";  -- 7AF1 = 0
      when "1101011110010" =>  data <= "10000101";  -- 7AF2 = 85
      when "1101011110011" =>  data <= "11000011";  -- 7AF3 = C3
      when "1101011110100" =>  data <= "11110000";  -- 7AF4 = F0
      when "1101011110101" =>  data <= "11010000";  -- 7AF5 = D0
      when "1101011110110" =>  data <= "10101001";  -- 7AF6 = A9
      when "1101011110111" =>  data <= "10000000";  -- 7AF7 = 80
      when "1101011111000" =>  data <= "10000101";  -- 7AF8 = 85
      when "1101011111001" =>  data <= "11000010";  -- 7AF9 = C2
      when "1101011111010" =>  data <= "11010000";  -- 7AFA = D0
      when "1101011111011" =>  data <= "11001010";  -- 7AFB = CA
      when "1101011111100" =>  data <= "10100101";  -- 7AFC = A5
      when "1101011111101" =>  data <= "11001111";  -- 7AFD = CF
      when "1101011111110" =>  data <= "11110000";  -- 7AFE = F0
      when "1101011111111" =>  data <= "00001010";  -- 7AFF = A
      when "1101100000000" =>  data <= "10101001";  -- 7B00 = A9
      when "1101100000001" =>  data <= "00000100";  -- 7B01 = 4
      when "1101100000010" =>  data <= "00100000";  -- 7B02 = 20
      when "1101100000011" =>  data <= "11000100";  -- 7B03 = C4
      when "1101100000100" =>  data <= "11111011";  -- 7B04 = FB
      when "1101100000101" =>  data <= "10101001";  -- 7B05 = A9
      when "1101100000110" =>  data <= "00000000";  -- 7B06 = 0
      when "1101100000111" =>  data <= "01001100";  -- 7B07 = 4C
      when "1101100001000" =>  data <= "10001011";  -- 7B08 = 8B
      when "1101100001001" =>  data <= "11111011";  -- 7B09 = FB
      when "1101100001010" =>  data <= "00100000";  -- 7B0A = 20
      when "1101100001011" =>  data <= "00001011";  -- 7B0B = B
      when "1101100001100" =>  data <= "11111101";  -- 7B0C = FD
      when "1101100001101" =>  data <= "11010000";  -- 7B0D = D0
      when "1101100001110" =>  data <= "00000011";  -- 7B0E = 3
      when "1101100001111" =>  data <= "01001100";  -- 7B0F = 4C
      when "1101100010000" =>  data <= "10001001";  -- 7B10 = 89
      when "1101100010001" =>  data <= "11111011";  -- 7B11 = FB
      when "1101100010010" =>  data <= "10100110";  -- 7B12 = A6
      when "1101100010011" =>  data <= "10111101";  -- 7B13 = BD
      when "1101100010100" =>  data <= "11001010";  -- 7B14 = CA
      when "1101100010101" =>  data <= "11110000";  -- 7B15 = F0
      when "1101100010110" =>  data <= "00101101";  -- 7B16 = 2D
      when "1101100010111" =>  data <= "10100101";  -- 7B17 = A5
      when "1101100011000" =>  data <= "10011101";  -- 7B18 = 9D
      when "1101100011001" =>  data <= "11110000";  -- 7B19 = F0
      when "1101100011010" =>  data <= "00001100";  -- 7B1A = C
      when "1101100011011" =>  data <= "10100000";  -- 7B1B = A0
      when "1101100011100" =>  data <= "00000000";  -- 7B1C = 0
      when "1101100011101" =>  data <= "10100101";  -- 7B1D = A5
      when "1101100011110" =>  data <= "11011101";  -- 7B1E = DD
      when "1101100011111" =>  data <= "11010001";  -- 7B1F = D1
      when "1101100100000" =>  data <= "11000111";  -- 7B20 = C7
      when "1101100100001" =>  data <= "11110000";  -- 7B21 = F0
      when "1101100100010" =>  data <= "00000100";  -- 7B22 = 4
      when "1101100100011" =>  data <= "10101001";  -- 7B23 = A9
      when "1101100100100" =>  data <= "00000001";  -- 7B24 = 1
      when "1101100100101" =>  data <= "10000101";  -- 7B25 = 85
      when "1101100100110" =>  data <= "11010000";  -- 7B26 = D0
      when "1101100100111" =>  data <= "10100101";  -- 7B27 = A5
      when "1101100101000" =>  data <= "11010000";  -- 7B28 = D0
      when "1101100101001" =>  data <= "11110000";  -- 7B29 = F0
      when "1101100101010" =>  data <= "01001100";  -- 7B2A = 4C
      when "1101100101011" =>  data <= "10100010";  -- 7B2B = A2
      when "1101100101100" =>  data <= "00111101";  -- 7B2C = 3D
      when "1101100101101" =>  data <= "11100100";  -- 7B2D = E4
      when "1101100101110" =>  data <= "11000000";  -- 7B2E = C0
      when "1101100101111" =>  data <= "10010000";  -- 7B2F = 90
      when "1101100110000" =>  data <= "00111111";  -- 7B30 = 3F
      when "1101100110001" =>  data <= "10100110";  -- 7B31 = A6
      when "1101100110010" =>  data <= "11000000";  -- 7B32 = C0
      when "1101100110011" =>  data <= "10100101";  -- 7B33 = A5
      when "1101100110100" =>  data <= "11001000";  -- 7B34 = C8
      when "1101100110101" =>  data <= "10011101";  -- 7B35 = 9D
      when "1101100110110" =>  data <= "00000001";  -- 7B36 = 1
      when "1101100110111" =>  data <= "00000001";  -- 7B37 = 1
      when "1101100111000" =>  data <= "10100101";  -- 7B38 = A5
      when "1101100111001" =>  data <= "11000111";  -- 7B39 = C7
      when "1101100111010" =>  data <= "10011101";  -- 7B3A = 9D
      when "1101100111011" =>  data <= "00000000";  -- 7B3B = 0
      when "1101100111100" =>  data <= "00000001";  -- 7B3C = 1
      when "1101100111101" =>  data <= "11101000";  -- 7B3D = E8
      when "1101100111110" =>  data <= "11101000";  -- 7B3E = E8
      when "1101100111111" =>  data <= "10000110";  -- 7B3F = 86
      when "1101101000000" =>  data <= "11000000";  -- 7B40 = C0
      when "1101101000001" =>  data <= "01001100";  -- 7B41 = 4C
      when "1101101000010" =>  data <= "01110111";  -- 7B42 = 77
      when "1101101000011" =>  data <= "11111011";  -- 7B43 = FB
      when "1101101000100" =>  data <= "10100110";  -- 7B44 = A6
      when "1101101000101" =>  data <= "11000001";  -- 7B45 = C1
      when "1101101000110" =>  data <= "11100100";  -- 7B46 = E4
      when "1101101000111" =>  data <= "11000000";  -- 7B47 = C0
      when "1101101001000" =>  data <= "11110000";  -- 7B48 = F0
      when "1101101001001" =>  data <= "00110111";  -- 7B49 = 37
      when "1101101001010" =>  data <= "10100101";  -- 7B4A = A5
      when "1101101001011" =>  data <= "11000111";  -- 7B4B = C7
      when "1101101001100" =>  data <= "11011101";  -- 7B4C = DD
      when "1101101001101" =>  data <= "00000000";  -- 7B4D = 0
      when "1101101001110" =>  data <= "00000001";  -- 7B4E = 1
      when "1101101001111" =>  data <= "11010000";  -- 7B4F = D0
      when "1101101010000" =>  data <= "00110000";  -- 7B50 = 30
      when "1101101010001" =>  data <= "10100101";  -- 7B51 = A5
      when "1101101010010" =>  data <= "11001000";  -- 7B52 = C8
      when "1101101010011" =>  data <= "11011101";  -- 7B53 = DD
      when "1101101010100" =>  data <= "00000001";  -- 7B54 = 1
      when "1101101010101" =>  data <= "00000001";  -- 7B55 = 1
      when "1101101010110" =>  data <= "11010000";  -- 7B56 = D0
      when "1101101010111" =>  data <= "00101001";  -- 7B57 = 29
      when "1101101011000" =>  data <= "11100110";  -- 7B58 = E6
      when "1101101011001" =>  data <= "11000001";  -- 7B59 = C1
      when "1101101011010" =>  data <= "11100110";  -- 7B5A = E6
      when "1101101011011" =>  data <= "11000001";  -- 7B5B = C1
      when "1101101011100" =>  data <= "10100101";  -- 7B5C = A5
      when "1101101011101" =>  data <= "10011101";  -- 7B5D = 9D
      when "1101101011110" =>  data <= "11110000";  -- 7B5E = F0
      when "1101101011111" =>  data <= "00001100";  -- 7B5F = C
      when "1101101100000" =>  data <= "10100101";  -- 7B60 = A5
      when "1101101100001" =>  data <= "11011101";  -- 7B61 = DD
      when "1101101100010" =>  data <= "10100000";  -- 7B62 = A0
      when "1101101100011" =>  data <= "00000000";  -- 7B63 = 0
      when "1101101100100" =>  data <= "11010001";  -- 7B64 = D1
      when "1101101100101" =>  data <= "11000111";  -- 7B65 = C7
      when "1101101100110" =>  data <= "11110000";  -- 7B66 = F0
      when "1101101100111" =>  data <= "00011001";  -- 7B67 = 19
      when "1101101101000" =>  data <= "10101001";  -- 7B68 = A9
      when "1101101101001" =>  data <= "00000001";  -- 7B69 = 1
      when "1101101101010" =>  data <= "10000101";  -- 7B6A = 85
      when "1101101101011" =>  data <= "11010000";  -- 7B6B = D0
      when "1101101101100" =>  data <= "10100101";  -- 7B6C = A5
      when "1101101101101" =>  data <= "11010000";  -- 7B6D = D0
      when "1101101101110" =>  data <= "11110000";  -- 7B6E = F0
      when "1101101101111" =>  data <= "00000111";  -- 7B6F = 7
      when "1101101110000" =>  data <= "10101001";  -- 7B70 = A9
      when "1101101110001" =>  data <= "00010000";  -- 7B71 = 10
      when "1101101110010" =>  data <= "00100000";  -- 7B72 = 20
      when "1101101110011" =>  data <= "11000100";  -- 7B73 = C4
      when "1101101110100" =>  data <= "11111011";  -- 7B74 = FB
      when "1101101110101" =>  data <= "11010000";  -- 7B75 = D0
      when "1101101110110" =>  data <= "00001010";  -- 7B76 = A
      when "1101101110111" =>  data <= "10100101";  -- 7B77 = A5
      when "1101101111000" =>  data <= "10011101";  -- 7B78 = 9D
      when "1101101111001" =>  data <= "11010000";  -- 7B79 = D0
      when "1101101111010" =>  data <= "00000110";  -- 7B7A = 6
      when "1101101111011" =>  data <= "10100101";  -- 7B7B = A5
      when "1101101111100" =>  data <= "11011101";  -- 7B7C = DD
      when "1101101111101" =>  data <= "10100000";  -- 7B7D = A0
      when "1101101111110" =>  data <= "00000000";  -- 7B7E = 0
      when "1101101111111" =>  data <= "10010001";  -- 7B7F = 91
      when "1101110000000" =>  data <= "11000111";  -- 7B80 = C7
      when "1101110000001" =>  data <= "11100110";  -- 7B81 = E6
      when "1101110000010" =>  data <= "11000111";  -- 7B82 = C7
      when "1101110000011" =>  data <= "11010000";  -- 7B83 = D0
      when "1101110000100" =>  data <= "00110011";  -- 7B84 = 33
      when "1101110000101" =>  data <= "11100110";  -- 7B85 = E6
      when "1101110000110" =>  data <= "11001000";  -- 7B86 = C8
      when "1101110000111" =>  data <= "11010000";  -- 7B87 = D0
      when "1101110001000" =>  data <= "00101111";  -- 7B88 = 2F
      when "1101110001001" =>  data <= "10101001";  -- 7B89 = A9
      when "1101110001010" =>  data <= "10000000";  -- 7B8A = 80
      when "1101110001011" =>  data <= "10000101";  -- 7B8B = 85
      when "1101110001100" =>  data <= "11000010";  -- 7B8C = C2
      when "1101110001101" =>  data <= "10100110";  -- 7B8D = A6
      when "1101110001110" =>  data <= "11011110";  -- 7B8E = DE
      when "1101110001111" =>  data <= "11001010";  -- 7B8F = CA
      when "1101110010000" =>  data <= "00110000";  -- 7B90 = 30
      when "1101110010001" =>  data <= "00000010";  -- 7B91 = 2
      when "1101110010010" =>  data <= "10000110";  -- 7B92 = 86
      when "1101110010011" =>  data <= "11011110";  -- 7B93 = DE
      when "1101110010100" =>  data <= "11000110";  -- 7B94 = C6
      when "1101110010101" =>  data <= "10111101";  -- 7B95 = BD
      when "1101110010110" =>  data <= "11110000";  -- 7B96 = F0
      when "1101110010111" =>  data <= "00001000";  -- 7B97 = 8
      when "1101110011000" =>  data <= "10100101";  -- 7B98 = A5
      when "1101110011001" =>  data <= "11000000";  -- 7B99 = C0
      when "1101110011010" =>  data <= "11010000";  -- 7B9A = D0
      when "1101110011011" =>  data <= "00011100";  -- 7B9B = 1C
      when "1101110011100" =>  data <= "10000101";  -- 7B9C = 85
      when "1101110011101" =>  data <= "11011110";  -- 7B9D = DE
      when "1101110011110" =>  data <= "11110000";  -- 7B9E = F0
      when "1101110011111" =>  data <= "00011000";  -- 7B9F = 18
      when "1101110100000" =>  data <= "00100000";  -- 7BA0 = 20
      when "1101110100001" =>  data <= "11000000";  -- 7BA1 = C0
      when "1101110100010" =>  data <= "11111100";  -- 7BA2 = FC
      when "1101110100011" =>  data <= "00100000";  -- 7BA3 = 20
      when "1101110100100" =>  data <= "10111011";  -- 7BA4 = BB
      when "1101110100101" =>  data <= "11111011";  -- 7BA5 = FB
      when "1101110100110" =>  data <= "10100000";  -- 7BA6 = A0
      when "1101110100111" =>  data <= "00000000";  -- 7BA7 = 0
      when "1101110101000" =>  data <= "10000100";  -- 7BA8 = 84
      when "1101110101001" =>  data <= "11000011";  -- 7BA9 = C3
      when "1101110101010" =>  data <= "00100000";  -- 7BAA = 20
      when "1101110101011" =>  data <= "11111001";  -- 7BAB = F9
      when "1101110101100" =>  data <= "11111100";  -- 7BAC = FC
      when "1101110101101" =>  data <= "10100101";  -- 7BAD = A5
      when "1101110101110" =>  data <= "11000011";  -- 7BAE = C3
      when "1101110101111" =>  data <= "01000101";  -- 7BAF = 45
      when "1101110110000" =>  data <= "11011101";  -- 7BB0 = DD
      when "1101110110001" =>  data <= "11110000";  -- 7BB1 = F0
      when "1101110110010" =>  data <= "00000101";  -- 7BB2 = 5
      when "1101110110011" =>  data <= "10101001";  -- 7BB3 = A9
      when "1101110110100" =>  data <= "00100000";  -- 7BB4 = 20
      when "1101110110101" =>  data <= "00100000";  -- 7BB5 = 20
      when "1101110110110" =>  data <= "11000100";  -- 7BB6 = C4
      when "1101110110111" =>  data <= "11111011";  -- 7BB7 = FB
      when "1101110111000" =>  data <= "01001100";  -- 7BB8 = 4C
      when "1101110111001" =>  data <= "00000000";  -- 7BB9 = 0
      when "1101110111010" =>  data <= "11100110";  -- 7BBA = E6
      when "1101110111011" =>  data <= "10100101";  -- 7BBB = A5
      when "1101110111100" =>  data <= "11111100";  -- 7BBC = FC
      when "1101110111101" =>  data <= "10000101";  -- 7BBD = 85
      when "1101110111110" =>  data <= "11001000";  -- 7BBE = C8
      when "1101110111111" =>  data <= "10100101";  -- 7BBF = A5
      when "1101111000000" =>  data <= "11111011";  -- 7BC0 = FB
      when "1101111000001" =>  data <= "10000101";  -- 7BC1 = 85
      when "1101111000010" =>  data <= "11000111";  -- 7BC2 = C7
      when "1101111000011" =>  data <= "01100000";  -- 7BC3 = 60
      when "1101111000100" =>  data <= "00000101";  -- 7BC4 = 5
      when "1101111000101" =>  data <= "10010110";  -- 7BC5 = 96
      when "1101111000110" =>  data <= "10000101";  -- 7BC6 = 85
      when "1101111000111" =>  data <= "10010110";  -- 7BC7 = 96
      when "1101111001000" =>  data <= "01100000";  -- 7BC8 = 60
      when "1101111001001" =>  data <= "10101001";  -- 7BC9 = A9
      when "1101111001010" =>  data <= "00001000";  -- 7BCA = 8
      when "1101111001011" =>  data <= "10000101";  -- 7BCB = 85
      when "1101111001100" =>  data <= "10110111";  -- 7BCC = B7
      when "1101111001101" =>  data <= "10101001";  -- 7BCD = A9
      when "1101111001110" =>  data <= "00000000";  -- 7BCE = 0
      when "1101111001111" =>  data <= "10000101";  -- 7BCF = 85
      when "1101111010000" =>  data <= "10111001";  -- 7BD0 = B9
      when "1101111010001" =>  data <= "10000101";  -- 7BD1 = 85
      when "1101111010010" =>  data <= "10111110";  -- 7BD2 = BE
      when "1101111010011" =>  data <= "10000101";  -- 7BD3 = 85
      when "1101111010100" =>  data <= "10110001";  -- 7BD4 = B1
      when "1101111010101" =>  data <= "10000101";  -- 7BD5 = 85
      when "1101111010110" =>  data <= "10111111";  -- 7BD6 = BF
      when "1101111010111" =>  data <= "01100000";  -- 7BD7 = 60
      when "1101111011000" =>  data <= "10100101";  -- 7BD8 = A5
      when "1101111011001" =>  data <= "11011101";  -- 7BD9 = DD
      when "1101111011010" =>  data <= "01001010";  -- 7BDA = 4A
      when "1101111011011" =>  data <= "10101001";  -- 7BDB = A9
      when "1101111011100" =>  data <= "01100000";  -- 7BDC = 60
      when "1101111011101" =>  data <= "10010000";  -- 7BDD = 90
      when "1101111011110" =>  data <= "00000010";  -- 7BDE = 2
      when "1101111011111" =>  data <= "10101001";  -- 7BDF = A9
      when "1101111100000" =>  data <= "10110000";  -- 7BE0 = B0
      when "1101111100001" =>  data <= "10100010";  -- 7BE1 = A2
      when "1101111100010" =>  data <= "00000000";  -- 7BE2 = 0
      when "1101111100011" =>  data <= "10001101";  -- 7BE3 = 8D
      when "1101111100100" =>  data <= "01001000";  -- 7BE4 = 48
      when "1101111100101" =>  data <= "11101000";  -- 7BE5 = E8
      when "1101111100110" =>  data <= "10001110";  -- 7BE6 = 8E
      when "1101111100111" =>  data <= "01001001";  -- 7BE7 = 49
      when "1101111101000" =>  data <= "11101000";  -- 7BE8 = E8
      when "1101111101001" =>  data <= "10101101";  -- 7BE9 = AD
      when "1101111101010" =>  data <= "01000000";  -- 7BEA = 40
      when "1101111101011" =>  data <= "11101000";  -- 7BEB = E8
      when "1101111101100" =>  data <= "01001001";  -- 7BEC = 49
      when "1101111101101" =>  data <= "00001000";  -- 7BED = 8
      when "1101111101110" =>  data <= "10001101";  -- 7BEE = 8D
      when "1101111101111" =>  data <= "01000000";  -- 7BEF = 40
      when "1101111110000" =>  data <= "11101000";  -- 7BF0 = E8
      when "1101111110001" =>  data <= "00101001";  -- 7BF1 = 29
      when "1101111110010" =>  data <= "00001000";  -- 7BF2 = 8
      when "1101111110011" =>  data <= "01100000";  -- 7BF3 = 60
      when "1101111110100" =>  data <= "00111000";  -- 7BF4 = 38
      when "1101111110101" =>  data <= "01100110";  -- 7BF5 = 66
      when "1101111110110" =>  data <= "11001000";  -- 7BF6 = C8
      when "1101111110111" =>  data <= "00110000";  -- 7BF7 = 30
      when "1101111111000" =>  data <= "00111100";  -- 7BF8 = 3C
      when "1101111111001" =>  data <= "10100101";  -- 7BF9 = A5
      when "1101111111010" =>  data <= "10111110";  -- 7BFA = BE
      when "1101111111011" =>  data <= "11010000";  -- 7BFB = D0
      when "1101111111100" =>  data <= "00010010";  -- 7BFC = 12
      when "1101111111101" =>  data <= "10101001";  -- 7BFD = A9
      when "1101111111110" =>  data <= "00010000";  -- 7BFE = 10
      when "1101111111111" =>  data <= "10100010";  -- 7BFF = A2
      when "1110000000000" =>  data <= "00000001";  -- 7C00 = 1
      when "1110000000001" =>  data <= "00100000";  -- 7C01 = 20
      when "1110000000010" =>  data <= "11100011";  -- 7C02 = E3
      when "1110000000011" =>  data <= "11111011";  -- 7C03 = FB
      when "1110000000100" =>  data <= "11010000";  -- 7C04 = D0
      when "1110000000101" =>  data <= "00101111";  -- 7C05 = 2F
      when "1110000000110" =>  data <= "11100110";  -- 7C06 = E6
      when "1110000000111" =>  data <= "10111110";  -- 7C07 = BE
      when "1110000001000" =>  data <= "10100101";  -- 7C08 = A5
      when "1110000001001" =>  data <= "11001000";  -- 7C09 = C8
      when "1110000001010" =>  data <= "00010000";  -- 7C0A = 10
      when "1110000001011" =>  data <= "00101001";  -- 7C0B = 29
      when "1110000001100" =>  data <= "01001100";  -- 7C0C = 4C
      when "1110000001101" =>  data <= "10000110";  -- 7C0D = 86
      when "1110000001110" =>  data <= "11111100";  -- 7C0E = FC
      when "1110000001111" =>  data <= "10100101";  -- 7C0F = A5
      when "1110000010000" =>  data <= "10111111";  -- 7C10 = BF
      when "1110000010001" =>  data <= "11010000";  -- 7C11 = D0
      when "1110000010010" =>  data <= "00001001";  -- 7C12 = 9
      when "1110000010011" =>  data <= "00100000";  -- 7C13 = 20
      when "1110000010100" =>  data <= "11011111";  -- 7C14 = DF
      when "1110000010101" =>  data <= "11111011";  -- 7C15 = FB
      when "1110000010110" =>  data <= "11010000";  -- 7C16 = D0
      when "1110000010111" =>  data <= "00011101";  -- 7C17 = 1D
      when "1110000011000" =>  data <= "11100110";  -- 7C18 = E6
      when "1110000011001" =>  data <= "10111111";  -- 7C19 = BF
      when "1110000011010" =>  data <= "11010000";  -- 7C1A = D0
      when "1110000011011" =>  data <= "00011001";  -- 7C1B = 19
      when "1110000011100" =>  data <= "00100000";  -- 7C1C = 20
      when "1110000011101" =>  data <= "11011000";  -- 7C1D = D8
      when "1110000011110" =>  data <= "11111011";  -- 7C1E = FB
      when "1110000011111" =>  data <= "11010000";  -- 7C1F = D0
      when "1110000100000" =>  data <= "00010100";  -- 7C20 = 14
      when "1110000100001" =>  data <= "10100101";  -- 7C21 = A5
      when "1110000100010" =>  data <= "10111001";  -- 7C22 = B9
      when "1110000100011" =>  data <= "01001001";  -- 7C23 = 49
      when "1110000100100" =>  data <= "00000001";  -- 7C24 = 1
      when "1110000100101" =>  data <= "10000101";  -- 7C25 = 85
      when "1110000100110" =>  data <= "10111001";  -- 7C26 = B9
      when "1110000100111" =>  data <= "11110000";  -- 7C27 = F0
      when "1110000101000" =>  data <= "00001111";  -- 7C28 = F
      when "1110000101001" =>  data <= "10100101";  -- 7C29 = A5
      when "1110000101010" =>  data <= "11011101";  -- 7C2A = DD
      when "1110000101011" =>  data <= "01001001";  -- 7C2B = 49
      when "1110000101100" =>  data <= "00000001";  -- 7C2C = 1
      when "1110000101101" =>  data <= "10000101";  -- 7C2D = 85
      when "1110000101110" =>  data <= "11011101";  -- 7C2E = DD
      when "1110000101111" =>  data <= "00101001";  -- 7C2F = 29
      when "1110000110000" =>  data <= "00000001";  -- 7C30 = 1
      when "1110000110001" =>  data <= "01000101";  -- 7C31 = 45
      when "1110000110010" =>  data <= "10110001";  -- 7C32 = B1
      when "1110000110011" =>  data <= "10000101";  -- 7C33 = 85
      when "1110000110100" =>  data <= "10110001";  -- 7C34 = B1
      when "1110000110101" =>  data <= "01001100";  -- 7C35 = 4C
      when "1110000110110" =>  data <= "00000000";  -- 7C36 = 0
      when "1110000110111" =>  data <= "11100110";  -- 7C37 = E6
      when "1110000111000" =>  data <= "01000110";  -- 7C38 = 46
      when "1110000111001" =>  data <= "11011101";  -- 7C39 = DD
      when "1110000111010" =>  data <= "11000110";  -- 7C3A = C6
      when "1110000111011" =>  data <= "10110111";  -- 7C3B = B7
      when "1110000111100" =>  data <= "10100101";  -- 7C3C = A5
      when "1110000111101" =>  data <= "10110111";  -- 7C3D = B7
      when "1110000111110" =>  data <= "11110000";  -- 7C3E = F0
      when "1110000111111" =>  data <= "00111101";  -- 7C3F = 3D
      when "1110001000000" =>  data <= "00010000";  -- 7C40 = 10
      when "1110001000001" =>  data <= "11110011";  -- 7C41 = F3
      when "1110001000010" =>  data <= "00100000";  -- 7C42 = 20
      when "1110001000011" =>  data <= "11001001";  -- 7C43 = C9
      when "1110001000100" =>  data <= "11111011";  -- 7C44 = FB
      when "1110001000101" =>  data <= "01011000";  -- 7C45 = 58
      when "1110001000110" =>  data <= "10100101";  -- 7C46 = A5
      when "1110001000111" =>  data <= "10111010";  -- 7C47 = BA
      when "1110001001000" =>  data <= "11110000";  -- 7C48 = F0
      when "1110001001001" =>  data <= "00010010";  -- 7C49 = 12
      when "1110001001010" =>  data <= "10100010";  -- 7C4A = A2
      when "1110001001011" =>  data <= "00000000";  -- 7C4B = 0
      when "1110001001100" =>  data <= "10000110";  -- 7C4C = 86
      when "1110001001101" =>  data <= "11011001";  -- 7C4D = D9
      when "1110001001110" =>  data <= "11000110";  -- 7C4E = C6
      when "1110001001111" =>  data <= "10111010";  -- 7C4F = BA
      when "1110001010000" =>  data <= "10100110";  -- 7C50 = A6
      when "1110001010001" =>  data <= "11011110";  -- 7C51 = DE
      when "1110001010010" =>  data <= "11100000";  -- 7C52 = E0
      when "1110001010011" =>  data <= "00000010";  -- 7C53 = 2
      when "1110001010100" =>  data <= "11010000";  -- 7C54 = D0
      when "1110001010101" =>  data <= "00000010";  -- 7C55 = 2
      when "1110001010110" =>  data <= "00001001";  -- 7C56 = 9
      when "1110001010111" =>  data <= "10000000";  -- 7C57 = 80
      when "1110001011000" =>  data <= "10000101";  -- 7C58 = 85
      when "1110001011001" =>  data <= "11011101";  -- 7C59 = DD
      when "1110001011010" =>  data <= "11010000";  -- 7C5A = D0
      when "1110001011011" =>  data <= "11011001";  -- 7C5B = D9
      when "1110001011100" =>  data <= "00100000";  -- 7C5C = 20
      when "1110001011101" =>  data <= "00001011";  -- 7C5D = B
      when "1110001011110" =>  data <= "11111101";  -- 7C5E = FD
      when "1110001011111" =>  data <= "10010000";  -- 7C5F = 90
      when "1110001100000" =>  data <= "00001010";  -- 7C60 = A
      when "1110001100001" =>  data <= "11010000";  -- 7C61 = D0
      when "1110001100010" =>  data <= "10010001";  -- 7C62 = 91
      when "1110001100011" =>  data <= "11100110";  -- 7C63 = E6
      when "1110001100100" =>  data <= "11001000";  -- 7C64 = C8
      when "1110001100101" =>  data <= "10100101";  -- 7C65 = A5
      when "1110001100110" =>  data <= "11011001";  -- 7C66 = D9
      when "1110001100111" =>  data <= "10000101";  -- 7C67 = 85
      when "1110001101000" =>  data <= "11011101";  -- 7C68 = DD
      when "1110001101001" =>  data <= "10110000";  -- 7C69 = B0
      when "1110001101010" =>  data <= "11001010";  -- 7C6A = CA
      when "1110001101011" =>  data <= "10100000";  -- 7C6B = A0
      when "1110001101100" =>  data <= "00000000";  -- 7C6C = 0
      when "1110001101101" =>  data <= "10110001";  -- 7C6D = B1
      when "1110001101110" =>  data <= "11000111";  -- 7C6E = C7
      when "1110001101111" =>  data <= "10000101";  -- 7C6F = 85
      when "1110001110000" =>  data <= "11011101";  -- 7C70 = DD
      when "1110001110001" =>  data <= "01000101";  -- 7C71 = 45
      when "1110001110010" =>  data <= "11011001";  -- 7C72 = D9
      when "1110001110011" =>  data <= "10000101";  -- 7C73 = 85
      when "1110001110100" =>  data <= "11011001";  -- 7C74 = D9
      when "1110001110101" =>  data <= "11100110";  -- 7C75 = E6
      when "1110001110110" =>  data <= "11000111";  -- 7C76 = C7
      when "1110001110111" =>  data <= "11010000";  -- 7C77 = D0
      when "1110001111000" =>  data <= "10111100";  -- 7C78 = BC
      when "1110001111001" =>  data <= "11100110";  -- 7C79 = E6
      when "1110001111010" =>  data <= "11001000";  -- 7C7A = C8
      when "1110001111011" =>  data <= "11010000";  -- 7C7B = D0
      when "1110001111100" =>  data <= "10111000";  -- 7C7C = B8
      when "1110001111101" =>  data <= "10100101";  -- 7C7D = A5
      when "1110001111110" =>  data <= "10110001";  -- 7C7E = B1
      when "1110001111111" =>  data <= "01001001";  -- 7C7F = 49
      when "1110010000000" =>  data <= "00000001";  -- 7C80 = 1
      when "1110010000001" =>  data <= "10000101";  -- 7C81 = 85
      when "1110010000010" =>  data <= "11011101";  -- 7C82 = DD
      when "1110010000011" =>  data <= "01001100";  -- 7C83 = 4C
      when "1110010000100" =>  data <= "00000000";  -- 7C84 = 0
      when "1110010000101" =>  data <= "11100110";  -- 7C85 = E6
      when "1110010000110" =>  data <= "11000110";  -- 7C86 = C6
      when "1110010000111" =>  data <= "11011110";  -- 7C87 = DE
      when "1110010001000" =>  data <= "11010000";  -- 7C88 = D0
      when "1110010001001" =>  data <= "00000011";  -- 7C89 = 3
      when "1110010001010" =>  data <= "00100000";  -- 7C8A = 20
      when "1110010001011" =>  data <= "11101011";  -- 7C8B = EB
      when "1110010001100" =>  data <= "11111100";  -- 7C8C = FC
      when "1110010001101" =>  data <= "10101001";  -- 7C8D = A9
      when "1110010001110" =>  data <= "01010000";  -- 7C8E = 50
      when "1110010001111" =>  data <= "10000101";  -- 7C8F = 85
      when "1110010010000" =>  data <= "10111101";  -- 7C90 = BD
      when "1110010010001" =>  data <= "10100010";  -- 7C91 = A2
      when "1110010010010" =>  data <= "00001000";  -- 7C92 = 8
      when "1110010010011" =>  data <= "01111000";  -- 7C93 = 78
      when "1110010010100" =>  data <= "00100000";  -- 7C94 = 20
      when "1110010010101" =>  data <= "11100000";  -- 7C95 = E0
      when "1110010010110" =>  data <= "11111100";  -- 7C96 = FC
      when "1110010010111" =>  data <= "11010000";  -- 7C97 = D0
      when "1110010011000" =>  data <= "11101010";  -- 7C98 = EA
      when "1110010011001" =>  data <= "10101001";  -- 7C99 = A9
      when "1110010011010" =>  data <= "01111000";  -- 7C9A = 78
      when "1110010011011" =>  data <= "00100000";  -- 7C9B = 20
      when "1110010011100" =>  data <= "11100001";  -- 7C9C = E1
      when "1110010011101" =>  data <= "11111011";  -- 7C9D = FB
      when "1110010011110" =>  data <= "11010000";  -- 7C9E = D0
      when "1110010011111" =>  data <= "11100011";  -- 7C9F = E3
      when "1110010100000" =>  data <= "11000110";  -- 7CA0 = C6
      when "1110010100001" =>  data <= "10111101";  -- 7CA1 = BD
      when "1110010100010" =>  data <= "11010000";  -- 7CA2 = D0
      when "1110010100011" =>  data <= "11011111";  -- 7CA3 = DF
      when "1110010100100" =>  data <= "00100000";  -- 7CA4 = 20
      when "1110010100101" =>  data <= "11001001";  -- 7CA5 = C9
      when "1110010100110" =>  data <= "11111011";  -- 7CA6 = FB
      when "1110010100111" =>  data <= "11000110";  -- 7CA7 = C6
      when "1110010101000" =>  data <= "11000011";  -- 7CA8 = C3
      when "1110010101001" =>  data <= "00010000";  -- 7CA9 = 10
      when "1110010101010" =>  data <= "11011000";  -- 7CAA = D8
      when "1110010101011" =>  data <= "10100010";  -- 7CAB = A2
      when "1110010101100" =>  data <= "00001010";  -- 7CAC = A
      when "1110010101101" =>  data <= "00100000";  -- 7CAD = 20
      when "1110010101110" =>  data <= "11100000";  -- 7CAE = E0
      when "1110010101111" =>  data <= "11111100";  -- 7CAF = FC
      when "1110010110000" =>  data <= "01011000";  -- 7CB0 = 58
      when "1110010110001" =>  data <= "11100110";  -- 7CB1 = E6
      when "1110010110010" =>  data <= "11000011";  -- 7CB2 = C3
      when "1110010110011" =>  data <= "10100101";  -- 7CB3 = A5
      when "1110010110100" =>  data <= "11011110";  -- 7CB4 = DE
      when "1110010110101" =>  data <= "11110000";  -- 7CB5 = F0
      when "1110010110110" =>  data <= "00100100";  -- 7CB6 = 24
      when "1110010110111" =>  data <= "00100000";  -- 7CB7 = 20
      when "1110010111000" =>  data <= "10111011";  -- 7CB8 = BB
      when "1110010111001" =>  data <= "11111011";  -- 7CB9 = FB
      when "1110010111010" =>  data <= "10100010";  -- 7CBA = A2
      when "1110010111011" =>  data <= "00001001";  -- 7CBB = 9
      when "1110010111100" =>  data <= "10000110";  -- 7CBC = 86
      when "1110010111101" =>  data <= "10111010";  -- 7CBD = BA
      when "1110010111110" =>  data <= "11010000";  -- 7CBE = D0
      when "1110010111111" =>  data <= "10000010";  -- 7CBF = 82
      when "1110011000000" =>  data <= "00001000";  -- 7CC0 = 8
      when "1110011000001" =>  data <= "01111000";  -- 7CC1 = 78
      when "1110011000010" =>  data <= "00100000";  -- 7CC2 = 20
      when "1110011000011" =>  data <= "11101011";  -- 7CC3 = EB
      when "1110011000100" =>  data <= "11111100";  -- 7CC4 = FC
      when "1110011000101" =>  data <= "10101001";  -- 7CC5 = A9
      when "1110011000110" =>  data <= "01111111";  -- 7CC6 = 7F
      when "1110011000111" =>  data <= "10001101";  -- 7CC7 = 8D
      when "1110011001000" =>  data <= "01001110";  -- 7CC8 = 4E
      when "1110011001001" =>  data <= "11101000";  -- 7CC9 = E8
      when "1110011001010" =>  data <= "10101001";  -- 7CCA = A9
      when "1110011001011" =>  data <= "00111100";  -- 7CCB = 3C
      when "1110011001100" =>  data <= "10001101";  -- 7CCC = 8D
      when "1110011001101" =>  data <= "00010001";  -- 7CCD = 11
      when "1110011001110" =>  data <= "11101000";  -- 7CCE = E8
      when "1110011001111" =>  data <= "10101001";  -- 7CCF = A9
      when "1110011010000" =>  data <= "00111101";  -- 7CD0 = 3D
      when "1110011010001" =>  data <= "10001101";  -- 7CD1 = 8D
      when "1110011010010" =>  data <= "00010011";  -- 7CD2 = 13
      when "1110011010011" =>  data <= "11101000";  -- 7CD3 = E8
      when "1110011010100" =>  data <= "10100010";  -- 7CD4 = A2
      when "1110011010101" =>  data <= "00001100";  -- 7CD5 = C
      when "1110011010110" =>  data <= "00100000";  -- 7CD6 = 20
      when "1110011010111" =>  data <= "11100000";  -- 7CD7 = E0
      when "1110011011000" =>  data <= "11111100";  -- 7CD8 = FC
      when "1110011011001" =>  data <= "00101000";  -- 7CD9 = 28
      when "1110011011010" =>  data <= "01100000";  -- 7CDA = 60
      when "1110011011011" =>  data <= "00100000";  -- 7CDB = 20
      when "1110011011100" =>  data <= "11000000";  -- 7CDC = C0
      when "1110011011101" =>  data <= "11111100";  -- 7CDD = FC
      when "1110011011110" =>  data <= "11110000";  -- 7CDE = F0
      when "1110011011111" =>  data <= "10100011";  -- 7CDF = A3
      when "1110011100000" =>  data <= "10111101";  -- 7CE0 = BD
      when "1110011100001" =>  data <= "01001100";  -- 7CE1 = 4C
      when "1110011100010" =>  data <= "11111101";  -- 7CE2 = FD
      when "1110011100011" =>  data <= "10000101";  -- 7CE3 = 85
      when "1110011100100" =>  data <= "10010000";  -- 7CE4 = 90
      when "1110011100101" =>  data <= "10111101";  -- 7CE5 = BD
      when "1110011100110" =>  data <= "01001101";  -- 7CE6 = 4D
      when "1110011100111" =>  data <= "11111101";  -- 7CE7 = FD
      when "1110011101000" =>  data <= "10000101";  -- 7CE8 = 85
      when "1110011101001" =>  data <= "10010001";  -- 7CE9 = 91
      when "1110011101010" =>  data <= "01100000";  -- 7CEA = 60
      when "1110011101011" =>  data <= "10101001";  -- 7CEB = A9
      when "1110011101100" =>  data <= "00111100";  -- 7CEC = 3C
      when "1110011101101" =>  data <= "10001101";  -- 7CED = 8D
      when "1110011101110" =>  data <= "00010011";  -- 7CEE = 13
      when "1110011101111" =>  data <= "11101000";  -- 7CEF = E8
      when "1110011110000" =>  data <= "10101101";  -- 7CF0 = AD
      when "1110011110001" =>  data <= "01000000";  -- 7CF1 = 40
      when "1110011110010" =>  data <= "11101000";  -- 7CF2 = E8
      when "1110011110011" =>  data <= "00001001";  -- 7CF3 = 9
      when "1110011110100" =>  data <= "00010000";  -- 7CF4 = 10
      when "1110011110101" =>  data <= "10001101";  -- 7CF5 = 8D
      when "1110011110110" =>  data <= "01000000";  -- 7CF6 = 40
      when "1110011110111" =>  data <= "11101000";  -- 7CF7 = E8
      when "1110011111000" =>  data <= "01100000";  -- 7CF8 = 60
      when "1110011111001" =>  data <= "10110001";  -- 7CF9 = B1
      when "1110011111010" =>  data <= "11000111";  -- 7CFA = C7
      when "1110011111011" =>  data <= "01000101";  -- 7CFB = 45
      when "1110011111100" =>  data <= "11000011";  -- 7CFC = C3
      when "1110011111101" =>  data <= "10000101";  -- 7CFD = 85
      when "1110011111110" =>  data <= "11000011";  -- 7CFE = C3
      when "1110011111111" =>  data <= "11100110";  -- 7CFF = E6
      when "1110100000000" =>  data <= "11000111";  -- 7D00 = C7
      when "1110100000001" =>  data <= "11010000";  -- 7D01 = D0
      when "1110100000010" =>  data <= "00000010";  -- 7D02 = 2
      when "1110100000011" =>  data <= "11100110";  -- 7D03 = E6
      when "1110100000100" =>  data <= "11001000";  -- 7D04 = C8
      when "1110100000101" =>  data <= "00100000";  -- 7D05 = 20
      when "1110100000110" =>  data <= "00001011";  -- 7D06 = B
      when "1110100000111" =>  data <= "11111101";  -- 7D07 = FD
      when "1110100001000" =>  data <= "11010000";  -- 7D08 = D0
      when "1110100001001" =>  data <= "11101111";  -- 7D09 = EF
      when "1110100001010" =>  data <= "01100000";  -- 7D0A = 60
      when "1110100001011" =>  data <= "10100101";  -- 7D0B = A5
      when "1110100001100" =>  data <= "11001000";  -- 7D0C = C8
      when "1110100001101" =>  data <= "11000101";  -- 7D0D = C5
      when "1110100001110" =>  data <= "11001010";  -- 7D0E = CA
      when "1110100001111" =>  data <= "11010000";  -- 7D0F = D0
      when "1110100010000" =>  data <= "00000100";  -- 7D10 = 4
      when "1110100010001" =>  data <= "10100101";  -- 7D11 = A5
      when "1110100010010" =>  data <= "11000111";  -- 7D12 = C7
      when "1110100010011" =>  data <= "11000101";  -- 7D13 = C5
      when "1110100010100" =>  data <= "11001001";  -- 7D14 = C9
      when "1110100010101" =>  data <= "01100000";  -- 7D15 = 60
      when "1110100010110" =>  data <= "10100010";  -- 7D16 = A2
      when "1110100010111" =>  data <= "11111111";  -- 7D17 = FF
      when "1110100011000" =>  data <= "01111000";  -- 7D18 = 78
      when "1110100011001" =>  data <= "10011010";  -- 7D19 = 9A
      when "1110100011010" =>  data <= "11011000";  -- 7D1A = D8
      when "1110100011011" =>  data <= "00100000";  -- 7D1B = 20
      when "1110100011100" =>  data <= "00000000";  -- 7D1C = 0
      when "1110100011101" =>  data <= "11100000";  -- 7D1D = E0
      when "1110100011110" =>  data <= "10101001";  -- 7D1E = A9
      when "1110100011111" =>  data <= "11111111";  -- 7D1F = FF
      when "1110100100000" =>  data <= "10000101";  -- 7D20 = 85
      when "1110100100001" =>  data <= "10010100";  -- 7D21 = 94
      when "1110100100010" =>  data <= "10101001";  -- 7D22 = A9
      when "1110100100011" =>  data <= "10110011";  -- 7D23 = B3
      when "1110100100100" =>  data <= "10000101";  -- 7D24 = 85
      when "1110100100101" =>  data <= "10010101";  -- 7D25 = 95
      when "1110100100110" =>  data <= "10101001";  -- 7D26 = A9
      when "1110100100111" =>  data <= "01111000";  -- 7D27 = 78
      when "1110100101000" =>  data <= "10000101";  -- 7D28 = 85
      when "1110100101001" =>  data <= "10010010";  -- 7D29 = 92
      when "1110100101010" =>  data <= "10101001";  -- 7D2A = A9
      when "1110100101011" =>  data <= "11010100";  -- 7D2B = D4
      when "1110100101100" =>  data <= "10000101";  -- 7D2C = 85
      when "1110100101101" =>  data <= "10010011";  -- 7D2D = 93
      when "1110100101110" =>  data <= "10101001";  -- 7D2E = A9
      when "1110100101111" =>  data <= "10100100";  -- 7D2F = A4
      when "1110100110000" =>  data <= "10001101";  -- 7D30 = 8D
      when "1110100110001" =>  data <= "11111010";  -- 7D31 = FA
      when "1110100110010" =>  data <= "00000011";  -- 7D32 = 3
      when "1110100110011" =>  data <= "10101001";  -- 7D33 = A9
      when "1110100110100" =>  data <= "11010111";  -- 7D34 = D7
      when "1110100110101" =>  data <= "10001101";  -- 7D35 = 8D
      when "1110100110110" =>  data <= "11111011";  -- 7D36 = FB
      when "1110100110111" =>  data <= "00000011";  -- 7D37 = 3
      when "1110100111000" =>  data <= "10101001";  -- 7D38 = A9
      when "1110100111001" =>  data <= "00000000";  -- 7D39 = 0
      when "1110100111010" =>  data <= "10001101";  -- 7D3A = 8D
      when "1110100111011" =>  data <= "11111100";  -- 7D3B = FC
      when "1110100111100" =>  data <= "00000011";  -- 7D3C = 3
      when "1110100111101" =>  data <= "01011000";  -- 7D3D = 58
      when "1110100111110" =>  data <= "10101101";  -- 7D3E = AD
      when "1110100111111" =>  data <= "00010000";  -- 7D3F = 10
      when "1110101000000" =>  data <= "11101000";  -- 7D40 = E8
      when "1110101000001" =>  data <= "00110000";  -- 7D41 = 30
      when "1110101000010" =>  data <= "00000011";  -- 7D42 = 3
      when "1110101000011" =>  data <= "01001100";  -- 7D43 = 4C
      when "1110101000100" =>  data <= "01110010";  -- 7D44 = 72
      when "1110101000101" =>  data <= "11010100";  -- 7D45 = D4
      when "1110101000110" =>  data <= "01001100";  -- 7D46 = 4C
      when "1110101000111" =>  data <= "10110110";  -- 7D47 = B6
      when "1110101001000" =>  data <= "11010011";  -- 7D48 = D3
      when "1110101001001" =>  data <= "01101100";  -- 7D49 = 6C
      when "1110101001010" =>  data <= "10010100";  -- 7D4A = 94
      when "1110101001011" =>  data <= "00000000";  -- 7D4B = 0
      when "1110101001100" =>  data <= "00000000";  -- 7D4C = 0
      when "1110101001101" =>  data <= "00000000";  -- 7D4D = 0
      when "1110101001110" =>  data <= "00000000";  -- 7D4E = 0
      when "1110101001111" =>  data <= "00000000";  -- 7D4F = 0
      when "1110101010000" =>  data <= "00000000";  -- 7D50 = 0
      when "1110101010001" =>  data <= "00000000";  -- 7D51 = 0
      when "1110101010010" =>  data <= "00000000";  -- 7D52 = 0
      when "1110101010011" =>  data <= "00000000";  -- 7D53 = 0
      when "1110101010100" =>  data <= "10011001";  -- 7D54 = 99
      when "1110101010101" =>  data <= "11111100";  -- 7D55 = FC
      when "1110101010110" =>  data <= "11111001";  -- 7D56 = F9
      when "1110101010111" =>  data <= "11111011";  -- 7D57 = FB
      when "1110101011000" =>  data <= "01010101";  -- 7D58 = 55
      when "1110101011001" =>  data <= "11100100";  -- 7D59 = E4
      when "1110101011010" =>  data <= "01110110";  -- 7D5A = 76
      when "1110101011011" =>  data <= "11111001";  -- 7D5B = F9
      when "1110101011100" =>  data <= "11110101";  -- 7D5C = F5
      when "1110101011101" =>  data <= "10101010";  -- 7D5D = AA
      when "1110101011110" =>  data <= "10101010";  -- 7D5E = AA
      when "1110101011111" =>  data <= "10101010";  -- 7D5F = AA
      when "1110101100000" =>  data <= "10101010";  -- 7D60 = AA
      when "1110101100001" =>  data <= "10101010";  -- 7D61 = AA
      when "1110101100010" =>  data <= "10101010";  -- 7D62 = AA
      when "1110101100011" =>  data <= "10101010";  -- 7D63 = AA
      when "1110101100100" =>  data <= "10101010";  -- 7D64 = AA
      when "1110101100101" =>  data <= "10101010";  -- 7D65 = AA
      when "1110101100110" =>  data <= "10101010";  -- 7D66 = AA
      when "1110101100111" =>  data <= "10101010";  -- 7D67 = AA
      when "1110101101000" =>  data <= "10101010";  -- 7D68 = AA
      when "1110101101001" =>  data <= "10101010";  -- 7D69 = AA
      when "1110101101010" =>  data <= "10101010";  -- 7D6A = AA
      when "1110101101011" =>  data <= "10101010";  -- 7D6B = AA
      when "1110101101100" =>  data <= "10101010";  -- 7D6C = AA
      when "1110101101101" =>  data <= "10101010";  -- 7D6D = AA
      when "1110101101110" =>  data <= "10101010";  -- 7D6E = AA
      when "1110101101111" =>  data <= "10101010";  -- 7D6F = AA
      when "1110101110000" =>  data <= "10101010";  -- 7D70 = AA
      when "1110101110001" =>  data <= "10101010";  -- 7D71 = AA
      when "1110101110010" =>  data <= "10101010";  -- 7D72 = AA
      when "1110101110011" =>  data <= "10101010";  -- 7D73 = AA
      when "1110101110100" =>  data <= "10101010";  -- 7D74 = AA
      when "1110101110101" =>  data <= "10101010";  -- 7D75 = AA
      when "1110101110110" =>  data <= "10101010";  -- 7D76 = AA
      when "1110101110111" =>  data <= "10101010";  -- 7D77 = AA
      when "1110101111000" =>  data <= "10101010";  -- 7D78 = AA
      when "1110101111001" =>  data <= "10101010";  -- 7D79 = AA
      when "1110101111010" =>  data <= "10101010";  -- 7D7A = AA
      when "1110101111011" =>  data <= "10101010";  -- 7D7B = AA
      when "1110101111100" =>  data <= "10101010";  -- 7D7C = AA
      when "1110101111101" =>  data <= "10101010";  -- 7D7D = AA
      when "1110101111110" =>  data <= "10101010";  -- 7D7E = AA
      when "1110101111111" =>  data <= "10101010";  -- 7D7F = AA
      when "1110110000000" =>  data <= "10101010";  -- 7D80 = AA
      when "1110110000001" =>  data <= "10101010";  -- 7D81 = AA
      when "1110110000010" =>  data <= "10101010";  -- 7D82 = AA
      when "1110110000011" =>  data <= "10101010";  -- 7D83 = AA
      when "1110110000100" =>  data <= "10101010";  -- 7D84 = AA
      when "1110110000101" =>  data <= "10101010";  -- 7D85 = AA
      when "1110110000110" =>  data <= "10101010";  -- 7D86 = AA
      when "1110110000111" =>  data <= "10101010";  -- 7D87 = AA
      when "1110110001000" =>  data <= "10101010";  -- 7D88 = AA
      when "1110110001001" =>  data <= "10101010";  -- 7D89 = AA
      when "1110110001010" =>  data <= "10101010";  -- 7D8A = AA
      when "1110110001011" =>  data <= "10101010";  -- 7D8B = AA
      when "1110110001100" =>  data <= "10101010";  -- 7D8C = AA
      when "1110110001101" =>  data <= "10101010";  -- 7D8D = AA
      when "1110110001110" =>  data <= "10101010";  -- 7D8E = AA
      when "1110110001111" =>  data <= "10101010";  -- 7D8F = AA
      when "1110110010000" =>  data <= "10101010";  -- 7D90 = AA
      when "1110110010001" =>  data <= "10101010";  -- 7D91 = AA
      when "1110110010010" =>  data <= "10101010";  -- 7D92 = AA
      when "1110110010011" =>  data <= "10101010";  -- 7D93 = AA
      when "1110110010100" =>  data <= "10101010";  -- 7D94 = AA
      when "1110110010101" =>  data <= "10101010";  -- 7D95 = AA
      when "1110110010110" =>  data <= "10101010";  -- 7D96 = AA
      when "1110110010111" =>  data <= "10101010";  -- 7D97 = AA
      when "1110110011000" =>  data <= "10101010";  -- 7D98 = AA
      when "1110110011001" =>  data <= "10101010";  -- 7D99 = AA
      when "1110110011010" =>  data <= "10101010";  -- 7D9A = AA
      when "1110110011011" =>  data <= "10101010";  -- 7D9B = AA
      when "1110110011100" =>  data <= "10101010";  -- 7D9C = AA
      when "1110110011101" =>  data <= "10101010";  -- 7D9D = AA
      when "1110110011110" =>  data <= "10101010";  -- 7D9E = AA
      when "1110110011111" =>  data <= "10101010";  -- 7D9F = AA
      when "1110110100000" =>  data <= "10101010";  -- 7DA0 = AA
      when "1110110100001" =>  data <= "10101010";  -- 7DA1 = AA
      when "1110110100010" =>  data <= "10101010";  -- 7DA2 = AA
      when "1110110100011" =>  data <= "10101010";  -- 7DA3 = AA
      when "1110110100100" =>  data <= "10101010";  -- 7DA4 = AA
      when "1110110100101" =>  data <= "10101010";  -- 7DA5 = AA
      when "1110110100110" =>  data <= "10101010";  -- 7DA6 = AA
      when "1110110100111" =>  data <= "10101010";  -- 7DA7 = AA
      when "1110110101000" =>  data <= "10101010";  -- 7DA8 = AA
      when "1110110101001" =>  data <= "10101010";  -- 7DA9 = AA
      when "1110110101010" =>  data <= "10101010";  -- 7DAA = AA
      when "1110110101011" =>  data <= "10101010";  -- 7DAB = AA
      when "1110110101100" =>  data <= "10101010";  -- 7DAC = AA
      when "1110110101101" =>  data <= "10101010";  -- 7DAD = AA
      when "1110110101110" =>  data <= "10101010";  -- 7DAE = AA
      when "1110110101111" =>  data <= "10101010";  -- 7DAF = AA
      when "1110110110000" =>  data <= "10101010";  -- 7DB0 = AA
      when "1110110110001" =>  data <= "10101010";  -- 7DB1 = AA
      when "1110110110010" =>  data <= "10101010";  -- 7DB2 = AA
      when "1110110110011" =>  data <= "10101010";  -- 7DB3 = AA
      when "1110110110100" =>  data <= "10101010";  -- 7DB4 = AA
      when "1110110110101" =>  data <= "10101010";  -- 7DB5 = AA
      when "1110110110110" =>  data <= "10101010";  -- 7DB6 = AA
      when "1110110110111" =>  data <= "10101010";  -- 7DB7 = AA
      when "1110110111000" =>  data <= "10101010";  -- 7DB8 = AA
      when "1110110111001" =>  data <= "10101010";  -- 7DB9 = AA
      when "1110110111010" =>  data <= "10101010";  -- 7DBA = AA
      when "1110110111011" =>  data <= "10101010";  -- 7DBB = AA
      when "1110110111100" =>  data <= "10101010";  -- 7DBC = AA
      when "1110110111101" =>  data <= "10101010";  -- 7DBD = AA
      when "1110110111110" =>  data <= "10101010";  -- 7DBE = AA
      when "1110110111111" =>  data <= "10101010";  -- 7DBF = AA
      when "1110111000000" =>  data <= "10101010";  -- 7DC0 = AA
      when "1110111000001" =>  data <= "10101010";  -- 7DC1 = AA
      when "1110111000010" =>  data <= "10101010";  -- 7DC2 = AA
      when "1110111000011" =>  data <= "10101010";  -- 7DC3 = AA
      when "1110111000100" =>  data <= "10101010";  -- 7DC4 = AA
      when "1110111000101" =>  data <= "10101010";  -- 7DC5 = AA
      when "1110111000110" =>  data <= "10101010";  -- 7DC6 = AA
      when "1110111000111" =>  data <= "10101010";  -- 7DC7 = AA
      when "1110111001000" =>  data <= "10101010";  -- 7DC8 = AA
      when "1110111001001" =>  data <= "10101010";  -- 7DC9 = AA
      when "1110111001010" =>  data <= "10101010";  -- 7DCA = AA
      when "1110111001011" =>  data <= "10101010";  -- 7DCB = AA
      when "1110111001100" =>  data <= "10101010";  -- 7DCC = AA
      when "1110111001101" =>  data <= "10101010";  -- 7DCD = AA
      when "1110111001110" =>  data <= "10101010";  -- 7DCE = AA
      when "1110111001111" =>  data <= "10101010";  -- 7DCF = AA
      when "1110111010000" =>  data <= "10101010";  -- 7DD0 = AA
      when "1110111010001" =>  data <= "10101010";  -- 7DD1 = AA
      when "1110111010010" =>  data <= "10101010";  -- 7DD2 = AA
      when "1110111010011" =>  data <= "10101010";  -- 7DD3 = AA
      when "1110111010100" =>  data <= "10101010";  -- 7DD4 = AA
      when "1110111010101" =>  data <= "10101010";  -- 7DD5 = AA
      when "1110111010110" =>  data <= "10101010";  -- 7DD6 = AA
      when "1110111010111" =>  data <= "10101010";  -- 7DD7 = AA
      when "1110111011000" =>  data <= "10101010";  -- 7DD8 = AA
      when "1110111011001" =>  data <= "10101010";  -- 7DD9 = AA
      when "1110111011010" =>  data <= "10101010";  -- 7DDA = AA
      when "1110111011011" =>  data <= "10101010";  -- 7DDB = AA
      when "1110111011100" =>  data <= "10101010";  -- 7DDC = AA
      when "1110111011101" =>  data <= "10101010";  -- 7DDD = AA
      when "1110111011110" =>  data <= "10101010";  -- 7DDE = AA
      when "1110111011111" =>  data <= "10101010";  -- 7DDF = AA
      when "1110111100000" =>  data <= "10101010";  -- 7DE0 = AA
      when "1110111100001" =>  data <= "10101010";  -- 7DE1 = AA
      when "1110111100010" =>  data <= "10101010";  -- 7DE2 = AA
      when "1110111100011" =>  data <= "10101010";  -- 7DE3 = AA
      when "1110111100100" =>  data <= "10101010";  -- 7DE4 = AA
      when "1110111100101" =>  data <= "10101010";  -- 7DE5 = AA
      when "1110111100110" =>  data <= "10101010";  -- 7DE6 = AA
      when "1110111100111" =>  data <= "10101010";  -- 7DE7 = AA
      when "1110111101000" =>  data <= "10101010";  -- 7DE8 = AA
      when "1110111101001" =>  data <= "10101010";  -- 7DE9 = AA
      when "1110111101010" =>  data <= "10101010";  -- 7DEA = AA
      when "1110111101011" =>  data <= "10101010";  -- 7DEB = AA
      when "1110111101100" =>  data <= "10101010";  -- 7DEC = AA
      when "1110111101101" =>  data <= "10101010";  -- 7DED = AA
      when "1110111101110" =>  data <= "10101010";  -- 7DEE = AA
      when "1110111101111" =>  data <= "10101010";  -- 7DEF = AA
      when "1110111110000" =>  data <= "10101010";  -- 7DF0 = AA
      when "1110111110001" =>  data <= "10101010";  -- 7DF1 = AA
      when "1110111110010" =>  data <= "10101010";  -- 7DF2 = AA
      when "1110111110011" =>  data <= "10101010";  -- 7DF3 = AA
      when "1110111110100" =>  data <= "10101010";  -- 7DF4 = AA
      when "1110111110101" =>  data <= "10101010";  -- 7DF5 = AA
      when "1110111110110" =>  data <= "10101010";  -- 7DF6 = AA
      when "1110111110111" =>  data <= "10101010";  -- 7DF7 = AA
      when "1110111111000" =>  data <= "10101010";  -- 7DF8 = AA
      when "1110111111001" =>  data <= "10101010";  -- 7DF9 = AA
      when "1110111111010" =>  data <= "10101010";  -- 7DFA = AA
      when "1110111111011" =>  data <= "10101010";  -- 7DFB = AA
      when "1110111111100" =>  data <= "10101010";  -- 7DFC = AA
      when "1110111111101" =>  data <= "10101010";  -- 7DFD = AA
      when "1110111111110" =>  data <= "10101010";  -- 7DFE = AA
      when "1110111111111" =>  data <= "10101010";  -- 7DFF = AA
      when "1111000000000" =>  data <= "10101010";  -- 7E00 = AA
      when "1111000000001" =>  data <= "10101010";  -- 7E01 = AA
      when "1111000000010" =>  data <= "10101010";  -- 7E02 = AA
      when "1111000000011" =>  data <= "10101010";  -- 7E03 = AA
      when "1111000000100" =>  data <= "10101010";  -- 7E04 = AA
      when "1111000000101" =>  data <= "10101010";  -- 7E05 = AA
      when "1111000000110" =>  data <= "10101010";  -- 7E06 = AA
      when "1111000000111" =>  data <= "10101010";  -- 7E07 = AA
      when "1111000001000" =>  data <= "10101010";  -- 7E08 = AA
      when "1111000001001" =>  data <= "10101010";  -- 7E09 = AA
      when "1111000001010" =>  data <= "10101010";  -- 7E0A = AA
      when "1111000001011" =>  data <= "10101010";  -- 7E0B = AA
      when "1111000001100" =>  data <= "10101010";  -- 7E0C = AA
      when "1111000001101" =>  data <= "10101010";  -- 7E0D = AA
      when "1111000001110" =>  data <= "10101010";  -- 7E0E = AA
      when "1111000001111" =>  data <= "10101010";  -- 7E0F = AA
      when "1111000010000" =>  data <= "10101010";  -- 7E10 = AA
      when "1111000010001" =>  data <= "10101010";  -- 7E11 = AA
      when "1111000010010" =>  data <= "10101010";  -- 7E12 = AA
      when "1111000010011" =>  data <= "10101010";  -- 7E13 = AA
      when "1111000010100" =>  data <= "10101010";  -- 7E14 = AA
      when "1111000010101" =>  data <= "10101010";  -- 7E15 = AA
      when "1111000010110" =>  data <= "10101010";  -- 7E16 = AA
      when "1111000010111" =>  data <= "10101010";  -- 7E17 = AA
      when "1111000011000" =>  data <= "10101010";  -- 7E18 = AA
      when "1111000011001" =>  data <= "10101010";  -- 7E19 = AA
      when "1111000011010" =>  data <= "10101010";  -- 7E1A = AA
      when "1111000011011" =>  data <= "10101010";  -- 7E1B = AA
      when "1111000011100" =>  data <= "10101010";  -- 7E1C = AA
      when "1111000011101" =>  data <= "10101010";  -- 7E1D = AA
      when "1111000011110" =>  data <= "10101010";  -- 7E1E = AA
      when "1111000011111" =>  data <= "10101010";  -- 7E1F = AA
      when "1111000100000" =>  data <= "10101010";  -- 7E20 = AA
      when "1111000100001" =>  data <= "10101010";  -- 7E21 = AA
      when "1111000100010" =>  data <= "10101010";  -- 7E22 = AA
      when "1111000100011" =>  data <= "10101010";  -- 7E23 = AA
      when "1111000100100" =>  data <= "10101010";  -- 7E24 = AA
      when "1111000100101" =>  data <= "10101010";  -- 7E25 = AA
      when "1111000100110" =>  data <= "10101010";  -- 7E26 = AA
      when "1111000100111" =>  data <= "10101010";  -- 7E27 = AA
      when "1111000101000" =>  data <= "10101010";  -- 7E28 = AA
      when "1111000101001" =>  data <= "10101010";  -- 7E29 = AA
      when "1111000101010" =>  data <= "10101010";  -- 7E2A = AA
      when "1111000101011" =>  data <= "10101010";  -- 7E2B = AA
      when "1111000101100" =>  data <= "10101010";  -- 7E2C = AA
      when "1111000101101" =>  data <= "10101010";  -- 7E2D = AA
      when "1111000101110" =>  data <= "10101010";  -- 7E2E = AA
      when "1111000101111" =>  data <= "10101010";  -- 7E2F = AA
      when "1111000110000" =>  data <= "10101010";  -- 7E30 = AA
      when "1111000110001" =>  data <= "10101010";  -- 7E31 = AA
      when "1111000110010" =>  data <= "10101010";  -- 7E32 = AA
      when "1111000110011" =>  data <= "10101010";  -- 7E33 = AA
      when "1111000110100" =>  data <= "10101010";  -- 7E34 = AA
      when "1111000110101" =>  data <= "10101010";  -- 7E35 = AA
      when "1111000110110" =>  data <= "10101010";  -- 7E36 = AA
      when "1111000110111" =>  data <= "10101010";  -- 7E37 = AA
      when "1111000111000" =>  data <= "10101010";  -- 7E38 = AA
      when "1111000111001" =>  data <= "10101010";  -- 7E39 = AA
      when "1111000111010" =>  data <= "10101010";  -- 7E3A = AA
      when "1111000111011" =>  data <= "10101010";  -- 7E3B = AA
      when "1111000111100" =>  data <= "10101010";  -- 7E3C = AA
      when "1111000111101" =>  data <= "10101010";  -- 7E3D = AA
      when "1111000111110" =>  data <= "10101010";  -- 7E3E = AA
      when "1111000111111" =>  data <= "10101010";  -- 7E3F = AA
      when "1111001000000" =>  data <= "10101010";  -- 7E40 = AA
      when "1111001000001" =>  data <= "10101010";  -- 7E41 = AA
      when "1111001000010" =>  data <= "10101010";  -- 7E42 = AA
      when "1111001000011" =>  data <= "10101010";  -- 7E43 = AA
      when "1111001000100" =>  data <= "10101010";  -- 7E44 = AA
      when "1111001000101" =>  data <= "10101010";  -- 7E45 = AA
      when "1111001000110" =>  data <= "10101010";  -- 7E46 = AA
      when "1111001000111" =>  data <= "10101010";  -- 7E47 = AA
      when "1111001001000" =>  data <= "10101010";  -- 7E48 = AA
      when "1111001001001" =>  data <= "10101010";  -- 7E49 = AA
      when "1111001001010" =>  data <= "10101010";  -- 7E4A = AA
      when "1111001001011" =>  data <= "10101010";  -- 7E4B = AA
      when "1111001001100" =>  data <= "10101010";  -- 7E4C = AA
      when "1111001001101" =>  data <= "10101010";  -- 7E4D = AA
      when "1111001001110" =>  data <= "10101010";  -- 7E4E = AA
      when "1111001001111" =>  data <= "10101010";  -- 7E4F = AA
      when "1111001010000" =>  data <= "10101010";  -- 7E50 = AA
      when "1111001010001" =>  data <= "10101010";  -- 7E51 = AA
      when "1111001010010" =>  data <= "10101010";  -- 7E52 = AA
      when "1111001010011" =>  data <= "10101010";  -- 7E53 = AA
      when "1111001010100" =>  data <= "10101010";  -- 7E54 = AA
      when "1111001010101" =>  data <= "10101010";  -- 7E55 = AA
      when "1111001010110" =>  data <= "10101010";  -- 7E56 = AA
      when "1111001010111" =>  data <= "10101010";  -- 7E57 = AA
      when "1111001011000" =>  data <= "10101010";  -- 7E58 = AA
      when "1111001011001" =>  data <= "10101010";  -- 7E59 = AA
      when "1111001011010" =>  data <= "10101010";  -- 7E5A = AA
      when "1111001011011" =>  data <= "10101010";  -- 7E5B = AA
      when "1111001011100" =>  data <= "10101010";  -- 7E5C = AA
      when "1111001011101" =>  data <= "10101010";  -- 7E5D = AA
      when "1111001011110" =>  data <= "10101010";  -- 7E5E = AA
      when "1111001011111" =>  data <= "10101010";  -- 7E5F = AA
      when "1111001100000" =>  data <= "10101010";  -- 7E60 = AA
      when "1111001100001" =>  data <= "10101010";  -- 7E61 = AA
      when "1111001100010" =>  data <= "10101010";  -- 7E62 = AA
      when "1111001100011" =>  data <= "10101010";  -- 7E63 = AA
      when "1111001100100" =>  data <= "10101010";  -- 7E64 = AA
      when "1111001100101" =>  data <= "10101010";  -- 7E65 = AA
      when "1111001100110" =>  data <= "10101010";  -- 7E66 = AA
      when "1111001100111" =>  data <= "10101010";  -- 7E67 = AA
      when "1111001101000" =>  data <= "10101010";  -- 7E68 = AA
      when "1111001101001" =>  data <= "10101010";  -- 7E69 = AA
      when "1111001101010" =>  data <= "10101010";  -- 7E6A = AA
      when "1111001101011" =>  data <= "10101010";  -- 7E6B = AA
      when "1111001101100" =>  data <= "10101010";  -- 7E6C = AA
      when "1111001101101" =>  data <= "10101010";  -- 7E6D = AA
      when "1111001101110" =>  data <= "10101010";  -- 7E6E = AA
      when "1111001101111" =>  data <= "10101010";  -- 7E6F = AA
      when "1111001110000" =>  data <= "10101010";  -- 7E70 = AA
      when "1111001110001" =>  data <= "10101010";  -- 7E71 = AA
      when "1111001110010" =>  data <= "10101010";  -- 7E72 = AA
      when "1111001110011" =>  data <= "10101010";  -- 7E73 = AA
      when "1111001110100" =>  data <= "10101010";  -- 7E74 = AA
      when "1111001110101" =>  data <= "10101010";  -- 7E75 = AA
      when "1111001110110" =>  data <= "10101010";  -- 7E76 = AA
      when "1111001110111" =>  data <= "10101010";  -- 7E77 = AA
      when "1111001111000" =>  data <= "10101010";  -- 7E78 = AA
      when "1111001111001" =>  data <= "10101010";  -- 7E79 = AA
      when "1111001111010" =>  data <= "10101010";  -- 7E7A = AA
      when "1111001111011" =>  data <= "10101010";  -- 7E7B = AA
      when "1111001111100" =>  data <= "10101010";  -- 7E7C = AA
      when "1111001111101" =>  data <= "10101010";  -- 7E7D = AA
      when "1111001111110" =>  data <= "10101010";  -- 7E7E = AA
      when "1111001111111" =>  data <= "10101010";  -- 7E7F = AA
      when "1111010000000" =>  data <= "10101010";  -- 7E80 = AA
      when "1111010000001" =>  data <= "10101010";  -- 7E81 = AA
      when "1111010000010" =>  data <= "10101010";  -- 7E82 = AA
      when "1111010000011" =>  data <= "10101010";  -- 7E83 = AA
      when "1111010000100" =>  data <= "10101010";  -- 7E84 = AA
      when "1111010000101" =>  data <= "10101010";  -- 7E85 = AA
      when "1111010000110" =>  data <= "10101010";  -- 7E86 = AA
      when "1111010000111" =>  data <= "10101010";  -- 7E87 = AA
      when "1111010001000" =>  data <= "10101010";  -- 7E88 = AA
      when "1111010001001" =>  data <= "10101010";  -- 7E89 = AA
      when "1111010001010" =>  data <= "10101010";  -- 7E8A = AA
      when "1111010001011" =>  data <= "10101010";  -- 7E8B = AA
      when "1111010001100" =>  data <= "10101010";  -- 7E8C = AA
      when "1111010001101" =>  data <= "10101010";  -- 7E8D = AA
      when "1111010001110" =>  data <= "10101010";  -- 7E8E = AA
      when "1111010001111" =>  data <= "10101010";  -- 7E8F = AA
      when "1111010010000" =>  data <= "10101010";  -- 7E90 = AA
      when "1111010010001" =>  data <= "10101010";  -- 7E91 = AA
      when "1111010010010" =>  data <= "10101010";  -- 7E92 = AA
      when "1111010010011" =>  data <= "10101010";  -- 7E93 = AA
      when "1111010010100" =>  data <= "10101010";  -- 7E94 = AA
      when "1111010010101" =>  data <= "10101010";  -- 7E95 = AA
      when "1111010010110" =>  data <= "10101010";  -- 7E96 = AA
      when "1111010010111" =>  data <= "10101010";  -- 7E97 = AA
      when "1111010011000" =>  data <= "10101010";  -- 7E98 = AA
      when "1111010011001" =>  data <= "10101010";  -- 7E99 = AA
      when "1111010011010" =>  data <= "10101010";  -- 7E9A = AA
      when "1111010011011" =>  data <= "10101010";  -- 7E9B = AA
      when "1111010011100" =>  data <= "10101010";  -- 7E9C = AA
      when "1111010011101" =>  data <= "10101010";  -- 7E9D = AA
      when "1111010011110" =>  data <= "10101010";  -- 7E9E = AA
      when "1111010011111" =>  data <= "10101010";  -- 7E9F = AA
      when "1111010100000" =>  data <= "10101010";  -- 7EA0 = AA
      when "1111010100001" =>  data <= "10101010";  -- 7EA1 = AA
      when "1111010100010" =>  data <= "10101010";  -- 7EA2 = AA
      when "1111010100011" =>  data <= "10101010";  -- 7EA3 = AA
      when "1111010100100" =>  data <= "10101010";  -- 7EA4 = AA
      when "1111010100101" =>  data <= "10101010";  -- 7EA5 = AA
      when "1111010100110" =>  data <= "10101010";  -- 7EA6 = AA
      when "1111010100111" =>  data <= "10101010";  -- 7EA7 = AA
      when "1111010101000" =>  data <= "10101010";  -- 7EA8 = AA
      when "1111010101001" =>  data <= "10101010";  -- 7EA9 = AA
      when "1111010101010" =>  data <= "10101010";  -- 7EAA = AA
      when "1111010101011" =>  data <= "10101010";  -- 7EAB = AA
      when "1111010101100" =>  data <= "10101010";  -- 7EAC = AA
      when "1111010101101" =>  data <= "10101010";  -- 7EAD = AA
      when "1111010101110" =>  data <= "10101010";  -- 7EAE = AA
      when "1111010101111" =>  data <= "10101010";  -- 7EAF = AA
      when "1111010110000" =>  data <= "10101010";  -- 7EB0 = AA
      when "1111010110001" =>  data <= "10101010";  -- 7EB1 = AA
      when "1111010110010" =>  data <= "10101010";  -- 7EB2 = AA
      when "1111010110011" =>  data <= "10101010";  -- 7EB3 = AA
      when "1111010110100" =>  data <= "10101010";  -- 7EB4 = AA
      when "1111010110101" =>  data <= "10101010";  -- 7EB5 = AA
      when "1111010110110" =>  data <= "10101010";  -- 7EB6 = AA
      when "1111010110111" =>  data <= "10101010";  -- 7EB7 = AA
      when "1111010111000" =>  data <= "10101010";  -- 7EB8 = AA
      when "1111010111001" =>  data <= "10101010";  -- 7EB9 = AA
      when "1111010111010" =>  data <= "10101010";  -- 7EBA = AA
      when "1111010111011" =>  data <= "10101010";  -- 7EBB = AA
      when "1111010111100" =>  data <= "10101010";  -- 7EBC = AA
      when "1111010111101" =>  data <= "10101010";  -- 7EBD = AA
      when "1111010111110" =>  data <= "10101010";  -- 7EBE = AA
      when "1111010111111" =>  data <= "10101010";  -- 7EBF = AA
      when "1111011000000" =>  data <= "10101010";  -- 7EC0 = AA
      when "1111011000001" =>  data <= "10101010";  -- 7EC1 = AA
      when "1111011000010" =>  data <= "10101010";  -- 7EC2 = AA
      when "1111011000011" =>  data <= "10101010";  -- 7EC3 = AA
      when "1111011000100" =>  data <= "10101010";  -- 7EC4 = AA
      when "1111011000101" =>  data <= "10101010";  -- 7EC5 = AA
      when "1111011000110" =>  data <= "10101010";  -- 7EC6 = AA
      when "1111011000111" =>  data <= "10101010";  -- 7EC7 = AA
      when "1111011001000" =>  data <= "10101010";  -- 7EC8 = AA
      when "1111011001001" =>  data <= "10101010";  -- 7EC9 = AA
      when "1111011001010" =>  data <= "10101010";  -- 7ECA = AA
      when "1111011001011" =>  data <= "10101010";  -- 7ECB = AA
      when "1111011001100" =>  data <= "10101010";  -- 7ECC = AA
      when "1111011001101" =>  data <= "10101010";  -- 7ECD = AA
      when "1111011001110" =>  data <= "10101010";  -- 7ECE = AA
      when "1111011001111" =>  data <= "10101010";  -- 7ECF = AA
      when "1111011010000" =>  data <= "10101010";  -- 7ED0 = AA
      when "1111011010001" =>  data <= "10101010";  -- 7ED1 = AA
      when "1111011010010" =>  data <= "10101010";  -- 7ED2 = AA
      when "1111011010011" =>  data <= "10101010";  -- 7ED3 = AA
      when "1111011010100" =>  data <= "10101010";  -- 7ED4 = AA
      when "1111011010101" =>  data <= "10101010";  -- 7ED5 = AA
      when "1111011010110" =>  data <= "10101010";  -- 7ED6 = AA
      when "1111011010111" =>  data <= "10101010";  -- 7ED7 = AA
      when "1111011011000" =>  data <= "10101010";  -- 7ED8 = AA
      when "1111011011001" =>  data <= "10101010";  -- 7ED9 = AA
      when "1111011011010" =>  data <= "10101010";  -- 7EDA = AA
      when "1111011011011" =>  data <= "10101010";  -- 7EDB = AA
      when "1111011011100" =>  data <= "10101010";  -- 7EDC = AA
      when "1111011011101" =>  data <= "10101010";  -- 7EDD = AA
      when "1111011011110" =>  data <= "10101010";  -- 7EDE = AA
      when "1111011011111" =>  data <= "10101010";  -- 7EDF = AA
      when "1111011100000" =>  data <= "10101010";  -- 7EE0 = AA
      when "1111011100001" =>  data <= "10101010";  -- 7EE1 = AA
      when "1111011100010" =>  data <= "10101010";  -- 7EE2 = AA
      when "1111011100011" =>  data <= "10101010";  -- 7EE3 = AA
      when "1111011100100" =>  data <= "10101010";  -- 7EE4 = AA
      when "1111011100101" =>  data <= "10101010";  -- 7EE5 = AA
      when "1111011100110" =>  data <= "10101010";  -- 7EE6 = AA
      when "1111011100111" =>  data <= "10101010";  -- 7EE7 = AA
      when "1111011101000" =>  data <= "10101010";  -- 7EE8 = AA
      when "1111011101001" =>  data <= "10101010";  -- 7EE9 = AA
      when "1111011101010" =>  data <= "10101010";  -- 7EEA = AA
      when "1111011101011" =>  data <= "10101010";  -- 7EEB = AA
      when "1111011101100" =>  data <= "10101010";  -- 7EEC = AA
      when "1111011101101" =>  data <= "10101010";  -- 7EED = AA
      when "1111011101110" =>  data <= "10101010";  -- 7EEE = AA
      when "1111011101111" =>  data <= "10101010";  -- 7EEF = AA
      when "1111011110000" =>  data <= "10101010";  -- 7EF0 = AA
      when "1111011110001" =>  data <= "10101010";  -- 7EF1 = AA
      when "1111011110010" =>  data <= "10101010";  -- 7EF2 = AA
      when "1111011110011" =>  data <= "10101010";  -- 7EF3 = AA
      when "1111011110100" =>  data <= "10101010";  -- 7EF4 = AA
      when "1111011110101" =>  data <= "10101010";  -- 7EF5 = AA
      when "1111011110110" =>  data <= "10101010";  -- 7EF6 = AA
      when "1111011110111" =>  data <= "10101010";  -- 7EF7 = AA
      when "1111011111000" =>  data <= "10101010";  -- 7EF8 = AA
      when "1111011111001" =>  data <= "10101010";  -- 7EF9 = AA
      when "1111011111010" =>  data <= "10101010";  -- 7EFA = AA
      when "1111011111011" =>  data <= "10101010";  -- 7EFB = AA
      when "1111011111100" =>  data <= "10101010";  -- 7EFC = AA
      when "1111011111101" =>  data <= "10101010";  -- 7EFD = AA
      when "1111011111110" =>  data <= "10101010";  -- 7EFE = AA
      when "1111011111111" =>  data <= "10101010";  -- 7EFF = AA
      when "1111100000000" =>  data <= "10101010";  -- 7F00 = AA
      when "1111100000001" =>  data <= "10101010";  -- 7F01 = AA
      when "1111100000010" =>  data <= "10101010";  -- 7F02 = AA
      when "1111100000011" =>  data <= "10101010";  -- 7F03 = AA
      when "1111100000100" =>  data <= "10101010";  -- 7F04 = AA
      when "1111100000101" =>  data <= "10101010";  -- 7F05 = AA
      when "1111100000110" =>  data <= "10101010";  -- 7F06 = AA
      when "1111100000111" =>  data <= "10101010";  -- 7F07 = AA
      when "1111100001000" =>  data <= "10101010";  -- 7F08 = AA
      when "1111100001001" =>  data <= "10101010";  -- 7F09 = AA
      when "1111100001010" =>  data <= "10101010";  -- 7F0A = AA
      when "1111100001011" =>  data <= "10101010";  -- 7F0B = AA
      when "1111100001100" =>  data <= "10101010";  -- 7F0C = AA
      when "1111100001101" =>  data <= "10101010";  -- 7F0D = AA
      when "1111100001110" =>  data <= "10101010";  -- 7F0E = AA
      when "1111100001111" =>  data <= "10101010";  -- 7F0F = AA
      when "1111100010000" =>  data <= "10101010";  -- 7F10 = AA
      when "1111100010001" =>  data <= "10101010";  -- 7F11 = AA
      when "1111100010010" =>  data <= "10101010";  -- 7F12 = AA
      when "1111100010011" =>  data <= "10101010";  -- 7F13 = AA
      when "1111100010100" =>  data <= "10101010";  -- 7F14 = AA
      when "1111100010101" =>  data <= "10101010";  -- 7F15 = AA
      when "1111100010110" =>  data <= "10101010";  -- 7F16 = AA
      when "1111100010111" =>  data <= "10101010";  -- 7F17 = AA
      when "1111100011000" =>  data <= "10101010";  -- 7F18 = AA
      when "1111100011001" =>  data <= "10101010";  -- 7F19 = AA
      when "1111100011010" =>  data <= "10101010";  -- 7F1A = AA
      when "1111100011011" =>  data <= "10101010";  -- 7F1B = AA
      when "1111100011100" =>  data <= "10101010";  -- 7F1C = AA
      when "1111100011101" =>  data <= "10101010";  -- 7F1D = AA
      when "1111100011110" =>  data <= "10101010";  -- 7F1E = AA
      when "1111100011111" =>  data <= "10101010";  -- 7F1F = AA
      when "1111100100000" =>  data <= "10101010";  -- 7F20 = AA
      when "1111100100001" =>  data <= "10101010";  -- 7F21 = AA
      when "1111100100010" =>  data <= "10101010";  -- 7F22 = AA
      when "1111100100011" =>  data <= "10101010";  -- 7F23 = AA
      when "1111100100100" =>  data <= "10101010";  -- 7F24 = AA
      when "1111100100101" =>  data <= "10101010";  -- 7F25 = AA
      when "1111100100110" =>  data <= "10101010";  -- 7F26 = AA
      when "1111100100111" =>  data <= "10101010";  -- 7F27 = AA
      when "1111100101000" =>  data <= "10101010";  -- 7F28 = AA
      when "1111100101001" =>  data <= "10101010";  -- 7F29 = AA
      when "1111100101010" =>  data <= "10101010";  -- 7F2A = AA
      when "1111100101011" =>  data <= "10101010";  -- 7F2B = AA
      when "1111100101100" =>  data <= "10101010";  -- 7F2C = AA
      when "1111100101101" =>  data <= "10101010";  -- 7F2D = AA
      when "1111100101110" =>  data <= "10101010";  -- 7F2E = AA
      when "1111100101111" =>  data <= "10101010";  -- 7F2F = AA
      when "1111100110000" =>  data <= "10101010";  -- 7F30 = AA
      when "1111100110001" =>  data <= "10101010";  -- 7F31 = AA
      when "1111100110010" =>  data <= "10101010";  -- 7F32 = AA
      when "1111100110011" =>  data <= "10101010";  -- 7F33 = AA
      when "1111100110100" =>  data <= "10101010";  -- 7F34 = AA
      when "1111100110101" =>  data <= "10101010";  -- 7F35 = AA
      when "1111100110110" =>  data <= "10101010";  -- 7F36 = AA
      when "1111100110111" =>  data <= "10101010";  -- 7F37 = AA
      when "1111100111000" =>  data <= "10101010";  -- 7F38 = AA
      when "1111100111001" =>  data <= "10101010";  -- 7F39 = AA
      when "1111100111010" =>  data <= "10101010";  -- 7F3A = AA
      when "1111100111011" =>  data <= "10101010";  -- 7F3B = AA
      when "1111100111100" =>  data <= "10101010";  -- 7F3C = AA
      when "1111100111101" =>  data <= "10101010";  -- 7F3D = AA
      when "1111100111110" =>  data <= "10101010";  -- 7F3E = AA
      when "1111100111111" =>  data <= "10101010";  -- 7F3F = AA
      when "1111101000000" =>  data <= "10101010";  -- 7F40 = AA
      when "1111101000001" =>  data <= "10101010";  -- 7F41 = AA
      when "1111101000010" =>  data <= "10101010";  -- 7F42 = AA
      when "1111101000011" =>  data <= "10101010";  -- 7F43 = AA
      when "1111101000100" =>  data <= "10101010";  -- 7F44 = AA
      when "1111101000101" =>  data <= "10101010";  -- 7F45 = AA
      when "1111101000110" =>  data <= "10101010";  -- 7F46 = AA
      when "1111101000111" =>  data <= "10101010";  -- 7F47 = AA
      when "1111101001000" =>  data <= "10101010";  -- 7F48 = AA
      when "1111101001001" =>  data <= "10101010";  -- 7F49 = AA
      when "1111101001010" =>  data <= "10101010";  -- 7F4A = AA
      when "1111101001011" =>  data <= "10101010";  -- 7F4B = AA
      when "1111101001100" =>  data <= "10101010";  -- 7F4C = AA
      when "1111101001101" =>  data <= "10101010";  -- 7F4D = AA
      when "1111101001110" =>  data <= "10101010";  -- 7F4E = AA
      when "1111101001111" =>  data <= "10101010";  -- 7F4F = AA
      when "1111101010000" =>  data <= "10101010";  -- 7F50 = AA
      when "1111101010001" =>  data <= "10101010";  -- 7F51 = AA
      when "1111101010010" =>  data <= "10101010";  -- 7F52 = AA
      when "1111101010011" =>  data <= "10101010";  -- 7F53 = AA
      when "1111101010100" =>  data <= "10101010";  -- 7F54 = AA
      when "1111101010101" =>  data <= "10101010";  -- 7F55 = AA
      when "1111101010110" =>  data <= "10101010";  -- 7F56 = AA
      when "1111101010111" =>  data <= "10101010";  -- 7F57 = AA
      when "1111101011000" =>  data <= "10101010";  -- 7F58 = AA
      when "1111101011001" =>  data <= "10101010";  -- 7F59 = AA
      when "1111101011010" =>  data <= "10101010";  -- 7F5A = AA
      when "1111101011011" =>  data <= "10101010";  -- 7F5B = AA
      when "1111101011100" =>  data <= "10101010";  -- 7F5C = AA
      when "1111101011101" =>  data <= "10101010";  -- 7F5D = AA
      when "1111101011110" =>  data <= "10101010";  -- 7F5E = AA
      when "1111101011111" =>  data <= "10101010";  -- 7F5F = AA
      when "1111101100000" =>  data <= "10101010";  -- 7F60 = AA
      when "1111101100001" =>  data <= "10101010";  -- 7F61 = AA
      when "1111101100010" =>  data <= "10101010";  -- 7F62 = AA
      when "1111101100011" =>  data <= "10101010";  -- 7F63 = AA
      when "1111101100100" =>  data <= "10101010";  -- 7F64 = AA
      when "1111101100101" =>  data <= "10101010";  -- 7F65 = AA
      when "1111101100110" =>  data <= "10101010";  -- 7F66 = AA
      when "1111101100111" =>  data <= "10101010";  -- 7F67 = AA
      when "1111101101000" =>  data <= "10101010";  -- 7F68 = AA
      when "1111101101001" =>  data <= "10101010";  -- 7F69 = AA
      when "1111101101010" =>  data <= "10101010";  -- 7F6A = AA
      when "1111101101011" =>  data <= "10101010";  -- 7F6B = AA
      when "1111101101100" =>  data <= "10101010";  -- 7F6C = AA
      when "1111101101101" =>  data <= "10101010";  -- 7F6D = AA
      when "1111101101110" =>  data <= "10101010";  -- 7F6E = AA
      when "1111101101111" =>  data <= "10101010";  -- 7F6F = AA
      when "1111101110000" =>  data <= "10101010";  -- 7F70 = AA
      when "1111101110001" =>  data <= "10101010";  -- 7F71 = AA
      when "1111101110010" =>  data <= "10101010";  -- 7F72 = AA
      when "1111101110011" =>  data <= "10101010";  -- 7F73 = AA
      when "1111101110100" =>  data <= "10101010";  -- 7F74 = AA
      when "1111101110101" =>  data <= "10101010";  -- 7F75 = AA
      when "1111101110110" =>  data <= "10101010";  -- 7F76 = AA
      when "1111101110111" =>  data <= "10101010";  -- 7F77 = AA
      when "1111101111000" =>  data <= "10101010";  -- 7F78 = AA
      when "1111101111001" =>  data <= "10101010";  -- 7F79 = AA
      when "1111101111010" =>  data <= "10101010";  -- 7F7A = AA
      when "1111101111011" =>  data <= "10101010";  -- 7F7B = AA
      when "1111101111100" =>  data <= "10101010";  -- 7F7C = AA
      when "1111101111101" =>  data <= "10101010";  -- 7F7D = AA
      when "1111101111110" =>  data <= "10101010";  -- 7F7E = AA
      when "1111101111111" =>  data <= "10101010";  -- 7F7F = AA
      when "1111110000000" =>  data <= "10101010";  -- 7F80 = AA
      when "1111110000001" =>  data <= "10101010";  -- 7F81 = AA
      when "1111110000010" =>  data <= "10101010";  -- 7F82 = AA
      when "1111110000011" =>  data <= "10101010";  -- 7F83 = AA
      when "1111110000100" =>  data <= "10101010";  -- 7F84 = AA
      when "1111110000101" =>  data <= "10101010";  -- 7F85 = AA
      when "1111110000110" =>  data <= "10101010";  -- 7F86 = AA
      when "1111110000111" =>  data <= "10101010";  -- 7F87 = AA
      when "1111110001000" =>  data <= "10101010";  -- 7F88 = AA
      when "1111110001001" =>  data <= "10101010";  -- 7F89 = AA
      when "1111110001010" =>  data <= "10101010";  -- 7F8A = AA
      when "1111110001011" =>  data <= "10101010";  -- 7F8B = AA
      when "1111110001100" =>  data <= "10101010";  -- 7F8C = AA
      when "1111110001101" =>  data <= "10101010";  -- 7F8D = AA
      when "1111110001110" =>  data <= "10101010";  -- 7F8E = AA
      when "1111110001111" =>  data <= "10101010";  -- 7F8F = AA
      when "1111110010000" =>  data <= "10101010";  -- 7F90 = AA
      when "1111110010001" =>  data <= "10101010";  -- 7F91 = AA
      when "1111110010010" =>  data <= "10101010";  -- 7F92 = AA
      when "1111110010011" =>  data <= "01001100";  -- 7F93 = 4C
      when "1111110010100" =>  data <= "11000111";  -- 7F94 = C7
      when "1111110010101" =>  data <= "11011010";  -- 7F95 = DA
      when "1111110010110" =>  data <= "01001100";  -- 7F96 = 4C
      when "1111110010111" =>  data <= "01000010";  -- 7F97 = 42
      when "1111110011000" =>  data <= "11011001";  -- 7F98 = D9
      when "1111110011001" =>  data <= "01001100";  -- 7F99 = 4C
      when "1111110011010" =>  data <= "00000111";  -- 7F9A = 7
      when "1111110011011" =>  data <= "11011010";  -- 7F9B = DA
      when "1111110011100" =>  data <= "01001100";  -- 7F9C = 4C
      when "1111110011101" =>  data <= "10101111";  -- 7F9D = AF
      when "1111110011110" =>  data <= "11010111";  -- 7F9E = D7
      when "1111110011111" =>  data <= "01001100";  -- 7F9F = 4C
      when "1111110100000" =>  data <= "11010010";  -- 7FA0 = D2
      when "1111110100001" =>  data <= "11011001";  -- 7FA1 = D9
      when "1111110100010" =>  data <= "01001100";  -- 7FA2 = 4C
      when "1111110100011" =>  data <= "01100101";  -- 7FA3 = 65
      when "1111110100100" =>  data <= "11011010";  -- 7FA4 = DA
      when "1111110100101" =>  data <= "01001100";  -- 7FA5 = 4C
      when "1111110100110" =>  data <= "01111110";  -- 7FA6 = 7E
      when "1111110100111" =>  data <= "11011010";  -- 7FA7 = DA
      when "1111110101000" =>  data <= "01001100";  -- 7FA8 = 4C
      when "1111110101001" =>  data <= "10100111";  -- 7FA9 = A7
      when "1111110101010" =>  data <= "11011010";  -- 7FAA = DA
      when "1111110101011" =>  data <= "01001100";  -- 7FAB = 4C
      when "1111110101100" =>  data <= "01110111";  -- 7FAC = 77
      when "1111110101101" =>  data <= "11011001";  -- 7FAD = D9
      when "1111110101110" =>  data <= "01001100";  -- 7FAE = 4C
      when "1111110101111" =>  data <= "00001101";  -- 7FAF = D
      when "1111110110000" =>  data <= "11011011";  -- 7FB0 = DB
      when "1111110110001" =>  data <= "01001100";  -- 7FB1 = 4C
      when "1111110110010" =>  data <= "00111010";  -- 7FB2 = 3A
      when "1111110110011" =>  data <= "11011011";  -- 7FB3 = DB
      when "1111110110100" =>  data <= "01001100";  -- 7FB4 = 4C
      when "1111110110101" =>  data <= "01110011";  -- 7FB5 = 73
      when "1111110110110" =>  data <= "11011000";  -- 7FB6 = D8
      when "1111110110111" =>  data <= "01001100";  -- 7FB7 = 4C
      when "1111110111000" =>  data <= "01010101";  -- 7FB8 = 55
      when "1111110111001" =>  data <= "11011011";  -- 7FB9 = DB
      when "1111110111010" =>  data <= "01001100";  -- 7FBA = 4C
      when "1111110111011" =>  data <= "01100110";  -- 7FBB = 66
      when "1111110111100" =>  data <= "11011011";  -- 7FBC = DB
      when "1111110111101" =>  data <= "01001100";  -- 7FBD = 4C
      when "1111110111110" =>  data <= "10010101";  -- 7FBE = 95
      when "1111110111111" =>  data <= "11011001";  -- 7FBF = D9
      when "1111111000000" =>  data <= "01001100";  -- 7FC0 = 4C
      when "1111111000001" =>  data <= "01100000";  -- 7FC1 = 60
      when "1111111000010" =>  data <= "11110101";  -- 7FC2 = F5
      when "1111111000011" =>  data <= "01001100";  -- 7FC3 = 4C
      when "1111111000100" =>  data <= "11011101";  -- 7FC4 = DD
      when "1111111000101" =>  data <= "11110010";  -- 7FC5 = F2
      when "1111111000110" =>  data <= "01001100";  -- 7FC6 = 4C
      when "1111111000111" =>  data <= "10101111";  -- 7FC7 = AF
      when "1111111001000" =>  data <= "11110111";  -- 7FC8 = F7
      when "1111111001001" =>  data <= "01001100";  -- 7FC9 = 4C
      when "1111111001010" =>  data <= "11111110";  -- 7FCA = FE
      when "1111111001011" =>  data <= "11110111";  -- 7FCB = F7
      when "1111111001100" =>  data <= "01001100";  -- 7FCC = 4C
      when "1111111001101" =>  data <= "10100110";  -- 7FCD = A6
      when "1111111001110" =>  data <= "11110010";  -- 7FCE = F2
      when "1111111001111" =>  data <= "01001100";  -- 7FCF = 4C
      when "1111111010000" =>  data <= "00010101";  -- 7FD0 = 15
      when "1111111010001" =>  data <= "11110010";  -- 7FD1 = F2
      when "1111111010010" =>  data <= "01001100";  -- 7FD2 = 4C
      when "1111111010011" =>  data <= "01100110";  -- 7FD3 = 66
      when "1111111010100" =>  data <= "11110010";  -- 7FD4 = F2
      when "1111111010101" =>  data <= "01001100";  -- 7FD5 = 4C
      when "1111111010110" =>  data <= "00000001";  -- 7FD6 = 1
      when "1111111010111" =>  data <= "11110100";  -- 7FD7 = F4
      when "1111111011000" =>  data <= "01001100";  -- 7FD8 = 4C
      when "1111111011001" =>  data <= "11011101";  -- 7FD9 = DD
      when "1111111011010" =>  data <= "11110110";  -- 7FDA = F6
      when "1111111011011" =>  data <= "01001100";  -- 7FDB = 4C
      when "1111111011100" =>  data <= "11110110";  -- 7FDC = F6
      when "1111111011101" =>  data <= "11110100";  -- 7FDD = F4
      when "1111111011110" =>  data <= "01001100";  -- 7FDE = 4C
      when "1111111011111" =>  data <= "11000011";  -- 7FDF = C3
      when "1111111100000" =>  data <= "11110110";  -- 7FE0 = F6
      when "1111111100001" =>  data <= "01001100";  -- 7FE1 = 4C
      when "1111111100010" =>  data <= "01000011";  -- 7FE2 = 43
      when "1111111100011" =>  data <= "11110011";  -- 7FE3 = F3
      when "1111111100100" =>  data <= "01001100";  -- 7FE4 = 4C
      when "1111111100101" =>  data <= "00000101";  -- 7FE5 = 5
      when "1111111100110" =>  data <= "11110010";  -- 7FE6 = F2
      when "1111111100111" =>  data <= "01001100";  -- 7FE7 = 4C
      when "1111111101000" =>  data <= "10100010";  -- 7FE8 = A2
      when "1111111101001" =>  data <= "11110010";  -- 7FE9 = F2
      when "1111111101010" =>  data <= "01001100";  -- 7FEA = 4C
      when "1111111101011" =>  data <= "01101000";  -- 7FEB = 68
      when "1111111101100" =>  data <= "11110111";  -- 7FEC = F7
      when "1111111101101" =>  data <= "10101010";  -- 7FED = AA
      when "1111111101110" =>  data <= "10101010";  -- 7FEE = AA
      when "1111111101111" =>  data <= "10101010";  -- 7FEF = AA
      when "1111111110000" =>  data <= "10101010";  -- 7FF0 = AA
      when "1111111110001" =>  data <= "10101010";  -- 7FF1 = AA
      when "1111111110010" =>  data <= "10101010";  -- 7FF2 = AA
      when "1111111110011" =>  data <= "10101010";  -- 7FF3 = AA
      when "1111111110100" =>  data <= "10101010";  -- 7FF4 = AA
      when "1111111110101" =>  data <= "10101010";  -- 7FF5 = AA
      when "1111111110110" =>  data <= "10101010";  -- 7FF6 = AA
      when "1111111110111" =>  data <= "10101010";  -- 7FF7 = AA
      when "1111111111000" =>  data <= "10101010";  -- 7FF8 = AA
      when "1111111111001" =>  data <= "10101010";  -- 7FF9 = AA
      when "1111111111010" =>  data <= "01001001";  -- 7FFA = 49
      when "1111111111011" =>  data <= "11111101";  -- 7FFB = FD
      when "1111111111100" =>  data <= "00010110";  -- 7FFC = 16
      when "1111111111101" =>  data <= "11111101";  -- 7FFD = FD
      when "1111111111110" =>  data <= "01000010";  -- 7FFE = 42
      when "1111111111111" =>  data <= "11100100";  -- 7FFF = E4
      --end_of_rom
      when others =>  data <= "00000000";
    end case;
  end process;

end arch_test_rom;

------------------------------------------------------------------------------
------------------------------------------------------------------------------

